/*

*********************************************************************
*********************************************************************

  file main.cpp :source code of bfs utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/

//#include <iostream.h>
#include <iostream>
#include <stdlib.h>
#include "comuni.h"


extern void bfs(char* graphMultiFileName, char* tempMultiFileName, char* outputMultiFileName,
                int firstNode,long available_RAM, bool printScreen, bool visitPred, bool visitSucc);
//void bfs(char* graphMultiFileName, char* tempMultiFileName, char* outputMultiFileName, int firstNode,long available_RAM,bool printScreen);

void stampaHelp(int arg,char*argv[]){
    cout<< "This utility performs the bfs of a graph.\n";
		cout<< "Usage:\n";
    cout<< " bfs  memory nameInputMultifile%d nameTempMultifile%d nameOutputMultifile%d startingNode directionOption\n";
		cout<< " \n";
		cout<< "memory                 memory available (MB)\n";
		cout<< "nameInputMultifile%d   name of the input graph multifile (IPS format)\n";
    cout<< "nameTempMultifile%d    name of the temp multifile\n";
    cout<< "nameOutputMultifile%d  name of the output multifile (*)\n";
    cout<< "startingNode           starting node of the bfs\n";
    cout<< "directionOption        -FORWARD| -BACKWARD | -BOTH to specify the direction of visit\n";
    cout<<"\n";
    cout<< "(*) The basic multiFile contains all the visited nodes, grouped by level. (Different levels are separated by -1)\n";
    cout<< "    The second multiFile with extension '.report' contains report informations\n";
    arg=0;argv=NULL;
}



int main(int arg, char *argv[])
{
    stampaLicenza(arg,argv);
    if (arg!=7) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

    long memoria=(long)atof(argv[1])*1024*1024;
    if (memoria<=1024*1024){cout<<"Memory parameter error or memory not enough!";EXIT(0);}

    long firstNode=(long)atof(argv[5]);

    char* grafo =argv[2];
    char* temp =argv[3];
    char* output =argv[4];
    char* direction =argv[6];

    char grafoINFO[300]; strcpy(grafoINFO,grafo);strcat(grafoINFO,".info");
    char grafoPRED[300]; strcpy(grafoPRED,grafo);strcat(grafoPRED,".pred");
    char grafoSUCC[300]; strcpy(grafoSUCC,grafo);strcat(grafoSUCC,".succ");

    

    //************************ CONTROLLO FILES DI INPUT ***************************
    if (!estMultiFileName(grafo)) STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifiles name must contain the substring '%d'");
    if (!estMultiFileName(temp)) STAMPA_ERRORE_PARAMETRI(argv[0],"Temporary multifiles name must contain the substring '%d'");
    if (!estMultiFileName(output)) STAMPA_ERRORE_PARAMETRI(argv[0],"Output multifiles name must contain the substring '%d'");

    if (getTotalSizeMultiFiles(grafoINFO)<=0){cout<<"The input graph is empty (INFO)\n";FINE};
    if (getTotalSizeMultiFiles(grafoPRED)<=0){cout<<"The input graph is empty (PRED)\n";FINE};
    if (getTotalSizeMultiFiles(grafoSUCC)<=0){cout<<"The input graph is empty (SUCC)\n";FINE};

    //cout << "Hello, World!" << endl;
    if (strcasecmp(direction,"-forward")==0){//avanti
      cout<<"Visit successors of nodes starting from node "<<firstNode<<"\n";
      bfs( grafo, temp, output, firstNode, memoria, true,false,true);
    }
    else if (strcasecmp(direction,"-BACKWARD")==0){//avanti
      cout<<"Visit predecessors of nodes starting from node "<<firstNode<<"\n";
      bfs( grafo, temp, output, firstNode, memoria, true,true,false);
    }
    else if (strcasecmp(direction,"-both")==0){//avanti
      cout<<"Visit predecessors and successors of nodes starting from node "<<firstNode<<"\n";
      bfs( grafo, temp, output, firstNode, memoria, true,true,true);
    }
    else
      cout<<"invalid direction parameter\n";

  EXIT(0);
}

