#ifndef MAIN_H
#define MAIN_H

#include <stdio.h>
#include "comuni.h"
#include "../common/scc_utl/BufferLetturaMultifile.h"
#include "../common/scc_utl/BufferScritturaMultifile.h"
#include "../common/scc_utl/BufferAppoggio.h"
#include "../common/scc_utl/SwappedStack.h"


//#define NDEBUG //flag usato anche da assert, se definito indica che non stiamo sviluppando e non serve il controllo per il debugging

//definizioni flag per il debug:
#ifndef NDEBUG
//#define USA_DIR_TMP //crea i file temporanei nella directory /tmp/
//#define TEST_POCA_MEM //alloca comunque una quantita' limitata di memoria
//#define PRINT_RISULTATO //stampa su video l'elenco dei nodi incontrati
//#define VERBOSE_DEBUG //stampa su video molte informazioni
#endif



//definizione costanti:
#define DIM_BLOCCO_STACK 256*1024
#define DIM_BUF_INFO 128*1024
#define DIM_BUF_ADIAC 128*1024
#define DIM_BUF_SCRITTURA_OUTPUT 128*1024
#define DIM_MINIMA_BLOCCO_MEMORIA 2*1024*1024 //almeno 2 MB per il blocco di memoria
#define DIM_BUF_LETTURA_FILE_INPUT_NODI 8*1024
#define DIM_BUF_SCRITTURA_INFOTREE 8*1024


const unsigned long MAX_ULONG= (unsigned long)((long)-1);

const char EXT_TUBES[]=".tubes";
const char EXT_INFOALBERO[]=".infotree"; //estensione da aggiungere al file di output con le informazioni sugli alberi DFS, rispetto al file di output principale
const char MSG_ERRORE_PILA[]= "stack read error";//"Impossibile leggere dalla pila";
const char MSG_ERRORE_BITS[]= "bit vector error";//"Errore nell'accedere al vettore di bit";
const char MSG_ERRORE_SEEK[]= "Seek multifile error on multifile %s";//"Errore nell'effettuare la seek sul multifile %s";
const char MSG_ERR_NODO_OUTOFRANGE[]= "Node out of range:\n node=%lu";//"Nodo fuori range:\n nodo=%lu";
const char MSG_ERRORE_LETTURA_MULTIFILE[]= "Read error in multifile %s";//"Impossibile leggere dal multifile %s";
const char MSG_DONE[]= "done.\n";

struct  grafoInfo{
  long inDeg;
  long outDeg;
  long long puntIn;
  long long puntOut;
};


struct InfoAlbero { //informazioni relative a ciascun albero DFS visitato, da salvare nel file .infotree dell'output
  long num_nodi_albero; //dimensione dell'albero
  long punt; //indice del primo nodo dell'albero nel file di output principale
};



template <class T>
T min(T a, T b)
{
  if(a<b)
    return a;
  else
    return b;
}




//definizione della macro per verificare se ci sono errori. Il primo parametro e' la condizione da verificare e che deve risultare vera, il 2o, 3o, ecc. sono passati a printf per stampare i vari messaggi
#define accertati_che(a, resto...)  \
  if(!(a))                               \
  {  gestione_errore( resto ); }




void libera_memoria();
void gestione_errore(const char *formato, ...);
void eraseMultiFile(const char* nomeMulti);

#endif
