/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file clique.cc :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "bloccografo.h"
#include "clique.h"
#include <string.h>
#include "proprietanodi.h"
#include "operazioni.h"
#include "permutazione.h"
#include "comuni.h"
#include <stdlib.h>
#include <ctype.h>



char bufferStampaProgressione[1000];


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(char* testo,long perc1,long perc2){

  /*======================== STAMPA MESSAGGI ===================================================================*/
  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

  if (perc1<0) perc1=0;
  else if (perc1>100) perc1=100;

  if (perc2<0) perc2=0;
  else if (perc2>100) perc2=100;

  perc2=(long) (20.0*perc2/100);
  //indicatore
  char st[90];

  strcpy(st,"____________________");
  for (long i=0;(i<20)&&(i<perc2);i++ )
     st[i]='@';

  //limite a 30 la lunghezza del testo
  char s[90];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<40);i++)
    s[i]=testo[i];
  for (; (i<40);i++)
    s[i]=' ';
  s[40]=0;

 sprintf(bufferStampaProgressione,"%c [%c] %3ld%c %20s ",STESSA_LINEA,cont,perc1,'%',st);
	printf("%s%28s%c",bufferStampaProgressione,s,STESSA_LINEA);
  fflush(stdout);
  /*============================================================================================================*/
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(char* testo){

  /*======================== STAMPA MESSAGGI ===================================================================*/

  static char cont='-';
  switch(cont){
  	case '-': cont='\\';break;
  	case '\\': cont='|';break;
  	case '|': cont='/';break;
  	case '/': cont='-';break;
  }

  //limite a 30 la lunghezza del testo
  char s[90];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<28);i++)
    s[i]=testo[i];

  s[i]=0;
  s[28]=0;

	printf("%s%28s",bufferStampaProgressione,s);
	printf("%c[%c]%c",STESSA_LINEA,cont,STESSA_LINEA);				
  fflush(stdout);

  /*============================================================================================================*/
}







/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(long long CONT_numeroOperazioniTotali){

  /*======================== STAMPA MESSAGGI ===================================================================*/
//        01234567890123456789012345678901234567890123456789012345678901234567890123456789
  printf("===============================================================================\n");
  printf(" total | i,j | BL| missing  |  waiting |  cliques |  note (tot nodes= %lld)\n",CONT_numeroOperazioniTotali);
  printf("-------------------------------------------------------------------------------\n");
  fflush(stdout);
  /*============================================================================================================*/
}






/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

void indiceProgressione(
  char* testo,
  long nBlocco,
  long nBlocchiTotali,
 	long long CONT_numeroOperazioniInAttesaSuFile,
  long long CONT_numeroOperazioniCompletate,
  long long CONT_numeroOperazioniTotali,
  long long numClique,
  long val_i,long val_j
){

  /*======================== STAMPA MESSAGGI ===================================================================*/
  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

  if (CONT_numeroOperazioniTotali<=0) CONT_numeroOperazioniTotali=1;
  long perc1=100 * CONT_numeroOperazioniCompletate/CONT_numeroOperazioniTotali;
  if (perc1<0) perc1=0;
  else if (perc1>100) perc1=100;

  long perc2=(100*(nBlocco+1)/nBlocchiTotali );
  if (perc2<0) perc2=0;
  else if (perc2>100) perc2=100;

  //limita la lunghezza del testo
  char s[90];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<28);i++)
	    s[i]=testo[i];
  s[i]=0;

  s[28]=0;


	sprintf(bufferStampaProgressione,"%c[%c]%3ld%c|%2ld,%2ld|%3ld|%10lld|%10lld|%10lld|",
				STESSA_LINEA,cont,perc1,'%',val_i,val_j,nBlocco+1,CONT_numeroOperazioniTotali-CONT_numeroOperazioniCompletate,
				CONT_numeroOperazioniInAttesaSuFile,numClique);				
	printf("%s%28s%c",bufferStampaProgressione,s,STESSA_LINEA);
				
	
  fflush(stdout);
  /*============================================================================================================*/
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(char* testo,long long byte){
  /*======================== STAMPA MESSAGGI ===================================================================*/
  //limite a 50 la lunghezza del testo
  char s[90];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<50);i++)
    s[i]=testo[i];

  for (; (i<50);i++)
    s[i]=' ';
  s[50]=0;

  printf(" %c %s ",STESSA_LINEA,s);
  cout<<byte/1048576<<" MB"<<(char)STESSA_LINEA;
  fflush(stdout);
  /*============================================================================================================*/
}











//#include "insieme.h"
#include "combinanodi.h"
#include "infoBloccoClique.h"
#include <time.h>


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long long calcolaCliques(  long val_i,long val_j,long maxIn ,long maxOut,report2 r,char* nomeFileMultiplo ){
static bool primaVolta=true;


  if (val_i<2 || val_j<2)
  		return 0;

  //la memoria disponibile e' quella che rimane dopo aver tolto quella per il buffer di 2 bit/nodo e quello per i files lettura
  long numeroNodiInMemoria=  (long)( ( RAM - r.getNumNodiTotali()*2/8 -DIM_BUFFER_LETTURA_GENERICA*NUM_BUFFER_LETTURA_GENERICA*3)/
  			(  2.0*sizeof(long)*(1+r.getNumeroArchi()/r.getNumNodiTotali())  ) ) ;//numero di pred+succ medi per ogni nodo
  			
  if (numeroNodiInMemoria<=100){cout<<"Memory not enough.";FINE}

  //alloca le strutture per gestire x nodi per volta in memoria - inizialmente non contiene nessuna informazione
  bloccoGrafo b=bloccoGrafo(&r,numeroNodiInMemoria);

  if (primaVolta){
    cout<<"Graph partition: (tot "<<r.getNumNodiTotali()<<" nodes) in "<<b.getNumeroTotaleBlocchi()<<" blocks that contain "<<numeroNodiInMemoria<<" nodes \n\n";
    primaVolta=false;
  }
  			
  //crea struttura condivisa per fan/center e controlla correttezza file report
  long long numCliqueTrovate=0;

/*		
  lettura informazioni iniziali sui nodi fan/center (comunque da aggiornare per i valore minimi !!!!)
	proprietaNodi p=proprietaNodi(r,val_i,val_j,nomeFileTempoBit);
*/

  cout<< "\nCliques searching (i,j) = ("<<val_i<<","<<val_j<<").\n";

  proprietaNodi p=proprietaNodi(r,val_i,val_j,maxIn ,maxOut);
				  	
	//stampa header
	indiceProgressione(r.getNumNodiTotali());
	
  //creo la struttura per allocare i blocchi
  infoBloccoClique infoB=infoBloccoClique(nomeFileMultiplo,b.getNumeroTotaleBlocchi(),b.getNumeroNodiPerBlocco(),r.getNumNodiTotali());
  long finito=false;
	
	//var di conteggio progressione blocco corrente
 	long long CONT_numeroOperazioniInAttesaSuFile=0;
  long long CONT_numeroOperazioniTotali=p.getNumeroFanRimasti();;//num operazioni==num FAN iniziali
  long long iterazioni=0;
  long tempo=time(NULL);
  long tempoHD=0;

  while (!finito){
		
     //----------------------------------------------------------------------------------
     // 							LETTURA NUOVO BLOCCO DEL GRAFO
     //----------------------------------------------------------------------------------
     if ( (   (p.getNumeroFanRimasti()<=0) || (p.getNumeroCenterRimasti()<=0)  ) ){
     			finito=true;	break; }


      //**************************************************************************************************
      //**************************************************************************************************
      //prende il blocco successivo se c'e' else comincia da capo
      long nBloccoCorrente=b.getNumeroBloccoCorrente();

      if (true){
		     long long CONT_numeroOperazioniCompletate=CONT_numeroOperazioniTotali-p.getNumeroFanRimasti();
    	   long t1=time(NULL);
	       indiceProgressione((char*)"reading BLOCK (INIT)",nBloccoCorrente+1,b.getNumeroTotaleBlocchi(),CONT_numeroOperazioniInAttesaSuFile,CONT_numeroOperazioniCompletate,CONT_numeroOperazioniTotali,numCliqueTrovate,val_i,val_j);
         b.leggiBloccoSuccessivo(&p);
         nBloccoCorrente=b.getNumeroBloccoCorrente();
         tempoHD+=time(NULL)-t1;
      }


      if (nBloccoCorrente<0){ //vuol dire che devo cominciare da capo
      	 //misura il tempo impiegato
      	 nBloccoCorrente=b.getNumeroBloccoCorrente();
		     long long CONT_numeroOperazioniCompletate=CONT_numeroOperazioniTotali-p.getNumeroFanRimasti();
    	   long t1=time(NULL);
	       indiceProgressione((char*)"reading BLOCK (INIT)",0,b.getNumeroTotaleBlocchi(),CONT_numeroOperazioniInAttesaSuFile,CONT_numeroOperazioniCompletate,CONT_numeroOperazioniTotali,numCliqueTrovate,val_i,val_j);
         b.leggiBloccoIniziale(&p);
      	 nBloccoCorrente=b.getNumeroBloccoCorrente();
      	 tempoHD+=time(NULL)-t1;
      }


    	//blocco vuoto
      if (nBloccoCorrente<0){cout<<"Fatal error:The input graph is empty";FINE;}






      //----------------------------------------------------------------------------------
      //      			SOLE OPERAZIONI CHE POSSONO ESSERE COMPLETATE SUBITO
      //----------------------------------------------------------------------------------
      //cerco i soli nuovi nodi che non devono essere salvati e cerco di calcolarne le cliques o annullarli come FAN
      iterazioni=MAX_ITER*10;
      long nuoveOperazioniCompletate=0;
      long primoNodoDaAnalizzareBlocco=infoB.getPrimoNodoNonAnalizzato(nBloccoCorrente);
      long ultimoNodoDaAnalizzareBlocco=infoB.getUltimoNodoBlocco(nBloccoCorrente);

//      cout<<"\n BLOCCO "<<nBloccoCorrente<<" - nodi DA "<<primoNodoDaAnalizzareBlocco<<" A "<<ultimoNodoDaAnalizzareBlocco<<"\n";

      //controlla che non siano finiti i nodi da analizzare
      for (long nodoCorrente=primoNodoDaAnalizzareBlocco;primoNodoDaAnalizzareBlocco>=0 && nodoCorrente<=ultimoNodoDaAnalizzareBlocco;nodoCorrente++){

        /*
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				break;
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        */

        //+++++++++++ STAMPA PROGRESSIONE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if (nodoCorrente<0){cout<<"Unexpected fatal error....";FINE;}
        if (++iterazioni>=MAX_ITER/10) {
                iterazioni=0;
                char s[1000];
                long long CONT_numeroOperazioniCompletate=CONT_numeroOperazioniTotali-p.getNumeroFanRimasti();
                sprintf(s,"Complete:%7ld nodes",nuoveOperazioniCompletate);
      			  	indiceProgressione(s,nBloccoCorrente,b.getNumeroTotaleBlocchi(),
						 				 	CONT_numeroOperazioniInAttesaSuFile,CONT_numeroOperazioniCompletate,CONT_numeroOperazioniTotali,numCliqueTrovate,val_i,val_j);
        }
        // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

        //se il nodo puo' essere FAN...
        if (p.getFAN(nodoCorrente)){
        	operazioni op=operazioni(nodoCorrente,&b,&p);
        	if (op.estOperazioneCompleta()){
            nuoveOperazioniCompletate++;

	        	long cl=op.cercaClique(&p);//cerca le clique dell'operazione corrente - se ha senso
  	      	if (cl>0)	numCliqueTrovate+=cl;//se >0 ho trovato nuove cliques
    	    	if ( !op.estOperazioneNulla() ){//se dal calcolo delle clique l'operazione e' stata annullata, non va scritta
								cout<<"Unexpected fatal error 1!!!";
								FINE;
	        	}
          }
  	      //dealloca le strutture dati per l'operazione corrente
	        op.cancella();
        }

      }



//      cout<<"\nOK NUOVI NON PARZIALI\n";







      //----------------------------------------------------------------------------------
      //       								 OPERAZIONI IN ATTESA DAL FILE
      //----------------------------------------------------------------------------------
      long numOperazioniInAttesaBloccoCorrente=infoB.getNumeroOperazioniInAttesa(nBloccoCorrente);
      if (  numOperazioniInAttesaBloccoCorrente >0 ){
 	        bufferedThreadFileInputStream* f=infoB.getFileLetturaOperazione(nBloccoCorrente);
 	        if (f==NULL){
  						cout<<"Unexpected fatal error 2!!!";
 	            FINE;
 	        }
 	
 	        iterazioni=MAX_ITER;
 	
 	        for (long i=0;i<numOperazioniInAttesaBloccoCorrente;i++){
 	           operazioni op=operazioni(f,&b,&p);
 	           CONT_numeroOperazioniInAttesaSuFile--;
 	
 	           long cl=op.cercaClique(&p);//cerca le clique dell'operazione corrente - se ha senso
 	           if (cl>0)
 	           			numCliqueTrovate+=cl;
 	           			 	           			
 	           if ( !op.estOperazioneNulla() ){//se dal calcolo delle clique l'operazione e' stata annullata, non va scritta
 	
 	               //controlla in quale blocco andra' memorizzato questa operazione
 								 long proxBlocco=op.ritornaNumeroBloccoProssimoSalvataggio(&b);
 	               if (  proxBlocco<0 || proxBlocco==nBloccoCorrente  ){cout<<"Unexpected fatal error 3!!!";;FINE;} 	
 	
 	               //aggiungo la nuova operazione
 	               if (infoB.aggiungeOperazione(proxBlocco,&op)<0){cout<<"Unexpected fatal error 4!!!";;FINE;}
 	
 	               //l'operazione resta in attesa 	
 	               CONT_numeroOperazioniInAttesaSuFile++;
 	           }
 	           op.cancella();
 	
 	           //+++++++++++ STAMPA PROGRESSIONE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
             if (++iterazioni>=MAX_ITER/10) {
                iterazioni=0;
                char s[1000];

                sprintf(s,"N. UPDATE:%6ld nodes",i+1);
                long long CONT_numeroOperazioniCompletate=CONT_numeroOperazioniTotali-p.getNumeroFanRimasti();
      			  	indiceProgressione(s,nBloccoCorrente,b.getNumeroTotaleBlocchi(),
						 				 	CONT_numeroOperazioniInAttesaSuFile,CONT_numeroOperazioniCompletate,CONT_numeroOperazioniTotali,numCliqueTrovate,val_i,val_j);
             }
             // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 	
 	        }
 	
 	        //chiude e azzera il file di lettura corrente per il blocco
 	        infoB.chiudiFileLetturaCorrente();
      }
      //----------------------------------------------------------------------------------
      //----------------------------------------------------------------------------------

      /*
      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      break;
      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! AGGIUNTO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      */






      //----------------------------------------------------------------------------------
      //       								 OPERAZIONI NUOVE
      //----------------------------------------------------------------------------------
      //inizio nuove operazioni sui nodi del blocco corrente (se ce ne sono ancora)
      long primoNodoDisponibile=infoB.getPrimoNodoNonAnalizzato(nBloccoCorrente);
      long contaNuoveOperazioni=0;
      iterazioni=MAX_ITER*100;

      //mentre ci sono nodi NUOVI da analizzare in questo blocco e non ha raggiunto in max num di operazioni in attesa
      while (primoNodoDisponibile>=0){

        //analizza un nuovo nodo (se necessario e comunque lo segna come usato)
        infoB.incrementaNuovoNodoAnalizzato(nBloccoCorrente);

        if (p.getFAN(primoNodoDisponibile)){
	        //nuove operazioni considerate
  	      contaNuoveOperazioni++;

	        operazioni op=operazioni(primoNodoDisponibile,&b,&p);

  	      long cl=op.cercaClique(&p);//cerca le clique dell'operazione corrente - se ha senso
    	    if (cl>0)	numCliqueTrovate+=cl;//se >0 ho trovato nuove cliques

        	if ( !op.estOperazioneNulla() ){//se dal calcolo delle clique l'operazione e' stata annullata, non va scritta
      	
            long proxBlocco=op.ritornaNumeroBloccoProssimoSalvataggio(&b);
            if (proxBlocco<0){cout<<"Unexpected fatal error 5!!!";;FINE;}

            //aggiungo la nuova operazione
            if (infoB.aggiungeOperazione(proxBlocco,&op)<0){cout<<"Error in next operation writing !!!!";	FINE;}

            //una nuova operazione in attesa
            CONT_numeroOperazioniInAttesaSuFile++;//l'operazione viene messa in attesa
        	}

        	//dealloca le strutture dati per l'operazione corrente
        	op.cancella();
        }
				
        //conteggia le operazioni in attesa del blocco corrente e conta le operazioni in attesa in totale x tutti i blocchi
        if (CONT_numeroOperazioniInAttesaSuFile>=MAX_NUM_OPERAZIONI_NUOVE_TOTALI)
        		break;//occorre cambiare blocco
        else//prende il successivo
        		primoNodoDisponibile=infoB.getPrimoNodoNonAnalizzato(nBloccoCorrente);
        		

        		
 	      //+++++++++++ STAMPA PROGRESSIONE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if (++iterazioni>=MAX_ITER) {
                iterazioni=0;
                char s[200];
                sprintf(s,"N. QUEUED:%6ld nodes",contaNuoveOperazioni);
                long long CONT_numeroOperazioniCompletate=CONT_numeroOperazioniTotali-p.getNumeroFanRimasti();
      			  	indiceProgressione(s,nBloccoCorrente,b.getNumeroTotaleBlocchi(),
											 	CONT_numeroOperazioniInAttesaSuFile,CONT_numeroOperazioniCompletate,CONT_numeroOperazioniTotali,numCliqueTrovate,val_i,val_j);
        }
        // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



      	//cout<<"OK NUOVI PARZIALI\n";




      }//FINE MENTRE - NUOVI NODI
      //----------------------------------------------------------------------------------
      //----------------------------------------------------------------------------------





      			
  }//MENTRE C'E' ancora da fare........




  //calcolo tempo in sec trascorso
  tempo=time(NULL)-tempo;
  if (tempo<0) tempo=0;
  char msg[100];

  //stampa msg finale
  sprintf(msg,"%ld:%02ld sec (HD %ld:%02ld)",tempo/60,tempo%60,tempoHD/60,tempoHD%60);
  indiceProgressione(msg,b.getNumeroTotaleBlocchi(),b.getNumeroTotaleBlocchi(),
											 	CONT_numeroOperazioniInAttesaSuFile,CONT_numeroOperazioniTotali,CONT_numeroOperazioniTotali,numCliqueTrovate,val_i,val_j);
	cout<<"\n";
  printf("===============================================================================\n");

  //chiude tutti i files se aperti
  infoB.cancella();
  b.cancella();
  p.cancella();

  return numCliqueTrovate;
}



void stampaHelp(int arg,char* argv[]){
  cout<<"This routine measure the number of clique, i.e. the number of bipartite cores, of the input graph. The command line options are as follows:\n";
	cout<<"\n";
  cout<< "Usage: "<<eliminaPath(argv[0])<<" memory nameInputMultifile%d nameTemporaryMultifile%d nameOutputFile {i,j}+\n";
	cout<<"\n";
  cout<<"memory                    memory available (MB)\n";
  cout<<"nameInputMultifile%d      name of the multifile of the input graph (ips format)\n";
  cout<<"nameTemporaryMultifile%d  name of a temporary multifile\n";
  cout<<"nameOutputFile            name of the report file \n";
  cout<<"\n{i,j}+ (one or more) type of bipartite cores to look for; examples are: 3,5 or  3,5 3,6  or  3,5 2,6  3,8.\n";
}






int main(int arg,char* args[]){

  char** argv=args;
  stampaLicenza(arg,argv);
  if (arg<5) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

  char* memory=args[1];
  char info[400];strcpy(info,args[2]);strcat(info,".info");
  char pred[400];strcpy(pred,args[2]);strcat(pred,".pred");
  char succ[400];strcpy(succ,args[2]);strcat(succ,".succ");
  char* temp=args[3];
  char* repFile=args[4];


  if (!estMultiFileName(info))STAMPA_ERRORE_PARAMETRI(argv[0],"INFO multifile name must contain the substring %d");
  if (!estMultiFileName(pred))STAMPA_ERRORE_PARAMETRI(argv[0],"PRED multifile name must contain the substring %d");

  if (!estMultiFileName(succ))STAMPA_ERRORE_PARAMETRI(argv[0],"SUCC multifile name must contain the substring %d");
  if (!estMultiFileName(temp))STAMPA_ERRORE_PARAMETRI(argv[0],"Temp multifile name must contain the substring %d");


  long m=(long) atof(memory)*1024*1024;

  setMemoriaDisponibile(m);
  TEST_MEMORIA;

  //apre file report
  report2 r=report2(info,pred,succ);

  //************************ CONTROLLO FILES DI INPUT ***************************
  if (getTotalSizeMultiFiles(info)<=0)STAMPA_ERRORE_PARAMETRI(argv[0],"The input graph is empty or not correct");
  if (getTotalSizeMultiFiles(pred)<=0)STAMPA_ERRORE_PARAMETRI(argv[0],"The input graph is empty or not correct");
  if (getTotalSizeMultiFiles(succ)<=0)STAMPA_ERRORE_PARAMETRI(argv[0],"The input graph is empty or not correct");

  //calcola la lista i,j
  int minI=0;
  int minJ=0;
  int numCoppie=arg-5;
  long nNodi= (long) (getTotalSizeMultiFiles(info)/(long long)sizeof(infoNodo) );

  long* vetI = new long [numCoppie];
  long* vetJ = new long [numCoppie];
  bool* cliqueNulla = new bool [numCoppie];//mi dice se la clique x quella coppia e' nulla o no (se non ancora calcolata -> non nullo)
  
  for (int cont=0;cont<numCoppie;cont++){

     cliqueNulla[cont]=false;

     char aux[200];
     strcpy(aux,args[cont+5]);
     int lung=strlen(aux);

     char* valI=aux;
     char* valJ=aux+lung;


     //individuo la parte i e j
     for (int h=0;h<lung;h++)
        if ( !isdigit( aux[h] ) ){
        		aux[h]='\0';
        		valJ=aux+h+1;
        		break;
        }

     vetI[cont]=strtol(valI,NULL,10);
     vetJ[cont]=strtol(valJ,NULL,10);

     if (vetI[cont]<2||vetJ[cont]<2){
       cout<<"The "<<cont+1<<"th couple of values i,j is wrong (found: "<<args[cont+5]<<").\n";
       FINE;
     }

     if (vetI[cont]<minI || minI<2 )
        minI = vetI[cont];

     if (vetJ[cont]<minJ || minJ<2 )
        minJ = vetJ[cont];

  }

  long maxIn=50;
  long maxOut=50;

  //inizia calcolo cliques
  FILE* fp=fopen(repFile,"w+");
  if (fp==NULL){
     printf( "Opening error for the file %s.",repFile);
     perror ("");
     FINE;
  }


  fprintf(fp,"\n           CLIQUES CALCULATION ( i,j >=2 )\n\n------------------------------------------\n%10s\t%10s\t%10s\n------------------------------------------\n\n" , "i","j","num");  						
  fflush(fp);

  for ( long i=0; i<numCoppie; i++ ){
     long long numCL=-1;
     long iCorrente=vetI[i];
     long jCorrente=vetJ[i];

     //controlla
     for (int j=0;j<numCoppie;j++)
       if (  (cliqueNulla[j])&&( iCorrente>=vetI[j] )&&( jCorrente>=vetJ[j] ) ){
          numCL=0;//la clique corrente sicuramente vale 0
          break;
       }

     //controlla se la clique va calcolata o e' sicuramente 0
     if (numCL<0){
         numCL=calcolaCliques(vetI[i],vetJ[i],maxIn,maxOut, r,temp);
         //cout<<vetI[i]<<","<<vetJ[i]<<" / calcolato = "<<numCL<<"\n";
     }
     else{
         cout<< "\nCliques searching (i,j) = ("<<vetI[i]<<","<<vetJ[i]<<").\n";
         indiceProgressione(nNodi);
         
         indiceProgressione( (char*)"0:00 sec (HD 0:00)",1,1,0,nNodi,nNodi,0,vetI[i],vetJ[i]);

         printf("\n===============================================================================\n");
     }

     //vede se la configurazione corrente e' nulla o meno
     cliqueNulla[i] = (numCL==0);
     
	   fprintf(fp,"%10ld\t%10ld\t%10lld\n",vetI[i],vetJ[i],numCL);
	   fflush(fp);
  }

  fclose(fp);

  delete[] vetI;vetI=NULL;
  delete[] vetJ;vetJ=NULL;
  delete[] cliqueNulla;cliqueNulla=NULL;

  //cancella il file temporaneo dei bit
  remove(temp);
  EXIT(0);
}

