/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file combinanodi.cpp :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "combinanodi.h"
#include <iostream>

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
combinaNodi::combinaNodi(long numNodi,long nCicli){
   this->numNodi=numNodi;
   this->numCicliTot=nCicli;
   punt=new long [numNodi];
   numCicloCorrente=-1;

   numCicloCorrente=0;
   punt[0]=0;
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
combinaNodi::combinaNodi(const combinaNodi& c){
  //costruttore di copia
//   std::cout<<"copia";

   this->numNodi  = c.numNodi;
   this->numCicliTot = c.numCicliTot;
   this->numCicloCorrente = c.numCicloCorrente;

   this->punt=new long [numNodi];
   for (long i=0;i<numNodi;i++)
     this->punt[i]=c.punt[i];
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
long combinaNodi::aggiungiNuovoCiclo(){
  //se non posso aggiungere un nuovo ciclo ritorno -1
  if (numCicloCorrente>=numCicliTot-1) return -1;

  //set il valore iniziale del nuovo ciclo
  if (numCicloCorrente<0)
  		return -1;
	
	punt[numCicloCorrente+1]=punt[numCicloCorrente]+1;
	numCicloCorrente++;

  return 0;
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
long combinaNodi::prossimaIterazioneCicloCorrente(){

  //non posso aggiungere nulla
  if (numCicloCorrente<0)
  	  return -1;

  //controllo se il valore massimo e' gia' stato raggiunto
  if (punt[numCicloCorrente]>= numNodi-numCicliTot+numCicloCorrente)
      return -1;

  //incremento il ciclo corrente se possibile
  punt[numCicloCorrente]++;
	return 0;
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
long combinaNodi::eliminaCicloCorrente(){
  //non posso eliminare l'ultimo ciclo
  if (numCicloCorrente<0) return -1;

  //elimino l'ultimo ciclo e lascio invariato il resto
  numCicloCorrente--;
	return 0;
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
void combinaNodi::stampa(){
  //set il valore iniziale del nuovo ciclo
  if (numCicloCorrente<0){
  		std::cout<<" (empty) ";
  }

  for (long i=0;i<=numCicloCorrente;i++)
     std::cout<<" "<<punt[i];
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
combinaNodi& combinaNodi::operator=(const combinaNodi& c){
  //assegnazione - prima elimino l'oggetto
  // std::cout<<"cancella(assign)";

   if (punt!=NULL)
     delete[] punt;
   punt=NULL;

   this->numNodi  = c.numNodi;
   this->numCicliTot = c.numCicliTot;
   this->numCicloCorrente = c.numCicloCorrente;

   this->punt=new long [numNodi];
   for (long i=0;i<numNodi;i++)
     this->punt[i]=c.punt[i];

   return *this;
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
long combinaNodi::getValoreUltimoCiclo(){
//ritorna il valore dell'ultimo ciclo
   if (numCicloCorrente<0)return -1;
   return punt[numCicloCorrente];
}


//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
combinaNodi::~combinaNodi(){
  //std::cout<<"cancella";
  if (punt!=NULL)
    delete[] punt;
  punt=NULL;
  numCicloCorrente=-1;
}
