/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file infoBloccoClique.cpp :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "infoBloccoClique.h"
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#define SUFFISSO (".file.%d")


//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
infoBloccoClique::infoBloccoClique(char* multiF, long numeroBlocchiTotali, long nodiPerBlocco, long numTotaleNodi ){

  //init randomiz
  srand(time(NULL));

  //copia valori parametri formali
  this->numeroBlocchiTotali=numeroBlocchiTotali;
  this->nodiPerBlocco=nodiPerBlocco;
  this->numNodiTotali=numTotaleNodi;

  //nomi dei files sia singolo (senza SUFFISSO finale che con...)
  strcpy(multiFileSingoloNumero,multiF);
  strcpy(this->multiFile,multiF);strcat(this->multiFile,SUFFISSO);

  //struttura che memorizza i nodi da analizzare per ogni blocco
  this->nodoNonAnalizzatoPerBlocco  =  new long[numeroBlocchiTotali];
  this->numFilesPerBlocco           =  new long[numeroBlocchiTotali];
  this->maxNodoBlocco 						  =  new long[numeroBlocchiTotali];
  this->numOperazioniNelFile			  =  new long[numeroBlocchiTotali];



  //CREO FILES VUOTI ASSOCIATI AD OGNI BLOCCO
  for (int i=0;i<numeroBlocchiTotali;i++){
    numFilesPerBlocco[i]=1;//1 file per ogni blocco - inizialmente
    char aux[5000];

    //nome del file del tipo tempo%d.file.%d
    sprintf(aux,this->multiFile,i,numFilesPerBlocco[i]-1);//creo i files dei blocchi cancellando quello che gia' c'era se esistenti
    FILE* fp=fopen(aux,"w");
    if (fp==NULL){
        cout<<"Error in the file "<<aux<<": ";printError("");
        FINE;

    }
    fclose(fp);
  }


  //contatore nodi progressivo
  long contCorrente=0;
  for (int i=0;i<numeroBlocchiTotali;i++){
       nodoNonAnalizzatoPerBlocco[i] = contCorrente;
       maxNodoBlocco[i]              = contCorrente+nodiPerBlocco-1;

       if (maxNodoBlocco[i]>=numTotaleNodi)
             maxNodoBlocco[i]=numTotaleNodi-1;//massimo assoluto

       numOperazioniNelFile[i]       = 0;
       contCorrente                  = contCorrente+nodiPerBlocco;   //incrementa del num max di nodi per blocco
  }

  //lettura
  lettura=NULL;
  bloccoInLettura=-1;

  //creazione buffer per la scrittura;
  append=new FILE* [numeroBlocchiTotali];
  for (int i=0;i<numeroBlocchiTotali;i++)
     append[i]=NULL;

  numFileAperti=0;
  cancellato=false;
}






//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
long  infoBloccoClique::estTuttoAnalizzato(){
  for (int i=0;i<numeroBlocchiTotali;i++){
     if (nodoNonAnalizzatoPerBlocco[i]<=maxNodoBlocco[i])
        return false;
     if (numOperazioniNelFile[i]>0)
        return false;
  }

  return true;
}






//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
long  infoBloccoClique::getPrimoNodoNonAnalizzato(long numBlocco){
  if (numBlocco<0 || numBlocco>=numeroBlocchiTotali)
  			return -20;

  if (nodoNonAnalizzatoPerBlocco[numBlocco] > maxNodoBlocco[numBlocco])
  			return -10;//nessun altro nodo disponibile

  if (  nodoNonAnalizzatoPerBlocco[numBlocco]>=this->numNodiTotali)
     return -30;
  			
  return nodoNonAnalizzatoPerBlocco[numBlocco];
}




//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
long  infoBloccoClique::getUltimoNodoBlocco(long numBlocco){
  if (numBlocco<0 || numBlocco>=numeroBlocchiTotali)
  			return -2;
  return maxNodoBlocco[numBlocco];
}




//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
long  infoBloccoClique::incrementaNuovoNodoAnalizzato(long numBlocco){
  if (numBlocco<0 || numBlocco>=numeroBlocchiTotali)
  			return -2;

  if (nodoNonAnalizzatoPerBlocco[numBlocco] > maxNodoBlocco[numBlocco])
  			return -1;

  nodoNonAnalizzatoPerBlocco[numBlocco]++;
  return 0;
}





//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
bufferedThreadFileInputStream*  infoBloccoClique::getFileLetturaOperazione(long numBlocco){
  if (cancellato) return NULL;
  if (numBlocco<0 || numBlocco>=numeroBlocchiTotali) return NULL;

  //se gia' usato x la lettura
  if (lettura!=NULL)  return NULL;

  //controllo se il file e' aperto in scrittura (se si lo chiudo)
  if (append[numBlocco]!=NULL){
     fclose(append[numBlocco]);
     append[numBlocco]=NULL;
     numFileAperti--;
  }


  //multifile per il blocco corrente (nome con %d alla file)
  char aux[5000];

  sprintf(aux,multiFileSingoloNumero,numBlocco);
  strcat(aux,SUFFISSO);

  //apre il file e si appunta il blocco in analisi
  bloccoInLettura=numBlocco;

//  cout<<"lettura del multifile "<<aux<<"\n";

  return (lettura=new bufferedThreadFileInputStream(aux,numFilesPerBlocco[numBlocco],DIM_BUFFER_LETTURA_GENERICA,NUM_BUFFER_LETTURA_GENERICA,true));//apre in lettura
}







//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
long infoBloccoClique::aggiungeOperazione(long numBlocco,operazioni* op){
  if (cancellato) return -1;
  if (numBlocco<0 || numBlocco>=numeroBlocchiTotali) return -1;

  //se il blocco e' gia' aperto in lettura non posso scrivere
  if (bloccoInLettura==numBlocco)
  		return -1;

  //se il file non e' ancora aperto per il blocco specificato
  if (append[numBlocco]==NULL){

    //se non posso aprire altri files, ne chiudo uno esistente
    if (numFileAperti>=MAX_NUM_FILE_APPEND){  //chiudo un FILE casuale
      long pos= rand()%numeroBlocchiTotali;
      while (append[pos]==NULL){
	       	pos= rand()%numeroBlocchiTotali;
      }
      fclose(append[pos]);
      append[pos]=NULL;
    }

    //apre il nuovo file per il blocco corrente

    char aux[5000];
    sprintf(aux,multiFile,numBlocco,numFilesPerBlocco[numBlocco]-1);
//    cout<<"apre in append il file "<<aux<<"\n";
    append[numBlocco]=fopen(aux,"a");
  }



  //scrive sul file
  op->scriveSuFile(append[numBlocco]);

  //se raggiunta la dim massima per il file corrente, passo al file successivo
  if (ftell(append[numBlocco])>=MAX_DIM_OUTPUT){
    //chiude il file
		fclose(append[numBlocco]);
		append[numBlocco]=NULL;
		numFileAperti--;
		numFilesPerBlocco[numBlocco]++;//un file in piu' per questo blocco e ne cancella il contenuto

    char aux[1000];
    sprintf(aux,multiFile,numBlocco,numFilesPerBlocco[numBlocco]-1);
//    cout<<"file del blocco "<<numBlocco<<" pieno. Apre il nuovo file "<<aux<<"\n";
    FILE* f=fopen(aux,"w");
    fclose(f);
  }

  //una operazione in piu' nel file assoc al blocco
  numOperazioniNelFile[numBlocco]++;

  return 0;
}





//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
void infoBloccoClique::chiudiFileLetturaCorrente(){

  if (cancellato) return ;
  if (bloccoInLettura<0 ) return ;
  if (lettura==NULL) return;//non serve, ma non si sa mai

  //cout<<" CLOSE FILE FISICO\n";

  //chiude il file in lettura
  lettura->close();//dovrebbe aver cancellato automaticamente tutti i files associati al blocco
  lettura->cancella();
  delete lettura; lettura=NULL;

  //1 solo file per il blocco corrente
  numFilesPerBlocco[bloccoInLettura]=1;

  //creo un nuovo file vuoto iniziale
  //svuota il file
  char aux[5000];
  sprintf(aux,multiFile,bloccoInLettura,0);
//  cout<<"chiusura files del blocco "<<bloccoInLettura<<". Crea il nuovo file "<<aux<<"\n";
  FILE* f=fopen(aux,"w");
  if (f!=NULL)  fclose(f);

  //azzero il num di operazioni nel file corrente
  numOperazioniNelFile[bloccoInLettura]=0;
  bloccoInLettura=-1;
  lettura=NULL;


}







//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
//<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
void infoBloccoClique::cancella(){
  if (cancellato) return;
  cancellato=true;

  delete[] numOperazioniNelFile;numOperazioniNelFile=NULL;
  delete[] nodoNonAnalizzatoPerBlocco;nodoNonAnalizzatoPerBlocco=NULL;
  delete[] maxNodoBlocco;maxNodoBlocco=NULL;

  for (int i=0;i<numeroBlocchiTotali;i++){
     //chiudo tutti i files
     if (append[i]!=NULL){
       fclose(append[i]);
       append[i]=NULL;
     }

     //elimino i files del blocco corrente
     for (int n_file=0;n_file<numFilesPerBlocco[i];n_file++){
	     char aux[5000];
  	   sprintf(aux,multiFile,i,n_file);
//       cout<<"elimina file "<<aux<<"\n";

    	 remove(aux);
     }
  }

  delete[] append;append=NULL;
  delete[] numFilesPerBlocco;numFilesPerBlocco=NULL;

  bloccoInLettura=-1;

  if (lettura!=NULL){
     lettura->cancella();
     delete lettura;
     lettura=NULL;
  }
}



