/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file infoBloccoClique.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          infoblocco.h  -  description
                             -------------------
    begin                : Wed Mar 6 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef  INFOBLOCCO_H
#define  INFOBLOCCO_H
#include "bloccografo.h"
#include "proprietanodi.h"
#include "operazioni.h"
#include "comuni.h"

/*
Classe che gestisce le info sui singoli blocchi in analisi
come ad esempio il primo nodo da analizzare, il nome 
del file temporaneo delle operazioni e altro. 
E' una struttura tenuta in memoria
*/

class infoBloccoClique {
public: 
	infoBloccoClique( char*multiFile, long numeroBlocchiTotali, long nodiPerBlocco, long numNodiTotali );
	
	//aggiunge l'operazione corrente nel blocco specificato
	long  aggiungeOperazione(long numeroBlocco,operazioni* op);//-1 se errore
	
	//ritorna il file in lettura per il blocco spec. NULL se errore
	bufferedThreadFileInputStream* getFileLetturaOperazione( long numeroBlocco);
	
	//chiude il file in lettura (se aperto) - necessario per fare una nuova richiesta di lettura
	//svuota il file delle operazioni
	void  chiudiFileLetturaCorrente();
	
	//ritorna il numero di operazioni in attesa nel blocco spec
	long  getNumeroOperazioniInAttesa(long numBlocco){return numOperazioniNelFile[numBlocco]; }
	
	//ritorna il numero del primo nodo del blocco corrente disponibile
	long  getPrimoNodoNonAnalizzato(long numBlocco);
	
	//ritorna ultimo nodo del blocco corrente
	long  getUltimoNodoBlocco(long numBlocco);
	
	//specifica che e' stato analizzato l'ultimo nodo libero
	long  incrementaNuovoNodoAnalizzato(long numBlocco);
	
	//cancella la struttura
	void  cancella();

	//controlla se c'e' ancora qualche nodo in attesa o da analizzare	
	long estTuttoAnalizzato();
	
private:
  long numeroBlocchiTotali;
  long nodiPerBlocco;
  long numNodiTotali;

  bufferedThreadFileInputStream* lettura;//file di lettura delle operazioni
  long bloccoInLettura;

  FILE*  *append;//buffer dei file di scrittura
  long * numFilesPerBlocco;//num files per ogni blocco

  long * nodoNonAnalizzatoPerBlocco; //num del succ nodo da trattare per il blocco i-esimo
  long * numOperazioniNelFile;//num operazioni in attesa x i vari blocchi
  long * maxNodoBlocco;//nodo massimo del blocco spec

  char multiFile[5000]; //nomi dei files temporanei (2 %d)
  char multiFileSingoloNumero[5000]; //nomi dei files temporanei (senza .file%d)

  long cancellato;
  long numFileAperti;
};

#endif
