/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file insiemeClique.cpp :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#include "insiemeClique.h"
#include <iostream>
#include <math.h>



insiemeClique::insiemeClique(long dim){
  if (dim<=0){
  		dim=0;
  		punt=NULL;
  		posLibera=0;
  		return;
  }

  maxDim=dim;
  posLibera=0;
  punt=new long[maxDim];
}


insiemeClique::insiemeClique(long* l,long dim){
  if (dim<=0){
  		dim=0;
  		punt=NULL;
  		posLibera=0;
  		return;
  }
	
	maxDim=dim;
  posLibera=0;
  punt=new long[maxDim];
  for (posLibera=0;posLibera<dim;posLibera++)
     punt[posLibera]=l[posLibera];
}


insiemeClique::insiemeClique(const insiemeClique& i){
//qui l'oggetto corrente ancorqa non esiste, quindi non devo cancellare nulla
  maxDim=i.maxDim;
  punt=new long[maxDim];

  //copia array
  for (posLibera=0;posLibera<i.posLibera;posLibera++)
     punt[posLibera]=i.punt[posLibera];
}


insiemeClique& insiemeClique::operator=(const insiemeClique& i){
  //l'oggetto corrente gia' esiste, quindi devo cancellarlo
  if (punt!=NULL)
    delete[] punt;

  maxDim=i.maxDim;
  punt=new long[maxDim];

  //copia array
  for (posLibera=0;posLibera<i.posLibera;posLibera++)
     punt[posLibera]=i.punt[posLibera];

  return *this;
}



void insiemeClique::stampa(){
  for (int i=0;i<posLibera;i++)
    std::cout<<punt[i]<<" ";
}




long insiemeClique::aggiungiInCoda(long elem){
  if (posLibera>=maxDim) return -1;

  punt[posLibera++]=elem;
  return 0;
}


long insiemeClique::minimo(long a,long b){
  if (a<b) return a;
  return b;
}

insiemeClique insiemeClique::intersezioneInsiemiOrdinati(insiemeClique& i1,insiemeClique& i2){
//INSIEMI ORDINATI IN SENSO CRESCENTE !!!!!!!!!!!

  long* l1;
  long* l2;
  long size1=i1.getArray(l1);
  long size2=i2.getArray(l2);

  //contatori
  long pos1=0;
  long pos2=0;


  insiemeClique aux=insiemeClique( minimo(size1,size2) );
  while (pos1<size1 && pos2<size2){
    if (l1[pos1]<l2[pos2])
    		pos1++;
    else if (l1[pos1]>l2[pos2])
    					pos2++;
    		 else{
    		   aux.aggiungiInCoda( l1[pos1] );
    		   pos1++;
    		   pos2++;
    		 }
  }
  return aux;
}




long insiemeClique::getArray(long*& l){
  l=punt;//puntatore al vettore
  return posLibera;//ritorna il num di elementi
}


insiemeClique::~insiemeClique(){
  if(punt==NULL) return;
  delete[]punt;
  punt=NULL;
  maxDim=posLibera=0;
  //std::cout<<" canc ";
}


