/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file insiemecondiviso.cpp :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#include "insiemecondiviso.h"
#include <iostream>
#include <math.h>


insiemeCondiviso::insiemeCondiviso(long* l,long dim){
	maxDim=dim;	
  posLibera=dim;
  punt=l;

  if (maxDim<0) maxDim=0;
  if (posLibera<0) posLibera=0;
}


insiemeCondiviso::insiemeCondiviso(nodoSucc& nodo){
	punt=nodo.getPredecessori(posLibera);
  maxDim=posLibera;

  if (maxDim<0) maxDim=0;
  if (posLibera<0) posLibera=0;
}


insiemeCondiviso::insiemeCondiviso(){
	maxDim=0;
  posLibera=0;
  punt=NULL;
}


void insiemeCondiviso::stampa(){
  //cout<<" DIM "<<maxDim<<"  posLibera "<<posLibera<<"  --   "<<punt<<"   --->   ";
  for (int i=0;i<posLibera;i++)
    cout<<punt[i]<<" ";

}


long insiemeCondiviso::aggiungiInCoda(long elem){
  //controlla se piena
  if (posLibera>=maxDim) return -1;
  punt[posLibera++]=elem;
  return 0;
}


long insiemeCondiviso::minimo(long a,long b){
  if (a<b) return a;
  return b;
}

void insiemeCondiviso::intersezioneInsiemiOrdinati(insiemeCondiviso i1,insiemeCondiviso i2,insiemeCondiviso& ris){
//INSIEMI ORDINATI IN SENSO CRESCENTE !!!!!!!!!!!

  long* l1;
  long* l2;
  long size1=i1.getArray(l1);
  long size2=i2.getArray(l2);

  /*ris.svuota();
  cout<<"INTERSEZIONE\n";fflush(stdout);
  i1.stampa();cout<<" - ";fflush(stdout);
  i2.stampa();cout<<" - ";fflush(stdout);
  ris.aggiungiInCoda(12324);
  ris.stampa();
  cout<<"\n__________________________________\n";fflush(stdout);
  */
  //contatori
  long pos1=0;
  long pos2=0;

  //svuota l'insieme
  ris.svuota();

  //effettua l'intersezione
  while (pos1<size1 && pos2<size2){
    if (l1[pos1]<l2[pos2])
    		pos1++;
    else if (l1[pos1]>l2[pos2])
    					pos2++;
    		 else{
    		   //cout<<" aggiunge "<<l1[pos1]<<"    ";fflush(stdout);
    		   ris.aggiungiInCoda( l1[pos1] );
    		   pos1++;
    		   pos2++;
    		 }
  }

}


long insiemeCondiviso::copiaDaArray(long* p, long l){
   long ris=-1;
   if (l<=maxDim)
      ris=0;

   //copia finche non e' raggiunta la fine dell'array parametro e di quello interno
   for (posLibera=0;posLibera<maxDim;posLibera++){
      if (posLibera>=l)
      		break;//raggiunta la fine dell'array
      punt[posLibera]=p[posLibera];
   }

   return ris;


}

long insiemeCondiviso::getArray(long*& l){
  l=punt;//puntatore al vettore
  return posLibera;//ritorna il num di elementi
}


