/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file insiemecondiviso.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          insiemecondiviso.h  -  description
                             -------------------
    begin                : Mon Mar 4 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INSIEMECONDIVISO_H
#define INSIEMECONDIVISO_H
#include "nodosucc.h"

class insiemeCondiviso {
public:
	insiemeCondiviso(long* l,long dim);    //inserisce per riferimento	
	insiemeCondiviso();						       //set la max dimensione
	insiemeCondiviso(nodoSucc& n);       //crea l'insieme dai predecessori del nodo passato
	
	long aggiungiInCoda(long l);//aggiunge alla fine se possibile (-1 se spazio esaurito)
	long getArray(long*& l);  	//punta all'array interno e ritorna il num di elementi presenti
  static void intersezioneInsiemiOrdinati(insiemeCondiviso i1, insiemeCondiviso i2, insiemeCondiviso& ris);//vale solo se gli insiemi sono ordinati in senso crescente
  void stampa();
  void svuota(){ posLibera=0;}//svuota l'insiemecondiviso
  long copiaDaArray(long* p, long l);//copia dall'array finche' possibile
  long getNumeroElementi(){return posLibera;}

private:
  long posLibera;
  long maxDim;
public:
  long* punt;

  static long minimo(long, long);
};

#endif
