/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file operazioni.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <stdio.h>
#include <iostream>
#include "proprietanodi.h"
#include "bloccografo.h"
#include "nodosucc.h"
#include "insiemecondiviso.h"
#include "combinanodi.h"
#include "comuni.h"

#ifndef OPERAZIONI_H
#define OPERAZIONI_H






// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/*
classe che rappresenta una operazione in attesa, parzialmente eseguita

*/


class operazioni {
	
private:
	long      nodoCorrente;        //nodo FAN che sto analizzando (solo se possibile FAN /altrimenti -1)
	long      numeroSuccessori;    //n. succ validi (ANCORA possibili CENTER)
	nodoSucc* listaNodiSuccessori; //nodi successori (i soli possibili CENTER /altrimenti -1)
  void      setOperazioneNulla();     //trasforma l'operazione corrente in operazione nulla (NESSUN NODO) - deallocando eventuale memoria

  //static long calcolaMassimo(long** l,long numero, long* pos, long* size);
  //static long aggiornaContatore(long massimo,long* l, long& pos,long size);
  //static long calcolaValoreComune(long massimo,long** l,long numero, long* pos, long* size);
  //long intersezioneMulti(long* risultato, long* nodiSelezionati,long numero);

  long numeroSuccessoriDisponibili;//numero di successori non nulli e completi
  long numeroSuccessoriIncompleti;//numero di successori non ancora caricati nell'operazione

public:
	operazioni(bufferedThreadFileInputStream* fp,bloccoGrafo* b,proprietaNodi* p); //legge da file la successiva operazione e aggiorna se possibile
	operazioni(long nodo,bloccoGrafo* b,proprietaNodi* p);//crea una nuova operazione per il nodo corrente - con indicazione della clique (i,j)
	
	void  update(bloccoGrafo* b,proprietaNodi* p);//aggiorna il blocco corrente completando altri successori e settando FAN/CENTER
	void  update(proprietaNodi* p);//aggiorna proprieta' FAN/CENTER
	long  estOperazioneNulla(){return (nodoCorrente<0);}//controlla se la classe contiene o no una operazione corretta
	long estOperazioneCompleta(){return  estOperazioneNulla() || (numeroSuccessoriIncompleti==0) ;}
	
	void  cancella();
	void  scriveSuFile(FILE* fp); //scrive l'operazione nel file specificato
  void  stampa(proprietaNodi* p);

  long  cercaClique(proprietaNodi* p);//l'operazione diventa nulla se ho fatto tutti i controlli
  long  getNodoInAnalisi(){return nodoCorrente;}

  //ritorna il numero di blocco in cui salvare l'operazione
  long ritornaNumeroBloccoProssimoSalvataggio(bloccoGrafo* b  );
};

#endif

