/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file permutazione.cpp :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          permutazione.cpp  -  description
                             -------------------
    begin                : Thu Feb 28 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include<stdio.h>
#include "../common/funzioniGenerali.h"
#include "permutazione.h"


permutazione::permutazione(long n, long k){
  if (n<=0) n=1;
  if (k<=0) k=1;

  this->n    = n;
  this->k    = k;
  this->punt = new long[k];
  this->vecchioPunt = new long[k];
  iniziale=TRUE;
}


long* permutazione::next(){
  if (punt==NULL) return NULL;

  if (iniziale){
     iniziale=FALSE;
     for(int i=0;i<k;i++)
         vecchioPunt[i]=punt[i]=i;
     return punt;
  }
  else{
     long fine=FALSE;
     for (int i=k-1;i>=0;i--){
         //devo garantire che quando aggiungo 1 rispetto a quello corrente , no vado oltre n
         if ( (punt[i]+1+k-i-1 )<n ){ //a dx ho k-i-1 elementi - l'elemento lo incremento di 1 e quelli a dx ancora di 1 ciascuno -
            punt[i]++;
            for (int j=i+1;j<k;j++)
                  punt[j]=punt[i]+(j-i);
            fine=TRUE;
            break;
         }
     }
     if (!fine) return NULL;
     else       return punt;
  }
}


void permutazione::cancella(){
  n=k=0;
  if (punt==0) return;
  delete[] punt;
  punt     = NULL;
  iniziale = TRUE;
}

