/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file proprietanodi.cpp :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/
                                                        
#include "config.h"
#include "proprietanodi.h"

#include <stdlib.h>
#include "clique.h"


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long proprietaNodi::set(unsigned char* val,long nodo,bool bit){
//set a 1 il pos-esimo bit al valore bit nel vettore di numElem caratteri
//nota che sizeof(...) ritorna il num di byte (per ottenere il num di bit va moltiplicato per 8 !!!!!!!!!!!!!!!)

/*

     +----+----+----+----+----+                               |----------------|
     | ...| ...| ...|... |... |       CON UN SINGOLO BYTE --> | 0,1,2,3,4,5,6,7|
     +----+----+----+----+----+         memorizzato cosi'     |----------------|
elem  0                    N-1

*/

  //controllo i vincoli di validit del nodo (tra 0 e max-1)
  if (nodo<0)return -1;
  if (nodo>=numNodi) return -1;

  //individua posizione dell'array da modificare
  long posElem=        nodo / (sizeof(char)*8);//num elemento in cui agire (char)
  long numBitRelativo= 7-nodo % (sizeof(char)*8);//peso bit corrente         (il bit 0 corrisponde a quello di peso 0...)

  //crea la maschera
  unsigned char mask=1;
  //1 solo nel bit di peso numBitRelativo
  mask=mask<<numBitRelativo;

  if (bit){
      val[posElem]=val[posElem]|mask;//set a 1 il bit
  }
  else{
      val[posElem]=val[posElem]&(~mask);//set a 0 il bit
  }

  return 0;
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long proprietaNodi::get(unsigned char* val,long nodo,bool& bit){
//penso ad un array memorizzato da dx a sx
//nota che size of ritorna il num di byte (per ottenere il num di bit va moltiplicato per 8 !!!!!!!!!!!!!!!)

/*
     +----+----+----+----+----+                               |----------------|
     | ...| ...| ...|... |... |       CON UN SINGOLO BYTE --> | 0,1,2,3,4,5,6,7|
     +----+----+----+----+----+         memorizzato cosi'     |----------------|
elem  0                    N-1

*/

  if (nodo<0)return -1;
  if (nodo>=numNodi) return -2;

  //individua posizione dell'array da modificare
  long posElem=        nodo / (sizeof(char)*8);//num elemento in cui agire
  long numBitRelativo= 7- nodo % (sizeof(char)*8);//peso bit corrente

  //selezione del bit significativo
  unsigned char mask=1;
  mask=mask<<numBitRelativo;

  if ( (val[posElem]&(mask))!=0)
     bit = TRUE;//1
  else
	   bit = FALSE;  //0
	
	//OK ..........
	return 0;
}






/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long proprietaNodi::setFAN(long nodo,bool val){
   if (cancellato) return -1;


   // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   //     CALCOLO DEL NUMERO TOT DI CENTER
   // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

   //calcola il prec valore
   bool prec=true;
   get(fan,nodo,prec);

   //e vedo se viene cambiato
   if (prec&&!val){// 1 --> 0
    	numFanRimasti--;
    	if ( set(fan,nodo,val)<0){cout<<"Node "<<nodo<<" not preset in the graph (set FAN)";  return -1;FINE;}
   }
   else
  	 if (!prec&&val){// 0 --> 1
 			 numFanRimasti++;
 			 if ( set(fan,nodo,val)<0){cout<<"Node "<<nodo<<" not preset in the graph (set FAN)"; return -1;FINE;}
     }
     return 0;//sempre ok
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long proprietaNodi::setCENTER(long nodo,bool val){
   if (cancellato) return -1;


   // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   //     CALCOLO DEL NUMERO TOT DI CENTER
   // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

   //calcola il prec valore
   bool prec;
   get(center,nodo,prec);

   //e vedo se viene cambiato
   if (prec&&!val){// 1 --> 0
    	numCenterRimasti--;
    	if ( set(center,nodo,val)<0){cout<<"Node "<<nodo<<" not preset in the graph (set CENTER)"; return -1;FINE;}
   }
   else
  	 if (!prec&&val){// 0 --> 1
 			 numCenterRimasti++;
 			 if ( set(center,nodo,val)<0){cout<<"Node "<<nodo<<" not preset in the graph (set CENTER)";;return -1; FINE;}
     }
     return 0;//sempre ok

}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long proprietaNodi::getCENTER(long nodo){
   if (cancellato) return -1;

   bool bit;
   if ( get(center,nodo,bit)<0){
      cout<<"Node "<<nodo<<" is not present in graph (get CENTER) \n";
      return false;
      FINE;
   }
   return bit;//ritorna il valore del bit
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long proprietaNodi::getFAN(long nodo){
   if (cancellato) return -1;
   bool bit;
   int i;
   if ( (i=get(fan,nodo,bit))<0){
       cout<<"Node "<<nodo<<" is not present in graph (get FAN) \n";
      return false;
      FINE;
   }
   return bit;//ritorna il valore del bit
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
proprietaNodi::proprietaNodi(

  report2 r,
	long _minInDeg,long _minOutDeg,  //min indeg e outdeg per essere possibili center e fan (-1 per saltare il controllo)
 	char* nomeFileBit){

//NOTA: dalla lettura non vengono fatti controlli sul minimo in/out degree... QUESTO VUOL DIRE CHE SARANNO
// LE VARIE OPERAZIONI AD OCCUPARSI DI QUESTO........ 	IN QUESTO MODO SI RISPARMIA UNA SCANSIONE DEL GRAFO....

 	 	
 	FILE* fp=fopen(nomeFileBit,"r");
 	if (fp==NULL){
 	  printError("Error in fopen function (bit file)");
 	  FINE;
 	}
 	
 	fan=center=NULL;
 	
 	//leggo le info varie
 	fread(&this->numNodi,sizeof(long),1,fp);
 	fread(&this->maxInDeg,sizeof(long),1,fp);
 	fread(&this->maxOutDeg,sizeof(long),1,fp);
 	fread(&this->numFanRimasti,sizeof(long),1,fp);
 	fread(&this->numCenterRimasti,sizeof(long),1,fp);

 	
 	//calcolo dimensione salvata 	
  long inc=0;
  if (  numNodi%(8*sizeof(char)) !=0) inc=1;
  long dimensione=numNodi/(sizeof(char)*8)+inc;
 	
  //allocazione delle strutture dati
  this->fan=new unsigned char[dimensione];
  this->center=new unsigned char[dimensione];

  //lettura buffer
  fread(this->fan,sizeof(unsigned char),dimensione,fp);
  fread(this->center,sizeof(unsigned char),dimensione,fp);

  this->minInDeg=_minInDeg;
  this->minOutDeg=_minOutDeg;
  this->cancellato=false;
   	
 	fclose(fp);
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void proprietaNodi::scriveSuFile(char* nomeFileBit){
 	
 	FILE* fp=fopen(nomeFileBit,"w");
 	if (fp==NULL){
 	  printError("Error in fopen function (bit file)");
 	  FINE;
 	}
 	 	
 	//scrivo le info varie
 	fwrite(&this->numNodi,sizeof(long),1,fp);
 	fwrite(&this->maxInDeg,sizeof(long),1,fp);
 	fwrite(&this->maxOutDeg,sizeof(long),1,fp);
 	fwrite(&this->numFanRimasti,sizeof(long),1,fp);
 	fwrite(&this->numCenterRimasti,sizeof(long),1,fp);
 	
 	//calcolo dimensione salvata 	
  long inc=0;
  if (  numNodi%(8*sizeof(char)) !=0) inc=1;
  long dimensione=numNodi/(sizeof(char)*8)+inc;
 	
  //scrittura buffer
  fwrite(this->fan,sizeof(unsigned char),dimensione,fp);
  fwrite(this->center,sizeof(unsigned char),dimensione,fp);
   	
 	fclose(fp);
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
proprietaNodi::proprietaNodi(
  report2 r,
	long _minInDeg,long _minOutDeg,  //min indeg e outdeg per essere possibili center e fan (-1 per saltare il controllo)
	long _maxInDeg, long _maxOutDeg  //max indeg e outdeg per essere possibili center e fan (-1 per saltare il controllo)
	){

	numFanRimasti=numCenterRimasti=r.getNumNodiTotali();
	
	//variabili per contenere le info sui files
	char nomeFilesInfo[1000]; long numFilesInfo; //nome e numero dei files contententi le info sui nodi (formato noto)

  //set dei valori limite per fan/center
  this->minInDeg  = _minInDeg;
  this->minOutDeg = _minOutDeg;
  this->maxInDeg  = _maxInDeg;

  this->maxOutDeg = _maxOutDeg;

  numFanRimasti=r.getNumNodiTotali();
  numCenterRimasti=r.getNumNodiTotali();

	//se non va considerato il valore max, metto un valore molto grande
  if (maxInDeg<0)     maxInDeg  = 2000000000;
  if (maxOutDeg<0)    maxOutDeg = 2000000000;

  numFilesInfo=r.getNomeAndNumFilesInfo(nomeFilesInfo);
  numNodi=r.getNumNodiTotali();
  cancellato=FALSE;

  //calcolo dimensione (in byte) del buffer di bit associato ad ogni nodo
  //ogni 8 nodi alloco 1 byte...
  long inc=0;
  if (  numNodi%(8*sizeof(char)) !=0) inc=1;
  long dimensione=numNodi/(sizeof(char)*8)+inc;

  //allocazione delle strutture dati
  fan=new unsigned char[dimensione];
  center=new unsigned char[dimensione];

  //controllo dei nodi come fan/center
  if ( minInDeg<0 && minOutDeg<0 && maxInDeg<0 && maxOutDeg<0){
     for (int i=0;i<dimensione;i++)
       fan[i]=center[i]=0xFF;//tutto true - cioe' tutti i nodi sono possibili fan/center
  }
  else{
     bufferedThreadFileInputStream* info=new bufferedThreadFileInputStream(nomeFilesInfo,numFilesInfo,DIM_BUFFER_LETTURA_GENERICA,NUM_BUFFER_LETTURA_GENERICA );

     //var che legge le info sui nodi
     infoNodo g;
     long long iterazioni=MAX_ITER+1;
     long nodoCorrente=-1;
     long nodiLetti=0;
     //cout<<" Ciao!!!!!!!!!!\n";
     //leggo tutti i nodi (indeg e outdeg)
     while (info->read(&g,sizeof(g),1 )>0 ){

         //ho letto un altro nodo e passo al nodo corrente(parto da 0)
         nodoCorrente++;
         nodiLetti++;

         if (nodiLetti>numNodi){
            break; //ERROREEEEEEEEE
         }

         //controlla la validit come center (inDegree)
         if (g.inDeg>=minInDeg && g.inDeg<=maxInDeg){
            set(center,nodoCorrente,TRUE);
         }
         else{
            set(center,nodoCorrente,FALSE);
            numCenterRimasti--;
         }

         //controlla la validit come center (inDegree)
         if (g.outDeg>=minOutDeg && g.outDeg<=maxOutDeg){
            set(fan,nodoCorrente,TRUE);
         }
         else{
            set(fan,nodoCorrente,FALSE);
            numFanRimasti--;
         }

         if (++iterazioni>=MAX_ITER) {
             iterazioni=0;
             char cc[200];
             sprintf(cc," pruning (%ld=<in<=%ld,%ld<=out<=%ld)",_minInDeg,_maxInDeg,  _minOutDeg, _maxOutDeg);
             indiceProgressione(cc,
           		 (long)(100.0*nodoCorrente/numNodi),
           		 (long)(100.0*nodoCorrente/numNodi)
           		 );
         }

     }

     char cc[200];
     sprintf(cc," pruning (%ld=<in<=%ld,%ld<=out<=%ld)",_minInDeg,_maxInDeg,  _minOutDeg, _maxOutDeg);
     indiceProgressione(cc,
           		 100,
           		 100);

     info->close();
     info->cancella();
  }

}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//dealloca la struttura
void proprietaNodi::cancella(){
  if (cancellato) return;
  delete[] center;
  delete[] fan;
  cancellato=TRUE;
}
