/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file proprietanodi.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "comuni.h"
#include "config.h"
#include <stdio.h>
#include <iostream>

#ifndef PROPRIETANODI_H
#define PROPRIETANODI_H


/*
questa classe contiene le propriet di fan/center
associata ad ogni nodo (2 bit per nodo)
Tutta la classe e' tenuta in memoria RAM !!!!!!!

			(NECESSARIAMENTE !!!!!!!!)

*/

class proprietaNodi {

private:
   bool cancellato;
   long numNodi;
   long numFanRimasti;
   long numCenterRimasti;

   unsigned char* center;//array di bit per la proprieta' di center
   unsigned char* fan;   //array di bit per la proprieta' di fan

public:

   //NON MODIFICARE !!!!!!!!!!!!!!!!!!!!
   long minInDeg;
   long minOutDeg;
   long maxInDeg;
   long maxOutDeg;

public:
   //NOTA: MinOutDeg==j   MinInDeg==i
	 proprietaNodi(report2 r, long minInDeg,long MinOutDeg,long maxInDeg, long MaxOutDeg);//da 0 a max-1
	 proprietaNodi( report2 r,	long _minInDeg,long _minOutDeg,char* nomeFileBit);
	
	 //scrive su file
	 void scriveSuFile(char* nomeFileBit);
	
	 //set il valore del nodo specificato al valore di verit specificato (-1 se errore)
	 long setFAN   (long nodo,bool value);
	 long setCENTER(long nodo,bool value);
	
	 //ritorna il valore di verit associato al nodo specificato
	 long getFAN   (long nodo);
	 long getCENTER(long nodo);	
	
	 void cancella();//dealloca la struttura
	 long getNumNodi(){return numNodi;}//ritorna il num di nodi
	
	 long getValoreI(){return minInDeg; }//nfan
	 long getValoreJ(){return minOutDeg;}//n center
	
	 long getNumeroFanRimasti(){return numFanRimasti;}
	 long getNumeroCenterRimasti(){return numCenterRimasti;}
	
private:
   //funzioni per accedere al bit associato ad ogni nodo
   long set(unsigned char* val,long nodo,bool bit);
   long get(unsigned char* val,long nodo,bool& bit);

};

#endif
