/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file binvector.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#include <stdio.h>
//#include <iostream.h>
#include <iostream>


#ifndef BINVECTOR_H
#define BINVECTOR_H


/**
  *@author root
  */

class binVector {
private:
   bool cancellato;
   long numElementi;
   long numElementiZero;
   long sizeBuffer;//size del buffer in char

   unsigned char* val;//array di bit per la proprieta'

public:
	binVector(long numElem);//crea un vettore binario inizializzato a 0
	void cancella();
  void set(long nodo,bool bit, long&errore);
  bool get(long nodo,long& errore);
  long getNumZero(){return numElementiZero;}
  long getNumUno(){return (numElementi-numElementiZero);}
  long getNumElem(){return numElementi;}
  void reset();//inizializza a 0

  //on error the parameter "errore" is equals to -1

};

#endif
