/*

*********************************************************************
*********************************************************************

  file binVector.h : common functions and classes of all graph utilities

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/


#include <stdio.h>
#include "streamFiles/multiFile.h"
#ifndef binVectorFile_DEF
#define binVectorFile_DEF

//num bytes da tenere x ogni buffer

class binVectorFile{
  private:
    multiFile f;
    
    bool chiuso;
    char* buffer;
    long sizeBuffer;//size massima del buffer

    long long primoBitBuffer_LL;//primo bit nel buffer
    long numBitBuffer;  //num bits nel buffer
    bool updateBuffer;  //true se il buffer stato modificato
    long long numBits_LL;//num bits totali

  private:
    void setVettore(char* buffer, long pos,bool bitValue);//funzione set direttamente su vettore in ram
    bool getVettore(char* buffer, long pos);//funzione get direttamente su vettore in ram
    void flushBuffer();//scrive il buffer su file se modificato
    void caricaNuovoBufferSeNecessario(long long pos);//controlla se  necessario caricare un nuovo buffer
    
  public:
    binVectorFile(char* multiFileName, long maxDimMultifile, long long numBits, bool initialValue);
    bool set(long long pos, bool val);
    bool get(long long pos, bool& val);
    void close();//chiude il vector e cancella il file temporaneo
    long long getNumberOfBits(){return numBits_LL;}
} ;
#endif

