/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file externalSort.cc :source code of externalsort utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//-----------------------------------------------------------------------------------------------------------
// revisione 24 nov 2001
//-----------------------------------------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <wait.h>
#include <unistd.h>
//#include "comuni.h"

#include "../coda.h"
#include "../funzioniGenerali.h"

#include "../streamFiles/multiFileReader.h"
#include "../streamFiles/multiFileWriter.h"
#include "../streamFiles/bufferedThreadFileOutputStream.h"
#include "../streamFiles/bufferedThreadFileInputStream.h"
#include "../labelInfoNodeScc.h"
#include "../infoNodeScc.h"

// AG_CHANGE added for compiling #define DIM_FILES_THREAD
#include "../../utl_succ2edges/config.h"
//

#include "ordina.h"
#include "infoBlocco.h"
//#include "config.h"
#include "../arco.h"
#include "externalSort.h"


#ifndef EXTERNALSORT_001
#define EXTERNALSORT_001



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaMbyteCorrenti(char* s,long long byte){
  /*======================== STAMPA MESSAGGI ===================================================================*/
  cout<<(char)13<<s<<"["<<byte/1048576<<"MB]";
  fflush(stdout);
  /*============================================================================================================*/
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaMbyteCorrenti(char* s,long long byte,long long totale){
  /*======================== STAMPA MESSAGGI ===================================================================*/
  cout<<(char)13<<s<<"["<<byte/1048576<<"/"<<totale/1048576<<" MB]";
  fflush(stdout);
  /*============================================================================================================*/
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaPercentuale(char* s,long long fatti,long long totale){
  /*======================== STAMPA MESSAGGI ===================================================================*/
  double perc=( (double)100.0)*(fatti)/totale;
  printf("%c%s [%3.1f%s]",13,s,perc,"%");
  fflush(stdout);
  /*============================================================================================================*/
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaPercentuale(char* s,long long fatti,long long totale,long numthread){
  /*======================== STAMPA MESSAGGI ===================================================================*/
  double perc= (double)100.0*fatti/totale;
  printf("%c%s [%3.1f%s - %ld threads] (%lld completed)",13,s,perc,"%",numthread,fatti);
  fflush(stdout);
  /*============================================================================================================*/
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long max(long a,long b){
  if (a>b) return a;
  return b;
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampa(char* titolo,long* v,long inizio,long fine){
     printf("%s\n",titolo);
     for (long i=inizio;i<=fine;i++)
       printf("%ld  ",v[i]);
     printf("\n");

}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
  void scambia(T& a, T& b){
    T aux=a;
    a=b;
    b=aux;
  }




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//          associato al quick sort
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

template <class T>
  long partition(T* szArray,long nLower, long nUpper){
// Pivot with first element

    long nLeft = nLower + 1;
    T szPivot = szArray[nLower];
    long nRight = nUpper;

    // Partition array elements
    T szSwap;//var di appoggio per lo scambio
    while (nLeft <= nRight)
    {
        // Find item out of place
        bool finito=false;
        while (nLeft <= nRight && !finito)
            if (szArray[nLeft]<=szPivot)	nLeft = nLeft + 1;

            else                        	finito=true;


        finito=false;
        while (nLeft <= nRight && !finito){
            if (szArray[nRight]> szPivot)
            		nRight = nRight - 1;
            else
            		finito=true;
        }

        // Swap values if necessary
        if (nLeft < nRight)
        {
            szSwap = szArray[nLeft];
            szArray[nLeft] = szArray[nRight];
            szArray[nRight] = szSwap;
            nLeft = nLeft + 1;
            nRight = nRight - 1;
        }
    }

    // Move pivot element
    szSwap = szArray[nLower];
    szArray[nLower] = szArray[nRight];
    szArray[nRight] = szSwap;
    return nRight;

  }




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//                           ordina il vettore di elementi di tipo T
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
  //ordina il vettore da inizio a fine ESTREMI COMPRESI
  void quickSort2(T* v,long inizio,long fine){


    if (fine>inizio){
      long nSplit=partition(v,inizio,fine);

      /*----------OTTIMIZZA ----------*/
      long ordinato=TRUE;
      for (long i=inizio;(i<fine)&&(ordinato);i++)
          ordinato= v[i]<=v[i+1];
      if (ordinato) return; //se gia' ordinato salto il processo
      /*------------------------------*/

      quickSort2(v,inizio,nSplit-1);
      quickSort2(v,nSplit+1,fine);
    }
  }




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//                           ordina il vettore di elementi di tipo T usando il merge sort
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
  //ordina il vettore da inizio a fine ESTREMI COMPRESI
  void mergeSort(T* v,long inizio,long fine, T* buffer){
    if (inizio<fine){

        /*----------OTTIMIZZA ----------*/
        long ordinato=TRUE;
        for (long i=inizio;(i<fine)&&(ordinato);i++)
          ordinato= v[i]<=v[i+1];
        if (ordinato) return; //se gia' ordinato salto il processo
        /*------------------------------*/


        long medio=(inizio+fine)/2 ;
        mergeSort(v,inizio,medio,buffer);
        mergeSort(v,medio+1,fine,buffer);

        long i=inizio;//primo elem da analizzare del buffer 1
        long j=medio+1;//primo elem da analizzare del buffer 2

        long pos=0;//primo elem vuoto del buffer d'appoggio


        while (i<=medio && j<=fine){
          if (v[i]<v[j]) buffer[pos++]=v[i++];
          else		       buffer[pos++]=v[j++];
        }

        for ( /**/ ;i<=medio;i++)
           buffer[pos++]=v[i];

        for ( /**/ ;j<=fine;j++)
           buffer[pos++]=v[j];

        //pos ora indica il num totale degli elementi ( fine-inizio+1 )
        if (pos!=fine-inizio+1){
          cout<<"MERGE :error pos"<<pos<<" calc"<<fine-inizio+1<<"\n";
          FINE;

        }

        //copia dal buffer al vettore
        memcpy(v+inizio,buffer,(pos)*sizeof(T));

        //copia dal buffer
        //for (int i=0;i<pos;i++){
        //   if (v[inizio+i]!=buffer[i]){cout<<"NOOOOOOOO";FINE}

        //}
    }

  }













/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//          permette il passaggio dei parametrio al thread per l'ordinamento in memoria centrale
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

//usata per passare i parametri alla funzione di ordinamento in modo concorrenziale
template <class T>
struct parametriQsort{

    T* buffer;// puntatore al vettore da ordinare
    long inizio; // da dove iniziare
    long fine;   // fino a dove
};







/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//     avvia il processo di ordinamento...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
void* avviaThreadOrdinamentoQuickSort(void* param){

    //puntatore alla struttura dinamica...
    parametriQsort<T>* p=(parametriQsort<T>*)param;

    //eseguo il sorting
    //cout<<"ordina da "<<p->inizio<<" a "<<p->fine<<"\n";

    quickSort2(p->buffer,p->inizio,p->fine);//<<<<<< FORSE GENERA UN GRAVE ERRORE !!!!!!

    //libero memoria come indicato alla chiamata
    delete p;p=NULL;

    return NULL;
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//struttura nece ssaria per la gestione del merge
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
class info{
 public:
   T elem;//elemento
   long nBuffer;//n buffer
   info(T e,long pos){elem=e;nBuffer=pos;}
   info(){;nBuffer=-1;}
   bool operator<(info& e){return this->elem<e.elem;}
   bool operator<=(info& e){return this->elem<=e.elem;}
   bool operator>(info& e){return this->elem>e.elem;}
   bool operator>=(info& e){return this->elem>=e.elem;}
   bool operator==(info& e){return this->elem==e.elem;}
};










/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//   prende i vari buffer ordinati e li fonde insieme e li salva in un file associato al blocco corrente
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
long long merge(T** listaBuffer,long* size,  //sono i vari buffer ciascuno con il n di elementi che contiene
			long numBufferUsati,//n buffer totali
			//long dimensioneOutBufferPerMerge, //dim del buffer d'appoggio di out in byte poi riconvertito internamente per contenere un nintero di elementi
			bufferedThreadFileOutputStream* fp,long numeroBloccoCorrente,
      long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,//dimensione buffer di scrittura file
      bool printScreen//true is print screen enabled       
      ){

	
	//conta il numero totale di byte da scrivere

	long long totaleByteDaScrivere=0;
  for (long i=0;i<numBufferUsati;i++){
			totaleByteDaScrivere+=size[i]*sizeof(T);
  }

//  cout<<"BYTE TOT DA FONDERE: "<<totaleByteDaScrivere<<"\n";
	
  			
  char buffer[1024];
  if (printScreen) printf("%c                                                                            ",13);
  if (printScreen) sprintf(buffer,"block %3ld: writing ",numeroBloccoCorrente);

  //struttura che tiene ordinati gli inizi dei vari buffer
  ordina< info<T> > valori=ordina< info<T> >();

  //array che indica la posizione corrente nei vari buffer
  long* pos =new long [numBufferUsati];
  check(pos);
  for (long i=0;i<numBufferUsati;i++){
      pos[i]=0;//punt del buffer in posizione relativa i
  }

  //inizializzo la lista degli elementi con i primi lementi dei vari buffer
  for (long i=0;i<numBufferUsati;i++){
    if (pos[i]<size[i]){
       info<T> ii=info<T>(listaBuffer[i][pos[i]] ,i);

       valori.addElement(ii);//aggiunge un nuovo elemento
       pos[i]++;
    }
  }

  //dimensioni del buffer di output espresse in archi
  long dimensione=param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT/sizeof(T)+1; //conversione in num di elementi

  //buffer di output - con dimensione ora trasformata in narchi
  T* bufferAusiliario=new T [dimensione];
  check(bufferAusiliario);

  //archi scritti fino ad ora
  long long archiScritti=0;
  long long iterazioni=MAX_ITER_EXTERNALSORT+1;
  long outCorrente=0;

  //ordino
  while (valori.getSize()>0){
    //un nuovo arco scritto
    archiScritti++;

    if (iterazioni++>MAX_ITER_EXTERNALSORT){
      iterazioni=0;
      if (printScreen) stampaMbyteCorrenti(buffer,archiScritti*sizeof(T),totaleByteDaScrivere );
    }


    info<T> minimo = valori.getMin();//primo valore (minimo)
    long nBuf=minimo.nBuffer;//nbuffer corrente

    //inserisco un nuovo elemento se presente
    if (pos[nBuf]<size[nBuf]){
       valori.addElement( info<T>(listaBuffer[nBuf][pos[nBuf]],nBuf) );
       pos[nBuf]++;
    }

    //elemento minimo
    T min=minimo.elem;


    //se il buffer di output e' pieno lo scrivo su disco
    if (outCorrente==dimensione){
        fp->write(bufferAusiliario,sizeof(T),outCorrente);
        outCorrente=0;
    }

    //copia il valore minimo sul buffer
    bufferAusiliario[outCorrente++]=min;
  }


    //controlla che la dim del blocco corrisponda a quella prevista
  if (archiScritti*sizeof(T)!=totaleByteDaScrivere){
    cout<<"Unexpected fatal error in function Merge: 1\n";
    FINE;
  }


  if (outCorrente>0){//scrivo la parte finale del buffer se c'e'
      fp->write(bufferAusiliario,sizeof(T),outCorrente);
      outCorrente=0;
  }

  delete[] bufferAusiliario;bufferAusiliario=NULL;//buffer ausiliario di scrittura

  //ritorna i byte scritti nel blocco

  if (printScreen) stampaMbyteCorrenti(buffer,archiScritti*sizeof(T),archiScritti*sizeof(T));
  return archiScritti*sizeof(T);
}






/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//     controlla se il file e' ordinato
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
bool estFileOrdinato(
  char* prototipoInputFiles,long numeroInputFiles,long long totaleByteDaLeggere,
  bool printScreen//true is print screen enabled       
  ){
  //apre il file di input
  bufferedThreadFileInputStream fp=bufferedThreadFileInputStream(prototipoInputFiles,numeroInputFiles,DIM_FILES_THREAD,NUM_FILES_THREAD,FALSE);
  long long conta=0;
  long long iterazioni=MAX_ITER;

  T buf;
  T prec;


  while (fp.read(&buf,sizeof(T),1)>0){
    if (conta>0)
       if (prec>buf){
          fp.close();

          fp.cancella();
          return false;
       }
    conta++;

    if (iterazioni++>MAX_ITER){
      iterazioni=0;
      if (printScreen) stampaMbyteCorrenti("Sorting check ",conta*sizeof(T),totaleByteDaLeggere );
    }

    prec=buf;
  }

  if (printScreen) stampaMbyteCorrenti("Sorting check ",totaleByteDaLeggere,totaleByteDaLeggere );

  fp.close();
  fp.cancella();
  return true;
}






















/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//     a partire dal file crea tanti files ordinati di dimensione numBlocchi*sizeof(T)*numeroBuffer ordinati
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
void creaBlocchiOrdinatiDaFile(
//a partire dal file crea tanti files ordinati di dimensione numBlocchi*sizeof(T)*numeroBuffer

      //elenco dei files creati per ogni blocco
      coda<infoBlocco>& blocchiScritti,

      //regola per la lettura dei files di input
      char* prototipoInputFiles,long numeroInputFiles,long cancellaFileLettura,

      //regola per creare i nomi dei vari blocchi di files e dimensioni per il thread di scrittura
      char* prototipoNomeFilesBlocchi,

      long param_RAM,//dim memoria totale disponibile da utilizzare
      long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 10)
      long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 128*1024);
      long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la scrittura nel file di output del merge (consigliato 50000*sizeof(long long))
      long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
      bool printScreen//true is print screen enabled       
      )//dim in byte poi riconvertite in archi

  {/*---------------------INIZIO --------------------*/



  //calcolo ram disponibile per i soli buffer ordinati
  long memoriaDisponibileBufferOrdinati=param_RAM-param_DIM_BUFFER_THREAD_IO_EXTERNALSORT* param_NUM_BUFFER_THREAD_IO_EXTERNALSORT*2-/*uno x il file di input e uno x quello di output*/
                                        param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT;

  //dimensioni dei buffer RAM UTENTE usati per il merge
  long numeroBuffer      = param_MAX_NUM_THREAD_QSORT_EXTERNALSORT;//NUM_BUFFER_CREAZIONE_BLOCCHI_EXTERNALSORT;
  long numArchiPerBuffer = ( memoriaDisponibileBufferOrdinati / (numeroBuffer+1) )/sizeof(T);

  //un buffer serve d'appoggio
  //cout<<"CIAOOOO";

  if ( numArchiPerBuffer<=0 || numeroBuffer<=0 || memoriaDisponibileBufferOrdinati<=1000){
     cout<<"Memory not enough";
     FINE
  }

  //buffer d'appoggio
  T* bufferAppoggio=new T [numArchiPerBuffer];

  //USO:  numeroBuffer*dimensioneBufferInByte per la bufferizzazione
  if (printScreen) printf("Running: elements partition...\n");

  // def di alcune strutture di gestione buffer
  T**  listaBuffer;     //puntatori ai vari buffer
  long*   size;         //n di archi contenuti nel buffer i-esimo

  //creo le strutture per gestire i buffer
  check(listaBuffer=new T* [numeroBuffer]);     //puntatori ai vari buffer
  check(size=new long [numeroBuffer]);          //array delle size dei vari blocchi

  // Allocazione dei vari buffer
  for (long i=0;i<numeroBuffer;i++){

    check(listaBuffer[i]=new T [numArchiPerBuffer]);//alloco dimensioneBuffer byte
    size[i]=0;//blocco vuoto
  }

  long fileFinito=FALSE;
  long numBufferUsati=0;//n buffer gia' usati
  long i=0;
  long numeroBloccoCorrente=0;
  char prototipoBloccoCorrente[N];

  //file di output che si sta correntemente creando
  bufferedThreadFileOutputStream* fout =NULL;
  long numFileOutScrittiBloccoCorrente;//num file creati nel blocco corrente
  long numBloccoScritto=0;
  char buffer[1024];

  numBufferUsati=0;
  long bufferOrdinati=0;//n buffer effettivemente ordinati


  //stampa iniziale degli indicatori

  #define NO_THREAD_QSORT_EXTERNALSORT
  sprintf(buffer,"block %3d: sorting ",0);
  #ifdef NO_THREAD_QSORT_EXTERNALSORT
    if (printScreen) stampaPercentuale(buffer,0,numeroBuffer);
  #else
    if (printScreen) stampaPercentuale(buffer,0,numeroBuffer,0);
  #endif

  //apre il file di input
  bufferedThreadFileInputStream fp=bufferedThreadFileInputStream(prototipoInputFiles,numeroInputFiles,param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,cancellaFileLettura);

  //coda dei tid dei thread attivi
  coda<pthread_t> codaTid= coda<pthread_t>();

  do{
    sprintf(buffer,"block %3ld: sorting ",numeroBloccoCorrente);
    i=0;//n buffer corrente in lettura
    numBufferUsati=0;//quanti buffer sono stati usati
    bufferOrdinati=0;
    /*leggo i vari buffer dal disco associati tutti allo stesso blocco*/
    do{
        size[i]=fp.read(listaBuffer[i],sizeof(T),numArchiPerBuffer);///sizeof(T);
        #ifdef DEBUG_SORT
        if (printScreen) printf("OK - edges %d - byte %d\n",size[i],size[i]*sizeof(T));
        #endif

        if (size[i]<numArchiPerBuffer){
            if (size[i]==0){//se vuoto
              numBufferUsati--;//questo ultimo buffer non e' stato usato
            }

            fileFinito=TRUE;
        }

        #ifdef DEBUG_SORT
        if (printScreen) printf("sorting buffer %d ...",i);fflush(stdout);
        #endif



        #ifdef NO_THREAD_QSORT_EXTERNALSORT
        mergeSort(listaBuffer[i],0,size[i]-1,bufferAppoggio);
        #else
				/*------------------------------------------------------------------------------------------------------------------------*/
        //XXXXXXXXXXXXX ASPETTO UN THREAD SE SONO TROPPI IN ESECUZIONE XXXXXXXXXXXXXXXXXXXXXXXXXXXX

        //troppi thread attivi...occorre aspettare che termini qualcuno
        if (codaTid.getSize()>=MAX_NUM_THREAD_QSORT_EXTERNALSORT ){
           pthread_t tidFiglio;

					 //prende il primo thread e aspetta che termini
           codaTid.getFirst(tidFiglio);

          long status;
          //attende che il processo figlio termini
           if (pthread_join(tidFiglio,NULL)!=0){
               fprintf(stderr,"System call error in function wait_thread %d",tidFiglio);
               printError("");
               FINE;
           }

           bufferOrdinati++;
        }


        //XXXXXXXXXXXXX AVVIO NUOVO THREAD XXXXXXXXXXXXXXXXXXXXXXXXXXXX

        //alloco memoria per i parametri (verranno deallocate nella funzione)
        parametriQsort<T>* param=new parametriQsort<T>;

        param->buffer=listaBuffer[i];
        param->inizio=0;
        param->fine=size[i]-1;

        pthread_t tidFiglio;
        //avvia il nuovo thread figlio e ritorna
        //equivale ad eseguire avviaThreadOrdinamentoQuickSort(/*listaBuffer[i],0,size[i]-1*/param);

        if ( pthread_create(  &tidFiglio,NULL,avviaThreadOrdinamentoQuickSort<T>,param ) !=-0){
           printError("Thread creation error in Qsort function\n");
           FINE
        }

        //aggiungo alla lista il nuovo thread
        codaTid.putLast(tidFiglio);

        //stampa stato elaborazione
        if (printScreen) stampaPercentuale(buffer,bufferOrdinati,numeroBuffer,codaTid.getSize());//percentuale buffer effettivamente ordinati
				/*------------------------------------------------------------------------------------------------------------------------*/

        #endif


        #ifdef DEBUG_SORT
        if (printScreen) printf("OK \n");

        #endif

        numBufferUsati++;
        #ifdef NO_THREAD_QSORT_EXTERNALSORT
        if (printScreen) stampaPercentuale(buffer,numBufferUsati,numeroBuffer);
        #endif

        i++;
    }
    while ( (numBufferUsati<numeroBuffer)&&(!fileFinito) );//tutti i buffer sono stati usati




    #ifndef NO_THREAD_QSORT_EXTERNALSORT
    //aspetto che tutti i thread terminino
    while (codaTid.getSize()>0){
           pthread_t tidFiglio;

					 //prende il primo thread e aspetta che termini
           codaTid.getFirst(tidFiglio);

          long status;
          //attende che il processo figlio termini
           if (pthread_join(tidFiglio,NULL)!=0){
               fprintf(stderr,"Error in wait_thread system call for the thread %d",tidFiglio);
               printError("");
               FINE;
           }
           bufferOrdinati++;
           if (printScreen) stampaPercentuale(buffer,bufferOrdinati,numeroBuffer,codaTid.getSize());//percentuale buffer effettivamente ordinati
    }
    #endif


    //processo di ordinamento in memoria terminato
    if (printScreen) stampaPercentuale(buffer,10,10);

    //imposto il prototipo di output corrente
    snprintf(prototipoBloccoCorrente,N,prototipoNomeFilesBlocchi,numeroBloccoCorrente);
    strncat(prototipoBloccoCorrente,".file%d",N);


    /* INIZIALIZZO IL FILE PER IL NUOVO BLOCCO PRIMA DEL NUOVO MERGE E POI COPIO GLI ARCHI ORDINATI*/

    if (numBufferUsati>0){
      	fout =new bufferedThreadFileOutputStream(prototipoBloccoCorrente,MAX_DIM_FILES_EXTERNALSORT,param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT);

      	check(fout);
      	long long byteScrittiBlocco;//num byte totali del blocco

       //la funzione richiede una dimensione in byte (conversione interna)
      	byteScrittiBlocco=merge(listaBuffer,size,numBufferUsati,fout,numeroBloccoCorrente,param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,printScreen);

	      /* TERMINO LA SCRITTURA DEL BLOCCO */
      	numFileOutScrittiBloccoCorrente=fout->close();//termino la scrittura precedente blocco
      	fout->cancella();//elimina strutture
      	delete fout;fout=NULL;

	      //aggiorno la lista dei files creati
        infoBlocco ib(numBloccoScritto,numFileOutScrittiBloccoCorrente,prototipoBloccoCorrente,byteScrittiBlocco);
      	blocchiScritti.putLast(ib);
  	  	if (printScreen) cout<<" ("<<prototipoBloccoCorrente<<" in "<<numFileOutScrittiBloccoCorrente<<" files)\n";
      	numBloccoScritto++;
    }
    else
        if (printScreen) cout<<" (empty block)\n";

    fflush(stdout);

    //passo al blocco successivo
    numeroBloccoCorrente++;
  }
  while(!fileFinito);



  codaTid.cancella();

  #ifdef DEBUG_SORT
  if (printScreen) printf(" Block partition completed\n");fflush(stdout);
  #endif


  //chiude il file di lettura
  fp.close();

  //ed elimina strutture di buffering di lettura
  fp.cancella();

  // DEALLOCAZIONE dei vari buffer e chiusura file
  for (long i=0;i<numeroBuffer;i++){
      delete[] listaBuffer[i];//dealloco i vari buffer
      listaBuffer[i]=NULL;
  }

  delete[] size;size=NULL;
  delete[] listaBuffer;listaBuffer=NULL;
  delete[] bufferAppoggio;bufferAppoggio=NULL;
  //eliminazione di fp automatica, all'uscita
}






/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/* esegue il merge dei blocchi passati come input e restituisce un nuovo MultiFile secondo il
   prototipo passato in input che e' ordinato e a sua volta e' un nuovo blocco */
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
long mergeSecondario(
   //merge fasi successive (a partire dai blocchi in memoria)
   //info files e num blocchi
   infoBlocco* infoFiles,long numFiles,

   //prototipo file output - max dimensione - dim buffer shmem e n di questi
   char* prototipoOutputFile,

   //dimensione in byte dei 'numFiles' buffers di appoggio per input
   long dimensioneBufferIn,

   //dimensione in byte buffer di appoggio per l'output
   long dimensioneBufferOut,

   //num totale di blocchi in attesa
   long numeroBlocchiTotaliInAttesa,

   long numeroBloccoCorrente,

   long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 10)
   long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 128*1024);
   bool printScreen//true is print screen enabled
   ){


  if (numFiles<=1)
       return numFiles;


  //converto le dimensioni dei buffer approssimandola ad un intero del num di elementi
  long inc=0;
  if(dimensioneBufferIn%sizeof(T)!=0) inc=1;
  dimensioneBufferIn=dimensioneBufferIn/sizeof(T)+inc;//conversione in num elementi T

  inc=0;
  if(dimensioneBufferOut%sizeof(T)!=0) inc=1;
  dimensioneBufferOut=dimensioneBufferOut/sizeof(T);//conversione in num elementi T

  //stampa messaggio di inizio
  char buffer[1024];
  sprintf(buffer,"block %3ld: merging of blocks [%3ld .. %3ld] (missing %ld block) ",numeroBloccoCorrente,infoFiles[0].numeroBlocco  ,infoFiles[numFiles-1].numeroBlocco,numeroBlocchiTotaliInAttesa);

//  sprintf(buffer,"%3d blocchi in attesa: merge da %3d a %3d  ",numeroBlocchiTotaliInAttesa,infoFiles[0].numeroBlocco  ,infoFiles[numFiles-1].numeroBlocco );fflush(stdout);

  // +++++++++++++++++++++++++ INIT dei files
  //creo i puntatori ai vari files
  multiFileReader* listaFile=new multiFileReader[numFiles];
  check(listaFile);


  //inizializzo i vari puntatori ai multiFiles (del tipo BLOCCOi.file%d al variare di i)
  long long byteTotaliDaScrivere=0;//dim totale in byte da scrivere (necessario!!!)
  for(long i=0;i<numFiles;i++){
      //apro il multiFile corrente in lettura
      listaFile[i]=multiFileReader(
    			infoFiles[i].prototipoMultiFile, infoFiles[i].numeroFiles,true);
    	byteTotaliDaScrivere+=infoFiles[i].sizeInByte;
  }

  //creo output stream
  bufferedThreadFileOutputStream* fp=new bufferedThreadFileOutputStream(
        prototipoOutputFile,MAX_DIM_FILES_EXTERNALSORT,param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT);
  check(fp);

  // +++++++++++++++++++++++++ FINE INIT dei files


  //struttura che dato il n hash relativo restituisce il num ASSOLUTO del buffer
  // - hash2Buffer[i] mi da il numero ASSOLUTO del buffer in pos dordine relativa i
  long* hash2Buffer=new long[numFiles];

  check(hash2Buffer);

  //array delle size dei buffer con indice ASSOLUTO
  // - size[i] si riferisce all'i-esimo buffer ASSOLUTO
  long* size =new long [numFiles];
  check(size);

  //array dei puntatori ai buffers con indice ASSOLUTO
  // - pos[i] si riferisce all'i-esimo buffer ASSOLUTO
  long* pos =new long [numFiles];
  check(pos);

  //creo tanti buffer ausiliari quanti sono i files
  T** listaBuffer=new T*  [numFiles];
  check(listaBuffer);

  // creo un buffer di out
  T* bufferAusiliario=new T[dimensioneBufferOut];//dimensione gia' espressa in narchi
  check(bufferAusiliario);

  //n files ancora disponibili

  long  numeroFileRimasti=numFiles;

  //----------------------------------------------------------------------------------

  //init dei vari array
  for (long i=0;i<numFiles;i++){

      //inizializzazioni
      listaBuffer[i]=new T[dimensioneBufferIn];//dimensione gia' espressa in narchi
      check(listaBuffer[i]);
      hash2Buffer[i]=i;
      pos[i]=0;

      //riempio i buffer leggendo dai files
      size[i]=listaFile[i].read(listaBuffer[i],sizeof(T),dimensioneBufferIn);
  }

  /********************************************
    insiemeOrdinato ord=new insiemeOrdinato();

  ********************************************/

  //controllo che alcuni files non siano gia' finiti
  for (long i=0;i<numFiles;i++){
      if (size[i]==0){
          numeroFileRimasti--;
          if(numeroFileRimasti>0){
            pos[i]=pos[numeroFileRimasti];

            hash2Buffer[i]=hash2Buffer[numeroFileRimasti];
          }
      }
  }
  //

  // variabili d'appoggio
  long hashBufferMin;    // indice hash del buffer in cui si trova il minimo
  long numeroBufferMin;  // numero buffer minimo
  long numeroOutCorrente=0;
  T minimo,aux;
  long long iterazioni=MAX_ITER_EXTERNALSORT+1;
  long long numeroArchiLetti=0;

  //mentre ci sono ancora files da leggere
  while (numeroFileRimasti>0){

    numeroArchiLetti++;
    if (iterazioni++>MAX_ITER_EXTERNALSORT){
        iterazioni=0;
        if (printScreen) stampaMbyteCorrenti(buffer,numeroArchiLetti*sizeof(T),byteTotaliDaScrivere);
    }

    // ----------------  calcolo il minimo --------------------------------

    //inizializzo il primo elemento del 1 buffer - ordine relativo al min
    hashBufferMin   = 0;
    numeroBufferMin = hash2Buffer[0];//il min e' per ora nel primo buffer (n relativo)
    minimo          = (listaBuffer[numeroBufferMin])[pos[numeroBufferMin]];//valore minimo

    //per ogni buffer rimasto trovo quello che contiene il min
    long numAssolutoBufferCorrente;
    for (long i=1;i<numeroFileRimasti;i++){
      //calcolo il n assoluto del buffer in prima posiz relativa
      numAssolutoBufferCorrente=hash2Buffer[i];

      //calcolo il 1 elemento del buffer
      aux=(listaBuffer[numAssolutoBufferCorrente])[pos[numAssolutoBufferCorrente]];

      if (aux<minimo ){
         minimo=aux;
         numeroBufferMin=numAssolutoBufferCorrente;
         hashBufferMin=i;
      }
    }

    // ----------------  FINE calcolo il minimo --------------------------------


    //controllo che il buffer di OUT non sia pieno e se si lo scrivo su file
    if (numeroOutCorrente==dimensioneBufferOut){
       fp->write(bufferAusiliario,sizeof(T),numeroOutCorrente);
       numeroOutCorrente=0;
    }

    //copia il valore nel buffer
    bufferAusiliario[numeroOutCorrente++]=minimo;

    //se il buffer contenente il minimo e' vuoto
    if( ++pos[numeroBufferMin]>=size[numeroBufferMin]){
      //se il buffer prec era + piccolo del max allora il file e' finito
      if (size[numeroBufferMin]<dimensioneBufferIn){//il file e' finito
        numeroFileRimasti--;
        if(numeroFileRimasti>0)//modifico la tab hash
           hash2Buffer[hashBufferMin]=hash2Buffer[numeroFileRimasti];

        //chiudo percio' il file
        listaFile[numeroBufferMin].close();
        listaFile[numeroBufferMin].cancella();//libera strutture dati
        //cout<<".";fflush(stderr);

      }
      //se ancore c'e' qualcosa nel file
      else{
        //leggo il successivo buffer se possibile
        size[numeroBufferMin]=listaFile[numeroBufferMin].read(listaBuffer[numeroBufferMin],sizeof(T),dimensioneBufferIn);

        //punto al primo elemento del buffer
        pos[numeroBufferMin]=0;

        //controllo che il buffer non sia vuoto e se si lo elimino dalla lista
        if (size[numeroBufferMin]==0){
          numeroFileRimasti--;
          if(numeroFileRimasti>0)

             hash2Buffer[hashBufferMin]=hash2Buffer[numeroFileRimasti];

          //chiudo percio' il file
          listaFile[numeroBufferMin].close();
          listaFile[numeroBufferMin].cancella();//libera strutture dati
        //cout<<".";fflush(stderr);
        }
      }
    }//fine buffer finito
  }//fine while

  //stampa ultimi dati
  
  sprintf(buffer,"block %3ld: block merging [%3ld .. %3ld] ",numeroBloccoCorrente,infoFiles[0].numeroBlocco  ,infoFiles[numFiles-1].numeroBlocco);
  if (printScreen) stampaMbyteCorrenti(buffer,numeroArchiLetti*sizeof(T),byteTotaliDaScrivere);




  //controlla che la dim del blocco corrisponda a quella prevista
  if (numeroArchiLetti*sizeof(T)!=byteTotaliDaScrivere){
    cout<<"Unexpected fatal error n.2: writing byte for the blocco is not correct!!!\n";
    FINE;
  }





  //i buffer sono finiti e se necessario scrivo quello di OUT
  if (numeroOutCorrente>0){//scrivo la parte finale del buffer
      fp->write(bufferAusiliario,sizeof(T),numeroOutCorrente);
      numeroOutCorrente=0;
  }

  //chiusura file output e successiva eliminazione strutture d'appoggio
  long numScritti=fp->close();
  fp->cancella();

  //eliminazione strutture di appoggio
  for (long i=0;i<numFiles;i++){
      delete[] listaBuffer[i];listaBuffer[i]=NULL;
  }

  delete[] listaBuffer;listaBuffer=NULL;
  delete[] size;size=NULL;
  delete[] pos;pos=NULL;
  delete[] hash2Buffer;hash2Buffer=NULL;
  delete[] bufferAusiliario;bufferAusiliario=NULL;
  delete[] listaFile;listaFile=NULL;
  delete   fp;fp=NULL;
  //cout<<endl;
  return numScritti;
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// prende il file di input con elementi di tipo T e restituisce un file ordinato - si puo' spec se cancellare
// l'originale o no - NOTA CHE IL TIPO DEGLI ELEMENTI DEVE ESSERE SPECIFICATO mediante classe e deve avere
// almeno gli operatori < = >
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
void externalSort(char* prototipoIn,
                  char* prototipoTempo, char* nomeFileOrdinato,
                  long cancellaSource,char* messaggio,

                  long param_RAM,//dim memoria totale disponibile da utilizzare
                  long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 10)
                  long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 128*1024);
                  long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                  long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                  long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                  bool printScreen//true is print screen enabled       
                  ){
// prende il prototipo del nome dei files di input
// prende il prototipo del nome dei files temporanei dei vari blocchi ( BLOCCO%d per indicare i vari blocchi con l'aggiunta di .file%d per indicare i vari files del multifile)
// prende il nome del file ordinato (ORDINATO a cui si aggiunge .file%d per indicare i vari files del multifile




     /*NOTE:la procedura apre un 'multiFile' in lettura (1 thread di input) e crea tanti blocchi di dimens
            max fissata;ciascun blocco e' un multiFile (1 thread di output); al max posso avere in contemporanea
            1 thread di lettura (dal file prototipoIn) e uno di scrittura (sul file prototipoOut).
            Internamente vengono allocati in ram utente NUM_BUFFER_CREA_BLOCCHI buffer di dimensione
            DIM_BUFFER_CREA_BLOCCHI su cui poi verra' fatto il merge interno. Si utilizza infine un buffer
            ausiliario per l'output di dimens DIMENSIONE_BUFFER_MERGE_OUT_CREA_BLOCCHI
            Il contenuto del file di input viene alla fine eliminato
     */

     //conta il num files di input
     long numeroFileDiInput=contaNumFilesMultiFile(prototipoIn);
     
     //coda dei blocchi da analizzare
     coda<infoBlocco> cd=coda<infoBlocco>();
     creaBlocchiOrdinatiDaFile<T>(cd,
             prototipoIn, numeroFileDiInput, cancellaSource,
             prototipoTempo,
             param_RAM,
             param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,
             param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
             param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
             param_MAX_NUM_THREAD_QSORT_EXTERNALSORT ,
             printScreen
     );

     if (printScreen) printf("\nRunning: blocks merging ...\n");

     //struttura per memorizzare le info dei blocchi
     infoBlocco* blocchi=new infoBlocco[param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT];
     check(blocchi);

     //buffer per memorizzare i nomi di out dei vari blochi creati
     char buffer[N];

     //n di blocchi creati fino ad ora - inizializza il contatore

     long contaBlocco=cd.getSize();
     while (cd.getSize()>1){

       //mentre ci sono file da analizzare e prendo i primi disponibili
       long num=0;
       long long byteTotaliDaScrivere=0;//conta size totale dei blocchi da fondere
       while ( (cd.getSize()>0)&&(num<param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT) ){
           cd.getFirst( blocchi[num] );
           byteTotaliDaScrivere+=blocchi[num].sizeInByte;
           num++;
       }

	     snprintf(buffer,N,prototipoTempo,contaBlocco);
	     strcat(buffer,".file%d");


       /*NOTE: la procedura apre NUM_FILE_CONTEMPORANEI_MERGE (al max) file di input (SENZA THREAD)
               e un file di out (1 thread scrittura) per il risultato; utilizza poi NUM_FILE_CONTEMPORANEI_MERGE buffer
               per l'input di dimens DIMENSIONE_BUFFER_MERGE_IN e uno di dim DIMENSIONE_BUFFER_MERGE_OUT per eseguire il merge,

               oltre che i buffer interni per la gestione dell'output;
               Tutti i file di input vengono fusi per ottenere quello di out e il loro contenuto cancellato
       */

       long numFileMultiFile=mergeSecondario<T>(blocchi,num,buffer,
	          param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
	          cd.getSize(),contaBlocco  ,  param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,printScreen
            );


       infoBlocco ib (contaBlocco,numFileMultiFile,buffer,byteTotaliDaScrivere);
       cd.putLast( ib );
       if (printScreen) cout<<"("<<buffer<<" in "<<numFileMultiFile<<" files)\n";
       contaBlocco++;
     }
     
     delete[] blocchi;blocchi=NULL;


     
     //se e' stato creato un solo blocco devo rinominare tutti i files del blocco
     if (cd.getSize()==1){

        //prende il nome del multifile
        infoBlocco* aux= new infoBlocco;
        cd.getFirst(*aux);

        //costruisce il nome dei files da generare come files ordinati
        char prototipoOrdinato[1000];
        strncpy(prototipoOrdinato,nomeFileOrdinato,1000);
        //strncat(prototipoOrdinato,".file%d",1000);

        //buffer d'appoggio
        char vecchio[1000];
        char nuovo[1000];

        //rename di tutti i files del multifile associato al multifile corrente
        for (long jj=0;jj<aux->numeroFiles;jj++){
           snprintf(vecchio,1000,aux->prototipoMultiFile,jj);//nome file corrente  old
           snprintf(nuovo,1000,prototipoOrdinato,jj);//nome file corrente  new

           remove(nuovo);//cancella quello nuovo se gia' esiste
           rename(vecchio,nuovo);//rinomina
        } 		
    		

    		/* STAMPA RAPPORTO */
        if (messaggio!=NULL){
  				if (printScreen && strlen(messaggio)>0) {
            fprintf(stdout,"%s\n",messaggio);
  				  fprintf(stdout,"Number of elements..........%lld\n",aux->sizeInByte/sizeof(T) );
    			  fprintf(stdout,"Total file size ...........%lld\n",aux->sizeInByte);	
          }
        }
       
        delete aux;
     }
     else{
        // file vuoto !!!!
        if (printScreen) cout<<"\nEmpty file ? \n";
        //FINE;
        //return;
     }
     
     cd.cancella();//cancella la coda
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// wrapper function ...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void externalSort_long(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,//dim memoria totale disponibile da utilizzare
                             long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 10)
                             long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 128*1024);
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                             long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                             bool printScreen//true is print screen enabled
){

  externalSort<long>(prototipoIn,prototipoTempo, nomeFileOrdinato, cancellaSource,messaggio,
                     param_RAM,
                     param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                     param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                     param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,
                     printScreen
  );

}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// wrapper function ...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void externalSort_longlong(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,//dim memoria totale disponibile da utilizzare
                             long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 10)
                             long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 128*1024);
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                             long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                             bool printScreen//true is print screen enabled
){

  externalSort<long long>(prototipoIn,prototipoTempo, nomeFileOrdinato, cancellaSource,messaggio,
                     param_RAM,
                     param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                     param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                     param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,
                     printScreen
  );

}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// wrapper function ...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void externalSort_arco32sorg(char* prototipoIn,char* prototipoTempo,
                             char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,//dim memoria totale disponibile da utilizzare
                             long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 10)
                             long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 128*1024);
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                             long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                             bool printScreen//true is print screen enabled
){
  externalSort<arco32sorg>(prototipoIn,prototipoTempo, nomeFileOrdinato, cancellaSource,messaggio,
                     param_RAM,
                     param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                     param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                     param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,
                     printScreen
  );
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// wrapper function ...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void externalSort_arco32dest(char* prototipoIn,char* prototipoTempo,
                             char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,//dim memoria totale disponibile da utilizzare
                             long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 128*1024)
                             long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 10);
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                             long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                             bool printScreen//true is print screen enabled
){
  externalSort<arco32dest>(prototipoIn,prototipoTempo, nomeFileOrdinato, cancellaSource,messaggio,
                     param_RAM,
                     param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                     param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                     param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,
                     printScreen
  );
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// wrapper function ...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void externalSort_labelInfoNodeScc(char* prototipoIn,char* prototipoTempo,
                             char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,//dim memoria totale disponibile da utilizzare
                             long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 128*1024)
                             long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 10);
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                             long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                             bool printScreen//true is print screen enabled
){
  externalSort<labelInfoNodeScc>(prototipoIn,prototipoTempo, nomeFileOrdinato, cancellaSource,messaggio,
                     param_RAM,
                     param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                     param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                     param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,
                     printScreen
  );
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// wrapper function ...
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void externalSort_InfoNodeScc(char* prototipoIn,char* prototipoTempo,
                             char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,//dim memoria totale disponibile da utilizzare
                             long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,//numero buffer che ogni thread di lettura usa (consigliato 128*1024)
                             long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,//dimensione del singolo buffer usato dai thread (consigliato 10);
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, //dimensione buffer per la lattura/scrittura nei files senza thread - in questo caso usato per l'output del merge di output del merge (consigliato 128*1024)
                             long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,//massimo num di thread che effettuano il sorting da creare (consigliato 20)
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,//massimo num di files che contemporaneamente vengono fusi (consigliato 30)
                             bool printScreen//true is print screen enabled
){
  externalSort<infoNodeScc>(prototipoIn,prototipoTempo, nomeFileOrdinato, cancellaSource,messaggio,
                     param_RAM,
                     param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                     param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                     param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,
                     printScreen
  );
}


#endif
