/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file externalSort.h :source code of externalsort utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

void stampaMbyteCorrenti(char* s,long long byte);

void stampaMbyteCorrenti(char* s,long long byte,long long totale);

void stampaPercentuale(char* s,long long fatti,long long totale);

void stampaPercentuale(char* s,long long fatti,long long totale,long numthread);


template <class T>
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort_long(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort_longlong(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort_arco32sorg(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato, long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort_arco32dest(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato,
                             long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort_labelInfoNodeScc(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato,
                             long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void externalSort_InfoNodeScc(char* prototipoIn,char* prototipoTempo, char* nomeFileOrdinato,
                             long cancellaSource,char* messaggio,
                             long param_RAM,long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,
                             long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT, long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,
                             long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,bool printScreen
);



//#define DEBUG_SORT

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*
         FILE DI CONFIGURAZIONE DEL PROCESSO DI SORTING, PER LA DEFINIZIONE DELLE DIMENSIONI DEI BUFFER
*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

#ifndef _CONFIG_EXTERNALSORT
#define _CONFIG_EXTERNALSORT


//n thread che possono essere eseguiti in parallelo per l'ordinamento
//#define MAX_NUM_THREAD_QSORT_EXTERNALSORT (20)


#define MAX_ITER_EXTERNALSORT         (500000)/*n di iterazioni prima di stampare il messaggio su video - usato per gli indici di avanzamento*/
#define MAX_DIM_FILES_EXTERNALSORT    (262144000*8)



/*
     NOTE:la procedura apre un 'multiFile' in lettura (1 thread di input) e crea tanti blocchi di dimens
            max fissata;ciascun blocco e' un multiFile (1 thread di output); al max posso avere in contemporanea
            1 thread di lettura (dal file prototipoIn) e uno di scrittura (sul file prototipoOut).
            Internamente vengono allocati in ram utente NUM_BUFFER_CREA_BLOCCHI buffer di dimensione
            DIM_BUFFER_CREA_BLOCCHI su cui poi verra' fatto il merge interno. Si utilizza infine un buffer
            ausiliario per l'output di dimens DIMENSIONE_BUFFER_MERGE_OUT_CREA_BLOCCHI
            Il contenuto del file di input viene alla fine eliminato


     //coda dei blocchi da analizzare
     coda<infoBlocco> cd=coda<infoBlocco>();

     creaBlocchiOrdinatiDaFile(cd,
             prototipoIn, numeroFileDiInput, DIM_SHMEM_INPUT_CREA_BLOCCHI, NUM_SHMEM_INPUT_CREA_BLOCCHI, TRUE,
             prototipoOut,  MAX_DIM_OUTPUT, DIM_SHMEM_OUTPUT_CREA_BLOCCHI, NUM_SHMEM_OUTPUT_CREA_BLOCCHI,
             DIM_BUFFER_CREA_BLOCCHI, NUM_BUFFER_CREA_BLOCCHI, DIMENSIONE_BUFFER_MERGE_OUT_CREA_BLOCCHI );
*/


/*
       NOTE: la procedura apre NUM_FILE_CONTEMPORANEI_MERGE (al max) file di input (SENZA THREAD)
               e un file di out (1 thread scrittura) per il risultato; utilizza poi NUM_FILE_CONTEMPORANEI_MERGE buffer
               per l'input di dimens DIMENSIONE_BUFFER_MERGE_IN e uno di dim DIMENSIONE_BUFFER_MERGE_OUT per eseguire il merge,
               oltre che i buffer interni per la gestione dell'output;
               Tutti i file di input vengono fusi per ottenere quello di out e il loro contenuto cancellato

       int numFileMultiFile=mergeSecondario(blocchi,num,
          buffer,MAX_DIM_OUTPUT,DIM_SHMEM_OUTPUT,NUM_SHMEM_OUTPUT,
          DIMENSIONE_BUFFER_MERGE_IN,DIMENSIONE_BUFFER_MERGE_OUT);
       cd.putLast(infoBlocco(contaBlocco,numFileMultiFile,buffer) );

*/
//-----------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------

#endif
