/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file ordina.h :source code of externalsort utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//classe che gestisce la memorizazione e il retrieval di dati ordinati
//e' parametrico rispetto al dato
//#include <iostream.h>
#include <iostream>

#include <stdio.h>
#ifndef _ORDINA_TREE
#define _ORDINA_TREE

template <class T>
	class rec{
  public:
		rec* minore;
		rec* maggiore;
		T elem;
	};

  
template <class T>
class ordina{
private:
    
	long size;//num elemnti presenti
	rec<T>* punt;//puntatore alla struttura di memorizzazione
  void aggiungi(rec<T>*& p, T& elem);
	void stampa(rec<T>* p);
  T delMinimo(rec<T>*& p);

public:
    void stampa();
    ordina();
    void addElement(T elem);
    T getMin();
    long getSize(){return size;}
};

template <class T>
ordina<T>::ordina(){
  punt=NULL;
  size=0;
}

template <class T>
void ordina<T>::addElement(T elem){
  aggiungi(punt,elem);
}

template <class T>
T ordina<T>::delMinimo(rec<T>*& p){
	if (p==NULL){
	    return T();
	}
	else{
		if (p->minore==NULL){
			T aux=p->elem;//elemento corrente 
			rec<T>* tt=p;
			p=p->maggiore;
			delete tt;
			size--;
			return aux;
		}
		    
		else
			return delMinimo(p->minore);
	}
}


template <class T>
T ordina<T>::getMin(){
	return delMinimo(punt);
}


template <class T>
void ordina<T>::aggiungi(rec<T>*& p,T& e){
	if (p==NULL){
	  p=new rec<T>();
	  p->minore=p->maggiore=NULL;//successori null
	  p->elem=e;
	  size++;
	}else{
		if (e<=p->elem)
		    aggiungi(p->minore,e);
		else
			aggiungi(p->maggiore,e);
	}
}


template <class T>
void ordina<T>::stampa(rec<T>* p){
  std::cout<<"(";
  if (p!=NULL){
    
	stampa(p->minore);
	std::cout<<p->elem;
    stampa(p->maggiore);
	
  }
  std::cout<<")";
}


template <class T>
void ordina<T>::stampa(){
  stampa(punt);
}
#endif


/*
int main(){
  ordina<int> o=ordina<int>();
  o.addElement(3);
  o.addElement(5);
	  std::cout<<o.getMin()<<" - ";  
  o.addElement(9);
  o.addElement(14);
  o.addElement(7);
 // o.stampa();
  while (o.getSize()>0)
	  std::cout<<o.getMin()<<" - ";
  return 0;
}

*/

