/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file externalbuffer.cpp :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "externalbuffer.h"
/***************************************************************************
                          externalBuffer.cpp  -  description
                             -------------------
    begin                : Mon Nov 18 2002
    copyright            : (C) 2002 by stefano millozzi
    email                : stefano@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//////////////////////////////////////////////////////////////////////////////////////////////
externalBuffer::externalBuffer (char* nome, long size){
  if (size<=0) size=1;

  sizeBuffer=0;
  sizeAllocata=size;
  strcpy(this->nome,nome);
  fp=NULL;
  chiuso=false;
  buf=new long[sizeAllocata];
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void externalBuffer::memorizzaValore(long val){
  if (chiuso) return;

  //vedo se il buffer e' pieno e se si lo scrivo su file
  if (sizeBuffer==sizeAllocata){
    if (fp==NULL)
      if ( (fp=fopen(nome,"w"))==NULL){perror ("Unexpected fatal error: temporary file opening");FINE;}
    fwrite(buf,sizeof(long),sizeBuffer,fp);
    sizeBuffer=0;
  }

  buf[sizeBuffer]=val;
  sizeBuffer++;
  sizeTotale++;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void externalBuffer::svuotaBufferSuFileAndSvuota(multiFileWriter& fout){
  if (chiuso) return;

  if (fp!=NULL){
    //copia il contenuto del file tempo nel file passato come parametro
    fclose(fp);fp=NULL;
    if ( (fp=fopen(nome,"r"))==NULL){perror ("Unexpected fatal error: temporary file opening");FINE;}
    long app;
    while ( fread(&app,sizeof(long),1,fp)>0){
       fout.write(&app,sizeof(long),1);
    }
    fclose(fp);fp=NULL;
  }

  //scrive il buffer su file
  fout.write(buf,sizeof(long),sizeBuffer);

  //contatori azzerati
  sizeBuffer=0;
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void externalBuffer::svuotaBufferSuFileAndSvuota(bufferedThreadFileOutputStream& fout){
  if (chiuso) return;

  if (fp!=NULL){
    //copia il contenuto del file tempo nel file passato come parametro
    fclose(fp);fp=NULL;
    if ( (fp=fopen(nome,"r"))==NULL){perror ("Unexpected fatal error: temporary file opening");FINE;}
    long app;
    while ( fread(&app,sizeof(long),1,fp)>0){
       fout.write(&app,sizeof(long),1);
    }
    fclose(fp);fp=NULL;
  }

  //scrive il buffer su file
  fout.write(buf,sizeof(long),sizeBuffer);

  //contatori azzerati
  sizeBuffer=0;
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void externalBuffer::cancella(){
  if (chiuso) return;
  if (fp!=NULL) fclose(fp);
  fp=NULL;
  chiuso=true;
  delete[] buf;buf=NULL;
  remove(nome);//eventualmente cancella il fil temporaneo
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////

