/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file externalbuffer.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          externalBuffer.h  -  description
                             -------------------
    begin                : Mon Nov 18 2002
    copyright            : (C) 2002 by stefano millozzi
    email                : stefano@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <math.h>
#include <stdio.h>
//#include <iostream.h>
#include <iostream>
#include <ctype.h>
#include <string.h>
#include "./streamFiles/multiFileWriter.h"
#include "./streamFiles/bufferedThreadFileOutputStream.h"


//////////////////////////////////////////////////////////////////////////////////////////////
//      classe che gestisce un buffer (eventualmente in mem secondaria se necessario)
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef BUF_CLASS_FILE
#define BUF_CLASS_FILE
class externalBuffer{
  private:
    FILE* fp;
    long* buf;
    long  sizeBuffer;
    long  sizeAllocata;//size mem allocata
    long  sizeTotale;
    char  nome[1000];
    bool  chiuso;
  public:
    externalBuffer (char* nome, long size);
    void  cancella();
    void  memorizzaValore(long val);
    void  svuotaBufferSuFileAndSvuota(multiFileWriter& fout);//scrive su file
    void  svuotaBufferSuFileAndSvuota(bufferedThreadFileOutputStream& fout);//scrive su file
    long  getSize(){return sizeTotale;}
};
#endif
//////////////////////////////////////////////////////////////////////////////////////////////
