/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file funzioniGenerali.cc :common functions and classes of all graph utilities

                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE  revisione 24 nov 01
//=======================================================================
//=======================================================================

//#include "shmem.h"
#include "processi.h"
#include "funzioniGenerali.h"
//#include <iostream.h>
#include <iostream>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/sem.h>
#include <stdio.h>


//tabella dei processi attivi per gestire i crash
//- OGNI PROCESSO DEVE usare iniziaProcesso e terminaProcesso per iniziare/finire
//e allocare deallocare sem e shmem con le wrapper function correnti o con la classe semaforo!!!!!!!!!!!!
processi p=processi();



/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */
void stampaLicenza1(){
  printf("NO WARRANTY\n");
  printf("11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM 'AS IS' WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.\n");
  printf("12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.\n");
}
/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */



/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */
void stampaFormati(){
  std::cout<<"The package support follow format file graph :\n";
  std::cout<<".edges format: \n";
  
  std::cout<<"'extended' .edges format: \n";
  
  std::cout<<".succ format: \n";
  
  std::cout<<".ips format: \n";

  std::cout<<".text format: \n";

  std::cout<<".dimacs format: \n";

}
/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */



/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */
void stampaLicenza2(){
  printf("0.  This License applies to any program or other work which contains a notice placed by the copyright holder saying it may be distributed under the terms of this General Public License. The 'Program', below, refers to any such program or work, and a 'work based on the Program' means either the Program or any derivative work under copyright law: that is to say, a work containing the Program or a portion of it, either verbatim or with modifications and/or translated into another language. (Hereinafter, translation is included without limitation in the term 'modification'.) Each licensee is addressed as 'you'.\n");
  printf("Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running the Program is not restricted, and the output from the Program is covered only if its contents constitute a work based on the Program (independent of having been made by running the Program). Whether that is true depends on what the Program does.\n");
  printf("1. You may copy and distribute verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and give any other recipients of the Program a copy of this License along with the Program.\n");
  printf("You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.\n");
  printf("2. You may modify your copy or copies of the Program or any portion of it, thus forming a work based on the Program, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:\n");
  printf("    * a) You must cause the modified files to carry prominent notices stating that you changed the files and the date of any change.\n");
  printf("    * b) You must cause any work that you distribute or publish, that in whole or in part contains or is derived from the Program or any part thereof, to be licensed as a whole at no charge to all third parties under the terms of this License.\n");
  printf("* c) If the modified program normally reads commands interactively when run, you must cause it, when started running for such interactive use in the most ordinary way, to print or display an announcement including an appropriate copyright notice and a notice that there is no warranty (or else, saying that you provide a warranty) and that users may redistribute the program under these conditions, and telling the user how to view a copy of this License. (Exception: if the Program itself is interactive but does not normally print such an announcement, your work based on the Program is not required to print an announcement.)\n");
  printf("These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Program, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Program, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.\n");
  printf("Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Program.\n");
  printf("In addition, mere aggregation of another work not based on the Program with the Program (or with a work based on the Program) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.\n");
  printf("3. You may copy and distribute the Program (or a work based on it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you also do one of the following:\n");
  printf("    * a) Accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,\n");
  printf("    * b) Accompany it with a written offer, valid for at least three years, to give any third party, for a charge no more than your cost of physically performing source distribution, a complete machine-readable copy of the corresponding source code, to be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,\n");
  printf("* c) Accompany it with the information you received as to the offer to distribute corresponding source code. (This alternative is allowed only for noncommercial distribution and only if you received the program in object code or executable form with such an offer, in accord with Subsection b above.)\n");
  printf("The source code for a work means the preferred form of the work for making modifications to it. For an executable work, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the executable. However, as a special exception, the source code distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.\n");
  printf("If distribution of executable or object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place counts as distribution of the source code, even though third parties are not compelled to copy the source along with the object code.\n");
  printf("4. You may not copy, modify, sublicense, or distribute the Program except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense or distribute the Program is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.\n");
  printf("5. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Program or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Program (or any work based on the Program), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Program or works based on it.\n");
  printf("6. Each time you redistribute the Program (or any work based on the Program), the recipient automatically receives a license from the original licensor to copy, distribute or modify the Program subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties to this License.\n");
  printf("7. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Program at all. For example, if a patent license would not permit royalty-free redistribution of the Program by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Program.\n");
  printf("If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply and the section as a whole is intended to apply in other circumstances.\n");
  printf("It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system, which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.\n");
  printf("This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.\n");
  printf("8. If the distribution and/or use of the Program is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Program under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.\n");
  printf("9. The Free Software Foundation may publish revised and/or new versions of the General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.\n");
  printf("Each version is given a distinguishing version number. If the Program specifies a version number of this License which applies to it and 'any later version', you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of this License, you may choose any version ever published by the Free Software Foundation.\n");
  printf("10. If you wish to incorporate parts of the Program into other free programs whose distribution conditions are different, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally. \n");
}
/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */




char* eliminaPath(char* s){
  int i;
  for (i=strlen(s);i>=0;i--){
    if (s[i]=='/'){
      i++;
      break;
    }
  }
  
  if (i<0) return s;
  return s+i;
}


/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */
void stampaLicenza(int n,char* argv[]){
  printf("%s version 1.0, Copyright (C) 2003 S.Millozzi, D.Donato, L.Laura, S.Leonardi - D.I.S. - University 'La Sapienza' of Rome.\n",eliminaPath(argv[0]));
  printf("%s comes with ABSOLUTELY NO WARRANTY; for details ",eliminaPath(argv[0]) );
  printf("type `%s -license'.\nThis is free software, and you are welcome ",eliminaPath(argv[0]));
  printf("to redistribute it under certain conditions; type `%s -condition' for details.\n\n",eliminaPath(argv[0]));

  /* ------------------------------------------------------ */
  if (n>1){
    if ( strcmp(argv[1],"-license")==0){
      stampaLicenza1();      
      EXIT(0);
    }

    if ( strcmp(argv[1],"-condition")==0){
      stampaLicenza2();
      EXIT(0);
    }

    if ( strcmp(argv[1],"-format")==0){
      stampaFormati();
      EXIT(0);
    }

    if ( (strcmp(argv[1],"-h")==0) || (strcmp(argv[1],"-help")==0) ){
      stampaHelp(n,argv);
      printf("\n");
      printf("To see details about utilitis supported format type %s -format\n",eliminaPath(argv[0]));
      
      EXIT(0);
    }
  }
  /* ------------------------------------------------------ */
  
}
/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */




//STAMPA ERRORI
void printError(const char *s){
  printf("%s: %s",strerror(errno),s);
}


// lista dei puntatori con attach alla memoria condivisa
// ogni processo deve utilizzare le funzioni di alloc/dealloc
// della memoria qui presenti-questa classe viene ereditata
// da tutti i processi figli e ciascun figlio ne ha una sua copia
// che indica il suo stato di mapping
//shmem shm=shmem();



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//									gestione memoria massima disponibile
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

/*------------------------------------------------------------------------*/
long long memoriaDisponibile=256*1024*1024;//default 256 MB


/*------------------------------------------------------------------------*/
void setMemoriaDisponibile(long long mem){
  memoriaDisponibile=mem;
}


/*------------------------------------------------------------------------*/
long long getMemoriaDisponibile(){
	return memoriaDisponibile;
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/






/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long contaNumFilesMultiFile(char* nome){

    long conta=0;
    FILE* fp;
    char nomeFile[1000];

    while(true){
      sprintf(nomeFile,nome,conta);
      fp=fopen(nomeFile,"r");
      if (fp!=NULL){
          //std::cout<<nomeFile<<"\n";
          conta++;
          fclose(fp);
      }
      else
          return conta;

      //controlla se il nome ha %d
      if (!estMultiFileName(nome))
          return conta;//se non ho %d --> calcola solo un file...
    }

    return conta;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long getFileSize(char* nomeFile){
  struct stat buf;
  stat(nomeFile, &buf);
  return buf.st_size;//size del file
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/


long long getTotalSizeMultiFiles(char* nomeMulti){

    struct stat buf;

    long long size = 0;
    long numTotFiles=contaNumFilesMultiFile(nomeMulti);

    FILE* fp;
    char nomeFile[1000];
    

    for (long conta=0;conta<numTotFiles;conta++){
      sprintf(nomeFile,nomeMulti,conta);
//      printf("file %s ",nomeFile);
      fp=fopen(nomeFile,"r");
      if (fp!=NULL){
          fclose(fp);
          stat(nomeFile, &buf);
          size+= buf.st_size;
//          printf("size %ld \n",buf.st_size);
      }
      else
          return size;
    }

    return size;

}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void interruzioneTastiera(int p){
  printf("\nSignal %d: Keyboard interrupt disabled.\n",p);
}

void stopTastiera(int p){
  printf("\nSignal %d: Program aborted by user.\n",p);
  ABORT();
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void ABORT(){
  //termina tutti i processi mediante kill ed elimina le strutture condivise
  fflush(stdout);
  p.abortAll();//NON RITORNA !!!!!!!!!!
  
  fflush(stdout);
}



//da utilizzare alla fine del main per attendere la fine di tutti i processi e per liberare tutte le risorse condivise
void EXIT(int i){
   fflush(stdout);
   long status;
   while (wait(&status)!=-1);
   p.exitAll(i);//NON RITORNA !!!!!!!!!!
   
   fflush(stdout);
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void EXIT_ALL(int i){
// aspetta che tutti i processi figli exit
// e poi termina anche lui
   fflush(stdout);
   long status;
   while (wait(&status)!=-1);
   p.exitAll(i);//NON RITORNA !!!!!!!!!!
   
   fflush(stdout);
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void rilasciaMappingShmem(char* addr){
//rilascia solo mapping shmem
  long ris=shmdt((char*)addr);//deattach la memoria
  if ( ris==-1 ){
     fprintf(stderr,"Error in rilasciaMappingShmem\n");
     printError("");
     FINE;
  }

  //eliminail mapping dal processo corrente
//  shm.elimina(addr);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
char* richiediMappingShmem(long id){
//richiede solo mapping shmem
  char* aux=(char*)shmat(id,0,0);
  if (aux==NULL){
     fprintf(stderr,"Error in richiediMappingShmem\n");
     printError("");
     FINE;
     return NULL;
  }

  //aggiunge una nuova area di memoria che viene mappata nel processo corrente
//  shm.aggiungi(aux,id);
  return aux;
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
char* richiediBlocco(long size,long& id){
//richiede un NUOVO blocco di memoria e restituisce il puntatore
  do{
    id=shmget(rand(),size,IPC_CREAT|0660|IPC_EXCL);
  }
  while( (id==-1)&&(errno=EEXIST) );
  if ( id==-1 ){
     fprintf(stderr,"Error n.1 in richiediBlocco\n");
     printError("");
     FINE;
     return NULL;
  }
  char* aux=(char*)shmat(id,0,0);
  if (aux==NULL){
     fprintf(stderr,"Error n.2 in richiediBlocco\n");
     printError("");
     FINE;
     return NULL;
  }

  //aggiunge il blocco alla lista di tutti i segmenti del processo corrente
//  shm.aggiungi(aux,id);

  //aggiunge il blocco alla lista di tutti i segmenti condivisi
  p.aggiungiMem(id);

  return aux;
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void rilasciaMemoriaCondivisa(void* addr,long id){
//rilascia il blocco deallocandolo dalla memoria ed eliminando il mapping

  long ris=shmdt((char*)addr);//deattach la memoria
  if ( ris==-1 ){
     fprintf(stderr,"Error n.1 in rilasciaMemoriaCondivisa - id %ld\n",id);
     printError("");
     FINE;
     return ;
  }

  ris=shmctl(id,IPC_RMID,0);
  if ( ris==-1 ){
     fprintf(stderr,"Error n.1 in rilasciaMemoriaCondivisa - id %ld\n",id);
     printError("");
     FINE;
     return ;
  }

  //cancella dalla lista degli addr del processo corrente
//  shm.elimina((char*) addr);

  //cancella il blocco dalla lista di tutti i segmenti condivisi
  p.cancellaMem(id);

}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long getSemaforo( long key,long numero){
//richiede 'numero' semafori associati allo stesso id
   long id=semget( key,numero,IPC_CREAT|IPC_EXCL|0660);
   //p.aggiungiSem(id);
   return id;
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void accettaSemaforo( long id){
//richiede 'numero' semafori associati allo stesso id
   p.aggiungiSem(id);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long removeSemaforo(long semid){
//elimina tutti i semafori del set
  union semun aux;//variabile ausiliaria
  long code=semctl(semid,0,IPC_RMID,aux);
  p.cancellaSem(semid);
  return code;
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long contaPrintfFormat(char* c){
//controlla che la stringa sia in formato printf e ritorna il n di %d
  long conta=0;

  long l=strlen(c);
  long stato=0;//0 aspetto %d   1 trovato%d

  for (long i=0;i<l;i++){
     switch(stato){
       case 0:{//aspetto %
     	   if (c[i]=='%')stato=1;
           break;
       }

       case 1:{//aspetto un n o 'd'
           if ( (c[i]=='d')||(c[i]=='D') ){conta++;stato=0;}
           else  if ( (c[i]>'9') | (c[i]<'0') ) stato=0; /*se non e' un numero allora ricomincio da capo*/
           break;
       }
     }
  }

  // ritorna il n di %d
  return (conta);
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
bool estMultiFileName(char* c){
  return (contaPrintfFormat(c)==1);
}



