/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file indeg.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//#include "config.h"

#ifndef RAGGRUPPAINDEG_H
#define RAGGRUPPAINDEG_H


/**
  *@author 
  */
/*classe che raggruppa insiemi di nodi e ne tiene la somma degli indegree. Serve per avere accessi rapidi*/

//n elementi del livello 1 che vengono raggruppati in livello 0

class inDeg {
private:
	long *livello0;long size0;//livello + alto che racchiude il liv 1
	long *livello1;long size1;
	long *livello2;long size2;

  long *inDegNodi;long numNodiTot;//lista indegree dei nodi
	
	//coefficienti di raggruppamento (n elementi del livello + basso corrispondenti ad 1 elemento del liv corrente)
	long COEFF0;
	long COEFF1;
	long COEFF2;
  long sommaInDeg;//max valore indegree disponibile
	
public:
	//inDeg(long nNodi);
  inDeg(long nNodi,long COEFF_LIVELLO_0, long COEFF_LIVELLO_1, long COEFF_LIVELLO_2);
	void cancella();
	long aggiungiInDeg(long nodo);
	long trovaNodo(long valore);
	void stampa();

  //restituisce il vettore degli indegree
  long* getRifInDeg(long& nNodi){nNodi=this->numNodiTot;return inDegNodi;}	
  long  getInDegTotale(){return sommaInDeg;}
};

#endif
