/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file infoNodeScc.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
*/                                                                   

/*
For each node it contains information about SCC component in which the node is part
The number of node is the position of each record. The 1° record is for node 0, the second for node 1 etc
*/
#ifndef INFONODO_SCC_H
#define INFONODO_SCC_H

#define labelScc_SCC      ('S')
#define labelScc_IN       ('I')
#define labelScc_OUT      ('O')
#define labelScc_DISC     ('D')
#define labelScc_TENDRILS ('T')
#define labelScc_TUBES    ('U')
#define labelScc_NULL     ('-')
//#define labelScc_TUBES    (6)

class infoNodeScc {
public: 
  long scc; //number of scc that contains the current node
  char sccType;   //type of SCC (see IN/OUT/SCC/DISC/TENDRILS)
  long sizeScc;//size of scc
public:
  /*sort by scc (from first to last)*/
  bool operator==(infoNodeScc& o){return this->scc==o.scc;}
  bool operator<(infoNodeScc& o) {return this->scc< o.scc;}
  bool operator>(infoNodeScc& o) {return this->scc> o.scc;}
  bool operator<=(infoNodeScc& o){return this->scc<=o.scc;}
  bool operator>=(infoNodeScc& o){return this->scc>=o.scc;}

  infoNodeScc& operator=(const infoNodeScc& o){
     this->scc=o.scc;
     this->sccType=o.sccType;
     this->sizeScc=o.sizeScc;     
     //cout<<"operator=\n";
     return *this;
  }
  
};

#endif
