/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file infoTree.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

/*
Structure of info files for trees
*/
#ifndef INFOTREE_H
#define INFOTREE_H

struct infoTree { //informazioni relative a ciascun albero DFS visitato, da salvare nel file .infotree dell'output
public:
  long numberOfChildren; //dimensione dell'albero
  long pointer; //indice del primo nodo dell'albero nel file di output principale
};

#endif
 
/*
The structure uses 2 multifiles:
the first that is a file of InfoTree records (1 for each node - the label-number of each node is the position in this file)
the second multifile store all children for every node 

The number of node is the position of each record. The 1° record is for node 0, the second for node 1 etc
-----------------------------------------------
this structure is used even for SCC; in this situation each infoTree is a SCC and the children are nodes of it


*/
