/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file labelInfoNodeScc.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
*/                                                                   

/*
Each record contains a couple <node,scc> used to calculate for each node (unsorted) the number of scc that contains the node
*/

#ifndef LABELINFONODO_SCC_H
#define LABELINFONODO_SCC_H

class labelInfoNodeScc {
public:
  long node;//node
  long scc; //number of scc that contains the current node
  long sizeScc;//size of scc

public:
  /*sort by node (from first to last)*/
  bool operator==(labelInfoNodeScc& o){return this->node==o.node;}
  bool operator<(labelInfoNodeScc& o) {return this->node< o.node;}
  bool operator>(labelInfoNodeScc& o) {return this->node> o.node;}
  bool operator<=(labelInfoNodeScc& o){return this->node<=o.node;}
  bool operator>=(labelInfoNodeScc& o){return this->node>=o.node;}
};
#endif
