/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file processi.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE rivisto 23 nov 2001
//=======================================================================
//=======================================================================
//gestisce solo i multithread

#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "multiSemaforo.h"
#include "funzioniGenerali.h"

#ifndef _PROCESSI_
#define _PROCESSI_
class processi{

  private:
    //in questa classe la mem condivisa viene ereditata
    //perche' si usano funzioni interne di allocazione !!!!!

    //la classe impone che ogni richiesta di add sia fatta prima
    // della remove dello stesso elemento
    //QUESTA PROPRIETA' VA BENE SE SI USA CON LE FUNZIONI DI CREAZIONE/FINE PROCESSO
    //E PER SEM E SHMEM

    //nota che i thread vengono cancellati quando il processo che li ha generati viene eliminato o esegue una exit

    /*----- VARIABILI ASSOC ALLA SHMEM ----*/

    char nomeFile[1000];
    char app[1000];
    
    int   pid;    
    long sem_id;

//    char* memoriaCondivisa;//gestita in locale, non presente nella lista delle shmem
//    long* canale;
//    long* parametri;	//shmem che contiene i parametri di comunicazione
			//contiene idParametri,idMemoriaCondivisa,idCanaleComunicazioni,idSemaforo

    //PUNTATORI ALLE STRUTTURE CONDIVISE

    /*-------------SEM--------------------*/
    long* numeroSem;   //1 long
    long* listaSem;   //max 2000

    /*-------------MEM--------------------*/
    long* numeroMem;   //1 long
    long* listaMem;   //max 2000
    FILE* fp;

 public:
    multiSemaforo* inUso;//[0] accesso alla classe;

  private:
    void eliminaSemaforo(long id);
    void eliminaShmem(long id);

    long cancella(char* c,long pid,long* vet, long& size);//aggiunge un elemento al vettore
    long aggiungi(char* c,long pid,long* vet, long& size,long limite);//elimina un elemento dal vettore
    void stampaInterna();


  public:
    processi();

    void  cancellaSem(long pid);
    void  aggiungiSem(long pid);

    void stampa();

    void  cancellaMem(long pid);
    void  aggiungiMem(long pid);

    //elimina tutta la shmem e sem e termina il processo main
    void  abortAll();

    //elimina tutta la shmem e sem e termina il processo main senza messaggi d'errore
    void  exitAll(long code);

};
#endif

