/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file randomGen2.cpp :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <stdlib.h>
#include "randomGen2.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
randomGen2::randomGen2()
{
    periodo=0;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
randomGen2::randomGen2(long seed)
{
    periodo=0;
    srand(seed);
}




//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
randomGen2::randomGen2(long seed, long periodo)
{
//    cout<<"Periodo iniziale "<<periodo<<"\n";
    this->seed=seed;
    
    //calcolo vero periodo
    if (periodo<=0)  periodo=10;
    this->periodo=periodo;

    sizePerBlocco = periodo /NUM_BUFFER_RANDOM;
    if (periodo % NUM_BUFFER_RANDOM!=0 || sizePerBlocco<=0)  sizePerBlocco++;

    periodo=this->periodo=sizePerBlocco*NUM_BUFFER_RANDOM;
//    cout<<"Periodo effettivo "<<periodo<<"\n";


    //alloco strutture d'appoggio e le inizializzo
    srand(seed);
    for (long h=0;h<NUM_BUFFER_RANDOM;h++){

        //allocazione lista dei vettori e memorizzazione dei valori random
        this->lista[h]=new unsigned long [sizePerBlocco];
        for (long i=0;i<sizePerBlocco;i++){
           (lista[h])[i]=rand();//valore random
        }

        if (h%30==0)
             printf("%cInit random generator... %6.2f %s",13,100.0*(h+1)/NUM_BUFFER_RANDOM,"%");fflush(stdout);

   }
   printf("%cInit random generator... %6.2f %s",13,100.0,"%");fflush(stdout);
   printf("%78s%c"," ",13);

}


//inizia da capo
void randomGen2::resetSeed(){
  srand(seed);
  puntCont=0;  
}


unsigned long randomGen2::genrand(){
  if (periodo==0)
      return rand();
  else
      return genRand(puntCont++);
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
unsigned long randomGen2::genRand(long long pos){
  if (periodo<=0) return 0;
  if (pos<0) pos=0;

  long posPeriodata = (long)(pos%periodo);//ritorna una posizione tra 0 e periodo-1
  long numBuffer = posPeriodata / sizePerBlocco; //numero del buffer
  long relativo  = posPeriodata % sizePerBlocco; //pos relativa all'interno del blocco

  return lista[numBuffer][relativo];
}






//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void randomGen2::cancella()
{
    if (periodo<=0) return;

    this->periodo=0;
    //dealloco strutture d'appoggio
    for (long h=0;h<NUM_BUFFER_RANDOM;h++){
        delete[] this->lista[h];
        lista[h]=NULL;
    }
    this->sizePerBlocco=0;
}





