/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file report.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/*

 CLASSE CHE ANALIZZA IL FILE DI REPORT (.report)
 e restituisce le informazioni caratteristiche

*/

#include "../common/funzioniGenerali.h"
#include <stdio.h>
#include <string.h>
//#include <iostream.h>
#include <iostream>
#include <stdlib.h>

#ifndef REPORT_H
#define REPORT_H

class report {

public:
	report(char* nomeFileReport);
  long getNumNodiTotali(){return numNodi;}

  long getNomeAndNumFilesSucc(char* buf){ strcpy(buf,nomeFilesSucc);return numFilesSucc; }
  long getNomeAndNumFilesPred(char* buf){ strcpy(buf,nomeFilesPred);return numFilesPred; }
  long getNomeAndNumFilesInfo(char* buf){ strcpy(buf,nomeFilesInfo);return numFilesInfo; }
  long getDimensioneMaxFiles(){return dimensioneMaxFiles;}
  long long getNumeroArchi(){return numeroArchi;}

private:
  long numNodi;
  long long numeroArchi;
  long numFilesInfo;
  char nomeFilesInfo[1000];

  long numFilesSucc;
  char nomeFilesSucc[1000];

  long numFilesPred;
  char nomeFilesPred[1000];

  long dimensioneMaxFiles;

  void leggeControllatoFileReport(char* aux,FILE* fp,int numRiga,char* nomeFileReport);
};

#endif
