/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file report2.cpp :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "report2.h"

report2::report2(char* nomeINFO,char* nomePRED,char* nomeSUCC){

  //memorizza nomi
  strcpy(this->nomeFilesInfo,nomeINFO);
  strcpy(this->nomeFilesPred,nomePRED);
  strcpy(this->nomeFilesSucc,nomeSUCC);

  //calcola numeri dei files
  this->numFilesInfo=contaNumFilesMultiFile(nomeINFO);
  this->numFilesPred=contaNumFilesMultiFile(nomePRED);
  this->numFilesSucc=contaNumFilesMultiFile(nomeSUCC);


  //calcolo dimensione totale dei files INFO (in byte)
  long long sizeTotInfo=0;
  for (long i=0;i<numFilesInfo;i++){
      char nome[1000];
      sprintf(nome,nomeINFO,i);
      struct stat buf;
      stat(nome,&buf);
      sizeTotInfo+=buf.st_size;
  }

  // calcolo num nodi - e' un file di elementi di tipo "infoNodo"
  numNodi=(long) ( sizeTotInfo/sizeof(infoNodo) );
  if (sizeTotInfo%sizeof(infoNodo)!=0){std::cout<<"Format error in INFO file";FINE;}



  //calcolo dimensione totale dei files PRED (in byte)
  long long sizeTotPred=0;
  for (long i=0;i<numFilesPred;i++){
      char nome[1000];
      sprintf(nome,nomePRED,i);
      struct stat buf;
      stat(nome,&buf);
      sizeTotPred+=buf.st_size;
  }



  //calcolo dimensione totale dei files PRED (in byte)
  long long sizeTotSucc=0;
  for (long i=0;i<numFilesSucc;i++){
      char nome[1000];
      sprintf(nome,nomeSUCC,i);
      struct stat buf;
      stat(nome,&buf);
      sizeTotSucc+=buf.st_size;
  }


  this->numeroArchi=sizeTotSucc/sizeof(long);//e' un file elementi di tipo "long"
  if (sizeTotSucc%sizeof(long)!=0){std::cout<<"Successors multifile is in a wrong format";FINE;}
  if (sizeTotSucc!=sizeTotPred){std::cout<<"Pred e succ files must have the same dimensions";FINE;}
}


