#ifndef VETTOREBITS_H
#define VETTOREBITS_H

/*#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>*/

//il tipo degli elementi dell'array "buffer" in cui verranno memorizzati piu' bit
#define TIPO_BASE unsigned long


class VettoreBits {
public:
	VettoreBits(unsigned long numElem);//crea un vettore binario con 'numElem' bit
	VettoreBits(unsigned long numElem, bool valore_iniziale);//crea un vettore binario inizializzato al valore specificato 0/1
  VettoreBits(unsigned long numElem, unsigned long dim_b, TIPO_BASE * buffer_passato);
  VettoreBits(unsigned long numElem, bool valore_iniziale, unsigned long dim_b, TIPO_BASE * buffer_passato);
	~VettoreBits();

  void reset(bool valore=false); //inizializza a tutti 0
  void print(const char * messaggio); //stampa gli indici dei bit che sono a 1
  unsigned long contaBits1(); //conta quanti bit=1 ci sono. Viene scandito tutto il vettore, perciò quest'operazione è costosa e va evitata se possibile
  bool set(unsigned long nodo, bool bit, long & errore); //setta il bit alla posizione 'nodo' al valore 'bit', ritornando il valore precedente del bit come avrebbe fatto la get()
  bool get(unsigned long nodo, long & errore);
  unsigned long getNumElem(){return numElementi;}
  bool findNext1(unsigned long & pos_trovato, unsigned long pos_start); //restituisce in "pos_trovato" il primo bit settato a 1, cercando a partire dal bit alla posizione specificata da <pos_start>. Ritorna true se e' stato trovato un tale bit, false altrimenti
  bool findNext1(unsigned long & pos_trovato); //restituisce in "pos_trovato" il primo bit settato a 1, cercando a partire dal bit alla posizione corrente (posizione dell'ultimo bit trovato a 1). Ritorna true se e' stato trovato un tale bit, false altrimenti
//N.B. l'indice corrente della ricerca nel vettore del bits è lo stesso per le due classi di funzioni (ricerca di 0 e di 1)
  bool findNext0(unsigned long & pos_trovato, unsigned long pos_start); //restituisce in "pos_trovato" il primo bit settato a 0, cercando a partire dal bit alla posizione specificata da <pos_start>. Ritorna true se e' stato trovato un tale bit, false altrimenti
  bool findNext0(unsigned long & pos_trovato); //restituisce in "pos_trovato" il primo bit settato a 0, cercando a partire dal bit alla posizione corrente (posizione dell'ultimo bit trovato a 0). Ritorna true se e' stato trovato un tale bit, false altrimenti

  bool salvaSuFile(const char * nomefile); //restituisce true se il salvataggio è stato completato senza errori, false altrimenti
  bool caricaDaFile(const char * nomefile); //restituisce true se il caricamento è stato completato senza errori, false altrimenti

  //per le funzioni seguenti viene ritornato true se OK, false se c'è stato un errore:
  void copia(VettoreBits & sorgente); //copia dei bit del vettore sorgente
  void NOT(VettoreBits & sorgente); //inverte tutti i bit
  void OR(VettoreBits & sorgente); //OR con un altro vettore
  void XOR(VettoreBits & sorgente); //XOR con un altro vettore
  void AND(VettoreBits & sorgente); //AND con un altro vettore
  void NAND(VettoreBits & sorgente); //NAND con un altro vettore
  void NOR(VettoreBits & sorgente); //NOR con un altro vettore

private:
  unsigned long numElementi;
  unsigned long sizeBuffer; //numero di elementi del vettore <buffer>
  TIPO_BASE * buffer; //array di elementi di un certo tipo (ad es. unsigned char, unsigned short, unsigned long) che memorizzano i bit
  bool buffer_nostro; //indica se il buffer lo abbiamo allocato noi o se invece ce lo hanno passato

  //variabili usate per ricordarci a che punto eravamo nella ricerca di bit=1 nell'array di bits, per ordine crescente dei nodi:
  unsigned long nodo_next; //prossimo bit del'array da considerare per la ricerca di un 1
  unsigned long posBuffer_next; //indice nel buffer dell'elemento contenente il prossimo bit da considerare: corrisponde a nodo_next / (sizeof(TIPO_BASE)*8), questa informazione ridondante viene mantenuta per non ricalcolarla ogni volta
  unsigned short posBit_next; //posizione all'interno di un elemento del buffer del prossimo bit da considerare per la ricerca di un 1 : corrisponde a nodo_next % (sizeof(TIPO_BASE)*8), questa informazione ridondante viene mantenuta per non ricalcolarla ogni volta

  bool scandisci_elemento_0(unsigned long & pos_trovato);
  bool scandisci_elemento_1(unsigned long & pos_trovato);

  void init(unsigned long num_el);
  void init(unsigned long num_el, unsigned long dim_b, TIPO_BASE * buffer_passato);
  inline unsigned long conta1_in_elemento(TIPO_BASE elemento);

  VettoreBits & operator=(const VettoreBits &); //disabilitiamo l'operatore di assegnazione (altrimenti andrebbe gestito opportunamente essendoci della memoria allocata dinamicamente)
  VettoreBits(const VettoreBits &); //disabilitazione del costruttore di copia (altrimenti andrebbe gestito opportunamente essendoci della memoria allocata dinamicamente)
};


#endif

