/*
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multiFileReader.cc :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================

#include "multiFileReader.h"
#include "funzioniGenerali.h"
#include <string.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream.h>

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// seek in avanti. Ritorna il num di elementi saltati.
long multiFileReader::seekInAvanti(long sizeElem,long numElem){

   if ((flagFileClose)||(numFileCorrente>=numFiles)){return 0;}

   long long numByteDaSaltare=sizeElem*numElem;
   long long byteSaltati=0;
   if (numByteDaSaltare<=0) return 0;

   while (!flagFileClose && numByteDaSaltare>0){

     //controllo la dimensione del file
     struct stat stbuf;
     stat(nomeFileCorrente,&stbuf);
     off_t sizeFile=stbuf.st_size;//dim file in byte

     //byte corrente da leggere
     long posCorrente=ftell(fp);

     long byte_restanti_nel_file= sizeFile - posCorrente;

     if(byte_restanti_nel_file > numByteDaSaltare)
     {
        fseek(fp,numByteDaSaltare,SEEK_CUR);
        byteSaltati += numByteDaSaltare;
        //numByteDaSaltare= 0;
        return byteSaltati/sizeElem;
     }
     else
     {
        byteSaltati += byte_restanti_nel_file;
        numByteDaSaltare -= byte_restanti_nel_file;

        fclose(fp);//chiudo il vecchio file
        if (cancellaQuandoLetto){
          deleteFile(nomeFileCorrente);
        }

        numFileCorrente++;//passo al file successivo
        if (numFileCorrente<numFiles){
           snprintf(nomeFileCorrente,N,prototipo,numFileCorrente);
           fp=fopen(nomeFileCorrente,"r");
     	    check(fp,(char*)"Opening error in file %s\n",nomeFileCorrente);
        }
        else{
           flagFileClose=true;
            //cout<<"finiti i files ";
        }
     }
   }

   return byteSaltati/sizeElem;
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long multiFileReader::read(void* buffer,long sizeElemento,long numeroElementi){

  if ((flagFileClose)||(numFileCorrente>=numFiles)){return 0;}

  //NOTA: char e' sempre di un byte
  char* b=(char*)buffer;//puntatore interno al buffer (array di 1 byte)
  long numByteDaLeggere=sizeElemento*numeroElementi;//n byte da leggere in totale
  long letti;//byte letti ad ogni fread (usata nel ciclo)
  while ( (numByteDaLeggere>0)&&(numFileCorrente<numFiles)){

     letti=fread(b,1,numByteDaLeggere,fp);//legge quanti piu' dati possibile
     //NON E' possibile fare alcun controllo di correttezza ulteriore sulle letture

          
     numByteDaLeggere=numByteDaLeggere-letti;
     //se mancano alcuni dati allora e' finito il file e se posso passo al successivo
     if (numByteDaLeggere>0){
         b=b+letti;//sposto il puntatore
         fclose(fp);//chiudo il vecchio file
         if (cancellaQuandoLetto){
           deleteFile(nomeFileCorrente);
         }

         numFileCorrente++;//passo al file successivo
         if (numFileCorrente<numFiles){
            sprintf(nomeFileCorrente,prototipo,numFileCorrente);
            fp=fopen(nomeFileCorrente,"r");
  	    		check(fp,(char*)"Errore nell'apertura del file %s\n",nomeFileCorrente);
         }
         else{
            flagFileClose=true;
         }
     }
  }
  return (sizeElemento*numeroElementi-numByteDaLeggere)/sizeElemento;
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::cancella(){
   close();
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::close(){
  //se fine non chiuso allora lo chiudo

  if ( !flagFileClose){
      fclose(fp);
      if (cancellaQuandoLetto){
         //cancella tutti i files rimasti
         for (int i=numFileCorrente;i<this->numFiles;i++){
           char app[1000];
           sprintf(app,prototipo,i);
           deleteFile(app);
         }
      }
      flagFileClose=true;
  }
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::deleteFile(char* nFile){
  remove(nFile);//elimina il file
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
multiFileReader::multiFileReader(char* prototipo,long num){
  init(prototipo,num,FALSE);
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
multiFileReader::multiFileReader(char* prototipo,long num,int cancella){
  init(prototipo,num,cancella);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::init(char* prototipo,long num,int cancella){

  this->numFileCorrente=0;//primo file in analisi

  if (num<=0) {
      num=1;
		  this->numFiles=1;//numero dei files
		  fp=fopen(prototipo,"r");//apro il primo file

  }else{
      this->numFiles=num;//numero dei files
      strncpy(this->prototipo,prototipo,N);//copio il prototipo
      snprintf(nomeFileCorrente,N,prototipo,numFileCorrente);
      fp=fopen(nomeFileCorrente,"r");//apro il primo file
  }

  check(fp,(char*)"Error:unable to open file %s\n",nomeFileCorrente);
  flagFileClose=false;
  cancellaQuandoLetto=cancella;
}


