/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file semaforo.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE        rivisto 24 nov 2001
//=======================================================================
//=======================================================================

#ifndef SEMAFORO
#define SEMAFORO

#include <sys/sem.h>
#include <sys/types.h>
#include <sys/ipc.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include "funzioniGenerali.h"

/*definizione di una union per utilizzare semctl*/
union semun
{
     long val;				// <= value for SETVAL
     struct semid_ds *buf;		// <= buffer for IPC_STAT & IPC_SET
     unsigned short int *array;		// <= array for GETALL & SETALL
     struct seminfo *__buf;		// <= buffer for IPC_INFO
};


//classe che implementa un semaforo in Linux
class semaforo{
private:

  long sem_id;//id del semaforo

public:
  semaforo(long init);
  semaforo(long oldId,bool inutile); //attach ad un semaforo esistente - l'altro parametro e' inutile

  long signal();
  long wait();
  void cancella();//drealloca il semaforo
  long getValue();
  long getId();
  void setValue(long val);
};
#endif

