/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file shmem.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================


#ifndef _SHMEM_XXX
#define _SHMEM_XXX

#include "funzioniGenerali.h"
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>

 struct nodo{
   char* punt;//punto di attach
   nodo* next;
   int   id;
 };


class shmem{
  private:
    nodo* inizio;//cancello elementi
    void detach(char* );
  public:
    shmem();
    void aggiungi(char* p,int id);
    void elimina(char* p);
    void detachAll();
    ~shmem();
    void stampa();
};


  void shmem::detach(char* addr){
    long ris=shmdt((char*)addr);//deattach la memoria
    if ( ris==-1 ){
     fprintf(stderr,"Errore nella richiesta di deattach di un blocco di memoria condivisa\n");
     perror("");
     FINE;
    }
  }



shmem::shmem(){
  inizio=NULL;
}


void shmem::elimina(char* p){
//elimina solo la prima occorrenza
  nodo* aux=inizio;
  nodo* prec=NULL;
//  int trovato=(0==1);//false
  for (aux=inizio;aux!=NULL;aux=aux->next){
    if (aux->punt==p){
       //se e' il primo
       if (prec==NULL){
         inizio=aux->next;
         delete aux;aux=NULL;
         return;
       }
       else{
         prec->next=aux->next;
         delete aux;aux=NULL;
         return;
       }
    }
    prec=aux;
  }
}



void shmem::aggiungi(char* p,int id){
  nodo* aux=inizio;
  inizio=new nodo;
  inizio->punt=p;
  inizio->id=id;
  inizio->next=aux;
}


void shmem::stampa(){
  nodo* aux=inizio;
  for (aux=inizio;aux!=NULL;aux=aux->next){
    printf("(%d) %p ",aux->id,aux->punt);
  }
}


shmem::~shmem(){
  nodo* aux;
  while (inizio!=NULL){
    aux=inizio;
    inizio=inizio->next;
    delete aux;aux=NULL;
  }
  inizio=NULL;
}


void shmem::detachAll(){
  nodo* aux;
  while (inizio!=NULL){
    aux=inizio;
    inizio=inizio->next;
//    printf("detach(%p)\n",aux->punt);
    detach(aux->punt);//libera condivisione
    delete aux;aux=NULL;
  }
  inizio=NULL;
}


void main_prova(){
  shmem s=shmem();
  char a;
  char b;
  char c;
  char d;
  s.aggiungi(&a,1);
  s.aggiungi(&b,1);
  s.aggiungi(&c,1);
  s.aggiungi(&d,1);
  printf("STAMPA 1\n");
  s.detachAll();
  s.stampa();
  printf("\nELIMINA %p %p %p %p\n",&b,&a,&d,&c);
  s.elimina(&b);
  s.elimina(&a);
  s.elimina(&d);
  s.elimina(&c);
  s.elimina(&d);
  s.stampa();
}

#endif
