/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file bufferedThreadFileInputStream.cc :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//#define DEBUG_ERR
//#define DEBUG_LETTURA
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================

//#include <iostream.h>
#include <iostream>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "bufferedThreadFileInputStream.h"
#include "../funzioniGenerali.h"
#include <pthread.h>

#define MAX_BUFFER (0x4000000)
#define MAX_NUM_BUFFER (100)

//dichiarazione della funzione figlio
void* processoFiglioInput(void* arg);


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void bufferedThreadFileInputStream::close(){
  cancella();
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long bufferedThreadFileInputStream::minimo(long a,long b){
  if (a<b) return a;
  return b;
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long bufferedThreadFileInputStream::read(void* buf,long sizeElemento,long numElementi){
  if (fineFile)
       return 0;//il file e' finito

  //n tot byte da LEGGERE
  long numeroTotByte=sizeElemento*numElementi;
  long numeroByteDaLeggere=numeroTotByte;
  long posizioneBuffer=0;//si sposta sempre di un byte
  char* b=(char*)buf;//punto il buffer carattere per carattere
  long byteDaCopiare;//num byte da copiare ad ogni ciclo

  //controllo se ci sono ancora elementi nel buffer
  while (!fineFile&&(numeroByteDaLeggere>0)){
    byteDaCopiare=minimo( size[nBufAttivo.bufferLettura]-posCorrenteLettura,numeroByteDaLeggere );

    memcpy( b+posizioneBuffer, bufferCondivisoCorrenteLettura+posCorrenteLettura, byteDaCopiare );
    posCorrenteLettura+=byteDaCopiare;
    numeroByteDaLeggere-=byteDaCopiare;
    posizioneBuffer+=byteDaCopiare;

    if (numeroByteDaLeggere>0){//se devo leggere altri byte vuol dire che il buffer e' finito
      //devo cambiare buffer
      if (size[nBufAttivo.bufferLettura]<this->dimensioneBuffer){
         //questo era l'ultimo blocco,
         //il file e' finito perche' ho potuto solo alcuni dati e non tutti quelli richiesti
         fineFile=TRUE;//true, in modo che successive richieste ritornino 0
         return ((numeroTotByte-numeroByteDaLeggere)/sizeElemento);//n elementi letti in totale
         /*vengono saltati i byte copiati n fondo*/
      }

      //sblocco il buffer terminato per la scrittura
      scrittura->signal(nBufAttivo.bufferLettura);

#ifdef DEBUG_LETTURA
      printf("PADRE READ: svuotato buffer %d \n",nBufAttivo.bufferLettura);
      fflush(stdout);
#endif

      //incremento n buffer e passo al buffer successivo
      if(++nBufAttivo.bufferLettura>=numeroTotBuffer)
         nBufAttivo.bufferLettura=0;

      //buffer attualmente in uso
      bufferCondivisoCorrenteLettura=bufferCondiviso[nBufAttivo.bufferLettura];

      //aspetto che sia pronto per la lettura
      lettura->wait(nBufAttivo.bufferLettura);

      posCorrenteLettura=0;

      //controllo se ci sono elementi e se si riprendo la lettura
      if (size[nBufAttivo.bufferLettura]==0)
          return ((numeroTotByte-numeroByteDaLeggere)/sizeElemento);// il file e' finito xche' ho un blocco di dim 0
    }
  }//fine while
  return ((numeroTotByte-numeroByteDaLeggere)/sizeElemento);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long bufferedThreadFileInputStream::readChar(char& buf){
  if (fineFile)
     return 0;//il file e' finito

  //controllo se ci sono ancora elementi nel buffer
  if (posCorrenteLettura<size[nBufAttivo.bufferLettura]){
     //prendo elemento successivo
     //buf=(bufferCondiviso[nBufAttivo.bufferLettura])[posCorrenteLettura];
     buf=bufferCondivisoCorrenteLettura[posCorrenteLettura];
     posCorrenteLettura++;
     return 1;
  }
  else{
     //devo cambiare buffer
     if (size[nBufAttivo.bufferLettura]<this->dimensioneBuffer){
       //questo era l'ultimo blocco,
       //il file e' finito perche' ho potuto solo alcuni dati e non tutti quelli voluti
       fineFile=TRUE;//true
       return 0;
     }

     //sblocco il buffer terminato per la scrittura
     scrittura->signal(nBufAttivo.bufferLettura);

#ifdef DEBUG_LETTURA
     printf("PADRE READ: svuotato buffer %d\n",nBufAttivo.bufferLettura);
     fflush(stdout);
#endif

     //incremento n buffer e passo al buffer successivo
     if(++nBufAttivo.bufferLettura>=numeroTotBuffer)
         nBufAttivo.bufferLettura=0;

     //buffer attualmente in uso
     bufferCondivisoCorrenteLettura=bufferCondiviso[nBufAttivo.bufferLettura];

     //aspetto che sia pronto per la lettura
     lettura->wait(nBufAttivo.bufferLettura);
     posCorrenteLettura=0;

     //controllo se ci sono elementi e se si leggo il primo byte
     if (size[nBufAttivo.bufferLettura]==0)
       return 0;// il file e' finito
     else{
        //buf=(bufferCondiviso[nBufAttivo.bufferLettura])[posCorrenteLettura];
        buf=bufferCondivisoCorrenteLettura[posCorrenteLettura];
        posCorrenteLettura++;
        return 1;
     }
  }
  return 1;
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
bufferedThreadFileInputStream::bufferedThreadFileInputStream(char* prototipo,long numeroFiles,long dim,long nBuf){
  init(prototipo,numeroFiles,dim,nBuf,false);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
bufferedThreadFileInputStream::bufferedThreadFileInputStream(char* prototipo,long numeroFiles,long dim,long nBuf, bool cancQuandoLetto){
  init(prototipo,numeroFiles,dim,nBuf,cancQuandoLetto);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void bufferedThreadFileInputStream::init(char* prototipo,long numeroFiles,long dim,long nBuf,int cancQuandoLetto){

  if (dim<=0){
    fprintf(stderr,"Initialization error: buffer dimension too small (%ld<1)\n",dim);
    FINE;
    return;}

  if (dim>MAX_BUFFER){
    fprintf(stderr,"Initialization error: buffer dimensione too high (%ld>%ld)\n",dim,(long)MAX_BUFFER);
    FINE;
    return;}

  if (nBuf<1){
    fprintf(stderr,"Initialization error: buffers number too small (%ld<2)\n",nBuf);
    FINE;
    return;}

  if (nBuf>MAX_NUM_BUFFER){
    fprintf(stderr,"Initialization error: buffers number too high (%ld>%ld)\n",nBuf,(long)MAX_NUM_BUFFER);
    FINE
    return;}

  if (numeroFiles<0)
      numeroFiles=contaNumFilesMultiFile(prototipo);//conteggio automatico (se non c'e' %d ritorna 1)


  //calcolo della dimensione come multiplo di un char (1 o 2 byte)
  long inc=0;
  if (nBuf%sizeof(char)!=0)
    inc=1;
  nBuf=(nBuf/sizeof(char)+inc )*sizeof(char);

  this->numeroTotBuffer=nBuf;   //n buffer totali da usare
  this->dimensioneBuffer=dim;   // dimensione dei buffer
  this->cancellaQuandoLetto=cancQuandoLetto;

  //variabili per la gestione multifiles
  check(this->prototipo = new char[strlen(prototipo)+1]);
  strcpy(this->prototipo,prototipo);
  this->numeroFiles=numeroFiles;

  //semafori
  check(this->fine=new semaforo(0));//semaforo per la fine del figlio
  check(this->lettura=new multiSemaforo (numeroTotBuffer,0) );//init dei semafori di lettura a 0      - tutti occupati
  check(this->scrittura=new multiSemaforo (numeroTotBuffer,1) );//init dei semafori di scrittura a 1  - tutti liberi

  //array che tiene il n byte contenuti vei vari blocchi
  check(size=(long*)new long [numeroTotBuffer]);

  //creo i vari buffer...
  check(bufferCondiviso=new char* [numeroTotBuffer]); //array di puntatori ai buffer

  //alloco i vari buffer
  for (long i=0;i<numeroTotBuffer;i++){
     bufferCondiviso[i]=new char[dimensioneBuffer];
     size[i]=dimensioneBuffer;//inizializzazione fittizia - in modo che alla prima lettura il buffer venga considerato finito e si passi a quello relamente primo
  }

  //l'ultimo blocco e' gia' impegnato dal padre e non ci si puo' scrivere
  nBufAttivo.bufferLettura=numeroTotBuffer-1; //serve per la prima lettura
  scrittura->wait(nBufAttivo.bufferLettura);  //l'ultimo buffer non puo' essere scritto perche' e' in uso dal padre
  posCorrenteLettura=dimensioneBuffer;        //serve per la prima lettura e indica che il buffer corrente e' finito (cioe' quello bloccato)

  //buffer correntemente in uso - che pero' e' sicuramente finito
  bufferCondivisoCorrenteLettura=bufferCondiviso[nBufAttivo.bufferLettura];

  //set di alcune variabili
  cancellato=FALSE; //ho cancellato le variabili locali???  NO
  fineFile=FALSE;   //ho finito il file ?????? NO

  tidFiglio=0;
  pthread_attr_t attr;                       //attributi del nuovo thread
  struct sched_param shedParam;              //param di scheduling
  shedParam.sched_priority=BACKGROUND_PRIOR; //fisso la priorit

  pthread_attr_init(&attr);                     //set init attrib
//  pthread_attr_setschedpolicy(&attr,SCHED_RR); //set politica RR
  pthread_attr_setschedparam(&attr,&shedParam); //set priorita'

  //avvia il nuovo thread figlio e ritorna
  if ( pthread_create(  &tidFiglio,&attr,processoFiglioInput,this ) !=-0){
    printError("Creation error for the child thread \n");
    FINE
  }
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void bufferedThreadFileInputStream::cancella(){
  if (cancellato) return;

  //avverte il figlio di terminare
  fine->signal();

 //sblocca tutti i buffer in modo che il figlio controlli il flag fine
  for (long i=0;i<numeroTotBuffer;i++)
    scrittura->signal(i);



  //attende che il processo figlio termini
  if (pthread_join(tidFiglio,NULL)!=0){
     fprintf(stderr,"system call error (wait thread %ld)",tidFiglio);
     printError("");
     FINE;
  }

  //cancello i semafori
  lettura->cancella();
  scrittura->cancella();
  fine->cancella();

  delete[] prototipo;prototipo=NULL;
  delete   lettura;lettura=NULL;//elimina i semafori di lettura
  delete   scrittura;scrittura=NULL;//elimina i semafori di scrittura
  delete   fine;fine=NULL;//elimina semaforo di fine

  //rilascia i buffer condivisi
  for (long i=0;i<numeroTotBuffer;i++){
     delete[] bufferCondiviso[i];bufferCondiviso[i]=NULL;
  }

  delete[] bufferCondiviso;bufferCondiviso=NULL;//elimino l'array di puntatori ai buffers
  delete[] size;size=NULL;

  fineFile=TRUE;//il file e' comunque finito e non puo' essere letto altro
  cancellato=TRUE;//viene cancellato tutto
}







/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*
             THREAD CHE GESTISCE L'INTERFACCIAMENTO COL DISCO
              (VIENE ELIMINATO SE IL PADRE VIENE ELIMINATO)
*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void* processoFiglioInput(void* arg){
  //apro il file di input in lettura

  bufferedThreadFileInputStream* oggetto=(bufferedThreadFileInputStream*)arg;
  multiFileReader fp=multiFileReader(oggetto->prototipo,oggetto->numeroFiles,oggetto->cancellaQuandoLetto);

  oggetto->nBufAttivo.bufferScrittura=0;//primo buffer disponibile per essere scritto
  long n_scritti;


  do{
    //aspetto che il buffer sia libero per la scrittura
    oggetto->scrittura->wait(oggetto->nBufAttivo.bufferScrittura);

    //controllo se il processo padre chiede la terminazione
    if (oggetto->fine->getValue()>0){//occorre uscire
        fp.close();
        fp.cancella();
        pthread_exit(0);
    }

    //leggo dal file
    n_scritti=fp.read(oggetto->bufferCondiviso[oggetto->nBufAttivo.bufferScrittura],1,oggetto->dimensioneBuffer);


#ifdef DEBUG_LETTURA
    printf("CHILD READ: letto da disco buffer %d - %d byte\n",oggetto->nBufAttivo.bufferScrittura,n_scritti);
    fflush(stdout);
#endif
    if (n_scritti==-1){
       fprintf(stderr,"Reading error");
       fprintf(stderr,oggetto->prototipo,fp.getNumeroFileCorrente());
       printError("\n");
       FINE;
    }

    //riporto la taglia dei dati
    oggetto->size[oggetto->nBufAttivo.bufferScrittura]=n_scritti;

    //abilito la lettura sul buffer appena creato
    oggetto->lettura->signal(oggetto->nBufAttivo.bufferScrittura);

    //passo al buffer successivo
    if (++oggetto->nBufAttivo.bufferScrittura>=oggetto->numeroTotBuffer)
    	oggetto->nBufAttivo.bufferScrittura=0;

  }while (n_scritti==oggetto->dimensioneBuffer);

  fp.close();
  fp.cancella();


#ifdef DEBUG_ERR
  fprintf(stderr,"processo figlio per lettura terminato...\n");
#endif

  pthread_exit(0);
}


/*
void main(){
  iniziaProcesso(0);
  bufferedThreadFileInputStream s=bufferedThreadFileInputStream("pippo.%d",1,1000000,10,FALSE);
  char c[10000];
  int n;

  while (  (n=s.read(c,1,10000)) >0){
       for (int i=0;i<n;i++)
         strlen("pippo e pluto");
//         printf("%c",c[i]);
  }
  s.cancella();
  printf("FINE 1");fflush(stdout);

  s=bufferedThreadFileInputStream("pippo.%d",1,1000000,10,FALSE);

  while (  (n=s.read(c,1,10000)) >0){
       for (int i=0;i<n;i++)
         strlen("pippo e pluto");
//         printf("%c",c[i]);
  }
  s.cancella();
  printf("FINE 2");fflush(stdout);


  aspettaFineTuttiProcessiDaMain();
}
*/
