#include <stdio.h>

#ifndef MULTIFILE_DEF
#define MULTIFILE_DEF
class multiFile{
  private:
    FILE* fp;//puntatore del file    
    long  numFiles;
    long  numFileCorrente;
    char  prototipo[300];
    long  maxDim;

  private:
  
    void  initFile    ( );//inizializza strutture gestione numerazione files
    void  openFile    (int num,bool readOnly);//apre il file specificato da num (se non esiste ne crea uno nuovo)
    long  readFile    (void* buffer, long elemSize,long numElem);//wrapper di lettura sul file
    long  writeFile   (void* buffer, long elemSize,long numElem);//wrapper di scrittura sul file
    void  closeFile   ( );//chiude il file fp corrente se necessario
    long  tellFile    ( );//ritorna ftell di fp (calcolato)
    long  seekFile    (long pos);//seek nel file fp
    long  sizeFile    (long num);//size del "num"-esimo file
    void  flushFile   ( );
    bool  estOpenFile ();//controlla che non sia chiuso il file fp
    
    long  min(long a, long b){if (a<b) return a;return b;}
    long  max(long a, long b){if (a<b) return b;return a;}

  public:
    multiFile(char* prototipo, long maxDim);//crea un nuovo multifile di dimensione prefissata (elimina multiFiles se gia' esistenti)
    multiFile(){fp=NULL;}

    long read(void* buffer, long elemSize, long numElem);
    long write(void* buffer, long elemSize, long numElem);
    long seek(long long pos);//seek di pos bytes dall'inizio del file
    long seek(long elemSize, long long numElem){return seek((long long)elemSize*(long long)numElem);}//seek di pos bytes dall'inizio del file
    long long tell();
    long long getSize();
    long getNumFiles(){return numFiles;}
    long getCurrentFile(){return numFileCorrente;}    

    void flush();
    void close();
    bool estOpen(){return fp!=0;}    

    //ritorna il node del multifile (per riferimento !!! - non modificare)
    char* getMultiFileName(){return prototipo;}

    static void removeMultiFile(char* prototipo);
};
#endif
