/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multiFileAppend.cc :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================

#include "multiFileAppend.h"
#include "../funzioniGenerali.h"
#include <string.h>

long min_Append(long a,long b){
  if (a<b) return a;
  return b;
}


void multiFileAppend::cancella(){
  close();
}


multiFileAppend::multiFileAppend(){
  this->flagFileClose=TRUE;
}


multiFileAppend::multiFileAppend(char* prototipo,long dimMax){
  init(prototipo,dimMax);
}


void multiFileAppend::init(char* prototipo,long dimMax){
/*prende la dim maxx dei files e il prototipo del nome in formato
  printf al variare del numero*/
  strcpy(this->prototipoNomeFiles,prototipo);
  this->dimMax=dimMax;

  this->numFileCorrente=contaNumFilesMultiFile(prototipo)-1;
  snprintf(this->nomeFileCorrente,N,this->prototipoNomeFiles,this->numFileCorrente);

  this->fp=fopen(this->nomeFileCorrente,"a");
  check(fp,(char*)"Error: unable to open file %s\n",this->nomeFileCorrente);

  this->flagFileClose=FALSE;
  this->byteScrittiFileCorrente=0;
}

//void close(int a);

long multiFileAppend::close(){
  //se file gia' chiuso allora
  if (this->flagFileClose) return numFileCorrente+1;

  fclose(fp);

  this->flagFileClose=TRUE;
  return numFileCorrente+1;

}


long multiFileAppend::getNumeroFilesCreati(){
  return numFileCorrente+1;
}

long multiFileAppend::write(void* v,long sizeElemento,long numElementi){
  if (flagFileClose) return 0;
  long totByteDaScrivere=sizeElemento*numElementi;//ntot byte da scrivere
  //nota char e' sempre 1 byte
  char* buf=(char*)v;//puntatore al file
  while (totByteDaScrivere>0){
    long scritti;

    if (dimMax>0)
        scritti=fwrite(buf,1,min_Append(totByteDaScrivere,dimMax-byteScrittiFileCorrente),fp);
    else
        scritti=fwrite(buf,1,totByteDaScrivere,fp);

    totByteDaScrivere-=scritti;
    byteScrittiFileCorrente+=scritti;
    buf=buf+scritti;
    if (totByteDaScrivere>0){
        fclose(fp);
        numFileCorrente++;
        snprintf(this->nomeFileCorrente,N,this->prototipoNomeFiles,this->numFileCorrente);

        this->fp=fopen(this->nomeFileCorrente,"a");
        check(fp,(char*)"Error:unable to open file %s\n",this->nomeFileCorrente);

        byteScrittiFileCorrente=0;//il file e' ora vuoto
    }
  }
  return numElementi;
}
