/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multiFileReader.cc :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================

#include "multiFileReader.h"
#include "../funzioniGenerali.h"
#include <string.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
//#include <iostream.h>
#include <iostream>





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// seek in avanti. Ritorna il num di elementi saltati. -1 on error
long long multiFileReader::seekInAvanti(long sizeElem,long numElem){
    if (fp==NULL) return -1;

    long long initialPosition=tell();//posizione di partenza
    this->seek(1, initialPosition+(long long)sizeElem*(long long)numElem );
    
    long long newPosition=tell();//posizione di arrivo

    //printf("salto %lld - Initial pos=%lld - new pos voluta =%lld - new tell ottenuta=%lld\n",(long long)sizeElem*(long long)numElem ,initialPosition, initialPosition+(long long)sizeElem*(long long)numElem, newPosition);
    //printf("Valore ritornato = %lld / %ld = %lld \n",newPosition-initialPosition, sizeElem,(newPosition-initialPosition)/(long long)sizeElem);

    //se non ho fatto un num di salti multiplo della size
    if ( (newPosition-initialPosition)%sizeElem!=0){
      seek(1,initialPosition);//ripristino la posizione iniziale
      return 0; 
    }
    else
      return ((newPosition-initialPosition)/(long long)sizeElem);
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
// seek in avanti. Ritorna il num di elementi saltati.
long multiFileReader::seekInAvanti_ernesto(long sizeElem,long numElem){

   if ((fp==NULL)||(numFileCorrente>=numFiles)){return 0;}

   long long numByteDaSaltare=sizeElem*numElem;
   long long byteSaltati=0;
   if (numByteDaSaltare<=0) return 0;

   while (fp!=NULL && numByteDaSaltare>0){

     //controllo la dimensione del file
     struct stat stbuf;
     stat(nomeFileCorrente,&stbuf);
     off_t sizeFile=stbuf.st_size;//dim file in byte

     //byte corrente da leggere
     long posCorrente=ftell(fp);

     long byte_restanti_nel_file= sizeFile - posCorrente;

     if(byte_restanti_nel_file > numByteDaSaltare)
     {
        fseek(fp,numByteDaSaltare,SEEK_CUR);
        byteSaltati += numByteDaSaltare;
        //numByteDaSaltare= 0;
        return byteSaltati/sizeElem;
     }
     else
     {
        byteSaltati += byte_restanti_nel_file;
        numByteDaSaltare -= byte_restanti_nel_file;

        fclose(fp);//chiudo il vecchio file
      	fp=NULL;

        numFileCorrente++;//passo al file successivo
        if (numFileCorrente<numFiles){
           snprintf(nomeFileCorrente,N,prototipo,numFileCorrente);
           fp=fopen(nomeFileCorrente,"r");
     	   check(fp,(char*)"Opening error in file %s\n",nomeFileCorrente);
        }
     }
   }

   return byteSaltati/sizeElem;
}






/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
multiFileReader::multiFileReader(char* prototipo,long num){
  init(prototipo,num,FALSE);
} 


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
multiFileReader::multiFileReader(char* prototipo,long num,bool cancella){
  init(prototipo,num,cancella);
} 







/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long multiFileReader::read(void* buffer,long sizeElemento,long numeroElementi){

  //NOTA: char e' sempre di un byte
  char* b=(char*)buffer;//puntatore interno al buffer (array di 1 byte)
  long numByteDaLeggere=sizeElemento*numeroElementi;//n byte da leggere in totale
  long letti;//byte letti ad ogni fread (usata nel ciclo)
  
  while ( (numByteDaLeggere>0) && (fp!=NULL)){

     letti=fread(b,1,numByteDaLeggere,fp);//legge quanti piu' dati possibile

     numByteDaLeggere=numByteDaLeggere-letti;
     
     //se mancano alcuni dati allora e' finito il file e se posso passo al successivo
     if (numByteDaLeggere>0){
         //sposto il puntatore
         b=b+letti;

         //chiudo il vecchio file
         closeCurrentFile();

         //apro il file successivo se esiste, altrimenti il multiFile risulta terminato
         numFileCorrente++;
         openFile(numFileCorrente);
     }
  }
//  printf("tot %d \n",(sizeElemento*numeroElementi-numByteDaLeggere)/sizeElemento);
  return (sizeElemento*numeroElementi-numByteDaLeggere)/sizeElemento;
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::cancella(){
   close();
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::close(){
  //se fine non chiuso allora lo chiudo

  if ( fp!=NULL){
      fclose(fp);

      //multifile chiuso
      fp=NULL;
  }

  if (cancellaQuandoLetto){
         //cancella tutti i files solo alla fine (quando si chiude)
         for (int i=0;i<this->numFiles;i++){
           char app[1000];
           sprintf(app,prototipo,i);
           remove(app);
         }
  }

}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::init(char* prototipo,long num,int cancella){

  //numero dei files
  if (num<=0) this->numFiles=contaNumFilesMultiFile(prototipo); //lo calcolo...
  else this->numFiles=num; // mi fido...

  fp=NULL;  //nessun file aperto  
  numFileCorrente=0;//num file corrente
  
  cancellaQuandoLetto=cancella;//opzione di cancellazione a file lettura...
  strcpy(this->prototipo,prototipo);
  openFile(numFileCorrente);//apre il primo file (pos 0)
  
  //calculate size for each file...
  size=new int[numFiles];

  for (int i=0;i<numFiles;i++){
    char app[N];
    snprintf(app,N,prototipo,i);
    size[i]= getFileSize(app);//get size of current file
  }
  
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void multiFileReader::reset(){
  openFile(0);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long multiFileReader::seek(long sizeElem,long long numElem){
  long long totalSeek=(long long)sizeElem*numElem;
  long long remainedSeek=totalSeek;

  //scelgo il num di file in cui andare a fare la seek
  int numFileDaSeek;
  for (numFileDaSeek=0;numFileDaSeek<numFiles;numFileDaSeek++){
    if (remainedSeek>=size[numFileDaSeek]) remainedSeek-=size[numFileDaSeek];
    else break;
  }

  if (numFileDaSeek>=numFiles) return -1;//not possible perform seek operation (exceed end of file), no pointer changed

  //cambia file corrente se necessario (torna indietro)
  if (numFileCorrente!=numFileDaSeek)
      openFile(numFileDaSeek);

  //controlla se c'e' un file
  if (fp==NULL) return -1;

  //esegue seek
  fseek(fp,(long)remainedSeek,SEEK_SET);

  return 0;
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long long multiFileReader::tell(){
  if (fp==NULL) return -1;
  long long ris=0;
  
  for (int i=0;i<numFileCorrente;i++)
    ris+=size[i];

  return ris+ftell(fp);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//apre il num di file specificato se possibile, else return fp=null
void multiFileReader::openFile(int num){
   closeCurrentFile();//close current file if opened

   //se il num del file non ha senso, ritorna NULL
   if (num>=numFiles) {
      closeCurrentFile();
      return;
   }

   //open new file
   this->numFileCorrente=num;
   sprintf(nomeFileCorrente,prototipo,num);
   fp=fopen(nomeFileCorrente,"r");
//   printf("XX nuovo %s %p\n",nomeFileCorrente,fp);
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//chiude il file corrente se possibile
void multiFileReader::closeCurrentFile(){
   if (fp!=NULL) fclose(fp);//close file if request
   fp=NULL;
}
