/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multiFileReader.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================


#ifndef _multiFileReader_
#define _multiFileReader_
#include <stdio.h>
#include "../funzioniGenerali.h"
// classe che gestisce l'accesso a piu' files (lo stesso file partizionato in + parti)
// in lettura
// CON CONDIVISIONE per la copia
class multiFileReader{

  public:
    multiFileReader(char* prototipo,long num);//vuole il nome dei files e il loro n; se num <0 allora viene calcolato in modo automatico usando tutti i files trovati
    multiFileReader(char* prototipo,long num,bool cancella);//spec se cancellare il file quando letto; se num <0 allora viene calcolato in modo automatico usando tutti i files trovati
    multiFileReader(){fp=NULL;cancellaQuandoLetto=false;numFiles=0;}//vuole il nome dei files e il loro nome
        
    long read(void* buffer,long size,long num);
    void cancella();
    void close();
    long getNumeroFileCorrente(){return numFileCorrente;}
    long getNumeroFiles(){return numFiles;}
    void init(char* prototipo,long num,int cancella);//funzione init
    long long seekInAvanti(long sizeElem,long numElem);//ritorna il num di elementi di size (sizeElem) che sono stati saltati
    long seekInAvanti_ernesto(long sizeElem,long numElem);

    long seek(long sizeElem,long long numElem);//seek to the file, from start... and return -1 on error, 0 else
    long long tell();//get current position in the file
    void reset();//reset pointer
    bool exists(){return (contaNumFilesMultiFile(prototipo)>0) && numFiles>0;}

    //ritorna il node del multifile (per riferimento !!! - non modificare)
    char* getMultiFileName(){return prototipo;}
  private:
    bool  cancellaQuandoLetto;//true se appena letto il file viene cancellato
    char prototipo[N];
    char nomeFileCorrente[N];
    long numFiles;
    long numFileCorrente;
    FILE* fp;
    int* size;
    //long flagFileClose;
    //void deleteFile(char* nome);
    void openFile(int numFile);
    void closeCurrentFile();    

};

#endif


