/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multiFileWriter.cc :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================

#include "multiFileWriter.h"
#include "../funzioniGenerali.h"
#include <string.h>

long min_Writer(long a,long b){
  if (a<b) return a;
  return b;
}


void multiFileWriter::cancella(){
  close();
}


multiFileWriter::multiFileWriter(){
  this->flagFileClose=TRUE;
}


multiFileWriter::multiFileWriter(char* prototipo,long dimMax){
  init(prototipo,dimMax);
}


void multiFileWriter::init(char* prototipo,long dimMax){


/*prende la dim maxx dei files e il prototipo del nome in formato printf al variare del numero*/
  strcpy(this->prototipoNomeFiles,prototipo);
  this->dimMax=dimMax;

  this->numFileCorrente=0;
  snprintf(this->nomeFileCorrente,N,this->prototipoNomeFiles,this->numFileCorrente);

  this->fp=fopen(this->nomeFileCorrente,"w");
  check(fp,(char*)"Error:unable to write file %s\n",this->nomeFileCorrente);

  this->flagFileClose=FALSE;
  this->byteScrittiFileCorrente=0;

  //if not in printf format then no partioning...
  if (!estMultiFileName(prototipo)) this->dimMax=-1;
}



long multiFileWriter::close(){
  //se file gia' chiuso allora
  if (this->flagFileClose) return numFileCorrente+1;
  fclose(fp);
  this->flagFileClose=TRUE;
  return numFileCorrente+1;
}


long multiFileWriter::getNumeroFilesCreati(){
  return numFileCorrente+1;
}


long multiFileWriter::write(void* v,long sizeElemento,long numElementi){
  if (flagFileClose) return 0;
  long totByteDaScrivere=sizeElemento*numElementi;//ntot byte da scrivere
  //nota char e' sempre 1 byte
  char* buf=(char*)v;//puntatore al file
  while (totByteDaScrivere>0){
    long scritti;
    long daScrivere;

    if (dimMax>0) daScrivere=min_Writer(totByteDaScrivere,dimMax-byteScrittiFileCorrente);//scrivo quelli rimasti x completare il file
    else          daScrivere=totByteDaScrivere;

    scritti=fwrite(buf,1,daScrivere,fp);
    if (daScrivere!=scritti){char app[1000];sprintf(app,"Error:unable to write file %s",prototipoNomeFiles);printError(app);FINE;}

    totByteDaScrivere-=scritti;
    byteScrittiFileCorrente+=scritti;
    buf=buf+scritti;
    if (totByteDaScrivere>0){
        fclose(fp);
        numFileCorrente++;
        snprintf(this->nomeFileCorrente,N,this->prototipoNomeFiles,this->numFileCorrente);

        this->fp=fopen(this->nomeFileCorrente,"w");
        check(fp,(char*)"Error:unable to write file %s\n",this->nomeFileCorrente);

        byteScrittiFileCorrente=0;//il file e' ora vuoto
    }
  }
  return numElementi;
}
