/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multiFileWriter.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//=======================================================================
//=======================================================================
//                              FILE COMUNE
//=======================================================================
//=======================================================================

#ifndef _multiFileWriter_
#define _multiFileWriter_

#include <stdio.h>
#include "../funzioniGenerali.h"

// classe che gestisce l'accesso a piu' files (lo stesso file partizionato in + parti)
// in scrittura CON CONDIVISIONE per la copia

class multiFileWriter{
  public:
    //multiFileWriter(char* prototipi,long num,char* mode);
    multiFileWriter(char* prototipo,long dim);
    multiFileWriter();
    void cancella();
    long write(void* buffer,long size,long num);
    long getNumeroFilesCreati();//n file attualmente creati
    long close();

    //ritorna il node del multifile (per riferimento !!! - non modificare)
    char* getMultiFileName(){return prototipoNomeFiles;}
  private:
    int  flagFileClose;
    char prototipoNomeFiles[N];
    char nomeFileCorrente[N];//nome del file in uso attualmente
    long numFileCorrente;
    long dimMax;//dimensione max in byte per ogni file
    long byteScrittiFileCorrente;
    FILE* fp;
    void init(char* prototipi,long num);
};

#endif

