/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file seekmultifilein.cpp :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#include "seekmultifilein.h"


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long seekMultiFileIn::contaNumFilesMultiFileLoc(char* nome){
    long conta=0;
    FILE* fp;
    char nomeFile[1000];

    while(true){
      sprintf(nomeFile,nome,conta);
      fp=fopen(nomeFile,"r");
      if (fp!=NULL){
          conta++;
          fclose(fp);
      }
      else
          return conta;

    }

    return conta;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long seekMultiFileIn::getFileSize(char* nomeFile){
  struct stat buf;
  stat(nomeFile, &buf);
  return buf.st_size;//size del file
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/



seekMultiFileIn::seekMultiFileIn(char* nome){
  strcpy(this->nomeFile,nome);
  this->f=NULL;
  this->numFileAperto=-1;
  chiuso=false;

  //conta il num di files presenti
  this->numFiles=contaNumFilesMultiFileLoc(nomeFile);

  //alloca memoria per il num di elementi per ogni file
  numBytePerFile=new long [numFiles];

  //conta gli elementi contenuti in ciascun multifile
  long long numByte=0;

  //per ogni file calcolo la size in bytes
  for (int i=0;i<numFiles;i++){ char nome[1000];sprintf(nome,nomeFile,i);numByte += ( numBytePerFile[i]=getFileSize(nome)   );     }
}





//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
//                          APRE IL FILE INFO/PRED/SUCC A SECONDA DELLE FUNZIONI
//-----------------------------------------------------------------------------------------------------------------------
//apre un file aggiornando le variabili di gestione
long seekMultiFileIn::apriSingoloFile(long numFileDaAprire, long posSeek){

   if (numFileDaAprire<0 || numFileDaAprire>=numFiles)   return -1;

   // controlla che il file non sia gia' aperto e se no lo riapre)
   if (numFileAperto!=numFileDaAprire){
//      printf("cambio file da %ld a %ld\n",numFileAperto,numFileDaAprire);

      //se qualcosa e' aperto, prima lo chiudo
      if (numFileAperto>=0){fclose(f);f=NULL;}

      // crea il nome del file
      char bb[1000];sprintf(bb, nomeFile,numFileDaAprire);

      //apre il file
      if ( (f=fopen(bb,"rb"))==NULL ) return -1;
//      cout<<" aperto file "<<bb<<" ";
      numFileAperto=numFileDaAprire;
   }

//   printf("seek in posizione %ld nel file %ld\n",posSeek,numFileAperto);
   return fseek(f,posSeek,SEEK_SET); //-1 se errore
}







//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
long seekMultiFileIn::trovaNumeroFile(long long posizioneInByte, long& posRelativaFile){
  long long rimasto=posizioneInByte;
  if (posizioneInByte<0) return -1;
  for (long pos=0;pos<numFiles;pos++){
    posRelativaFile=rimasto;//pos relativa nel file
    rimasto-=numBytePerFile[pos];
    if (rimasto<0) return pos;//equivale a rimasto_prec < buffer[pos]
  }
  return -1;
}
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------





void seekMultiFileIn::chiudi(){
  if (this->chiuso) return;
  chiuso=true;
  if (f!=NULL) fclose(f);
}





long long seekMultiFileIn::getSizeTotaleInByte(){
  long long somma=0;
  for (long i=0;i<numFiles;i++) somma+=numBytePerFile[i];
  return somma;
}




long seekMultiFileIn::getNumeroFiles(){
  return numFiles;
}




long seekMultiFileIn::getSizeFileI_esimo(long i){
  if ( i<0 || i>=numFiles ) return -1;
  return numBytePerFile[i];
}




long seekMultiFileIn::leggi( unsigned char* buffer, long sizeElemento,long numElementi,long long posSeekInizialeInByte){
  if (chiuso) return 0;

  long letti=0;//num byte letti
  long daLeggere=numElementi*sizeElemento;//num Byte rimasti da leggere
  unsigned char* cc=buffer;//puntatore al buffer


  while (daLeggere>0 ){
//     cout<<"\n  #################################   \n da leggere "<<daLeggere<<" dalla posizione totale "<<posSeekInizialeInByte<<"  ";

     //calcolo il numero del file in cui leggere e cerco di aprirlo se possibile...
     long posRelativa;
     long fileInizialeLettura=trovaNumeroFile(posSeekInizialeInByte, posRelativa);
//     cout<<" num file "<<fileInizialeLettura<<" posiz. "<<posRelativa<< " ";
     if (apriSingoloFile(fileInizialeLettura,posRelativa)<0) {return letti/sizeElemento;}//se file finito si esce

     //leggo e sposto i contatori
     long nuoviLetti=fread(cc,sizeof(unsigned char),daLeggere,f);
     if (nuoviLetti<0) return letti/sizeElemento;

//     cout<<" letti "<<nuoviLetti<<" ";
     daLeggere-=nuoviLetti;
     letti+=nuoviLetti;
     posSeekInizialeInByte+=nuoviLetti;//aggiorno la posizione della successiva lettura
     cc+=nuoviLetti;
  }

  return letti/sizeElemento;
}


