/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file avgsucc.cpp :source code of correlation utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <unistd.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#include "comuni.h"
#include "config.h"
#include "infonodo.h"
#include "mediaPerInDegree.h"

#define STESSA_LINEA (char)13



char bufferStampaProgressione[1000];

void trovaCorrelazione(
    bool prendiPredVicini,bool propagaIndegree,bool raggruppaNodiPerIndegree, bool ReportPerNodo,
    char *nomeTempo,char* nomeInfo,char* nomePred,char* nomeSucc, long memoria,
    char* fileRisPerNodi,char* fileRisDistr);





FILE* apriFile(char* nomeMultiFile,long numFileDaAprire){
  char nome[200];
  sprintf(nome,nomeMultiFile,numFileDaAprire);
  FILE* f=fopen(nome,"w");
  if (f==NULL){
      char a[200];
      sprintf(a,"Errore nell'apertura del file %s",nome);
      printError(a);FINE;
  }
  return f;
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(char* testo,long perc1,long perc2){

  /*======================== STAMPA MESSAGGI ===================================================================*/
  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

  if (perc1<0) perc1=0;
  else if (perc1>100) perc1=100;

  if (perc2<0) perc2=0;
  else if (perc2>100) perc2=100;

  perc2=(long) (20.0*perc2/100);
  //indicatore
  char st[50];

  strcpy(st,"____________________");
  for (long i=0;(i<20)&&(i<perc2);i++ )
     st[i]='@';

  //limite a 30 la lunghezza del testo
  char s[55];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<40);i++)
    s[i]=testo[i];
  for (; (i<40);i++)
    s[i]=' ';
  s[40]=0;


	sprintf(bufferStampaProgressione,"%c [%c] %3ld%c %20s ",STESSA_LINEA,cont,perc1,'%',st);
	printf("%s%28s%c",bufferStampaProgressione,s,STESSA_LINEA);
  fflush(stdout);
  /*============================================================================================================*/
}


long maxLoc (long a, long b){
  if (a>b) return a;
  return b;
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(char* testo){

  /*======================== STAMPA MESSAGGI ===================================================================*/

  static char cont='-';
  switch(cont){
  	case '-': cont='\\';break;
  	case '\\': cont='|';break;
  	case '|': cont='/';break;
  	case '/': cont='-';break;
  }
	
  //limite a 30 la lunghezza del testo
  char s[45];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<28);i++)
    s[i]=testo[i];
  s[i]=0;
  s[28]=0;

	printf("%s%28s",bufferStampaProgressione,s);
	printf("%c [%c]%c",STESSA_LINEA,cont,STESSA_LINEA);				
  fflush(stdout);

  /*============================================================================================================*/
}













//num long long in ogni buffer (8 MB ciascuno)
#define DIM_BUFFER_in_long_long        (long) maxLoc( 10, ( (RAM_DISPONIBILE/sizeof(long long)) /( NUM_BUFFER  )) )

//num buffer massimi che si possono creare
#define NUM_BUFFER        						 (long)(100)









void stampaHelp(int arg,char* argv[]){
  cout<<"This routine computes the degree correlation functions of the input graph. We can define eight distinct of such quantities that give us the correlation between the in-degree (out-degree) of the followers (predecessors) as a function of the in-degree (out-degree) distribution; we have all the combination {I|O}{f|p}{I|O} where the first letter ({I|O}) means that we are plotting the average in-degree (or out-degree), the second({f|p}) that we are looking at the followers (or predecessors), and the last one ({I|O}) that we are drawing the plot as a function of the in-degree (or the out-degree). The usage is as follows:\n";
	cout<<"\n";
  cout<<eliminaPath(argv[0])<<" memory neighbors degree degNeighbors nameInputMultifile%d nameTemporaryMultifile%d nameOutputTextMultifile%d\n";
  cout<<"\n";
  cout<<"memory        memory available (MB)\n";
  cout<<"neighbors     -pred|- succ specify that the analysis is based on the predecessors or successors\n";
  cout<<"degree        -indeg|-outdeg|-node if we want the results collected by the indegree, the outdegree or for each node\n";
  cout<<"degNeighbors  -indeg|-outdeg if we are interested in the indegree or outdegree of the predecessors or successors (as specified in neighbors)\n";
  cout<<"nameInputMultifile%d       name of the multifile of the input graph(ips format)\n";
  cout<<"nameTemporaryMultifile%d   name of a temporary multifile\n";
  cout<<"nameOutputTextMultifile%d  name of the output file, that is a text multifile\n";
}



int main(int arg,char* args[]){

  stampaLicenza(arg,args);
  if (arg!=8) STAMPA_ERRORE_PARAMETRI(args[0],"Incorrect parameters.");

  char nomeInfo[300];strcpy(nomeInfo,args[5]);strcat(nomeInfo,".info");
  char nomePred[300];strcpy(nomePred,args[5]);strcat(nomePred,".pred");
  char nomeSucc[300];strcpy(nomeSucc,args[5]);strcat(nomeSucc,".succ");
  
//  char* nomeInfo = args[5];
//  char* nomePred = args[6];
//  char* nomeSucc = args[7];
  char* tempo    = args[6];
  char* ris      = args[7];
  

  if (!estMultiFileName(nomeInfo))  STAMPA_ERRORE_PARAMETRI(args[0],"The INFO multifile name must contain the substring '%d' ");
  if (!estMultiFileName(nomePred))  STAMPA_ERRORE_PARAMETRI(args[0],"The PRED multifile name must contain the substring '%d' ");
  if (!estMultiFileName(nomeSucc))  STAMPA_ERRORE_PARAMETRI(args[0],"The SUCC multifile name must contain the substring '%d' ");
  if (!estMultiFileName(tempo   ))  STAMPA_ERRORE_PARAMETRI(args[0],"The Temporary multifile name must contain the substring '%d' ");
  if (!estMultiFileName(ris     ))  STAMPA_ERRORE_PARAMETRI(args[0],"Report multifile name must contain the substring '%d' ");

  //specifcia dei tipi
  bool  tipoViciniPred=false;//true se analizzo i successori - false se i predecessori
  bool  ragDegNodoIn=false;     //true se raggruppo per indegree ; false se x outdegree
  bool  degViciniIn=false;   //true se x i successori analizzo indegree; false se gli outdegree
  bool  reportPerNodo=false; //true se report per singoli nodi (escude "degNodoIn")

  //************************ CONTROLLO FILES DI INPUT ***************************
  if (getTotalSizeMultiFiles(nomeInfo)<=0){cout<<"The input graph is empty\n";FINE};
  if (getTotalSizeMultiFiles(nomePred)<=0){cout<<"The input graph is empty\n";FINE};
  if (getTotalSizeMultiFiles(nomeSucc)<=0){cout<<"The input graph is empty\n";FINE};

  
  if (strcasecmp(args[2],"-pred")==0)         tipoViciniPred=true;
  else if (strcasecmp(args[2],"-succ")==0)    tipoViciniPred=false;
  else {printf("<tipoVicini> non specificato");fflush(stdout); FINE;}

  if (strcasecmp(args[3],"-indeg")==0)       {reportPerNodo=false;ragDegNodoIn=true;}
  else if (strcasecmp(args[3],"-outdeg")==0) {reportPerNodo=false;ragDegNodoIn=false;}
  else if (strcasecmp(args[3],"-node")==0)   {reportPerNodo=true;ragDegNodoIn=false;}
  else {printf("<ragDegNodo> non specificato");fflush(stdout); FINE;}

  if (strcasecmp(args[4],"-indeg")==0)       degViciniIn=true;
  else if (strcasecmp(args[4],"-outdeg")==0) degViciniIn=false;
  else {printf("<degVicini> non specificato");fflush(stdout); FINE;}

  cout<<"Correlation: average "<<args[4]+1<<" of "<<args[2]+1<<" of each node, group by "<<args[3]+1<<"\n";

  
#ifdef SOLO_NODI_CON_NUM_VICINI_POSITIVO
  if (tipoViciniPred)
    printf("The nodes with INDEGREE == 0 are removed\n\n");
  else  
    printf("The nodes with OUTDEGREE == 0 are removed\n\n");
#else    
  if (tipoViciniPred)
    printf("The nodes with INDEGREE == 0 are counted like 0\n\n");
  else
    printf("The nodes with OUTDEGREE == 0 are counted like 0\n\n");
#endif



  long long m=(long)atof(args[1])*1024*1024;
  setMemoriaDisponibile(m);
  //cout<<"Memoria disponibile indicata: "<<getMemoriaDisponibile()/1024/1024<<"MB \n";

  //////////////////////////////////////////////////////////////
  // NUOVA PROVA ///////////////////////////////////////////////
  //////////////////////////////////////////////////////////////
  char risNodi[1000] ;strcpy(risNodi,ris);
  char risDistr[1000];strcpy(risDistr,ris);
  trovaCorrelazione(
    tipoViciniPred,degViciniIn,ragDegNodoIn, reportPerNodo,
    tempo,nomeInfo,nomePred,nomeSucc, m,risNodi,risDistr);
  //////////////////////////////////////////////////////////////
  
  EXIT(0);
}

