/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file correla.cpp :source code of correlation utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "comuni.h"
#include "config.h"
#include "multifilewritertxt.h"
#include <iostream>

/***************************************************************************
                          correla.cpp  -  description
                             -------------------
    begin                : Tue Nov 12 2002



    copyright            : (C) 2002 by root
    email                : root@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 
void trovaCorrelazione(
    bool prendiPredVicini,bool propagaIndegree,bool raggruppaNodiPerIndegree, bool ReportPerNodo,
    char *nomeTempo,char* nomeInfo,char* nomePred,char* nomeSucc, long memoria,
    char* fileRisPerNodi,char* fileRisDistr) {

  //calcolo num nodi e maxdim buffer
  long numNodi=getTotalSizeMultiFiles(nomeInfo)/sizeof(infoNodo);

  //calcolo num blocchi
  long sizeBuffer=memoria/sizeof(long long);
  if (sizeBuffer>numNodi) sizeBuffer=numNodi;
  
  long numBlocchi=numNodi/sizeBuffer;
  if (numNodi%sizeBuffer!=0) numBlocchi++;
  long long* buffer=new long long[sizeBuffer];

  printf("(*) Nodes partition: %ld nodes in %ld blocks (block size = %ld)\n",numNodi,numBlocchi,sizeBuffer);fflush(stdout);
  
  //file temporaneo
  multiFileWriter fTempo = multiFileWriter(nomeTempo,MAX_DIM_OUTPUT);

  // x ogni blocco ..............
  long nodiRimasti=numNodi;
  for (long bl=0;bl<numBlocchi;bl++){

    //calcolo max nodo del blocco corrente
    long maxNodoBloccoCorrente=(bl+1)*sizeBuffer-1;if (maxNodoBloccoCorrente>=numNodi) maxNodoBloccoCorrente=numNodi-1;
    long minNodoBloccoCorrente=bl*sizeBuffer;

    //messaggio blocco corrente
    char msg[100];
    sprintf(msg,"block %2ld/%2ld [nodes range %10ld;%10ld]",bl+1,numBlocchi,minNodoBloccoCorrente,maxNodoBloccoCorrente);
  
    //azzera il buffer
    for (int i=0;i<sizeBuffer;buffer[i++]=0);
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // trova quali files considerare come vicini
    // se voglio la distr x pred devo prendere i successori del nodo xche' distribuisco il valore ad essi
    multiFileReader fVicini;
    if (prendiPredVicini) fVicini = multiFileReader (nomeSucc, contaNumFilesMultiFile(nomeSucc) );
    else                  fVicini = multiFileReader (nomePred, contaNumFilesMultiFile(nomePred) );
    ///////////////////////////////////////////////////////////////////////////////////////////////

    multiFileReader fInfo   = multiFileReader (nomeInfo, contaNumFilesMultiFile(nomeInfo) );    
    infoNodo nodoCorrente;
    long numNodoCorrente=0;
    while ( fInfo.read(&nodoCorrente,sizeof(nodoCorrente),1)>0) {

#ifdef STAMPA




      cout<<"Node: "<<numNodoCorrente<<" - ";
#endif      

      //eventuale stampa
      if ( (numNodoCorrente%200000==0)||(numNodoCorrente==numNodi-1) ){
#ifndef STAMPA
        printf("%c%s ... %6.2f %s",13,msg,100.0*(numNodoCorrente+1)/numNodi,"%");
#endif
        fflush(stdout);
      }
      
      ///////////////////////////////////////////////////////////////////////////////////////////////
      // calcolo il num di elementi da leggere (pred o succ )
      long numVicini;
      if (prendiPredVicini)  numVicini=nodoCorrente.outDeg;
      else                   numVicini=nodoCorrente.inDeg ;
      ///////////////////////////////////////////////////////////////////////////////////////////////

      ///////////////////////////////////////////////////////////////////////////////////////////////
      // calcolo valore del nodo corrente da considerare (indeg o outdeg)
      long valoreNodo;
      if (propagaIndegree) valoreNodo=nodoCorrente.inDeg;
      else                 valoreNodo=nodoCorrente.outDeg;
      ///////////////////////////////////////////////////////////////////////////////////////////////

      //leggo i vicini del nodo corrente
      long vicino;
      for (long i=0;i<numVicini;i++){
        if (fVicini.read(&vicino,sizeof(long),1)<0){cout<<"Unexpected fatal error\n";FINE;}
        if (vicino/sizeBuffer == bl){
            long posRelativa=vicino-bl*sizeBuffer;
            if (posRelativa<0 || posRelativa>=sizeBuffer){cout<<"Unexpected fatal error\n";FINE;}
            buffer[posRelativa]+=valoreNodo;          
        }

#ifdef STAMPA
        cout<<vicino<<" ";
#endif        
      }
      numNodoCorrente++;
#ifdef STAMPA
      cout<<"\n";
#endif      
    }

    
    //chiude i files in lettura
    fInfo.close();
    fVicini.close();

    //scrive il calcolo ottenuto in un file temporaneo
    long numElementiNelBuffer=maxNodoBloccoCorrente-minNodoBloccoCorrente+1;
    fTempo.write(buffer,sizeof(long long),numElementiNelBuffer);
    //printf(" %ld nodes written\n",numElementiNelBuffer);fflush(stdout);

    nodiRimasti-=numElementiNelBuffer;
  }

  if (nodiRimasti>0){cout<<"Unexpected fatal error\n";FINE;}
  
  fTempo.close();
  delete[] buffer;
  buffer=NULL;





  
  //////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////// GENERAZIONE FILES DI REPORT //////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////
  
  multiFileReader f=multiFileReader(nomeTempo, contaNumFilesMultiFile(nomeTempo));//il file non verra' cancellato ora ma allo step successivo
  multiFileReader fInfo   = multiFileReader (nomeInfo, contaNumFilesMultiFile(nomeInfo) );


  cout<<"\n\n(*) Running distribution...\n";fflush(stdout);


  infoNodo nodoCorrente;
  long numNodoCorrente=0;
  long long sommaValVicini;

  double sommaDegree=0;
  double sommaCorrelazione=0;
  
  while ( fInfo.read(&nodoCorrente,sizeof(infoNodo),1)>0 ){

    //leggo la somma dei valori...
    if (f.read(&sommaValVicini,sizeof(long long),1)<=0){cout<<"Unexpected fatal error\n";FINE;}

    //eventuale stampa
    if ( (numNodoCorrente%200000==0)||(numNodoCorrente==numNodi-1) ){
#ifndef STAMPA
      printf("%c[%6.2f %s] Correlation calculus step [1] ",13,100.0*(numNodoCorrente+1)/numNodi,"%");
      printf(" -- numNodoCorrente %ld ",numNodoCorrente);
#endif
      fflush(stdout);
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // calcolo il num di elementi da leggere (pred o succ )
    //in questo caso prendo i pred x i pred
    long numVicini;
    if (prendiPredVicini) numVicini=nodoCorrente.inDeg ;
    else                  numVicini=nodoCorrente.outDeg;
    ///////////////////////////////////////////////////////////////////////////////////////////////

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // calcolo valore del nodo corrente da considerare (indeg o outdeg)
    long valoreRaggruppamentoNodo;
    if (raggruppaNodiPerIndegree) valoreRaggruppamentoNodo=nodoCorrente.inDeg;
    else                          valoreRaggruppamentoNodo=nodoCorrente.outDeg;
    ///////////////////////////////////////////////////////////////////////////////////////////////

    //valore medio associato al nodo corrente
    float mediaVal=0;
    if (numVicini>0) mediaVal=(1.0*sommaValVicini/numVicini);

    sommaDegree+=valoreRaggruppamentoNodo;
    sommaCorrelazione+=mediaVal;

    //nodo successivo
    numNodoCorrente++;
  }

  double mediaDegree=1.0*sommaDegree/numNodi;
  double mediaCorrelazione=1.0*sommaCorrelazione/numNodi;

//  cout<<"\nmediaDegree = "<<mediaDegree<<"mediaCorrelazione = "<<mediaCorrelazione<<endl;
  printf("SONO QUI 1\n");fflush(stdout);  
  f.close();
  printf("SONO QUI 2\n");fflush(stdout);
  fInfo.close();
  printf("SONO QUI 3\n");fflush(stdout);



//=====================================================================================
//=====================================================================================





  //ripeto la lettura
  f=multiFileReader(nomeTempo, contaNumFilesMultiFile(nomeTempo),true);//il file verra' cancellato
  fInfo   = multiFileReader (nomeInfo, contaNumFilesMultiFile(nomeInfo) );
  printf("SONO QUI 4\n");fflush(stdout);

  multiFileWriterTXT fNodi;
  if (ReportPerNodo) fNodi=multiFileWriterTXT( fileRisPerNodi, 10000000 );
  printf("SONO QUI 5\n");fflush(stdout);

  //header del file
  if (ReportPerNodo){

       printf("SONO QUI 5-A\n");fflush(stdout);
       //formatta scrittura intestazione
       char txtCorr[300];strcpy(txtCorr,"");
       if (propagaIndegree)strcat(txtCorr,"%avg indeg ");
       else                strcat(txtCorr,"%avg outdeg ");
       if (prendiPredVicini)strcat(txtCorr,"of pred.");
       else                 strcat(txtCorr,"of succ.");

       char txt[300];
       sprintf(txt,"%10s\t%10s\t%10s\t%10s\t%s\n","%node","%indegree","%outdegree",txtCorr,"%sum");

       printf("SONO QUI 5-B\n");fflush(stdout);
       fNodi.scriviStringa(txt);
       printf("SONO QUI 5-C\n");fflush(stdout);
       
  }
  printf("SONO QUI 6\n");fflush(stdout);

  
#ifdef STAMPA
  //formatta scrittura intestazione
  char txtCorr[300];strcpy(txtCorr,"");
  if (propagaIndegree)strcat(txtCorr,"%avg indeg ");
  else                strcat(txtCorr,"%avg outdeg ");
  if (prendiPredVicini)strcat(txtCorr,"of the pred.");
  else                 strcat(txtCorr,"of the succ.");
  fprintf(stderr,"%10s\t%10s\t%10s\t%10s\t%ssum\n","%node","%indegree","%outdegree",txtCorr);
#endif

  //allocazione nuovi buffer
  sizeBuffer=memoria/(sizeof(long)+sizeof(long));
  if (sizeBuffer<=100) {sizeBuffer=100;  printf("POCA MEMORIA\n");fflush(stdout);}
  if (sizeBuffer>numNodi) sizeBuffer=numNodi;

  printf("SONO QUI 7\n");fflush(stdout);
  float* valDistr = new float[sizeBuffer];
  long* numValori = new long [sizeBuffer];
  printf("Range of x-values of distribution is [0-%ld]\n",sizeBuffer-1);
  
  for (int i=0;i<sizeBuffer;i++){
      valDistr[i]=0;
      numValori[i]=0;
  }
  printf("SONO QUI 8\n");fflush(stdout);


  
  double sigmaDegree=0;
  double sigmaCorrela=0;
  double covDegreeCorrela=0;
  numNodoCorrente=0;
  printf("SONO QUI 9\n");fflush(stdout);
          
  while ( fInfo.read(&nodoCorrente,sizeof(infoNodo),1)>0 ){
  
    //eventuale stampa
    if ( (numNodoCorrente%200000==0)||(numNodoCorrente==numNodi-1) ){
#ifndef STAMPA
      printf("%c[%6.2f %s] Correlation calculus step [2] ",13,100.0*(numNodoCorrente+1)/numNodi,"%");
      printf(" -- numNodoCorrente %ld ",numNodoCorrente);
#endif      
      fflush(stdout);
    }

    //leggo la somma dei valori...
    if (f.read(&sommaValVicini,sizeof(long long),1)<=0){cout<<"Unexpected fatal error\n";FINE;}

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // calcolo il num di elementi da leggere (pred o succ )
    //in questo caso prendo i pred x i pred
    long numVicini;
    if (prendiPredVicini) numVicini=nodoCorrente.inDeg ;
    else                  numVicini=nodoCorrente.outDeg;
    ///////////////////////////////////////////////////////////////////////////////////////////////

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // calcolo valore del nodo corrente da considerare (indeg o outdeg)
    long valoreRaggruppamentoNodo;
    if (raggruppaNodiPerIndegree) valoreRaggruppamentoNodo=nodoCorrente.inDeg;
    else                          valoreRaggruppamentoNodo=nodoCorrente.outDeg;
    ///////////////////////////////////////////////////////////////////////////////////////////////

    //valore medio associato al nodo corrente
    float mediaVal=0;
    if (numVicini>0) mediaVal=(1.0*sommaValVicini/numVicini);

    
    sigmaDegree += (valoreRaggruppamentoNodo-mediaDegree)  * (valoreRaggruppamentoNodo-mediaDegree) ;
    sigmaCorrela+= (mediaVal-mediaCorrelazione) * (mediaVal-mediaCorrelazione);
    covDegreeCorrela+= (valoreRaggruppamentoNodo-mediaDegree) * (mediaVal-mediaCorrelazione);

                  
    if (ReportPerNodo){
       char txt[200];
       if (numVicini>0)
         sprintf(txt,"%10ld\t%10ld\t%10ld\t%10g\t%10g\n", numNodoCorrente, nodoCorrente.inDeg, nodoCorrente.outDeg, mediaVal,1.0*sommaValVicini);
       else  
         sprintf(txt,"%10ld\t%10ld\t%10ld\t%10g\t%10g *\n", numNodoCorrente, nodoCorrente.inDeg, nodoCorrente.outDeg, mediaVal,1.0*sommaValVicini);
       fNodi.scriviStringa(txt);      
    }

#ifdef STAMPA
    fprintf(stderr,"%10ld\t%10ld\t%10ld\t%10g\t%10lld\n", numNodoCorrente, nodoCorrente.inDeg, nodoCorrente.outDeg, mediaVal,sommaValVicini);
#endif

#ifdef SOLO_NODI_CON_NUM_VICINI_POSITIVO
    //aggiorna la distrib. (NELLA DISTRIBUZIONE FINALE TENGO CONTO SOLO DEI NODI CON NUM VICINI >0 )
    if (numVicini>0){
#endif      
      if (valoreRaggruppamentoNodo>=sizeBuffer) valoreRaggruppamentoNodo=sizeBuffer-1;
      valDistr [valoreRaggruppamentoNodo]+=mediaVal;
      numValori[valoreRaggruppamentoNodo]++;//un nuovo nodo con in/outdeg
#ifdef SOLO_NODI_CON_NUM_VICINI_POSITIVO
    }
#endif

    //nodo successivo
    numNodoCorrente++;
  }

  sigmaDegree  = sqrt(1.0/numNodi*sigmaDegree);
  sigmaCorrela = sqrt(1.0/numNodi*sigmaCorrela);
  covDegreeCorrela  = 1.0/numNodi*covDegreeCorrela;
  double corrDegreeCorrela=0;
  if (sigmaDegree*sigmaCorrela!=0) corrDegreeCorrela = covDegreeCorrela/(sigmaDegree*sigmaCorrela);
  
  
  fNodi.chiudi();
  fInfo.close();
  f.close();
  cout<<"\n";

#ifdef STAMPA
  for (int i=0;i<20;i++)
    printf("degree=%2d - n val=%3d - somma medie=%g\n",i,numValori[i],valDistr[i]);  
#endif


  if (!ReportPerNodo){
    cout<<"\nGlobal correlation between values = "<<corrDegreeCorrela<<endl;
/*    cout<<"sigma Degree      "<<sigmaDegree<<endl;
    cout<<"sigma Correla     "<<sigmaCorrela<<endl;
    cout<<"covDegreeCorrela "<<covDegreeCorrela<<endl;*/
    
    ///////////////// SCRITTURA DISTRIBUZIONE
    multiFileWriterTXT fDistr=multiFileWriterTXT(fileRisDistr,10000000);

    
    //formatta scrittura testo prima riga
    char txt[300];
    char txtCorr[400];
    strcpy(txtCorr,"");
    if (propagaIndegree)strcat(txtCorr,"%average indegree ");
    else                strcat(txtCorr,"%average outdegree ");
    #ifdef SOLO_NODI_CON_NUM_VICINI_POSITIVO
    if (prendiPredVicini)strcat(txtCorr,"of the predecessors of each node with indeg>0");
    else                 strcat(txtCorr,"of the successors of each node with outdeg>0");
    if (raggruppaNodiPerIndegree)strcat(txtCorr,"group by (avg) indegree");
    else                         strcat(txtCorr,"group by (avg) outdegree");
    #else
    if (prendiPredVicini)strcat(txtCorr,"of the predecessors of each node (let 0 if indeg node =0)");
    else                 strcat(txtCorr,"of the successors of each node (let 0 if indeg node =0)");
    if (raggruppaNodiPerIndegree)strcat(txtCorr,"group by (avg) indegree");

    else                         strcat(txtCorr,"group by (avg) outdegree");
    #endif
    
    if (raggruppaNodiPerIndegree)sprintf(txt,"%10s\t%10s\n","%indegree",txtCorr);
    else                         sprintf(txt,"%10s\t%10s\n","%outdegree",txtCorr);
    fDistr.scriviStringa(txt);


    printf("\n(*) Writing report file... ");fflush(stdout);
    for (long i=0;i<sizeBuffer;i++){
      float valMediaFinale=0;
      if (numValori[i]>0)valMediaFinale=1.0*valDistr[i]/numValori[i];
      if (valMediaFinale>0){
         sprintf(txt,"%10ld\t%10g\n",i,valMediaFinale);
         fDistr.scriviStringa(txt);
      }    
    }
    cout<<"OK\n";fflush(stdout);

    sprintf(txt,"\nTotal correlation\t%.10f\n",corrDegreeCorrela);
    fDistr.scriviStringa(txt);

    fDistr.chiudi();
  }

  delete[] valDistr;valDistr=NULL;
  delete[] numValori;numValori=NULL;
}

