/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file grafoPredSucc.cc :source code of infopredsucc2edges32 utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "config.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <wait.h>
#include <unistd.h>
#include "comuni.h"

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*
class grafoInfo{
public:
long inDeg;
long outDeg;
long long puntIn;
long long puntOut;
};*/




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//  stampa i parametri d'uso
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

void stampaHelp(int arg,char* argv[]){
  
		cout<< "This utility converts an ips format multifile in the edges format\n";
		cout<< " \n";
		cout<< "Usage: "<<eliminaPath(argv[0])<<" memory -savesource|-deletesource nameInputMultifile%d nameOutputMultifile%d\n";
		cout<<"\n";
		cout<< "memory                     memory available(MB)\n";
		cout<< "-savesource|-deletesource  specify whether to delete or keep the input file\n";
		cout<< "nameInputMultifile%d       name of the multifile of the input graph (ips format)\n";
		cout<< "nameOutputMultifile%d      name of the output multifile (in 'extended' edges format)\n";
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void creaFileArchi(char* grafoINFO, long numINFO, char* grafoPRED, long numPRED, char* grafoSUCC, long numSUCC,char* grafoOut ,bool cancella){

  if (cancella){
     //cancella i files pred
     char nome[1000];
     for (int i=0;i<numPRED;i++){
        sprintf(nome,grafoPRED,i);
        remove(nome);
     }
  }


  // buffer per l'accesso ai files in scrittura...
//  arco* bufArchi = new arco [MAX_NUM_SUCCESSORI];
//  long* bufSucc  = new long [MAX_NUM_SUCCESSORI];

  //conteggio
  long long numArchiTotali=getTotalSizeMultiFiles(grafoSUCC)/sizeof(long);
  long      numNodiTotali=getTotalSizeMultiFiles(grafoINFO)/sizeof(infoNodo);


  //apertura del file grafo output INFO/PRED/SUCC
  bufferedThreadFileOutputStream fArchi=bufferedThreadFileOutputStream(grafoOut,MAX_DIM_FILES,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE);

  //  FILE INFO
  bufferedThreadFileInputStream  fInfo=bufferedThreadFileInputStream(grafoINFO,numINFO,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE ,cancella);

  //  FILE SUCC
  bufferedThreadFileInputStream  fSucc=bufferedThreadFileInputStream(grafoSUCC,numSUCC,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE ,cancella);




  infoNodo info;
  long nodoCorrente=0;
  long long nArchiParziali=0;
  long long iterazioni= MAX_ITER;
  cout<<"Format conversion:\n";fflush(stdout);

  while ( fInfo.read(&info,sizeof(infoNodo),1)>0 ){
    //if (info.outDeg>MAX_NUM_SUCCESSORI){cout<<"Number of successors for node "<<nodoCorrente<<" is too high (higher than "<<MAX_NUM_SUCCESSORI<<")";FINE;}


    //crea gli archi dai nodi successori
    for (int i=0;i<info.outDeg;i++){
      long nodoSucc;

      //legge il successore corrente
      fSucc.read(&nodoSucc,sizeof(long),1);

      //crea l'arco
      arco ar;
      ar.source = nodoCorrente;
      ar.dest   = nodoSucc;

      //scrive in output l'arco
      fArchi.write(&ar,sizeof(arco),1);
    }


    //conto il nodo corrente e i suoi archi
    nodoCorrente++;
    nArchiParziali+=info.outDeg;

    if ( (iterazioni++>MAX_ITER) || (nodoCorrente==numNodiTotali) ){
       iterazioni=0;
       printf("%c[%6.2f%s] ips --> edges (%6.2fMB written)%c",13,100.0*nArchiParziali/numArchiTotali,"%",1.0*nArchiParziali*sizeof(arco)/(1024*1024),13);
       fflush(stdout);
    }

  }

  //aggiuge la label relativa al num di nodi...
  arco aux;
  aux.source=aux.dest=-nodoCorrente;
  if (fArchi.write(&aux,sizeof(arco),1)<1){perror("Write error");FINE;}
  PRINT_ISOLATED_NODES_SPECIFICATION;


  //chiusura files


  fInfo.close();
  fInfo.cancella();

  fSucc.close();
  fSucc.cancella();

  fArchi.close();
  fArchi.cancella();

  //cancellazione buffer
  //delete[] bufArchi;
  //delete[] bufSucc;

  if (nArchiParziali!=numArchiTotali){
    cout<<"Unexpected fatal error 1";
    FINE;
  }


  printf("\n\n");
  printf("Total nodes : %ld\n",nodoCorrente );
  printf("Total edges : %lld\n",nArchiParziali);

}



int main(int arg,char** argv)
{

    stampaLicenza(arg,argv);
    if (arg!=5) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

  	
    long cancellaSource;
    if (strcasecmp(argv[1+1],"-saveSource")==0)  cancellaSource=FALSE;
    else    if (strcasecmp(argv[1+1],"-deleteSource")==0)  cancellaSource=TRUE;
            else  STAMPA_ERRORE_PARAMETRI(argv[0],"option -deleteSource or -saveSource not found");



    char grafoINFO[300];strcpy(grafoINFO,argv[2+1]);strcat(grafoINFO,".info");
    char grafoPRED[300];strcpy(grafoPRED,argv[2+1]);strcat(grafoPRED,".pred");//=argv[3];
    char grafoSUCC[300];strcpy(grafoSUCC,argv[2+1]);strcat(grafoSUCC,".succ");//=argv[4];
    char* grafoOut =argv[3+1];

    
    //************************ CONTROLLO FILES DI INPUT ***************************
    if (getTotalSizeMultiFiles(grafoINFO)<=0){cout<<"The input graph is empty (INFO)\n";FINE};
    if (getTotalSizeMultiFiles(grafoPRED)<=0){cout<<"The input graph is empty (PRED)\n";FINE};
    if (getTotalSizeMultiFiles(grafoSUCC)<=0){cout<<"The input graph is empty (SUCC)\n";FINE};




    long numINFO=contaNumFilesMultiFile(grafoINFO);//atol(argv[3]);
    long numPRED=contaNumFilesMultiFile(grafoPRED);//atol(argv[5]);
    long numSUCC=contaNumFilesMultiFile(grafoSUCC);//atol(argv[5]);


    if (numINFO<=0)       STAMPA_ERRORE_PARAMETRI(argv[0],"The input graph is empty (INFO)");
    if (numSUCC<=0)       STAMPA_ERRORE_PARAMETRI(argv[0],"The input graph is empty (SUCC)");
    if (numPRED<=0)       STAMPA_ERRORE_PARAMETRI(argv[0],"The input graph is empty (PRED)");

    if (!estMultiFileName(grafoINFO)) STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifiles names must contain the substring '%d'");
    if (!estMultiFileName(grafoPRED)) STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifiles names must contain the substring '%d'");
    if (!estMultiFileName(grafoSUCC)) STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifiles names must contain the substring '%d'");
    if (!estMultiFileName(grafoOut)) STAMPA_ERRORE_PARAMETRI(argv[0],"Output multifiles names must contain the substring '%d'");



    creaFileArchi( grafoINFO, numINFO, grafoPRED, numPRED, grafoSUCC, numSUCC,grafoOut ,cancellaSource );
	
    EXIT(0);
    return 0;
}



