/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file distribuzionePotenza.h :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          distribuzionePotenza.h  -  description
                             -------------------
    begin                : Wed Nov 27 2002
    copyright            : (C) 2002 by root
    email                : root@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "comuni.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <math.h>

#define long64 long long

#ifndef DISTR_POTENZA
#define DISTR_POTENZA

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//gestisce una distr di potenza dei degree
//---------------------------------------------------------------------------------
class distrPotenza{

 /*===================================================================================================*/
 public:
   distrPotenza(long numNodi, double esp, long maxDegree,long seed);
   distrPotenza(long numNodi, long numSuccPerNodo, double esp, long maxDegree,long seed);
   distrPotenza(){distr=degree=NULL;sizeDistr=0;}
   long getNextOutDeg();
   void cancella();
   void stampa();
   long getOutDeg();

   static double zeta(double esp, long numIterazioniMax);
 /*===================================================================================================*/


  /*===================================================================================================*/
public:
   long* distr; //num nodi rimasti
   long  sizeDistr;  //size vettore (max n. di outegree)

private:
   long* degree;//valore degree associato

   ////////////// livelli di puntamento //////////////
   long* liv1, *liv2, *liv3;
   long  size1, size2, size3;

   //fattori di rapporto tra i vari livelli
   #define RAGG1  (20) /*livello piu' elevato*/
   #define RAGG2  (20)
   #define RAGG3  (20) /*livello piu' basso*/
   ///////////////////////////////////////////////////

   double coeff;
   long64 numElementiRimasti;
 /*===================================================================================================*/


};
//---------------------------------------------------------------------------------

#endif
