/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file grafo.cpp :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#include "grafo.h"


//----------------------------------------------
//    costruttore grafo vuoto
//----------------------------------------------
grafo::grafo(long nNodi){
  this->numNodi=nNodi;

  //per ogni nodo creo il puntatore alla lista dei successori ma senza allocarli
  this->succ=new long* [numNodi];
  
  for (long i=0;i<numNodi;i++)
      succ[i]=NULL;//new long [ this->nSuccPerNodo];
}



//----------------------------------------------
//specifica il num di successori per il nodo corrente
//----------------------------------------------
void grafo::setMaxSuccNodo(long nodo,long nSucc){
  if (nSucc<=0) return;
  if (nodo<0||nodo>=this->numNodi) return;
  if (this->succ[nodo]==NULL) return;

  //alloca il vettore dei successori per il nodo e lo inizializza a -1
  succ[nodo]=new long[nSucc+2];

  succ[nodo][0]=0;//num successori =0

  for (int i=1;i<=nSucc;succ[nodo][i++]=-1);//nodi successori

  succ[nodo][nSucc+1]=-10;//chiusura del vettore
  
}


//----------------------------------------------
//    ritorna il  posSucc-esimo  successore SENZA ALCUN CONTROLLO !!!!!!!!
//----------------------------------------------
long grafo::getSuccNodo(long nodo,long posSucc){
  if (succ==NULL) return -1;
  if (succ[nodo]==NULL) return -1;//il nodo non ha successori
  if (succ[nodo][0]<=posSucc) return -1;//il nodo non ha sufficienti successori  
  return (succ[nodo])[posSucc+1];
}




//----------------------------------------------
//aggiunge un nuovo successore se ancora non c'e' SENZA ALCUN CONTROLLO !!!!!!!!
//----------------------------------------------
long grafo::addSucc(long nodo, long nodoSucc){

  //errore
  if (succ==NULL) return -3;

  long* v=succ[nodo];
  if (v==NULL) return -10;//non c'e' spazio

  //controllo la fine del vettore...
  if ( v[ v[0]+1 ]<=-10){
    cout<<"Error: you want insert a successor node, but there is no space for it\n";
    FINE;    
  }
  
  v[v[0]+1]=nodo;
  v[0]++;
        
  return 0;

}




//----------------------------------------------
//       cancella la struttura del grafo
//----------------------------------------------
void grafo::cancella(){

  //errore
  if (succ==NULL) return ;

  for (long i=0;i<numNodi;i++){
    if (succ[i]!=NULL)
        delete[] succ[i];
    succ[i]=NULL;
  }
  delete[] this->succ;this->succ=NULL;

}
