/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file modelLayer.cpp :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "utilityModel.h"
#include "config.h"
#include <math.h>
#include "distribuzionePotenza.h"








// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
//
//                          GENERA I VARI NODI PER OGNI LAYER
//
// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################

void generaLayer(long layerTot,long layerPerNodo,long numNodi,long numSuccTotali,char* nomeGrafo, long seed,
  long* sizeLayerComplete, long* numFilesLayer,bool sceltaUniforme,bool generaLayerDistinti,
  long*maxSuccPerLayer,float esp,bool distPotenza,randomGen2& generaRandom){

  randomGen2 r2=randomGen2(seed,1000);
  
  for (int i=0;i<layerTot;maxSuccPerLayer[i++]=0);
  //layer rimasti
  long layerRimasti=layerTot;
  long primoLayerCompresoInAnalisi=0;

  //conteggio stampa
  long conta=1000000;


  printf("Multilayer nodes partition (%ld layers x node)\n",layerPerNodo);
  printf("+---------+---------+---------+---------------+\n");
  printf("|  %s tot  |  layer  |%s partial|    nodes      |\n","%","%");
  printf("+---------+---------+---------+---------------+\n");

  long long numTotaleNodiCopiati=0;//num tot di copie dei vari archi inseriti


  //---------------------------------------------------------------------
  //---------------------------------------------------------------------
  //                    PER OGNI BLOCCO DI LAYER IN ESAME
  //---------------------------------------------------------------------
  //---------------------------------------------------------------------

  //LAVORO A BLOCCHI DI LAYER (per velocizzare tutto)
  while (layerRimasti>0){

    //'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    //          distribuzione a potenza se necessaria
    //.................................................................
    //cout<<"\n ------- NUOVA ANALISI -----------\n";
    distrPotenza dp;
    if (distPotenza)  {
      cout<<"OutDegree distribution...";fflush(stdout);

      //se fisso il num di archi
      //cout<<"\n";
      //cout<<"Nodi = "<<numNodi<<" num Succ = "<<numSuccTotali<<" - esp = "<<esp<<" - MAX_OUTDEGREE_GENERATORE = "<<MAX_OUTDEGREE_GENERATORE<<"\n";

      long outdg=MAX_OUTDEGREE_GENERATORE;if (outdg>numNodi) outdg=numNodi;
      
      //impone num nodi
      //dp = distrPotenza(numNodi,esp,outdg,seed);
      dp = distrPotenza(numNodi,numSuccTotali,esp,outdg,seed);
      
      
      //dp.stampa();
      //cout<<"\n";
      
      //se fisso il num di nodi
      //dp = distrPotenza(numNodi,esp,MAX_OUTDEGREE,seed);
    
      cout<<"OK";fflush(stdout);
      //FINE;
    }

    //.................................................................
    //.................................................................


    //init random generator - QUI PERCHE' COSI' OGNI VOLTA E' COME SE CREASSI TUTTO DA CAPO
    //long long puntRandom=0;
    generaRandom.resetSeed();

    //init la size dei layer (init a 1 perche' contiene in realta' size+1)
    inDeg sizeLayerAccess=inDeg(layerTot,10,10,10);
    for (long i=0;i<layerTot;sizeLayerAccess.aggiungiInDeg(i++));

    //calcola l'intervallo dei layer in esame
    long ultimoLayerCompresoInAnalisi = primoLayerCompresoInAnalisi+NUM_LAYER_CONTEMPORANEI-1;
    if (ultimoLayerCompresoInAnalisi>=layerTot) ultimoLayerCompresoInAnalisi=layerTot-1;
    long numLayerInAnalisi=ultimoLayerCompresoInAnalisi-primoLayerCompresoInAnalisi+1;

    //apre i files temporanei dei nodi
    multiFileWriter* f_tempo_nodi = new multiFileWriter [numLayerInAnalisi]();
    for (long i=0;i<numLayerInAnalisi;i++){
       char b[1000];
       generaNomeTempoNodiPerLayer(b,i+primoLayerCompresoInAnalisi,nomeGrafo);
       f_tempo_nodi[i]=multiFileWriter(b,DIM_MAX);
    }

    //azzera conteggio size dei vari layer come numero di nodi
    for (long i=0;i<layerTot;sizeLayerComplete[i++]=0);

    //---------------------------------------------------------------------
    //inizia calcolo per tutti i nodi del layer corrispondente
    //---------------------------------------------------------------------
    for (long nodo=0;nodo<numNodi;nodo++){

        //STAMPA
        if ( (conta++>=300000) || (nodo>=numNodi-1)  ){
              float percParz=100.0*(nodo+1)/numNodi;
              float percTot= 100.0-100.0*( 1.0*layerRimasti-numLayerInAnalisi*percParz/100.0     )/layerTot;
              //cout<<"\n ___ "<<layerRimasti-numLayerInAnalisi<<"\n";
              printf("%c| %6.2f%s | %3ld;%3ld | %6.2f%s |     %9ld |%c|",13,percTot,"%",primoLayerCompresoInAnalisi,ultimoLayerCompresoInAnalisi,percParz,"%",nodo+1,13);
              conta=0;fflush(stdout);
        }


        //_________________________________________________________________________________________
        //
        //SCELGO I LAYER DISTINTI DA ASSEGNARE AL NODO IN QUESTIONE IN BASE ALLA SIZE DI OGNI LAYER
        //_________________________________________________________________________________________

        //insieme dei layer gia' assegnati
        insieme layerAssegnati = insieme(layerPerNodo);
//        cout<<"TOT = "<<layerTot<<"\n";

        //mentre non ho scelto tutti i layer distinti
        while (layerAssegnati.getSize()<layerPerNodo){

          //scelta del layer in base alla size dei vari layer e aggiunta
          long layerScelta;

          //sceltaUniforme=true;;
          if (!sceltaUniforme)//scelta in base alla size dei layer
              layerScelta= sizeLayerAccess.trovaNodo( normalizzaLancio(generaRandom.genrand(),1, sizeLayerAccess.getInDegTotale() ));
          else//scelta uniforme dei layer
              layerScelta= normalizzaLancio(generaRandom.genrand(),0, layerTot-1 );

          //cout<<"   "<<layerAssegnati.getSize()<<"  "<<layerScelta<<" rand = "<<generaRandom.genrand()<<"  \n";fflush(stdout);

          if (layerScelta<0){ cout<<"Unexpected fatal error n.1";FINE;};

          //---------------------------------------------------------------------------------------------------------------------------------
          //---------------------------------------------------------------------------------------------------------------------------------
          //---------------------------------------------------------------------------------------------------------------------------------
          //se il layer e' nuovo per il nodo o non voglio layer distinti --> lo prendo
          if ((layerAssegnati.getPosizioneElemento(layerScelta)<0)||( !generaLayerDistinti )){
              //aggiunge nodo per il layer
              if (layerAssegnati.aggiungiElemento(layerScelta)<0){ cout<<"Unexpected fatal error n.2";FINE;};
              sizeLayerAccess.aggiungiInDeg(layerScelta);
          }
          //---------------------------------------------------------------------------------------------------------------------------------
          //---------------------------------------------------------------------------------------------------------------------------------
          //---------------------------------------------------------------------------------------------------------------------------------

        }
        //_________________________________________________________________________________________
        //_________________________________________________________________________________________


//        cout<<" OK3\n";fflush(stdout);
        
        //_________________________________________________________________________________________
        //
        //CALCOLO LA LISTA DEI LAYER TROVATI PER IL NODO CORRENTE (TUTTI)
        //_________________________________________________________________________________________
        //punto ai layer trovati e quelli possibili li copio su file
        long* v=NULL;
        long size=0;
        size=layerAssegnati.getVettore(v);

        if (size!=layerPerNodo){
            cout<<"Unexpected fatal error n.3";
            FINE;
        }
        //_________________________________________________________________________________________
        //_________________________________________________________________________________________


    
        //_________________________________________________________________________________________
        //
        //  PRENDO I SOLI LAYER (TRA QUELLI ASSOCIATI AL NODO) CHE STO ANALIZZANDO E SCRIVO IL
        //  NODO SUL CORRISPONDENTE FILE TEMPORANEO ASSOCIATO AL LAYER
        //_________________________________________________________________________________________

        //la size DEL VETTORE sara' sicuramente layerPerNodo per costruzione (a blocchi di layer)
        long degRimastiDaAssegnare;
        //cout<<"nodo "<<nodo<<"\n";
        if (distPotenza)  numSuccTotali=degRimastiDaAssegnare = dp.getOutDeg();
        else              degRimastiDaAssegnare = numSuccTotali;

//        cout<<"\nnodo "<<nodo<<": ";//["<<degRimastiDaAssegnare<<"]";
        
        for (long i=0;i<size;i++){
           // se il layer corrente e' compreso in quelli in esame lo copio
           if (v[i]>=primoLayerCompresoInAnalisi && v[i]<=ultimoLayerCompresoInAnalisi){
                  long layerRelativo=v[i]-primoLayerCompresoInAnalisi;

                  //nuovo nodo da associare al layer trovato
                  infoNodoSucc info;
                  info.nodo=nodo;


                  //-------------------------------------------------------------------------------------
                  //CALCOLA IL NUM DI ARCHI USCENTI DAL NODO IN OGNI LAYER IN CUI SI TROVA IL NODO STESSO
                  //-------------------------------------------------------------------------------------
                  //se e' l'ultimo layer
                  if (i==size-1){
                      if (degRimastiDaAssegnare<0) {cout<<"Unexpected fatal error n.4";FINE;}
                      info.nSucc = degRimastiDaAssegnare;
                  }
                  else{
                      if (distPotenza)  info.nSucc = (long)(r2.genrand()%(degRimastiDaAssegnare+1));
                      else              info.nSucc = numSuccTotali/size;                      
                      degRimastiDaAssegnare-=info.nSucc;
                  }
//                  cout<<"layer "<<v[i]<<" (n succ "<<info.nSucc<<")  ";
                  
                  //-------------------------------------------------------------------------------------

                  //controllo max num di successori per il layer corrente
                  if (maxSuccPerLayer[v[i]]<info.nSucc)maxSuccPerLayer[v[i]]=info.nSucc;
                  
                  
                  //scrittura in output
                  (f_tempo_nodi[layerRelativo]).write(&info,sizeof(info),1);
                  numTotaleNodiCopiati++;
           }
           //aggiorno numero di nodi per il layer corrente           
           sizeLayerComplete[v[i]]++;

           
        }
        //_________________________________________________________________________________________
        //_________________________________________________________________________________________

        
/*        printf("\nLayers = ");
        for (long i=0;i<layerTot;i++){
          printf(" %d",sizeLayerComplete[i]);          
        }
        printf("\n");
*/
        //svuota l'insieme
        layerAssegnati.cancella();

    }
    //---------------------------------------------------------------------
    // FINE CALCOLO DEI LAYER PER TUTTI I NODI
    //---------------------------------------------------------------------


    //cancella la sdistr a potenza
    dp.cancella();

    //chiude i files temporanei dei nodi
    for (long i=0;i<numLayerInAnalisi;i++){
       numFilesLayer[ i+primoLayerCompresoInAnalisi ] = f_tempo_nodi[i].close();
    }
    
    delete[] f_tempo_nodi;f_tempo_nodi=NULL;


    //dealloca struttura dati per size dei layer
    sizeLayerAccess.cancella();

    //aggiorno contatore
    layerRimasti-=numLayerInAnalisi;
    primoLayerCompresoInAnalisi=ultimoLayerCompresoInAnalisi+1;


  }

  //---------------------------------------------------------------------
  //---------------------------------------------------------------------
  // fine calcolo di tutti i layer
  //---------------------------------------------------------------------
  //---------------------------------------------------------------------

  //controlla che tutti i nodi siano stati scritti
  if (numNodi*layerPerNodo != numTotaleNodiCopiati ){
  	  cout<<"Unexpected fatal error n.5";
      //cout<<"Errore nella scrittura dei nodi. Scritte "<<numTotaleNodiCopiati<<" copie invece delle "<<numNodi*layerPerNodo<<"\n";
      FINE;
  }


  long somma=0;
  for (long i=0;i<layerTot;i++){
      somma+=sizeLayerComplete[i];
  }
  if (numTotaleNodiCopiati!=somma){
			cout<<"Unexpected fatal error n.6";
      //cout<<"Errore nella scrittura degli nodi nei vari layer\n";
      FINE;
  }
  printf("\n+---------+---------+---------+---------------+\n");

  r2.cancella();
//  EXIT(0);
}
















// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
void hashingGrafo(long numNodi, long long numArchiAttesi,char* nomeFileNodi, long numFilesNodi, char* nomeFileArchi, long numFilesArchi, multiFileWriter& f_grafo){
    long* hashing = new long [numNodi];
    long long numArchiTrovati=0;
    char* stampa="/-\\|/-\\|/-\\|/-\\|/-\\|";
    cout<<" ";//stampa iniziale
    //se non c'e niente da fare, almeno cancello  i files - perche' richiesto
    if (numFilesArchi==0 ||nomeFileNodi==0){
        for (long i=0;i<numFilesArchi;i++){char a[1000];sprintf(a,nomeFileArchi,i);remove(a);}
        for (long i=0;i<numFilesNodi;i++){char a[1000];sprintf(a,nomeFileNodi,i);remove(a);}
        return ;
    }

    //i files di lettura vengono cancellati
    multiFileReader f_tempo_nodi_read = multiFileReader(nomeFileNodi,numFilesNodi,true);
    multiFileReader f_tempo_archi_read = multiFileReader(nomeFileArchi,numFilesArchi,true);
    long prec=0;

//    printf("Layer ???? \n");
    //leggo i veri valori dei nodi
    for (long i=0;i<numNodi;i++){

          //leggo le info corrispondenti del nodo corrente (num reale nodo e num successori da creare)
          infoNodoSucc info;
          if (f_tempo_nodi_read.read(&info,sizeof(info),1)<0){
							cout<<"Unexpected fatal error n.7";
              //cout<<"errore nella lettura delle info sul nodo in analisi";
							FINE;
          }
          hashing[i]=info.nodo;
          //printf("da [%d] --> %d\n",i,hashing[i]);

    }

    //converto il file degli archi
    arco a;
    while (f_tempo_archi_read.read(&a,sizeof(a),1)>0){
//        printf("%d->%d diventa %d->%d\n",a.source,a.dest,hashing[a.source],hashing[a.dest]);

        a.dest=hashing[a.dest];
        a.source=hashing[a.source];
        f_grafo.write(&a,sizeof(a),1);
        numArchiTrovati++;
        if (prec!= (long)(10.0 * numArchiTrovati/numArchiAttesi )){
          long nuovoPrec=(long)(10.0 * numArchiTrovati/numArchiAttesi );
          for (long i=prec;i<nuovoPrec;i++,cout<<(char)8<<stampa[i]);prec=nuovoPrec;fflush(stdout);
        }

    }

    for (long i=prec;i<10;i++,cout<<(char)8<<stampa[i]);

    //dealloca
    delete[] hashing;
    hashing=NULL;

    //chiude i files in lettura
    f_tempo_nodi_read.close();
    f_tempo_archi_read.close();
    if (numArchiTrovati!=numArchiAttesi){
				cout<<"Unexpected fatal error n.8";
				//ut<<"Errore: mancano alcuni archi..."<<numArchiTrovati<<"-"<<numArchiAttesi<<"\n";
				FINE;
		}
    cout<<(char)8;
}








// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
void stampaHelp(int arg,char* argv[]){
  char* nome=eliminaPath(argv[0]);
/*
eliminaPath(argv[0])<<"
*/

cout<<"This program generates a graph according to the Multi-Layer model proposed by Laura et al. We distinguish six different cases that depend on the random graph generator that is used to model every single layer. Therefore we have:\n";
cout<<"\n";
cout<<"\n";
cout<<"{Copying Model} This generates a graph according to the Multi-Layer Model in which the single layer is modelled according to the Copying Model of Kumar et al.The usage is as follows:\n";
cout<<"\n";
cout<<nome<<" memory -LC|-LC_nd num_nodes numSucc numLayers layersPerNode alpha seed nameOutputMultifile%d\n";
cout<<"\n";
cout<<"memory        memory available (MB)\n";
cout<<"num-nodes     number of graph's nodes\n";
cout<<"numSucc       number of successor of every node(constant)\n";
cout<<"numLayers     total number of layers\n";
cout<<"layersPerNode number of layers per edge\n";
cout<<"alpha*        copying parameter (range 0-100)\n";
cout<<"seed          seed for the random number generator\n";
cout<<"nameOutputMultifile%d  name of the output multifile (in 'extended' edges format)\n";
cout<<"\n";
cout<<"(Note that instead of the -LC switch, you can use the -LC_nd that allows nodes in a single layer not necessarily to be distinct ones)\n";
cout<<"\n";
cout<<"\n";
cout<<"{Evolving Network Model}. This generates a graph according to the Multi-Layer Model in which the single layer is modelled according to the Evolving Networks of Albert etal.The usage is as follows:\n";
cout<<"\n";
cout<<nome<<" memory -LB|-LB_nd num_nodes numSucc numLayers layersPerNode seed nameOutputMultifile%d\n";
cout<<"\n";
cout<<"memory        memory available (MB)\n";
cout<<"num-nodes     number of graph's nodes\n";
cout<<"numSucc       number of successor of every node (constant)\n";
cout<<"numLayers     total number of layers\n";
cout<<"layersPerNode number of layers per node\n";
cout<<"seed          seed for the random number generator\n";
cout<<"nameOutputMultifile%d  name of the output multifile (in 'extended' edges format)\n";
cout<<"\n";
cout<<"(Note that instead of the -LB switch, you can use the -LB_nd that allows nodes in a single layer not necessarily to be distinct ones)\n";
cout<<"\n";
cout<<"\n";
cout<<"{Mixed: Copying Model and Evolving Network Model}. This generates a graph according to the Multi-Layer Model in which the single layer is modelled using a mixed strategy between the Copying Model of Kumar etal and the Evolving Networks of Albert etal.The usage is as follows:\n";
cout<<"\n";
cout<<nome<<" memory -LCB|-LCB_nd num_nodes numSucc numLayers layersPerNode alpha seed nameOutputMultifile%d\n";
cout<<"memory        memory available (MB)\n";
cout<<"num-nodes     number of graph's nodes\n";
cout<<"numSucc       number of successor of every node (constant)\n";
cout<<"numLayers     total number of layers\n";
cout<<"layersPerNode number of layers per node\n";
cout<<"alpha*        copying parameter (range 0-100)\n";
cout<<"seed          seed for the random number generator\n";
cout<<"nameOutputMultifile%d  name of the output multifile (in 'extended' edges format)\n";
cout<<"\n";
cout<<"(Note that instead of the -LCB switch, you can use the -LCB_nd that allows nodes in a single layer not necessarily to be distinct ones)\n";
cout<<"\n";
cout<<"\n";
cout<<"{Network Growth Model}. This generates a graph according to the Multi-Layer Model in which the single layer is modelled according to the Network Growth Model of Pennock etal.The usage is as follows:\n";
cout<<"\n";
cout<<nome<<" memory -LN1|-LN1_nd num_nodes numSucc numLayers layersPerNode beta seed nameOutputMultifile%d\n";
cout<<"\n";
cout<<"memory        memory available (MB)\n";
cout<<"num-nodes     number of graph's nodes\n";
cout<<"numSucc       number of successor of every node (constant)\n";
cout<<"numLayers     total number of layers\n";
cout<<"layersPerNode number of layers per node\n";
cout<<"beta**        uniform choice parameter (range 0-100)\n";
cout<<"seed          seed for the random number generator\n";
cout<<"nameOutputMultifile%d  name of the output multifile (in 'extended' edges format)\n";
cout<<"\n";
cout<<"(Note that instead of the -LN1 switch, you can use the -LN1_nd that allows nodes in a single layer not necessarily to be distinct ones)\n";
cout<<"\n";
cout<<"\n";
cout<<"{Network Growth Model with random parameter}. This generates a graph according to the Multi-Layer Model in which the single layer is modelled according to the Copying Model of Kumar etal.The usage is as follows:\n";
cout<<"\n";
cout<<nome<<" memory -LN2|-LN2_nd num_nodes numSucc numLayers layersPerNode betaLow betaHigh seed nameOutputMultifile%d\n";
cout<<"\n";
cout<<"memory        memory available (MB)\n";
cout<<"num-nodes     number of graph's nodes\n";
cout<<"numSucc       number of successor of every node (constant)\n";
cout<<"numLayers     total number of layers\n";
cout<<"layersPerNode number of layers per node\n";
cout<<"betaLow**     min uniform choice parameter (range 0-100)\n";
cout<<"betaHig**     max uniform choice parameter (range 0-100)\n";
cout<<"seed          seed for the random number generator\n";
cout<<"nameOutputMultifile%d  name of the output multifile (in 'extended' edges format)\n";
cout<<"\n";
cout<<"(Note that instead of the -LN2 switch, you can use the -LN2_nd that allows nodes in a single layer not necessarily to be distinct ones)\n";
cout<<"\n";
cout<<"\n";
cout<<"{The model is randomly chosen amongst the ones described above}. This generates a graph according to the Multi-Layer Model in which the single layer is modelled according to the Copying Model of Kumar etal.The usage is as follows:\n";
cout<<"\n";
cout<<nome<<" memory -RND|-RND_nd num_nodes numSucc numLayers layersPerNode alphaCopy alphaCopyEvol alpha_Net seed nameOutputMultifile%d\n";
cout<<"\n";
cout<<"memory         memory available (MB)\n";
cout<<"num-nodes      number of graph's nodes\n";
cout<<"numSucc        number of successor of every node(constant)\n";
cout<<"numLayers      total number of layers\n";
cout<<"layersPerNode  number of layers per node\n";
cout<<"alphaCopy*     copying parameter (range 0-100)\n";
cout<<"alphaCopyEvol* copying+evolving parameter (range 0-100)\n";
cout<<"alpha_Net**    netgrowth parameter (range 0-100)\n";
cout<<"seed           seed for the random number generator \n";
cout<<"nameOutputMultifile%d  name of the output multifile (in 'extended' edges format)\n";
cout<<"\n";
cout<<"(Note that instead of the -RND switch, you can use the -RND_nd that allows nodes in a single layer not necessarily to be distinct ones)\n";
cout<<"\n";
cout<<" (*) copying probability (in the range 0-100) : with probability alpha copies a link, with prob 100-alpha creates a new random link\n";
cout<<" (**) uniform probability (in the range 0-100) : with probability beta choice destination node uniformely, with probability 100-beta uses indegrees\n";

}






// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
//
//                            MAIN                      MAIN                        MAIN                      MAIN
//
// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
int main (int arg,char** argv){


     
                                

  stampaLicenza(arg,argv);
  if (arg<7) STAMPA_ERRORE_PARAMETRI(argv[0],"Parameters incorrect.");

	

  long memoria       = (long)atof(argv[1])*1024*1024;
  char* strTipo       = argv[2];
	long numNodi       = strtol(argv[3],NULL,10);
	long numSuccTotali = strtol(argv[4],NULL,10);		
	long layerTot      = strtol(argv[5],NULL,10);

	long layerPerNodo  = strtol(argv[6],NULL,10);


  //parametri dipendenti dal tipo
  float probNuovo     = 0;
  float probUniforme  = 0;
  float probUniforme1 = 0;
  float probUniforme2 = 0;
  long  seed          = 0;
  char  nomeGrafo[1000];
  char  messTipoAlgo[1000];//messaggio sul tipo di algoritmo usato eni vari layer

  //reset anche random per uso
  srand(seed);
	
  //controllo della memoria disponibile
  if (memoria<5000000) STAMPA_ERRORE_PARAMETRI(argv[0],"Memory not enough\n");
  setMemoriaDisponibile(memoria) ;
//  cout<<"Memoria disponibile indicata: "<<(getMemoriaDisponibile()-(2*numNodi/25000)*sizeof(long))/1024/1024<<"MB \n";
  long memoriaDispRand=(long)(getMemoriaDisponibile())-NUM_BUFFER*DIM_BUFFER;//memoria a disposizione per il calc random
  if  (memoriaDispRand<1*MB){cout<<"Memory not enough"; FINE;}


  //init random generator
  randomGen2 generaRandom2;
  //spec se i layer per nodo sono distinti o no
  bool generaLayerDistinti=false;



  bool distribuzioneUniformeDeiNodiTraLayer=false;//layer scelto uniformemente o no (SET SEMPRE A false)


 	
  long tipo;

  //VAR necessarie per lavorare con la fase random
  float probNuovoMod1;
  float probNuovoMod2;
  float probUniformeMod4;
  bool randomizzato=false;



//  cout<<"\n vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv\n"<<strTipo<<" \n\n\n\n";

  if (strcasecmp(strTipo,"-LCB")==0)      {tipo=0;generaLayerDistinti=true;}
  else if (strcasecmp(strTipo,"-LC")==0)  {tipo=1;generaLayerDistinti=true;}
  else if (strcasecmp(strTipo,"-LN1")==0) {tipo=2;generaLayerDistinti=true;}
  else if (strcasecmp(strTipo,"-LB")==0)  {tipo=3;generaLayerDistinti=true;}
  else if (strcasecmp(strTipo,"-LN2")==0) {tipo=4;generaLayerDistinti=true;}
  else if (strcasecmp(strTipo,"-RND")==0) {tipo=5;generaLayerDistinti=true;randomizzato=true;}

  else if (strcasecmp(strTipo,"-LCB_nd")==0)      {tipo=0;generaLayerDistinti=false;}
  else if (strcasecmp(strTipo,"-LC_nd")==0)  {tipo=1;generaLayerDistinti=false;}

  else if (strcasecmp(strTipo,"-LN1_nd")==0) {tipo=2;generaLayerDistinti=false;}
  else if (strcasecmp(strTipo,"-LB_nd")==0)  {tipo=3;generaLayerDistinti=false;}
  else if (strcasecmp(strTipo,"-LN2_nd")==0) {tipo=4;generaLayerDistinti=false;}
  else if (strcasecmp(strTipo,"-RND_nd")==0) {tipo=5;generaLayerDistinti=false;randomizzato=true;}

  else{cout<<"algorithm not specified\n";FINE;}

//  cout<<"\n vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv\n"<<tipo<<" \n\n\n\n";



  switch(tipo){

    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    case 5:{
            if (arg!=12) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

            probNuovoMod1    = 100.0-atof(argv[7]);
            probNuovoMod2    = 100.0-atof(argv[8]);
            probUniformeMod4 = atof(argv[9]);
            seed             = strtol(argv[10],NULL,10);
          	strcpy(nomeGrafo,argv[11]);


            sprintf(messTipoAlgo,"(RANDOM) \n In each layer it uses a random generation algorithm \n ");

//  cout<<"   "<<nome<<"  <memoria>  (-RND|-RND_nd) <num_nodi>  <numSucc>  <layerTotali>  <LayerPerNodo>  <PROB_COPIA(mod. 1)> <PROB_COPIA(mod. 2)> <PROB_SCELTA_UNIFORME(Mod. 4)> <seed>  <nomeFileOut%>\n\n";
            long periodo=(long)(0.6*( memoriaDispRand )/sizeof(long));
            if (periodo<1000) periodo=1000;
            //cout<<"\n INIT RANDOM GENERATOR con periodo "<<periodo<<"\n";
            generaRandom2 = randomGen2(seed,periodo);
    break;}
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    case 0:{
            if (arg!=10)STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
            probNuovo     = 100.0-atof(argv[7]);
//            cout<<"Prob nuovo = "<<probNuovo<<"\n";
            seed          = strtol(argv[8],NULL,10);
          	strcpy(nomeGrafo,argv[9]);


            sprintf(messTipoAlgo,"(LAYERMODEL --> COPYMODEL+EVOLVING) \n In each layer it uses the CopyModel+Indegree (preferential attachment).\nseed=%ld \n copy prob=%f \n ",seed, 100-probNuovo);
//            cout<<messTipoAlgo<<" \n numnodi "<<numNodi<<" \n numSuccTotali "<<numSuccTotali<<" \n layerTot "<<layerTot<<" \n layerPerNodo "<<layerPerNodo;
            generaRandom2 = randomGen2(seed);
    break;}
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    case 1:{  //memoria occupata dalla tabella hashing (mediamente)
            if (arg!=10)STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
            probNuovo     = 100.0-atof(argv[7]);
//            cout<<"Prob nuovo = "<<probNuovo<<"\n";
            seed          = strtol(argv[8],NULL,10);
          	strcpy(nomeGrafo,argv[9]);

            sprintf(messTipoAlgo,"(LAYERMODEL --> COPYMODEL)\n In each layer it uses the CopyModel Algorithm\nSeed=%ld \n prob=%f \n ",seed, 100-probNuovo);

            long periodo=(long)(0.6* memoriaDispRand )/sizeof(long);
            if (periodo<1000) periodo=1000;
//            cout<<"\n INIT RANDOM GENERATOR con periodo "<<periodo<<"\n";
            generaRandom2 = randomGen2(seed,periodo);
    break;}
    
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    case 2:{if (arg!=10)STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
            probUniforme  = atof(argv[7]);
            seed          = strtol(argv[8],NULL,10);
          	strcpy(nomeGrafo,argv[9]);

            sprintf(messTipoAlgo,"(LAYERMODEL --> NETGROWTH) \n In each layer it uses the NetGrowthModel \nSeed=%ld \n prob=%f \n ",seed, probUniforme);
            generaRandom2 = randomGen2(seed);
    break;}
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    case 3:{ if (arg!=9)STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
             seed          = strtol(argv[7],NULL,10);
          	 strcpy(nomeGrafo,argv[8]);

             sprintf(messTipoAlgo,"(LAYERMODEL --> EVOLVING) \n In each layer it uses the EvolvingModel \nSeed=%ld \n ",seed);
             generaRandom2 = randomGen2(seed);

    break;}
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    case 4:{if (arg!=11)STAMPA_ERRORE_PARAMETRI(argv[0],"Parameters incorrect.");
            probUniforme1  = atof(argv[7]);
            probUniforme2  = atof(argv[8]);
            seed           = strtol(argv[9],NULL,10);
          	strcpy(nomeGrafo,argv[10]);

            sprintf(messTipoAlgo,"(LAYERMODEL --> NETGROWTH_VARIABILE) \n In each layer it uses the NetGrowthModel with variable prob\nSeed=%ld \n prob[%f,%f] \n ",seed, probUniforme1,probUniforme2);
            generaRandom2 = randomGen2(seed);
    break;}
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  }


	if (!estMultiFileName(nomeGrafo)) STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");
	if (numNodi<1) STAMPA_ERRORE_PARAMETRI(argv[0],"Nodes number not valid");
	if (numSuccTotali<1) STAMPA_ERRORE_PARAMETRI(argv[0],"Successors number not valid");
	if (probNuovo<0 || probNuovo>100 ) STAMPA_ERRORE_PARAMETRI(argv[0],"'new node' probability not in [0,100]");
	if (probUniforme<0 || probUniforme>100 ) STAMPA_ERRORE_PARAMETRI(argv[0],"'uniform choice' probability not in [0,100]");
	if (probUniforme1<0 || probUniforme1>100 ) STAMPA_ERRORE_PARAMETRI(argv[0],"'uniform choice (1)' probability not in [0,100]");
	if (probUniforme2<0 || probUniforme2>100 ) STAMPA_ERRORE_PARAMETRI(argv[0],"'uniform choice (2)' probability not in [0,100]");
	if (probUniforme1>probUniforme2 ) STAMPA_ERRORE_PARAMETRI(argv[0],"'uniform choice' probability not in [0,100]");
  if (layerTot<layerPerNodo) STAMPA_ERRORE_PARAMETRI(argv[0],"Layers number not valid");
  if (layerPerNodo>numSuccTotali)STAMPA_ERRORE_PARAMETRI(argv[0],"Layers number not valid");
	if (seed<0) STAMPA_ERRORE_PARAMETRI(argv[0],"seed not valid (<0)");








  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //  FASE 1                                      GENERAZIONE NODI PER OGNI LAYER
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  float esp;
  bool distPotenza=false;
  int scelta;

//#define EXTENDED_OUTDEGREE
#ifdef EXTENDED_OUTDEGREE
  cout<<"\nOut degree distribution:.\n";
  cout<<"Uniform (default).........[1]\n";
  cout<<"Power Law .................[2]\n";
  cin>>scelta;
  if (scelta==2){
    cout<<"insert exp of power law (with in sign): ";
    cin>>esp;
    distPotenza=true;
  }
#else
  scelta=1;
#endif
  
  

  
  long* sizeLayerComplete=new long[layerTot];//size reale di ogni layer (COME NUM DI NODI CHE VI FANNO PARTE)
  long* numFilesLayer=new long[layerTot];//num di files generati per ogni layer(NUM DI FILES ASSOCIATI A CIASCUN LAYER)
  long* maxSuccPerLayer=new long[layerTot];

  //genera i fari files (1 multifile per ogni layer) - scelta dei layer ripetto all'indegree
  generaLayer(layerTot,layerPerNodo,numNodi,numSuccTotali,nomeGrafo,seed,sizeLayerComplete,numFilesLayer,distribuzioneUniformeDeiNodiTraLayer,generaLayerDistinti,
              maxSuccPerLayer,esp,distPotenza,generaRandom2);



  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //  FASE 2                       PER OGNI LAYER, CALCOLO tutti i link tra i nodi presenti
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


  long long nTotArchi=0;

  //apro il file complessivo
  multiFileWriter f_grafo = multiFileWriter (nomeGrafo,DIM_MAX);


  cout<<"\n\n";
//  printf("Multilayer nodes partition (%d layers x node)\n",layerPerNodo);
  printf("Single layer graph generation\n");
  randomGen2 sceltaRandom = randomGen2(seed,layerTot);


  //ripeto per ogni layer il calcolo degli archi
  for (long layer=0;layer<layerTot;layer++){

       if (layer%20==0){
            printf ("+--------+---------+--------+------------+-------------+\n");
            printf ("| %s tot  |num layer| %s part |  num nodes |  num edges  |\n","%","%");
            printf ("+--------+---------+--------+------------+-------------+\n");
            fflush (stdout);
       }

       printf("|%6.2f%s | %7ld |%6.2f%s | %10ld |%12d |",100.0*(layer+1)/layerTot,"%",layer, 100.0,"%",sizeLayerComplete[layer],0);


       //--------------------------------------------------------------------------------------------------------------------------


       //il num max e' quello che rimane alla fine
       long numSuccMassimi=maxSuccPerLayer[layer]; //numSuccTotali-succNorm*(layerPerNodo-1);
//       cout<<"\nSucc massimi = "<<numSuccMassimi<<"\n";

       if (randomizzato){
          tipo=sceltaRandom.genRand(layer)%4;
       }

       switch(tipo){

         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         //                           (COPYMODEL+BARABASI)
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         case 0:{

           //nomi files in gioco
           char nomeFileNodi_In [1000];generaNomeTempoNodiPerLayer(nomeFileNodi_In,layer,nomeGrafo);
           char nomeFileArchi_Out[1000];generaNomeTempoArchiPerLayer(nomeFileArchi_Out,layer,nomeGrafo);

           //num files generati

           long numFilesOut;
           long sceltaUniforme=false;
           if (randomizzato)  probNuovo=probNuovoMod1;

           long long archiParz = copyModelAndInDegree( layer,layerTot,
                        generaRandom2,sizeLayerComplete[layer],numSuccMassimi,
                        nomeFileNodi_In,numFilesLayer[layer],  nomeFileArchi_Out,numFilesOut,
                        probNuovo,sceltaUniforme);

           cout<<"  Merging ";fflush(stdout);
           nTotArchi+=archiParz;
           hashingGrafo(sizeLayerComplete[layer],archiParz,
                      nomeFileNodi_In, numFilesLayer[layer], nomeFileArchi_Out, numFilesOut, f_grafo);
           printf("(COPYMODEL+EVOLVING)\n");
           fflush(stdout);

           break;
         }
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         //                           (LAYERMODEL --> COPYMODEL)
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         case 1:{

           //nomi files in gioco
           char nomeFileNodi_In [1000];generaNomeTempoNodiPerLayer(nomeFileNodi_In,layer,nomeGrafo);
           char nomeFileArchi_Out[1000];generaNomeTempoArchiPerLayer(nomeFileArchi_Out,layer,nomeGrafo);

           //num files generati
           long numFilesOut;
           if (randomizzato)  probNuovo=probNuovoMod2;

           /*********************************************************************************************/
           /* SOSTITUITO DA UNA SPECIALIZZAZIONE DEL Copyng+Evolving usando prob di copia data
           e scegliendo uniformemente gli altri nodi*/
           /*********************************************************************************************/
           /*long long archiParz = copyModel( layer,layerTot,
                        generaRandom2,sizeLayerComplete[layer],numSuccMassimi,
                        nomeFileNodi_In,numFilesLayer[layer],  nomeFileArchi_Out,numFilesOut,
                        probNuovo);*/
           /*********************************************************************************************/
           long long archiParz = copyModelAndInDegree( layer,layerTot,
                        generaRandom2,sizeLayerComplete[layer],numSuccMassimi,
                        nomeFileNodi_In,numFilesLayer[layer],  nomeFileArchi_Out,numFilesOut,
                        probNuovo,true);
           /*********************************************************************************************/

                        
           cout<<"  Merging ";fflush(stdout);
           nTotArchi+=archiParz;
           hashingGrafo(sizeLayerComplete[layer],archiParz,
                      nomeFileNodi_In, numFilesLayer[layer], nomeFileArchi_Out, numFilesOut, f_grafo);

           printf("(COPYMODEL)\n");
           fflush(stdout);

           break;
         }
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         //             (LAYERMODEL --> NETGROWTH)
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         case 2:{

           //nomi files in gioco
           char nomeFileNodi_In [1000];generaNomeTempoNodiPerLayer(nomeFileNodi_In,layer,nomeGrafo);
           char nomeFileArchi_Out[1000];generaNomeTempoArchiPerLayer(nomeFileArchi_Out,layer,nomeGrafo);


           //num files generati
           long numFilesOut;
           if (randomizzato)  probUniforme=probUniformeMod4;
           long long archiParz = netGrowthModel_layer(layer,layerTot,
                     sizeLayerComplete[layer],numSuccMassimi, probUniforme,generaRandom2,
                     nomeFileNodi_In, numFilesLayer[layer],
                     nomeFileArchi_Out, numFilesOut,false);


           cout<<" Merging ";fflush(stdout);
           nTotArchi+=archiParz;
           hashingGrafo(sizeLayerComplete[layer],archiParz,
                      nomeFileNodi_In, numFilesLayer[layer], nomeFileArchi_Out, numFilesOut, f_grafo);
           printf("(NETGROWTH)\n");
           fflush(stdout);

           break;
         }
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         //                          (LAYERMODEL --> BARABASI)
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         case 3:{

           //nomi files in gioco
           char nomeFileNodi_In [1000];generaNomeTempoNodiPerLayer(nomeFileNodi_In,layer,nomeGrafo);
           char nomeFileArchi_Out[1000];generaNomeTempoArchiPerLayer(nomeFileArchi_Out,layer,nomeGrafo);


           //num files generati
           long numFilesOut;

           /*********************************************************************************************/
           /* SOSTITUITO DA UNA SPECIALIZZAZIONE DEL Copyng+Evolving usando prob di copia = 0
           e scegliendo in base all'indegree gli altri nodi*/
           /*********************************************************************************************/
           // ---------------- BARABASI (perche' la prob di scelta unifrome e' 0 ------------------------------
           /*long long archiParz = netGrowthModel_layer(layer,layerTot,
                     sizeLayerComplete[layer],numSuccMassimi, 0,generaRandom2,
                     nomeFileNodi_In, numFilesLayer[layer],
                     nomeFileArchi_Out, numFilesOut,false);*/
           /*********************************************************************************************/
           long long archiParz = copyModelAndInDegree( layer,layerTot,
                        generaRandom2,sizeLayerComplete[layer],numSuccMassimi,
                        nomeFileNodi_In,numFilesLayer[layer],  nomeFileArchi_Out,numFilesOut,
                        100,false);
           /*********************************************************************************************/

           // #################################################################################################


           cout<<" Merging ";fflush(stdout);
           nTotArchi+=archiParz;
           hashingGrafo(sizeLayerComplete[layer],archiParz,
                      nomeFileNodi_In, numFilesLayer[layer], nomeFileArchi_Out, numFilesOut, f_grafo);

           printf("(EVOLVING)\n");fflush(stdout);

           break;
         }
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         //             (LAYERMODEL --> NETGROWTH VARIABILE)
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
         case 4:{

           //nomi files in gioco
           char nomeFileNodi_In [1000];generaNomeTempoNodiPerLayer(nomeFileNodi_In,layer,nomeGrafo);
           char nomeFileArchi_Out[1000];generaNomeTempoArchiPerLayer(nomeFileArchi_Out,layer,nomeGrafo);

           //scelgo casualmente la probabilita' corrente
           float probUniformeCorrente=normalizzaLancioFloat(rand(),probUniforme1,probUniforme2);


           //num files generati
           long numFilesOut;
           long long archiParz = netGrowthModel_layer(layer,layerTot,
                     sizeLayerComplete[layer],numSuccMassimi, probUniformeCorrente,generaRandom2,

                     nomeFileNodi_In, numFilesLayer[layer],
                     nomeFileArchi_Out, numFilesOut,true);

           cout<<"  Merging ";
           nTotArchi+=archiParz;
           hashingGrafo(sizeLayerComplete[layer],archiParz,
                      nomeFileNodi_In, numFilesLayer[layer], nomeFileArchi_Out, numFilesOut, f_grafo);

           printf("(NETGROWTH VAR)\n");
           fflush(stdout);

           break;
         }
         //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

                   
       };




       
  }
  // --------------------------------------------
  //    FINE CREAZIONE ARCHI PER TUTTI I LAYER
  // --------------------------------------------


  //chiude il file del grafo
  /*long numFilesGrafoFinale = */


  //aggiuge la label relativa al num di nodi...
  arco aux;
  aux.source=aux.dest=-numNodi;
  if (f_grafo.write(&aux,sizeof(arco),1)<1){perror("Write error");FINE;}
  PRINT_ISOLATED_NODES_SPECIFICATION;

  //chiude file finale
  f_grafo.close();



  cout<<"\n";
  //ALLA FINE .....
  delete[] sizeLayerComplete;   sizeLayerComplete=NULL;


  delete[] numFilesLayer;       numFilesLayer=NULL;
  delete[] maxSuccPerLayer;     maxSuccPerLayer=NULL;


  char c[512];
	strcpy(c,nomeGrafo);
	strcat(c,".layerModel.report");		
	fprintf(stdout,"Nodes number .............................%ld\n"  ,numNodi);
	fprintf(stdout,"Edges number .............................%lld\n" ,nTotArchi);

  generaRandom2.cancella();
  sceltaRandom.cancella();


  EXIT(0);
}




