/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file utilityModel.h :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   



#ifndef UTILITY_MODEL_
#define UTILITY_MODEL_

#include "comuni.h"
#include "grafo.h"
#include <iostream>

// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
/*void stampa(char* msg,char* z,long l){
    cout<<msg<<": ";
    for (int i=0;i<l;i++)
        cout<<"  "<<(int)z[i];
     cout<<"\n";
} */





// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
class infoNodoSucc{
public:
  long nodo;
  long nSucc;
};







// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################

class nodoRitornato{
  public:
    long nodoDest;
    char tipo;//spec se ho subito il nodo o un riferimento al successore di un altro nodo

    nodoRitornato(long nodo, char t){
        nodoDest=nodo;
        tipo=t;
    }

    nodoRitornato(){;}

    bool estNodo() {return tipo==1; }
    bool estNullo(){return tipo==0; }
    bool estSuccessoreDi(){return tipo==2; }
};


nodoRitornato calcolaLinkUscente(long nodoSorgente, long numSuccessore, randomGen2& r, long numeroSuccTotali,float probabilitaNuovoNodo_1_100);


float normalizzaLancioFloat(unsigned long lancio, float inferiore, float superiore);
long normalizzaLancio(unsigned long lancio, long inferiore, long superiore);

long long  copyModel(long layer,long numTotLayer,randomGen2& generaRandom,
                    long numNodi,long numSuccMassimi,
                    char* nomeFileNodi,long numFileIn,
                    char* nomeFileArchiOut,long& numFilesOut,
                    float probNuovo);


long long copyModelAndInDegree( long layer,long numTotLayer,randomGen2& generaRandom,
                                long numNodi,long numSuccMassimi,
                                char* nomeFileNodi,long numFileIn,
                                char* nomeFileArchiOut,long& numFilesOut,
                                float probNuovo,bool sceltaUniforme);

long long  netGrowthModel_layer(long layer,long layerTot,
          long numNodi,long numSuccMassimi, float probUniforme,randomGen2& rg,
          char* nomeFileNodi, long numFilesIn,
          char* nomeGrafo, long& numFilesOut,bool probVariabile);


void generaNomeTempoNodiPerLayer(char*s,long layer,char* nomeGrafo);
void generaNomeTempoArchiPerLayer(char*s,long layer,char* nomeGrafo);


#endif



