/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file bufferizzazionelistafiles.cpp :source code of pagerank utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#include "bufferizzazionelistafiles.h"

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/





//-----------------------------------------------------------------------------------------------------
//  chiude i files e ritorna il num di files creati
//-----------------------------------------------------------------------------------------------------
void bufferizzazioneListaFiles::chiudi(long* nFilesPerBlocco){

  //se chiuso, termino
  if (chiuso) return;

  /////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////
  //scrivo i buffer su files
  for (int i=0;i<nBlocchi;i++){
    out[i].write(buffer[i],sizeof(long),numElemBuffer[i]);
    numElemBuffer[i]=0;
    nFilesPerBlocco[i]=out[i].close();
    delete[] buffer[i];
    buffer[i]=NULL;
  }
  /////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////

  //libera memoria
  delete[] out;out=NULL;
  delete[] buffer;buffer=NULL;
  delete[] numElemBuffer;numElemBuffer=NULL;
}









//-----------------------------------------------------------------------------------------------------
//  scrive un elemento nel buffer o al + nel file se il buffer e' pieno
//-----------------------------------------------------------------------------------------------------
void bufferizzazioneListaFiles::scrivi(long valore, long nBlocco){
  if (chiuso) return;
  if (nBlocco>=this->nBlocchi) return;
  if (nBlocco<0) return;
  
  scriviBuf(valore, buffer[nBlocco], numElemBuffer[nBlocco], sizeTotBuffer, out[nBlocco]);
}







//-----------------------------------------------------------------------------------------------------
//  funzione d'appoggio per la scrittura
//-----------------------------------------------------------------------------------------------------
void bufferizzazioneListaFiles::scriviBuf(long valore, long* buf, long& numElementiBuffer, long maxNumElem, multiFileWriter& f){
  //se il buffer e' pieno, scrivo su disco
  if (numElementiBuffer == maxNumElem){
    f.write(buf,sizeof(long),numElementiBuffer);
    numElementiBuffer=0;
  }

  //scrivo sul buffer
  buf[numElementiBuffer]=valore;
  numElementiBuffer++;//un elemento e' stato aggiunto
}




//-----------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------
void bufferizzazioneListaFiles::calcolaNomeFileBlocco(long nBlocco,char* multiNome,char* postFisso,char* dest){
    char app[1000];
    sprintf(app,postFisso,nBlocco);
    strcpy(dest,multiNome);strcat(dest,app);
}



//-----------------------------------------------------------------------------------------------------
//  init: il nome dei files  ottenuto aggiungendo .blocco_i al nome per il blocco i-esimo
//-----------------------------------------------------------------------------------------------------
bufferizzazioneListaFiles::bufferizzazioneListaFiles(char* multiNome,char* postFisso,long nBlocchi, long sizeBuffer, long dimMassimaFilesInByte){

  //salvataggio parametri
  this->nBlocchi=nBlocchi;
  this->sizeTotBuffer=sizeBuffer;
  chiuso=false;
  if ( (sizeBuffer<1)||(nBlocchi<=0) ){chiuso=true;return;}

  //allocazione memoria per i blocchi
  buffer=new long*[nBlocchi];//alloco tanti buffer, 1 x blocco
  out=new multiFileWriter[nBlocchi];//creo un file, uno per blocco
  numElemBuffer=new long[nBlocchi];//x ogni blocco conto il num di elementi
  for (int i=0;i<nBlocchi;i++){

    //crea il multifile associato al blocco corrente
    char nome_i[1000];
    calcolaNomeFileBlocco(i,multiNome,postFisso,nome_i);
    out[i]=multiFileWriter(nome_i,dimMassimaFilesInByte);//apro il file

    //allocazione del buffer associato al blocco corrente
    buffer[i]=new long[sizeBuffer];//alloco il buffer
    numElemBuffer[i]=0;//num elementi nel buffer = 0
  }
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
