/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file pagerank.cpp :source code of pagerank utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "comuni.h"
#include <math.h>
#include "config.h"
#include "bufferizzazionelistafiles.h"
#include <ctype.h>
#include <string.h>

//////////////////////////////////////////////////////////////////////////////////////////////
//      classe che gestisce un buffer (eventualmente in mem secondaria se necessario)
//////////////////////////////////////////////////////////////////////////////////////////////
class bufferFile{
  private:
    FILE* fp;
    long* buf;
    long  sizeBuffer;
    long  sizeAllocata;//size mem allocata
    long  sizeTotale;
    char  nome[DIM_TEXT_FILENAME];
    bool  chiuso;
  public:
    bufferFile (char* nome, long size);
    void  cancella();
    void  memorizzaValore(long val);
    void  svuotaBufferSuFileAndSvuota(bufferizzazioneListaFiles& fout,long nBlocco);//scrive su file
    long  getSize(){return sizeTotale;}
};
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
bufferFile::bufferFile (char* nome, long size){
  if (size<=0) size=1;

  sizeBuffer=0;
  sizeAllocata=size;
  strcpy(this->nome,nome);
  fp=NULL;
  chiuso=false;
  buf=new long[sizeAllocata];
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void bufferFile::memorizzaValore(long val){
  if (chiuso) return;

  //vedo se il buffer e' pieno e se si lo scrivo su file
  if (sizeBuffer==sizeAllocata){
    if (fp==NULL)
      if ( (fp=fopen(nome,"w"))==NULL){perror ("Unexpected fatal error");FINE;}
    fwrite(buf,sizeof(long),sizeBuffer,fp);
    sizeBuffer=0;   
  }
  
  buf[sizeBuffer]=val;
  sizeBuffer++;
  sizeTotale++;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void bufferFile::svuotaBufferSuFileAndSvuota(bufferizzazioneListaFiles& fout,long nBlocco){
  if (chiuso) return;
  
  if (fp!=NULL){
    //copia il contenuto del file tempo nel file passato come parametro
    fclose(fp);fp=NULL;
    if ( (fp=fopen(nome,"r"))==NULL){perror ("Unexpected fatal error");FINE;}
    long app;
    while ( fread(&app,sizeof(long),1,fp)>0){
       fout.scrivi(app,nBlocco);
    }
    fclose(fp);fp=NULL;
  }

  //scrive il buffer su file
  for (int i=0;i<sizeBuffer;i++){
      fout.scrivi(buf[i],nBlocco);
  }

  //contatori azzerati
  sizeBuffer=0;
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////
void bufferFile::cancella(){
  if (chiuso) return;
  if (fp!=NULL) fclose(fp);
  fp=NULL;
  chiuso=true;
  delete[] buf;buf=NULL;  
  remove(nome);//eventualmente cancella il fil temporaneo
  sizeTotale=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////







/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long minimo(long m1,long m2){
  if (m1<m2) return m1;
  return m2;    
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
class recordInfo{
public:
long inDeg;
long outDeg;
long long puntIn;
long long puntOut;
};


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void   concatenaAndTogliTab(char*buf1,char*buf2,char*buf3,char*buf4,char*buf){
  buf[0]=0;
  strcat(buf,buf1);strcat(buf,buf2);strcat(buf,buf3);strcat(buf,buf4);
  long l=strlen(buf);
  if (l>0)   buf[l-1]=0;//elimina l'ultimo carattere
  strcat(buf,"\n");
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
bool trovaLetteraInStringa(char* formato,char lettera){
 long l=strlen(formato);
 for (int i=0;i<l;i++)
    if (  tolower(lettera)==tolower(formato[i]) )return true;

 return false;   
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void eraseMultiFile(char* nomeMulti){

    long conta=0;

    FILE* fp;
    char nomeFile[DIM_TEXT_FILENAME];

    while(true){
      sprintf(nomeFile,nomeMulti,conta);
      fp=fopen(nomeFile,"r");
      if (fp!=NULL){
          conta++;
          fclose(fp);
          remove(nomeFile);
      }
      else
          return ;

    }

}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//          associato al quick sort
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

template <class T>
  long partition(T* szArray,long nLower, long nUpper){
// Pivot with first element

    long nLeft = nLower + 1;
    T szPivot = szArray[nLower];
    long nRight = nUpper;


    // Partition array elements
    T szSwap;//var di appoggio per lo scambio
    while (nLeft <= nRight)
    {
        // Find item out of place
        bool finito=false;
        while (nLeft <= nRight && !finito)
            if (szArray[nLeft]<=szPivot)	nLeft = nLeft + 1;

            else                        	finito=true;


        finito=false;
        while (nLeft <= nRight && !finito){
            if (szArray[nRight]> szPivot)
            		nRight = nRight - 1;
            else
            		finito=true;
        }

        // Swap values if necessary
        if (nLeft < nRight)
        {
            szSwap = szArray[nLeft];
            szArray[nLeft] = szArray[nRight];
            szArray[nRight] = szSwap;
            nLeft = nLeft + 1;
            nRight = nRight - 1;
        }
    }

    // Move pivot element
    szSwap = szArray[nLower];
    szArray[nLower] = szArray[nRight];
    szArray[nRight] = szSwap;
    return nRight;

  }




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//                           ordina il vettore di elementi di tipo T
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
template <class T>
  //ordina il vettore da inizio a fine ESTREMI COMPRESI
  void quickSort2(T* v,long inizio,long fine){

    if (fine>inizio){
      long nSplit=partition(v,inizio,fine);

      /*----------OTTIMIZZA ----------*/
      long ordinato=TRUE;
      for (long i=inizio;(i<fine)&&(ordinato);i++)
          ordinato= v[i]<=v[i+1];
      if (ordinato) return; //se gia' ordinato salto il processo
      /*------------------------------*/

      quickSort2(v,inizio,nSplit-1);
      quickSort2(v,nSplit+1,fine);
    }
  }


  

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//scrivo i successori individuati dai punt nel buffer specificato(estremi compresi)
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void scriviSuccNelFileEstremiCompresi(
    long nBlocco,long nodo, long outDeg,
    long* buffer,long posInizioBuffer,long posFineBuffer,
    bufferizzazioneListaFiles& fTempo){

  long numSuccBloccoCorrente = posFineBuffer - posInizioBuffer + 1;
  if ((numSuccBloccoCorrente)<=0) return;//nessun successore...
  fTempo.scrivi(nodo,nBlocco);                  //NODO
  fTempo.scrivi(outDeg,nBlocco);                //NUM SUCC TOTALI
  fTempo.scrivi(numSuccBloccoCorrente,nBlocco); //NUM SUCCESSORI IN QUESTO BLOCCO
  for (int j=posInizioBuffer;j<=posFineBuffer;j++)           //scrivo la parte di successori del blocco corrente
     fTempo.scrivi(buffer[j],nBlocco);
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//Crea i files di appoggio come lista di successori. Ritorna il num di nodi per blocco
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long partizionaFileSuccessori(
      char* grafoInfo, char* grafoSucc,
      char* nomeMultiFilesTempo, char* postFisso,
      long nBlocchi /*,long dimMemoriaDisponibileInBytePerIBuffer*/)
  {

    long long* conta=new long long[nBlocchi];
    for (int i=0;i<nBlocchi;conta[i++]=0);

    //calcolo  grandezze varie
    long numSucc=contaNumFilesMultiFile(grafoSucc);
    long numInfo=contaNumFilesMultiFile(grafoInfo);
    long numNodi=getTotalSizeMultiFiles(grafoInfo)/sizeof(recordInfo);
    long numNodiPerOgniBlocco = numNodi/nBlocchi;
    if (numNodi%nBlocchi!=0) numNodiPerOgniBlocco++;

    //si cerca di utilizzare tutta la memoria per leggere i successori (impossibile fare altrimenti...)- dimensione almeno 1
    long sizeBufferInLong = 2000;

    //cout<<""<<numNodi<<" nodes found suddivisi in "<<nBlocchi<<" blocchi da "<<numNodiPerOgniBlocco<<" nodi per blocco\n";
    //cout<<"Size dei "<<nBlocchi<<" buffer di scrittura su file pari a "<<sizeBufferInLong*sizeof(long)<<" byte\n";


    //buffer per la lettura
    recordInfo info;
    long nodo=0;

    //apertura dei files di input/output
    multiFileReader fInfo = multiFileReader(grafoInfo,numInfo);
    multiFileReader fSucc = multiFileReader(grafoSucc,numSucc);
    bufferizzazioneListaFiles fTempo=bufferizzazioneListaFiles(nomeMultiFilesTempo,postFisso,nBlocchi,sizeBufferInLong,MAX_DIM_FILES);

    //buffer dei successori
    bufferFile bf = bufferFile((char*)"temporaneo_PR",1000);
    
    //mentre non e' finito ancora il grafo di input
    long contatore=100000000;
    while (fInfo.read(&info,sizeof(info),1)>0){

      if ( (contatore++>500000)||(nodo==numNodi-1) ){
          printf("%cnodes partition in %ld blocks [%6.2f%s]",13,nBlocchi,100.0*(nodo+1)/numNodi,"%");
          fflush(stdout); contatore=0;
      }

      //controllo memoria
      //if ((long long)dimMemoriaDisponibileInBytePerIBuffer<(long long)info.outDeg*sizeof(long)){
      //  cout<<"Memory not enough\n";FINE;
      //}

      //var di appoggio
      long nBloccoCorrente=0;

      //scandisco i successori e li ripartisco (sfruttando il fatto che sono ordinati)
      int i;
      for (i=0;i<info.outDeg;i++){

        //leggo il successore
        long succ_i;
        fSucc.read(&succ_i,sizeof(long),1);

        //calcolo il num di blocco
        long bl=succ_i/numNodiPerOgniBlocco;//blocco del file corrente
        conta[bl]++;
        //cout<<succ_i<<"["<<bl<<"] ";

        if (bl>=nBlocchi){cout<<"Unexpected fatal error n.1\n";FINE;}        

        //se finito blocco
        if (bl!=nBloccoCorrente){

          //se ci sono nodi
          if ( bf.getSize()>0 ){
            //scrive i successori nel blocco giusto (riaprendo il file in lettura)
            fTempo.scrivi(nodo,nBloccoCorrente);                       //NODO
            fTempo.scrivi(info.outDeg,nBloccoCorrente);                //NUM SUCC TOTALI
            fTempo.scrivi(bf.getSize(),nBloccoCorrente);    //NUM succ relativi
            bf.svuotaBufferSuFileAndSvuota(fTempo,nBloccoCorrente);    //scrive successori che vanno in questo blocco
          }

          nBloccoCorrente=bl;//nuovo blocco
        }

        //scrive il nuovo successore nel file temporaneo (bufferizzato)
        bf.memorizzaValore(succ_i);
      }
      
      // SCRIVO LE INFO RESTANTI DEI SUCCESSORI
      //se ci sono nodi
      if ( bf.getSize()>0 ){
         fTempo.scrivi(nodo,nBloccoCorrente);                       //NODO
         fTempo.scrivi(info.outDeg,nBloccoCorrente);                //NUM SUCC TOTALI
         fTempo.scrivi(bf.getSize(),nBloccoCorrente);    //NUM succ relativi
         bf.svuotaBufferSuFileAndSvuota(fTempo,nBloccoCorrente);    //successori che vanno in questo blocco
      }

      //nodo successivo
      nodo++;
    }


    //chiusura files tempo
    bf.cancella();
    
    //chiusura files
    long* numFilesPerBlocco=new long [nBlocchi];
    fTempo.chiudi(numFilesPerBlocco);
    fInfo.close();
    fSucc.close();
    cout<<"\n";
    for (int i=0;i<nBlocchi;i++)
      cout<<"-> The block n."<<i<<" contains "<<conta[i]<<" edges\n";
      
    delete[] numFilesPerBlocco;numFilesPerBlocco=NULL;
    delete[] conta;conta=NULL;
    return numNodiPerOgniBlocco;
}






void stampaHelp(int arg,char* argv[]){
  arg=0;
  cout<<"This routine computes the PageRank on the input graph. The output are two file that contain, respectively, the distribution of pagerank values and, for each node, its pagerank value. The command line usage is as follows:\n";
	cout<<"\n";
  cout<<eliminaPath(argv[0])<<" memory graph%d c residual maxIter fileTxtOutDistr%d fileTxtOutNodes%d [colums]\n";
	cout<<"\n";
  cout<<"memory       memory available (MB)\n";
  cout<<"graph%d      name of the multifile of the input graph (ips format)\n";
  cout<<"c            PageRank parameter: probability to remain in the page (the value is in the range 0 up to 1;suggested is 0.85)\n";
  cout<<"residual     minimum residual value to stop the computation\n";
  cout<<"maxIter      maximum number of iterations allowed\n";
  cout<<"fileTxtOutDistr%d   name of the output (text) multifile where the distribution of pagerank values are stored\n";
  cout<<"fileTxtOutNodes%d   name of the output (text) multifile where pagerank values are stored\n";
  cout<<"colums       (optional) specify the info to write in fileTxtOutNodes%d; possible values are N,I,O,P where\n";
  cout<<"       N: column with the number of the node\n";
  cout<<"       I: column with the indegree value of the node\n";
  cout<<"       O: column with the outdegree value of the node\n";
  cout<<"       P: column with the pagerank value of the node\n";
  cout<<"\n";
  cout<<"\n";

}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
int main (int arg,char** argv){

  stampaLicenza(arg,argv);
  if (arg!=9 && arg!=8) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");


  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //                                                    lettura parametri di input
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  long  memoria         = (long)( atof(argv[1])*1024*1024 ); //100*1024*1024;
//  cout<< "MEMORIA "<<memoria<<" ????????????\n";
  char grafoInfo[DIM_TEXT_FILENAME];
  strcpy(grafoInfo,argv[2])             ;//(char*)"grafo.%d.info";
  strcat(grafoInfo,".info");
  
  char grafoSucc[DIM_TEXT_FILENAME];
  strcpy(grafoSucc,argv[2])             ;//(char*)"grafo.%d.succ";
  strcat(grafoSucc,".succ");
         
  float c               = atof(argv[4-1])       ;//0.1;//coeff di errore... tra 0 e 1
  float limiteResidual  = atof(argv[5-1])       ;//0.0001;
  long  maxIterazioniPR = (long)atof(argv[6-1]) ;//10;

  char* multiFileDistrPRTXT    = argv[7-1];//(char*)"distr.%d";
  char* multiFileOutputNodiTXT = argv[8-1];//(char*)"out.%d";  
  char* formato;
  if (arg==9) formato = argv[9-1];//formato
  else        formato = (char*)"";

  //************************ CONTROLLO FILES DI INPUT ***************************
  if (getTotalSizeMultiFiles(grafoInfo)<=0){cout<<"The input graph is empty\n";FINE};
  if (getTotalSizeMultiFiles(grafoSucc)<=0){cout<<"The input graph is empty\n";FINE};


  
  //valori da riportare in output
  bool  scriviNodi   = trovaLetteraInStringa(formato,'N');
  bool  scriviInDeg  = trovaLetteraInStringa(formato,'I');
  bool  scriviOutDeg = trovaLetteraInStringa(formato,'O');
  bool  scriviPR     = trovaLetteraInStringa(formato,'P');


  
  //variabili associate ai parametri
  char  grafoTempoBlocchi[DIM_TEXT_FILENAME];strcpy(grafoTempoBlocchi,grafoSucc);strcat(grafoTempoBlocchi,(char*)".tempo");
  char* postFisso        = (char*)".bloccoN%d";
  long  numNodi          = getTotalSizeMultiFiles(grafoInfo)/sizeof(recordInfo);

  char* fileSorgente     = (char*)"sorg_stadio_1.%d";//file in cui invio i dati relativi
  char* fileTemporaneo   = (char*)"sorg_stadio_Temp.%d";
  char* fileDestinatario = (char*)"sorg_stadio_2.%d";


  if (c<0 || c>1){cout<<"The c value must belong to [0,1]\n";FINE;}

  
  if (!estMultiFileName(grafoInfo ))               STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");
  if (!estMultiFileName(grafoSucc ))               STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");
  if (!estMultiFileName(multiFileOutputNodiTXT ))  STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");
  if (!estMultiFileName(multiFileDistrPRTXT ))     STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");

  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  

    
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //                        calcolo del numero di blocchi e del corrispondente num di nodi x blocco
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  long numFloatAllocabili=memoria/sizeof(float);//num float che possono essere allocati in ram (a me ne servono in tutto numNodi)
  long nBlocchi=numNodi/numFloatAllocabili;if (nBlocchi<=0)nBlocchi=1;
//  nBlocchi=2;
  
  long numNodiPerOgniBloccoPrevisti=numNodi/nBlocchi;
  if (numNodiPerOgniBloccoPrevisti*nBlocchi<numNodi) nBlocchi++;
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


                        

        
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //                                                partiziona il grafo in vari blocchi
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//  nBlocchi=3;
  cout<<" ----------- STEP 1 ----------- \n";
  long numNodiPerOgniBlocco=partizionaFileSuccessori(grafoInfo, grafoSucc,grafoTempoBlocchi, postFisso,nBlocchi /*,memoria*/);
  cout<<"\n";

  
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX







      
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //                                                      calcolo iterazione principale
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  
  //--------------------------------------------------------------------------------------------------------------------------------
  //                                              inizializzazione 1/N dei valori dei nodi...e salvataggio in file
  //--------------------------------------------------------------------------------------------------------------------------------
  cout<<" ----------- STEP 2 ----------- \nPage Rank initialization (value = "<<1.0/numNodi<<" )\n\n";fflush(stdout);
  multiFileWriter dest=multiFileWriter(fileDestinatario,MAX_DIM_FILES);
  float* bufferFloatPR=new float[numNodiPerOgniBlocco];
  //
  for (int i=0;i<numNodiPerOgniBlocco;bufferFloatPR[i++]=1.0/numNodi);

  //scrittura valori 1/N per tutti i nodi
  long nodiRimasti=numNodi;
  while(nodiRimasti>0){
      long scrivi=nodiRimasti;if (scrivi>numNodiPerOgniBlocco) scrivi=numNodiPerOgniBlocco;
      nodiRimasti-=dest.write(bufferFloatPR,sizeof(float),scrivi);    
  }
  dest.close();
//  cout<<"(creato multiFile "<<fileDestinatario<<")\n\n";fflush(stdout);


  //--------------------------------------------------------------------------------------------------------------------------------
  //                                                         iterazioni: ciclo principale
  //--------------------------------------------------------------------------------------------------------------------------------
  float residual=1000;
//  long* succ=new long[MAX_NUM_SUCCESSORI];
  long contaIterazioni=0;
  float massimoPR;//valore massimo dei PR
  float minimoPR ;//valore minimo dei PR
  cout<<" ----------- STEP 3 ----------- \n";

  while ( (residual>limiteResidual)&&(contaIterazioni<maxIterazioniPR) ){

    //conteggio del num di iterazioni
    contaIterazioni++;
    printf("(*) %3ldth iteration:\n",contaIterazioni);
  
    
    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //<<<<<<<<<<<<<<<  analisi del grafo, blocco per blocco >>>>>>>>>>>>>>>>>>>>>>>>
    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //scambia sorg con destinatario
    char* app=fileSorgente;
    fileSorgente=fileDestinatario;
    fileDestinatario=app;

    //file contenenti i valori di PR
    multiFileReader fileSourcePR=multiFileReader(fileSorgente,contaNumFilesMultiFile(fileSorgente));

    multiFileWriter fileDestPR=multiFileWriter(fileTemporaneo,MAX_DIM_FILES);
    
    //somma valori PR, calcolato blocco x blocco
    float sommaPR=0;

    // PER OGNI BLOCCO ................
    for (long blocco=0;blocco<nBlocchi;blocco++){

      // calcola il primo nodo in analisi
      long nodoInizialeBlocco=blocco*numNodiPerOgniBlocco;


      // calcola l' ultimo nodo in analisi
      long nodoFinaleBlocco=(blocco+1)*numNodiPerOgniBlocco-1;
      if (nodoFinaleBlocco>=numNodi) nodoFinaleBlocco=numNodi-1;            

      //calcola il num di nodi del bloccos
      long numNodiBloccoCorrente=nodoFinaleBlocco-nodoInizialeBlocco+1;

      //controllo correttezza valori calcolati
      if (numNodiBloccoCorrente>numNodiPerOgniBlocco){cout<<"Unexpected fatal error n.1\n";FINE;}

      // azzera tutti i valori del buffer float
      for (int i=0;i<numNodiBloccoCorrente;bufferFloatPR[i++]=0);
      
      // genero il nome del GRAFO blocco corrente  <->  apertura grafo blocco corrente
      char nomeFilesBloccoCorrente[DIM_TEXT_FILENAME];
      bufferizzazioneListaFiles::calcolaNomeFileBlocco(blocco,grafoTempoBlocchi,postFisso,nomeFilesBloccoCorrente);
      multiFileReader grafoBlocco=multiFileReader(nomeFilesBloccoCorrente , contaNumFilesMultiFile(nomeFilesBloccoCorrente) );
      long  puntCorrenteFilePR=-1;//nodo correntemente valore PR float
      float sourcePR=0;

      //mentre ci sono ancora nodi nel GRAFO DEL blocco corrente
      long nodoCorrente;
      long long conta=100000000;
      long numSucc;
      long numSuccBlocco;
      while (grafoBlocco.read(&nodoCorrente,sizeof(long),1)>0){

          if (conta++>50000){
            printf("%cBLOCK %3ld - nodes range [%9ld-%9ld]  (%6.2f%s)",13,blocco,nodoInizialeBlocco,nodoFinaleBlocco,100.0*(nodoCorrente+1)/numNodi,"%");
            fflush(stdout); conta=0;            
          }
          
      
          //leggo i successori          
          grafoBlocco.read(&numSucc,sizeof(long),1  );//num succ totali

          grafoBlocco.read(&numSuccBlocco,sizeof(long),1  );//num succ blocco corrente
          //grafoBlocco.read(succ,sizeof(long),numSuccBlocco);

          //cerco il valore PR del nodo corrente nel file
          if (nodoCorrente<puntCorrenteFilePR){cout<<"Unexpected fatal error n.2\n";FINE;}
          
          while(puntCorrenteFilePR<nodoCorrente){

              if (fileSourcePR.read(&sourcePR,sizeof(float),1)<0){cout <<"Unexpected fatal error n.3\n";FINE;}
              puntCorrenteFilePR++;
          }
          
          //aggiorna valori PR per i successori del nodo corrente
          for (int j=0;j<numSuccBlocco;j++){
              //leggo il successore
              long succ_j;
              grafoBlocco.read(&succ_j,sizeof(long),1);
              
              long posRelativa=succ_j-nodoInizialeBlocco;
              if (posRelativa>=numNodiBloccoCorrente){cout<<"Unexpected fatal error n.4.(node "<<nodoCorrente<<", successor "<<succ_j<<")\n";FINE;}
              bufferFloatPR[ posRelativa ] += sourcePR/numSucc;
          }
          
      }

      //stampa finale analisi grafo...
      printf("%cBLOCK %3ld - nodes range [%9ld-%9ld] damping/saving ...",13,blocco,nodoInizialeBlocco,nodoFinaleBlocco);fflush(stdout);

      //dampening finale
      for (int i=0;i<numNodiBloccoCorrente;i++){
          bufferFloatPR[i]=c*bufferFloatPR[i]+(1.0-c)/numNodi;
          sommaPR+=bufferFloatPR[i];
      }
      
      fileDestPR.write(bufferFloatPR,sizeof(float),numNodiBloccoCorrente);
      printf("%cBLOCK %3ld - nodes range [%9ld-%9ld] complete               \n",13,blocco,nodoInizialeBlocco,nodoFinaleBlocco);fflush(stdout);
      grafoBlocco.close();
    }

    //chiusura files
    fileSourcePR.close();
    fileDestPR.close();
    
    //calcola somma
    //cout<<"\nSum PageRank values ="<<sommaPR<<"\n";
		fflush(stdout);

    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


    
    


    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //                    normalizza e calcola Residual
    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    //apertura dei files Vecchio e NuovoTemporaneo
    printf("Page Rank normalization...");fflush(stdout);
    multiFileReader fileSourceVecchio = multiFileReader (fileSorgente     , contaNumFilesMultiFile(fileSorgente));
    multiFileReader fileSourceTempo   = multiFileReader (fileTemporaneo  , contaNumFilesMultiFile(fileTemporaneo), true);    
    multiFileWriter fileSourceNuovo   = multiFileWriter (fileDestinatario, MAX_DIM_FILES);

    //punt al buffer esistente
    long numElementiBuffer = numNodiPerOgniBlocco/2;
    if (numNodiPerOgniBlocco%2!=0)numElementiBuffer--;
    if (numElementiBuffer<=0){cout<<"\nUnexpected fatal error n.5\n";FINE;}
    
    float* bufVecchi=bufferFloatPR;
    float* bufNuovi=bufferFloatPR+numElementiBuffer;
    long rimasti=numNodi;

    //min /max e somma dei Page Rank e residual
    massimoPR=0;
    minimoPR=2147483647;
    residual=0;

    while (rimasti>0){
      long leggi=rimasti;
      if (leggi>numElementiBuffer)leggi=numElementiBuffer;

//      cout<<"\nDa leggere "<<leggi<<"\n";fflush(stdout);
      if (fileSourceVecchio.read(bufVecchi,sizeof(float),leggi)<leggi){cout<<"Error: Unable to real file";FINE;}
      if (fileSourceTempo  .read(bufNuovi,sizeof(float),leggi)<leggi){cout<<"Error: Unable to real file";FINE;}

      //normalizza vettore nuovi

      for (int i=0;i<leggi;i++)
        bufNuovi[i]=bufNuovi[i]/sommaPR;

//      cout<<"letti "<<leggi<<"\n";fflush(stdout);
      
      //calcolo residual e max/min      
      for (int i=0;i<leggi;i++){

        //calcolo del residuo
        residual += (bufVecchi[i]-bufNuovi[i]) * (bufVecchi[i]-bufNuovi[i]);

        //calcolo del massimo
        if (massimoPR<bufNuovi[i]) massimoPR = bufNuovi[i];


        //calcolo del minimo
        if (minimoPR>bufNuovi[i])  minimoPR  = bufNuovi[i];


      }
      rimasti-=leggi;
//      cout<<"letti "<<leggi<<"\n";fflush(stdout);

      //scrive la nuova versione dell'output
      fileSourceNuovo.write(bufNuovi,sizeof(float),leggi);
//      cout<<"scritti "<<leggi<<"\n";fflush(stdout);
//      scanf("%d",&leggi);
    }
    
    residual=sqrt(residual);
            
    fileSourceNuovo.close();
    fileSourceTempo.close();
    fileSourceVecchio.close();
    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


    cout<<"OK\n";
    
    cout<<(char)13<<"Residual value = "<<residual<<"- Max Page Rank value = "<<massimoPR<<" - Min Page Rank value = "<<minimoPR<<"        \n\n";
  }
  //--------------------------------------------------------------------------------------------------------------------------------
  // FINE ITERAZIONE
  //--------------------------------------------------------------------------------------------------------------------------------

  //cancella buffer dei valori PR
  delete[] bufferFloatPR;bufferFloatPR=NULL;


  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX




  

  
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //    SCRITTURA DEI DATI IN FORMATO TXT NEI FILES DI OUTPUT E CALCOLO DELLA DISTRIBUZIONE DEI VALORI PAGE RANK
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX



  
  
  //--------------------------------------------------------------------------------------------------------------------------------
  //        dichiarazione di variabili di gestione 
  //--------------------------------------------------------------------------------------------------------------------------------

  //Scrittura files di output
  multiFileReader fileSourceNuovo = multiFileReader (fileDestinatario , contaNumFilesMultiFile(fileDestinatario));
  multiFileReader fileInfo        = multiFileReader (grafoInfo, contaNumFilesMultiFile(grafoInfo));
//  multiFileWriter txtNodi         = multiFileWriter (multiFileOutputNodiTXT,MAX_DIM_FILES);//report x nodi

  long numFileCorrente=0;
  long long numRighe=0;

  char nome[DIM_TEXT_FILENAME];
  sprintf(nome,multiFileOutputNodiTXT,numFileCorrente);
  FILE* txtNodi = fopen (nome,"w");//report come distribuzione
  if (txtNodi==NULL){perror("Unexpected fatal error");FINE;}

  


  
  //variabili d'appoggio
  recordInfo inf;
  long numNodoCorrente=0;
  float valPR;

  //calcolo dei buffer di output
  long sizeBufferDistribuzione=memoria/sizeof(long);//size del buffer di long per la distr PR

  //intervallo di ogni livello di raggruppamento - in modo da raggruppare tutti i valori disponibili
  float quantizzazionePR=(massimoPR-minimoPR)/sizeBufferDistribuzione;//tengo conto solo dei valori non negativi

  //genera il buffer
  long* bufDistr=new long[sizeBufferDistribuzione];//buffer di conteggio...
  for (int i=0;i<sizeBufferDistribuzione;bufDistr[i++]=0);//init buffer distribuzione


  //buffer x la scrittura
  char buf [500] ;strcpy(buf ,"");
  char buf1[500];strcpy(buf1,"");
  char buf2[500];strcpy(buf2,"");
  char buf3[500];strcpy(buf3,"");
  char buf4[500];strcpy(buf4,"");
  



  
  
  //--------------------------------------------------------------------------------------------------------------------------------
  //                              formattazione intestazione files di report per i singoli nodi
  //--------------------------------------------------------------------------------------------------------------------------------

  long numColonne=0;                  
  //formattazione output dei dati
  if (scriviNodi)   {numColonne++;sprintf( buf1,"%sNODE_NUM_\t","%" );}//nodi
  if (scriviInDeg)  {numColonne++;sprintf( buf2,"%s_INDEGREE\t","%" );}//indeg
  if (scriviOutDeg) {numColonne++;sprintf( buf3,"%sOUTDEGREE\t","%" );}//outdeg
  if (scriviPR)     {numColonne++;sprintf( buf4,"%sPAGE_RANK\t","%" );}//Page Rank  
  concatenaAndTogliTab(buf1,buf2,buf3,buf4,buf);

  //scrittura intestazione files di output TXT
  if (numColonne>0)
    fwrite(buf,sizeof(char),strlen(buf),txtNodi);


  
  
  //scrittura files: per ogni nodo calcolo l'indeg/outdeg/PR e conteggio x la distribuzione
  long conta=100000000;
  cout<<" ----------- STEP 4 ----------- \n";

  double avgIn=0;
  double avgOut=0;
  double avgPr=0;  

  while ( fileSourceNuovo.read(&valPR,sizeof(float),1)>0 ){

      if (conta++>200000){printf("%c[%6.2f%s] distribution",13,100.0*(1+numNodoCorrente)/numNodi/2,"%"); fflush(stdout);conta=0;}
      if(fileInfo.read(&inf,sizeof(inf),1)<1){cout<<"Unexpected fatal error n.5\n";FINE;}

       //seleziona le colonne da scrivere
      if (scriviNodi)   sprintf( buf1,"%10ld\t" ,numNodoCorrente );//nodi
      if (scriviInDeg)  sprintf( buf2,"%10ld\t" ,inf.inDeg       );//indeg
      if (scriviOutDeg) sprintf( buf3,"%10ld\t" ,inf.outDeg      );//outdeg
      if (scriviPR)     sprintf( buf4,"%10g\t"  ,valPR           );//Page Rank

      avgIn +=inf.inDeg;
      avgOut+=inf.outDeg;
      avgPr +=valPR;

      if (numColonne>0) concatenaAndTogliTab(buf1,buf2,buf3,buf4,buf);

      //scrive su file
      if (numColonne>0){
        fwrite(buf,sizeof(char),strlen(buf),txtNodi);//scrive l'output
      
        if (numRighe>=10000000){
          fclose(txtNodi);numFileCorrente++;

          sprintf(nome,multiFileOutputNodiTXT,numFileCorrente);
          txtNodi = fopen (nome,"w");//report come distribuzione
          if (txtNodi==NULL){cout<<"Unexpected fatal error n.6 ";FINE;}
          numRighe=0;
        }
        numRighe++;
      }
      
      //calcola la posizione nell'array
      long pos=(long)( (valPR-minimoPR)/quantizzazionePR);if (pos>=sizeBufferDistribuzione) pos=sizeBufferDistribuzione-1;
      if (pos<0) {cout<<"Unexpected fatal error n.7 (pos <0) \n";FINE;}
      bufDistr[pos]++;
      
      numNodoCorrente++;
  }

  avgIn=1.0/numNodi*avgIn;
  avgOut=1.0/numNodi*avgOut;
  avgPr=1.0/numNodi*avgPr;

  //chiusura files
  fclose(txtNodi);
  fileSourceNuovo.close();
  fileInfo.close();


  //apre nuovamente in lettura per il calcolo della correlazione
  fileSourceNuovo = multiFileReader (fileDestinatario , contaNumFilesMultiFile(fileDestinatario));
  fileInfo        = multiFileReader (grafoInfo, contaNumFilesMultiFile(grafoInfo));

  double sigmaIn=0;
  double sigmaOut=0;
  double sigmaPr=0;

  double covInOut=0;
  double covInPr=0;
  double covOutPr=0;

  while ( fileSourceNuovo.read(&valPR,sizeof(float),1)>0 ){
      if (conta++>200000){printf("%c[%6.2f%s] distribution",13,100.0*(1+numNodoCorrente)/numNodi/2+50,"%");fflush(stdout);conta=0;}
      if(fileInfo.read(&inf,sizeof(inf),1)<1){cout<<"Unexpected fatal error n.5\n";FINE;}

      sigmaIn += (inf.inDeg-avgIn)   * (inf.inDeg-avgIn);
      sigmaOut+= (inf.outDeg-avgOut) * (inf.outDeg-avgOut);
      sigmaPr += (valPR-avgPr)       * (valPR-avgPr);

      covInOut+= (inf.inDeg-avgIn)   * (inf.outDeg-avgOut);
      covInPr += (inf.inDeg-avgIn)   * (valPR-avgPr);
      covOutPr+= (inf.outDeg-avgOut) * (valPR-avgPr);
  }

  sigmaIn  = sqrt(1.0/numNodi*sigmaIn);
  sigmaOut = sqrt(1.0/numNodi*sigmaOut);
  sigmaPr  = sqrt(1.0/numNodi*sigmaPr);
  
  covInOut = 1.0/numNodi*covInOut;
  covInPr  = 1.0/numNodi*covInPr;
  covOutPr = 1.0/numNodi*covOutPr;

  double corrInOut=0;
  double corrInPr=0;
  double corrOutPr=0;

  if (sigmaIn*sigmaOut!=0) corrInOut=covInOut/(sigmaIn*sigmaOut);
  if (sigmaIn*sigmaPr!=0)  corrInPr =covInPr /(sigmaIn*sigmaPr);
  if (sigmaOut*sigmaPr!=0) corrOutPr=covOutPr/(sigmaOut*sigmaPr);
  
//cov/(sigmaX*sigmaY)
  
  
  fileSourceNuovo.close();
  fileInfo.close();

  printf("%c[100.00%s]  distribution \n",13,"%");fflush(stdout);


  

  //--------------------------------------------------------------------------------------------------------------------------------
  //            scrittura file x la distribuzione;
  //--------------------------------------------------------------------------------------------------------------------------------

  //file di report
  char app[DIM_TEXT_FILENAME];
  sprintf(app,".report");
  sprintf(nome,multiFileDistrPRTXT, numFileCorrente);
  strcat(nome,app );

  FILE* reportDistr = fopen (nome,"w");//report come distribuzione
  if (reportDistr==NULL){cout<<"Error during opening of Report File";FINE;}

  //..................................................................

  fprintf(reportDistr,"Correlation Indegree/Outdegree   = %12.10f\n",corrInOut);
  fprintf(reportDistr,"Correlation Indegree/Pagerank    = %12.10f\n",corrInPr);
  fprintf(reportDistr,"Correlation Outdegree/Pagerank   = %12.10f\n",corrOutPr);

  fprintf(reportDistr,"Cov Indegree/Outdegree   = %12.10f\n",covInOut);
  fprintf(reportDistr,"Cov Indegree/Pagerank    = %12.10f\n",covInPr);
  fprintf(reportDistr,"Cov Outdegree/Pagerank   = %12.10f\n",covOutPr);

  fprintf(reportDistr,"Avg Indegree   = %12.10f\n",avgIn);
  fprintf(reportDistr,"Avg Outdegree  = %12.10f\n",avgOut);
  fprintf(reportDistr,"Avg Pagerank   = %12.10f\n",avgPr);

  fprintf(reportDistr,"Std deviation Indegree   = %12.10f\n",sigmaIn);
  fprintf(reportDistr,"Std deviation Outdegree  = %12.10f\n",sigmaOut);
  fprintf(reportDistr,"Std deviation Pagerank   = %12.10f\n",sigmaPr);

  fclose(reportDistr);

  //..................................................................

  fprintf(stdout,"\nAvg Indegree   = %12.10f\n",avgIn);
  fprintf(stdout,"Avg Outdegree  = %12.10f\n",avgOut);
  fprintf(stdout,"Avg Pagerank   = %12.10f\n",avgPr);

  fprintf(stdout,"Std deviation Indegree   = %12.10f\n",sigmaIn);
  fprintf(stdout,"Std deviation Outdegree  = %12.10f\n",sigmaOut);
  fprintf(stdout,"Std deviationPagerank    = %12.10f\n",sigmaPr);

  fprintf(stdout,"Cov Indegree/Outdegree   = %12.10f\n",covInOut);
  fprintf(stdout,"Cov Indegree/Pagerank    = %12.10f\n",covInPr);
  fprintf(stdout,"Cov Outdegree/Pagerank   = %12.10f\n",covOutPr);

  fprintf(stdout,"Correlation Indegree/Outdegree   = %12.10f\n",corrInOut);
  fprintf(stdout,"Correlation Indegree/Pagerank    = %12.10f\n",corrInPr);
  fprintf(stdout,"Correlation Outdegree/Pagerank   = %12.10f\n",corrOutPr);

  //..................................................................



        
  //scrittura report sulla distribuzione
  numFileCorrente=0;
  numRighe=0;

  cout<<"\n----------- STEP 5 ----------- \n";
  printf("Writing report files...\n");fflush(stdout);
  for (long ragg=1;ragg<=minimo(200000000,sizeBufferDistribuzione) ;ragg*=5){
    printf("Values group by %10ld (unit %g)",ragg,ragg*quantizzazionePR);fflush(stdout);

    //crea nome file di output
    char app[DIM_TEXT_FILENAME];
    sprintf(app,"_group_by_%ld",ragg);
    sprintf(nome,multiFileDistrPRTXT, numFileCorrente);
    strcat(nome,app );
    
    FILE* txtDistr = fopen (nome,"w");//report come distribuzione
    if (txtDistr==NULL){cout<<"Error in Temporary File";FINE;}
  
    sprintf(buf,"%sunit %10g\n%sPageRank \t%snum nodes \n","%",quantizzazionePR*ragg,"%","%");//26 - 8
    fwrite(buf,sizeof(char),strlen(buf),txtDistr);//scrive l'output  
    for (long i=0;i<=sizeBufferDistribuzione-ragg;i+=ragg){    

      //calcola somma valori
      long somma=0;
      for (int j=0;j<ragg ;j++)
          somma+=bufDistr[j+i];
      
      
      if ( somma >0){
        if (numRighe==500000000){
          fclose(txtDistr);numFileCorrente++;
          sprintf(nome,multiFileDistrPRTXT,numFileCorrente);
          txtDistr = fopen (nome,"w");//report come distribuzione
          if (txtDistr==NULL){cout<<"Error in Temporary File";FINE;}
          numRighe=0;
        }
        
        numRighe++;        
        sprintf(buf,"%10g\t%10ld\n", 1.0*quantizzazionePR*i+minimoPR,somma);
        fwrite(buf,sizeof(char),strlen(buf),txtDistr);//scrive l'output  
      }
    
    }
    printf("completed\n");fflush(stdout);

    fclose(txtDistr);
  }


  //dealloca il buffer per il calcolo della distr PR
  delete[] bufDistr;bufDistr=NULL;

  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


  //--------------------------------------------------------------------------------------------------------------------------------
  //            eliminazione files di output temporanei
  //--------------------------------------------------------------------------------------------------------------------------------
  // elimina i files temporanei relativi ai valori PR float
  eraseMultiFile(fileSorgente);
  eraseMultiFile(fileDestinatario);

  for (int i=0;i<nBlocchi;i++){
      char nomeFilesBloccoCorrente[DIM_TEXT_FILENAME];
      bufferizzazioneListaFiles::calcolaNomeFileBlocco(i,grafoTempoBlocchi,postFisso,nomeFilesBloccoCorrente);
      eraseMultiFile(nomeFilesBloccoCorrente);   
  }
  

  //Eliminazione files temporanei
  EXIT(0);
}


