/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file rewiring.cpp :source code of rewiring utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <stdio.h>
#include <math.h>
#include "comuni.h"
#include <stdlib.h>
#include "config.h"
#include <ctype.h>

#define STESSA_LINEA (char)13

bool estArcoLabel(arco a){
  return a.source==a.dest && a.source<0;
}


// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
long normalizzaLancio(unsigned long lancio, long inferiore, long superiore){
    long diff=superiore-inferiore+1;
    if (diff<0) return -1;
    if (diff==0) return inferiore;
    return inferiore+lancio%diff;
}
// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*void indiceProgressione(long long numArchi){

  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

	printf("%c [%c] running conversion of %lld edges ",STESSA_LINEA,cont,numArchi);
  fflush(stdout);
}
*/



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
bool estValido(char* s){
//  printf("%s",s);

  long lung=strlen(s);
  bool contieneNum=false;

  for (long i=0;i<lung;i++){
    if (s[i]>' '){
    	if (!isdigit(s[i]))
    	   return false;
    	else
    	   contieneNum=true;    	
    }
  }
//  printf(" (%d)",contieneNum);
  return contieneNum;
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//calcola il maggiore nodo disponibile (ed eventualmente ne crea una copia)
long trovaNodoMassimoEdEnventualmenteCreaCopia(char* nomeFileArchi,bufferedThreadFileOutputStream* fCopia, bool cancellaOriginale){


  //controlla se occorre fare la copia
  if (fCopia==NULL)  cancellaOriginale=false;

  //calc num archi totali
  long long numArchiTot  = getTotalSizeMultiFiles( 	nomeFileArchi )/sizeof(arco);

  //calcola dim buffer di lettura e allocazione
  long      dimBuffer    = DIM_BUFFER/sizeof(arco);if (dimBuffer<100) dimBuffer=100;
  arco* buf=new arco[dimBuffer ];

  //init contatori
  long long archiTrovati = 0;
  long      nodoMax      = 0;
  long long itera        = 50000000;
  long letti;



  //apertura del file
  long numFileIn = contaNumFilesMultiFile(nomeFileArchi);
  bufferedThreadFileInputStream  fin  = bufferedThreadFileInputStream (nomeFileArchi ,numFileIn,DIM_BUFFER,NUM_BUFFER,cancellaOriginale);

  //lettura del multifile di archi
  while ( (letti=fin.read(buf,sizeof(arco),dimBuffer))>0){
    //se occorre fare la copia...
    if (fCopia!=NULL)  fCopia->write(buf,sizeof(arco),letti);

    //legge buffer
    for (long i=0;i<letti;i++){

      if (buf[i].source>nodoMax) nodoMax=buf[i].source;
      if (buf[i].dest>nodoMax) nodoMax=buf[i].dest;

      //label dichiarazione num nodi grafo !!!!
      if (estArcoLabel(buf[i]))
        if (-buf[i].dest-1>nodoMax) nodoMax=-buf[i].dest-1;
    }

    //aggiorna contatori
    itera+=letti;
    archiTrovati+=letti;

    //controlla stampa
    if ( (itera>500000)|(archiTrovati==numArchiTot) ){
      itera=0;
      printf("%c[%6.2f%s] Running: nodes scanning ",13,100.0* archiTrovati/numArchiTot,"%");fflush(stdout);
    }

  }

  delete[] buf;buf=NULL;
  fin.close();
  return nodoMax;

}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

void stampaHelp(int arg,char* argv[]){
  cout<<"This routine allows to modify an input graph by i) inverting the direction of randomly selected edges, or ";
  cout<<"ii)  changing the successor in randomly selected edges, or iii) substitutes randomly selected edges with ";
  cout<<"new random edges (both source and dest changed). iv) by adding new edges to the graph. The usage is as follows:\n";
  cout<<"\n";
  cout<<"\n";
  cout<<"(1) Inverting the direction of randomly selected edges. The usage is as follows:\n";
  cout<<"\n";
  cout<<eliminaPath(argv[0])<<" memory -IE -deleteSource|-saveSource nameInputfile%d probInversion seed nameOutputFile%d\n";
  cout<<"\n";
  cout<<"memory                  available memory in MB\n";
  cout<<"-deleteSource|-saveSource   specify whether to delete or keep the input file\n";
  cout<<"nameInputMultifile%d    name of the input multifile (in 'extended' edges format)\n";
  cout<<"nameOutputMultiFile%d   name of the output multifile (in 'extended' edges format)\n";
  cout<<"probInversion           probability (in the range 0-100) of inverting an edge\n";
  cout<<"\n";
  cout<<"\n";
  cout<<"(2) Changing the destination in randomly selected edges. Command line options are the following:\n";
  cout<<"\n";
  cout<<eliminaPath(argv[0])<<" memory -CD -deleteSource|-saveSource nameInputfile%d probChangingSucc seed nameOutputFile%d\n";
  cout<<"\n";
  cout<<"memory                  available memory in MB\n";
  cout<<"-deleteSource|-saveSource  specify whether to delete or keep the input file\n";
  cout<<"nameInputMultifile%d    name of the input multifile (in 'extended' edges format)\n";
  cout<<"nameOutputMultiFile%d   name of the output multifile (in 'extended' edges format)\n";
  cout<<"probChangingSucc        probability (in the range 0-100) of changing the destination node of the edge\n";
  cout<<"seed                    the seed for the random number generator\n";
  cout<<"\n";
  cout<<"\n";
  cout<<"(3) Substitutes randomly selected edges with new random edges (both source and dest changed). Command line options are the following:\n";
  cout<<"\n";
  cout<<eliminaPath(argv[0])<<" memory -CE -deleteSource|-saveSource nameInputfile%d probChangingEdge seed nameOutputFile%d\n";
  cout<<"\n";
  cout<<"memory                  available memory in MB\n";
  cout<<"-deleteSource|-saveSource  specify whether to delete or keep the input file\n";
  cout<<"nameInputMultifile%d    name of the input multifile (in 'extended' edges format)\n";
  cout<<"nameOutputMultiFile%d   name of the output multifile (in 'extended' edges format)\n";
  cout<<"probChangingSucc        probability (in the range 0-100) of changing edges\n";
  cout<<"seed                    the seed for the random number generator\n";
  cout<<"\n";
  cout<<"\n";
  cout<<"(4) Adding new edges. It follows the command line usage:\n";
  cout<<"\n";
  cout<<eliminaPath(argv[0])<<" memory -AE -deleteSource|-saveSource nameInputfile%d m seed nameOutputFile%d\n";
  cout<<"\n";
  cout<<"memory                  available memory in MB\n";
  cout<<"-deleteSource|-saveSource  specify whether to delete or keep the input file\n";
  cout<<"nameInputMultifile%d    name of the input multifile (in 'extended' edges format)\n";
  cout<<"nameOutputMultiFile%d   name of the output multifile (in 'extended' edges format)\n";
  cout<<"m                       number of edges to be added\n";
  cout<<"seed                    the seed for the random number generator\n";
}




int main(int arg,char* argv[]){

  stampaLicenza(arg,argv);    
  if (arg!=8) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
  

  
  // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	
  long  memoria        = (long)atof(argv[1])*1024*1024;
  char* tipoElab     = argv[2];
  char* tipoCanc     = argv[3];
  char* multiFileIn  = argv[4];
  long  seed         = strtol(argv[6],NULL,10);
  char* multiFileOut = argv[7];

  float prob         = atof(argv[5]);// PARAMETRI ALTERNATIVI a seconda del tipo di scelta....
  long  m            = strtol(argv[5],NULL,10);//  == == == == ==           == == == == ==


//  printf("%s ",multiFileIn);

  /////////////////////////////////////////////////////////////////////////////////////////////////
  //
  //                            CONTROLLO PARAMETRI COMUNI
  //
  /////////////////////////////////////////////////////////////////////////////////////////////////

  //************************ CONTROLLO FILES DI INPUT ***************************
  if (getTotalSizeMultiFiles(multiFileIn)<=0){cout<<"The input graph is empty\n";FINE};

  // controllo della memoria disponibile
  if (memoria<5000000) STAMPA_ERRORE_PARAMETRI(argv[0],"Memory not enuogh");
  setMemoriaDisponibile(memoria) ;

  // controllo tipo cancellazione
  bool  cancellaSorgente=false;
  if (strcasecmp(tipoCanc,"-deleteSource")==0)      {cancellaSorgente=true;}
  else if (strcasecmp(tipoCanc,"-saveSource")==0)   {cancellaSorgente=false;}
  else STAMPA_ERRORE_PARAMETRI(argv[0],"option -saveSource or -deleteSource not found");

  //controlla i nomi di files
  if (!estMultiFileName(multiFileOut))	STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");
  if (!estMultiFileName(multiFileIn))	STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");

  //tipo di operazione da eseguire
  int tipo;
  #define IE (1)
  #define CD (2)
  #define AE (3)
  #define CE (4)
  
  if (strcasecmp(tipoElab,"-IE")==0)        {tipo=IE;}
  else if (strcasecmp(tipoElab,"-CD")==0)   {tipo=CD;}
  else if (strcasecmp(tipoElab,"-AE")==0)   {tipo=AE;}
  else if (strcasecmp(tipoElab,"-CE")==0)   {tipo=CE;}
  else STAMPA_ERRORE_PARAMETRI(argv[0],"rewiring option not correct");

  //calc num archi totali
  long long numArchiTot  = getTotalSizeMultiFiles( 	multiFileIn )/sizeof(arco);
  srand(seed);

  long long numArchiModificati=0;
  long long numArchiScritti=0;
  long numFilesCreati;
  long numNodiTotali=0;

  switch(tipo){
    // ---------------------------------------------------------------------------------------------------------------
    case IE:
    case CD:
    case CE:{//      INVERSIONE      O    MODIFICA (parziale e totale)
    // ---------------------------------------------------------------------------------------------------------------
      if ( (prob<0)||(prob>100)) STAMPA_ERRORE_PARAMETRI(argv[0],"Probability' not valid");

      if (tipo==CD ||tipo==CE) {
          cout<<"(*) STEP 1:\n";
          numNodiTotali= trovaNodoMassimoEdEnventualmenteCreaCopia(multiFileIn,NULL,false)+1;
          cout<<"\n >> found "<<numNodiTotali<<" nodes\n";
          cout<<"(*) STEP 2:\n";
      }

      
      printf("\n");

      //apertura files output
    	bufferedThreadFileOutputStream fout = bufferedThreadFileOutputStream(multiFileOut,DIM_MAX  ,DIM_BUFFER,NUM_BUFFER);

      long numFileIn = contaNumFilesMultiFile(multiFileIn);
    	bufferedThreadFileInputStream  fin  = bufferedThreadFileInputStream (multiFileIn ,numFileIn,DIM_BUFFER,NUM_BUFFER,cancellaSorgente);

      #define BUF_ARCHI (5000)
      arco buffer[BUF_ARCHI];
      long letti;
      long long conta=50000000;

      while ( (letti=fin.read(&buffer,sizeof(arco),BUF_ARCHI))>0 ){

        //analizza tutti gli archi
        for (int i=0;i<letti;i++){

          //salta le label
          if (estArcoLabel(buffer[i]))  continue;

          float lancio=(float)100.0*rand()/RAND_MAX;
          if ((prob==100.0)||((float)lancio<prob)){

            //-----------------------------------------------------------
            //INVERSIONE ------------------------------------------------
            //-----------------------------------------------------------
            if (tipo==IE){
                numArchiModificati++;
                long app=buffer[i].source;
                buffer[i].source=buffer[i].dest;
                buffer[i].dest=app;
            }
            //-----------------------------------------------------------
            //SOSTITUZIONE ARCHI ----------------------------------------
            //-----------------------------------------------------------
            else if (tipo==CE){

                //trova un nuovo destinatario casuale, scelto tra tutti i nodi, ma diverso dal nodo corrente (NO SELF LOOP)
                while ( (buffer[i].dest=normalizzaLancio(rand(),0,numNodiTotali-1))==buffer[i].source );
                numArchiModificati++;
            }
            //-----------------------------------------------------------
            //SOSTITUZIONE DEST -----------------------------------------
            //-----------------------------------------------------------
            else if (tipo==CD){

                //trova un nuovo sorgente casuale, scelto tra tutti i nodi, ma diverso dal nodo corrente (NO SELF LOOP)
                buffer[i].source=normalizzaLancio(rand(),0,numNodiTotali-1);

                //trova un nuovo sorgente casuale, scelto tra tutti i nodi, ma diverso dal nodo corrente (NO SELF LOOP)
                while ( (buffer[i].source=normalizzaLancio(rand(),0,numNodiTotali-1))==buffer[i].source );

                numArchiModificati++;
            }
          }
        }


        //scrive gli archi in output
        fout.write(&buffer,sizeof(arco),letti);
        numArchiScritti+=letti;
        conta+=letti;

        //STAMPA SE NECESSARIO...
        if (conta++>500000){
          printf("[%6.2f%s] rewiring edges: %lld modified edges",100.0*numArchiScritti/numArchiTot ,"%",numArchiModificati)  ;
          fflush(stdout);
          conta=0;
        }
      }

      numFilesCreati = fout.close();
      fin.close();
      printf("%c[%6.2f%s] rewiring edges: %lld modified edges",13,100.0*numArchiScritti/numArchiTot ,"%",numArchiModificati)  ;

      break;
    }
    // ---------------------------------------------------------------------------------------------------------------






    // ---------------------------------------------------------------------------------------------------------------
    case AE:{//      AGGIUNTA
    // ---------------------------------------------------------------------------------------------------------------
      if ( (m<0)) STAMPA_ERRORE_PARAMETRI(argv[0],"'m' parameters not valid.");


      //apertura files output
      cout<<"(*) STEP 1:\n";
    	bufferedThreadFileOutputStream fout = bufferedThreadFileOutputStream(multiFileOut,DIM_MAX  ,DIM_BUFFER,NUM_BUFFER);
      numNodiTotali= trovaNodoMassimoEdEnventualmenteCreaCopia(multiFileIn,&fout,cancellaSorgente)+1;
      cout<<"\n >> found "<<numNodiTotali<<" nodes\n >> found "<<numArchiTot<<" edges\n";

      printf("\n");
      cout<<"(*) STEP 2:\n";

      numArchiScritti=numArchiTot;
      numArchiModificati=0;
      long long conta=100000000;

      arco buffer[BUF_ARCHI];
      for (long i=0;i<m;i++){

         //crea un arco (non SELF LOOP)
         long nodo1=rand()%numNodiTotali;
         long nodo2=rand()%numNodiTotali;
         while (nodo2==nodo1)
            nodo2=rand()%numNodiTotali;

         //posizione relativa
         long posRelativa=i%BUF_ARCHI;

         //scrive l'arco corrente nel buffer
         buffer[posRelativa].source = nodo1;
         buffer[posRelativa].dest   = nodo2;
//         cout<<nodo1<<" -> "<<nodo2<<"\n";

         //se buffer pieno o ultimo valore di i --> copio su file
         if (  (posRelativa==(BUF_ARCHI-1))||(i==m-1) ){
            fout.write(buffer,sizeof(arco),posRelativa+1);
            //cout<<"Scritti "<<posRelativa+1<<" archi \n";
         }

         numArchiModificati++;
         numArchiScritti++;

        //STAMPA SE NECESSARIO...
        if ( (conta++>500000)||(i==m-1) ){
          printf("%c[%6.2f%s] rewiring edges: %lld added edges",13,100.0*numArchiModificati/m ,"%",numArchiModificati)  ;
          fflush(stdout);
          conta=0;
        }
      }
      
      numFilesCreati = fout.close();
      printf("%c[%6.2f%s] rewiring edges: %lld added edges\n",13,100.0 ,"%",numArchiModificati)  ;

      break;
    }
    // ---------------------------------------------------------------------------------------------------------------

  };
//  cout<<"Edges number should be not valid if there is a <node declaration>, according to enhanced edge format\n";
  EXIT(0);
}

