/*

*********************************************************************
*********************************************************************

  file accessovirtualearchi_ips.cpp :source code of utl_sccgraphconstructor utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/


#include "accessovirtualearchi_ips.h"

accessoVirtualeArchi_IPS::accessoVirtualeArchi_IPS(char*info,char* succ){
  f_info=multiFileReader(info,-1);
  f_succ=multiFileReader(succ,-1);
  numSuccRimastiDaLeggere=0;
  nodoCorrente=-1;
}



void accessoVirtualeArchi_IPS::readNewBuffer(arco* buffer,long& sizeBufferUsato){

  //controllo se ci sono ancora nodi da leggere tra i successori del nodo corrente, ed eventualmente passo al successivo
  if (numSuccRimastiDaLeggere<=0){
    //printf("----- Leggo ------ \n");
    //legge l'info succ con almeno un successore
    infoNodo n;
    do{
      if (f_info.read(&n,sizeof(infoNodo),1)<=0){
        //printf("FINITO\n");
        sizeBufferUsato=0;
        return;//file INFO finito
      }
      nodoCorrente++;//nuovo nodo in analidi
    }while (n.outDeg<=0);

    //printf("Nuovo nodo %ld - succ=%ld\n",nodoCorrente,n.outDeg);

    //num nodi rimasti da leggere
    numSuccRimastiDaLeggere=n.outDeg;
  }

  //leggo i nodi successori
  long daLeggere=numSuccRimastiDaLeggere;
  if (daLeggere>SIZE_BUFFER_accessoVirtualeArchi) daLeggere=SIZE_BUFFER_accessoVirtualeArchi;
  if (f_succ.read(bufferSucc,sizeof(long),daLeggere)<daLeggere){printf("Format file error.");FINE;}

  //nodi rimasti da leggere per la prossima volta
  numSuccRimastiDaLeggere-=daLeggere;

  //creo il buffer degli archi
  for (int i=0;i<daLeggere;i++){
    buffer[i].source=nodoCorrente;
    buffer[i].dest=bufferSucc[i];
  }

  //aggiorno la dim dei nodi
  sizeBufferUsato=daLeggere;
  
}

