#ifndef BUFFERLETTURABITS_H_
#define BUFFERLETTURABITS_H_

#include <stdio.h>
#include <assert.h>
#include "../common/scc_utl/BufferLetturaFile.h"


class BufferLetturaBits
{
  public:
  BufferLetturaBits(const char * nome_file_bits, unsigned long num_elem, unsigned long dim_memoria_buffer);
  BufferLetturaBits(const char * nome_file_bits, unsigned long num_elem, unsigned long dim_memoria_buffer, unsigned char * punt_buffer_passato);
  ~BufferLetturaBits();

  bool get(unsigned long n, long & errore); //ritorna il bit relativo a 'n'.
  
  private:
  unsigned char * buffer; //puntatore alla memoria allocata (o al buffer passato dall'utente)
  unsigned long numero_elementi_vettore_bits;
  unsigned long num_byte_letti; //ci permette di capire come siamo posizionati nel file
  unsigned long indice_ultimo_bit_letto; //serve per far rispettare il vincolo di non tornare indietro con le richieste di elementi del vettore di bit
  unsigned char ultimo_byte_letto;
  FILE * file_input;
  BufferLetturaFile<unsigned char> * buf_input; //il buffer da leggere (a byte perche' il file vettore di bits usato da VettoreBits salva su disco il numero minimo di byte)

  void init(const char * nome_file_bits, unsigned long num_elem, unsigned long dim_memoria_buffer, unsigned char * punt_buffer_passato); //invocata dai costruttori

  BufferLetturaBits & operator=(const BufferLetturaBits &); //disabilitiamo l'operatore di assegnazione (altrimenti andrebbe gestito opportunamente essendoci della memoria allocata dinamicamente)
  BufferLetturaBits(const BufferLetturaBits &); //disabilitazione del costruttore di copia (altrimenti andrebbe gestito opportunamente essendoci della memoria allocata dinamicamente)
};

#endif
