#include "main.h"
#include "nodi_passivi.h"
#include "ListaStatica.h"
#include "../common/scc_utl/VettoreBits.h"
#include "../common/scc_utl/MergeSort.h"


unsigned long numero_passivi;
bool is_dirty_vettore_bits;
unsigned long numero_padri_da_escludere;

//(!) occhio alle inizializzazioni //*****
unsigned long numero_caricamenti_archi_nel_round; //*****
float somma_perc_caricamento_archi; //*****
unsigned long num_passivi_in_round_precedente; //*****indica se l'ultima volta che e' stata invocata calcola_nodi_padri_da_escludere() c'erano gia' dei nodi passivi
unsigned long nodi_salvati_Inizio_foresta, nodi_salvati_Fine_foresta; //impostato da salva_contenuto_stack_e_dati_Inizio_foresta()
unsigned long tot_nodi_scoperti_Inizio_foresta= 0, tot_nodi_scoperti_Fine_foresta= 0; //(!) occhio all'inizializzazione: la stima di Inizio usa la var. di Fine e viceversa. N.B. gli insiemi dei nodi delle parti iniziale e finale non e' garatito che siano disgiunti: percio' la somma dei nodi dei due insiemi puo' essere > numero_nodi.
unsigned long tot_swappati_Inizio_foresta= 0; //mentre per la parte finale il numero di passivi individuati coincide con il # di nodi swappati, con la parte iniziale i nodi swappati sono un _sottoinsieme_ dei nodi passivi individuati. Questa var. indica il numero effettivo di nodi swappati, mentre 'tot_nodi_scoperti_Fine_foresta' indica il # di nodi individuati
unsigned long ultimo_nodo_Parte_Finale; //rappresenta il nodo appartenente alla parte finale stabile della foresta con il # di preordine minore. Se tale parte finale e' vuota assume un valore speciale (MAX_ULONG)
long parti_mfile_Inizio_foresta_prec, parti_mfile_Fine_foresta_prec;
//unsigned long num_swappati_ultima_volta_Inizio_foresta, num_swappati_ultima_volta_Fine_foresta; //*****
unsigned long match_volta_precedente_Inizio_foresta, match_volta_precedente_Fine_foresta;
float somma_pesata_rate_Inizio_foresta, somma_pesata_rate_Fine_foresta;
unsigned long conta_calcoli_Inizio_foresta, conta_calcoli_Fine_foresta, conta_calcoli_NPE;
unsigned long long archi_scanditi_fino_a_ultimo_calcolo_passivi; //salva il conteggio degli archi scanditi quando abbiamo eseguito l'ultima volta il corpo della funzione gestione_ricerca_nodi_passivi(), ovvero quando abbiamo fatto l'ultima volta il calcolo dei passivi
unsigned long rounds_da_ultimo_calcolo_passivi_NPE; //conta i rounds passati dall'ultimo calcolo NPE fatto. I calcoli NPE possono venire distanziati tra loro perche' sono piuttosto costosi e potrebbe non essere conveniente eseguirli ad ogni round.
unsigned long rounds_da_attendere_x_prossimo_calcolo_passivi_NPE; //conta quanti rounds dobbiamo attendere per eseguire il prossimo calcolo NPE
//unsigned long parziale_nodi_radice_swappati; //***** indica quante _radici_ (nodi figli del super root) sono state swappate o con InizioForesta, o con FineForesta. Occhio a non confonderlo con le radici che sono state passate provvisoriamene su disco prima della DFS interna

multiFileWriter * mf_info_swap_passivi_FineForesta= NULL;
multiFileWriter * mf_nodi_swap_passivi_FineForesta= NULL;
multiFileWriter * mf_info_swap_passivi_InizioForesta= NULL;
multiFileWriter * mf_nodi_swap_passivi_InizioForesta= NULL;



//per vedere le variabili e funzioni definite altrove:
extern ListaStatica * liste_adiacenza;
extern const char * nome_mfile_max_reached;
extern const char * nome_file_bits_passivi_prec;
extern const char * nome_mfile_Inizio_foresta_prec;
extern const char * nome_mfile_Fine_foresta_prec;
extern const char * nome_mfile_nodi_swap_passivi_InizioForesta;
extern const char * nome_mfile_info_swap_passivi_InizioForesta;
extern const char * nome_mfile_nodi_swap_passivi_FineForesta;
extern const char * nome_mfile_info_swap_passivi_FineForesta;
extern const char * nome_file_bits_padri_esclusi;
extern unsigned long quick_test_modifiche_albero();
extern unsigned long valore_test_modifiche_albero_prec;
extern unsigned long ultimo_nodo_leftmost_path;


//variabili usate per statistiche:
unsigned long numero_stime_carenti_Inizio_foresta= 0;
unsigned long numero_salvataggi_inutili_nodi_Inizio_foresta= 0;
unsigned long numero_stime_carenti_Fine_foresta= 0;
unsigned long numero_salvataggi_inutili_nodi_Fine_foresta= 0;
unsigned long conta_passivi_scoperti_NPE= 0;
unsigned long conta_passivi_scoperti_Parte_Iniziale= 0;
unsigned long conta_passivi_scoperti_Parte_Finale= 0;
unsigned long tot_ricariche_passivi_da_disco= 0;
extern long long  tot_max_preord_calcolo_passivi_NPE;
extern long long  tot_numero_preordine_NPE;
extern long long  tot_calcolo_passivi_NPE;
extern long long  tot_calcolo_passivi_InitialPart;
extern long long  tot_calcolo_passivi_FinalPart;

static clock_t  tag001, tag_1, tag002, tag_2; //******variabili che servono solo a prendere i tempi (sono globali solo per non ridichiararle ogni volta)




//"costruttore" che inizializza le variabili usate in questo modulo
void init_modulo_nodi_passivi()
{
  numero_padri_da_escludere= 0;
  num_passivi_in_round_precedente= 0; //*****
  conta_calcoli_NPE= 0;
  conta_calcoli_Inizio_foresta= 0;
  conta_calcoli_Fine_foresta= 0;
  tot_nodi_scoperti_Inizio_foresta= 0;
  tot_nodi_scoperti_Fine_foresta= 0;
  tot_swappati_Inizio_foresta= 0;
  archi_scanditi_fino_a_ultimo_calcolo_passivi= 0;
  rounds_da_ultimo_calcolo_passivi_NPE= 0;
  rounds_da_attendere_x_prossimo_calcolo_passivi_NPE= 2; //(!) all'inizio aspettiamo X rounds prima di calcolare con NPE
//  parziale_nodi_radice_swappati= 0;
  somma_perc_caricamento_archi= 0.0f;
  numero_caricamenti_archi_nel_round= 0;
  
//  num_swappati_ultima_volta_Inizio_foresta= 0; num_swappati_ultima_volta_Fine_foresta= 0; //*****
  
  numero_passivi= 0;
  is_dirty_vettore_bits= true; //in modo che la prima volta che serve il vettore di bits pulito, questo viene azzerato (e' numero_passivi==0)

  
  eraseMultiFile(nome_mfile_info_swap_passivi_FineForesta); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  eraseMultiFile(nome_mfile_nodi_swap_passivi_FineForesta); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  mf_info_swap_passivi_FineForesta= new multiFileWriter((char *) nome_mfile_info_swap_passivi_FineForesta, 512*1024*1024);
  mf_nodi_swap_passivi_FineForesta= new multiFileWriter((char *) nome_mfile_nodi_swap_passivi_FineForesta, 512*1024*1024);
  mf_info_swap_passivi_InizioForesta= new multiFileWriter((char *) nome_mfile_info_swap_passivi_InizioForesta, 512*1024*1024);
  mf_nodi_swap_passivi_InizioForesta= new multiFileWriter((char *) nome_mfile_nodi_swap_passivi_InizioForesta, 512*1024*1024);
}



#ifndef NDEBUG
//*****serve per il debug
void print_stack(const char * testo, SwappedStack<unsigned long> * pila)
{
  unsigned long num_elementi= pila->stackSize();

  printf("Contenuto dello stack %s (bottom-up):\n", testo);
  
  for(unsigned long i=0; i<num_elementi; i++)
  {
    unsigned long elem;
    
    bool ok= pila->readTop(elem, num_elementi - 1 - i);
    if(ok)
      printf(" %lu", elem);
    else
      printf(" Err");
  }
  
  printf("\n");
}



//*****serve per il debug
void print_passivi()
{
  nodi_passivi->print("Nodi Passivi");
}


//*****serve per il debug
void print_numero_passivi()
{
  unsigned long nodo_raggiunto, quanti_trovati=0;
  bool found;
  
  //ricerca e output dei nodi marcati come visitati:
  found= nodi_passivi->findNext1(nodo_raggiunto, 0); //cerchiamo il primo nodo raggiunto, a partire dal nodo 0

  while(found)
  {
    quanti_trovati++;
    found= nodi_passivi->findNext1(nodo_raggiunto);
  }
  
  printf(">>>>>>>>>>>>>>> num. passivi reale=%lu\n", quanti_trovati);
}
#endif



#ifdef CHECK_PASSIVI //*******

#define size_bufferone_check 5*1024*1024
unsigned long bufferone_check[size_bufferone_check];



//*****serve per il debug
bool sono_parenti(unsigned long nodo_src, unsigned long nodo_dst)
{
  SwappedStack<unsigned long> pila(10000);

  liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_src, &pila);

  while( !pila.isEmpty() )
  {
    bool ris;
    unsigned long nodo_affiorante;

    ris= pila.pop(nodo_affiorante);
    accertati_che( ris, MSG_ERRORE_PILA);

    if(nodo_affiorante == nodo_dst)
      return true;
    else
      liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_affiorante, &pila);
  }


  return false;
}


//*****serve per il debug
void check_like_max_preordine_raggiunto(unsigned long * vettore_numeri, unsigned long dim_tot_mem_buffers, unsigned long * memoria_per_buffers)
{
  unsigned long il_prossimo_passivo;

  alloca_buffers_lettura_IPS(memoria_per_buffers, dim_tot_mem_buffers);

  //usiamo findNext1 per accedere al vettore di bits, perche' l'accesso e' sequenziale. Inizializziamo la variabile usata:
  if(numero_passivi == 0)
    il_prossimo_passivo= MAX_ULONG; //massimo valore intero, corrisponde a "nessun nodo del grafo"
  else
  {
    bool found= nodi_passivi->findNext1(il_prossimo_passivo, 0);
    accertati_che(found, "Errore nei bits nodi passivi: ci aspettavamo almeno un bit 1");
  }

  for(unsigned long nodo_src=0; nodo_src < numero_nodi; nodo_src++)
  {
    struct grafoInfo info;
    unsigned long size_lista_adiac;

    bool ris= buf_info->get(info); //leggiamo l'info del nodo successivo
    accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoINFO);

    if(visita_avanti)
      size_lista_adiac= info.outDeg;
    else
      size_lista_adiac= info.inDeg;

    unsigned long preord_nodo_src;
    preord_nodo_src= vettore_numeri[nodo_src]; //leggiamo il # di preordine del nodo sorgente
    
    if(nodo_src == il_prossimo_passivo) //nodo corrente passivo?
    {
      bool ok, found;
      //(!) saltiamo tutti gli adiacenti del grafo passivo: infatti SE I NODI PASSIVI SONO STATI CALCOLATI DA ALMENO UN ROUND, allora tutti gli archi uscenti dal nodo sono o all'indietro (cross/tree), o forward tree (ma non minacciano il sottoalbero), oppure sono figli del nodo passivo stesso. Non ci possono essere cioe' forward cross edges.

      for(unsigned long i=0; i < size_lista_adiac; i++) //consideriamo tutti gli adiacenti nel grafo complessivo:
      {
        unsigned long nodo_dest, preord_dest;
        ris= buf_adiac->get(nodo_dest);
        accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoADIAC);
        preord_dest= vettore_numeri[nodo_dest]; //# di preordine del nodo destinazione dell'arco
        if(is_passivo(nodo_dest) && (preord_dest>preord_nodo_src) && (preord_nodo_src!=0) && !sono_parenti(nodo_src, nodo_dest))
        {
          printf("\narco (%lu, %lu) con # preord: %lu--> %lu\n passivi? src=%d, dst=%d\n", nodo_src, nodo_dest, preord_nodo_src, preord_dest, is_passivo(nodo_src), is_passivo(nodo_dest));
//          printf("\nfigli nodo:\n");    for(unsigned long ji=0; ji < liste_adiacenza->degree_of(nodo_src); ji++) printf("%lu ", liste_adiacenza->get_adiac(nodo_src, ji)); printf("\n");
          printf("\nListe di adiac.:\n"); liste_adiacenza->print_adiacenti(); //*****
          accertati_che(false, "errore check nodi passivi");
        }
      }

      //vediamo qual'e' il prossimo nodo passivo che incontreremo:
      found= nodi_passivi->findNext1(il_prossimo_passivo);
      if(!found)
        il_prossimo_passivo= MAX_ULONG; //massimo valore intero, corrisponde a "nessun nodo del grafo"
    }
    else // non e' passivo
    {
      for(unsigned long i=0; i < size_lista_adiac; i++) //consideriamo tutti gli adiacenti nel grafo complessivo:
      {
        unsigned long nodo_dest, preord_dest;

        ris= buf_adiac->get(nodo_dest);
        accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoADIAC);

        preord_dest= vettore_numeri[nodo_dest]; //# di preordine del nodo destinazione dell'arco

        if(is_passivo(nodo_dest) && (preord_dest>preord_nodo_src) && (preord_nodo_src!=0))
        {
          printf("\narco (%lu, %lu) con # preord: %lu--> %lu\n passivi? src=%d, dst=%d\n", nodo_src, nodo_dest, preord_nodo_src, preord_dest, is_passivo(nodo_src), is_passivo(nodo_dest));
//          printf("\nfigli nodo:\n");    for(unsigned long ji=0; ji < liste_adiacenza->degree_of(nodo_src); ji++) printf("%lu ", liste_adiacenza->get_adiac(nodo_src, ji)); printf("\n");
          printf("\nListe di adiac.:\n"); liste_adiacenza->print_adiacenti(); //*****
          accertati_che(false, "errore check nodi passivi");
        }
      }

    } //fine blocco else (caso nodo non passivo)

  } //fine blocco for di tutti i nodi

  libera_buffers_lettura_IPS();
}


//*****serve per il debug
void controlla_passivi(const char * messaggio)
{
  printf("\n -------------> %s..", messaggio);
  unsigned long * mem_ad_hoc= new unsigned long[numero_nodi];
  calcola_numero_preordine(mem_ad_hoc, size_bufferone_check, bufferone_check);
  printf("...");
  ripristina_nodi_passivi_se_necessario();
  check_like_max_preordine_raggiunto(mem_ad_hoc, size_bufferone_check, bufferone_check);
  delete [] mem_ad_hoc;
  printf("Fatto.\n");
}


//*****serve per il debug
void print_numeri_preordine()
{
  SwappedStack<unsigned long> pila(100000);

  printf("\n\nNumeri di preordine dei nodi:\n");
  
  unsigned long conta_preordine= 1; //parte da 1 in modo da usare lo 0 come un valore "nil" che viene sicuramente trascurato

  unsigned long num_alberi= liste_adiacenza->degree_of(NODO_SUPER_ROOT);
  for(unsigned long i=0; i < num_alberi ; i++)
  {
    pila.push( liste_adiacenza->get_adiac(NODO_SUPER_ROOT, i) );

    while( !pila.isEmpty() )
    {
      bool ris;
      unsigned long nodo_affiorante;

      ris= pila.pop(nodo_affiorante);
      accertati_che(ris, MSG_ERRORE_PILA);

      printf("%lu) ---> # %lu\n", nodo_affiorante, conta_preordine);
      conta_preordine++; //incrementiamo il conteggio

      //mettiamo i suoi adiacenti nello stack (IN ORDINE INVERSO!):
      liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_affiorante, &pila);
    }
  }
}
#endif



//scrive sullo schermo informazioni statistiche sui passivi calcolati
void print_statistiche_passivi()
{
  printf(" Numero di calcoli passivi effettuati:  NPE=%lu  ;  p. Iniziale=%lu  ;  p. Finale=%lu\n", conta_calcoli_NPE, conta_calcoli_Inizio_foresta, conta_calcoli_Fine_foresta);
  printf(" Numero di letture da disco del vettore dei bits:  %lu\n", tot_ricariche_passivi_da_disco);  
  printf(" Prestazioni passivi\n   parte Iniziale:  stime insufficienti=%lu ; eccesso di nodi salvati:%lu (%.1f%%, %.1f%% medio)\n   parte Finale:  stime insufficienti=%lu ; eccesso di nodi salvati:%lu (%.1f%%, %.1f%% medio)\n", numero_stime_carenti_Inizio_foresta, numero_salvataggi_inutili_nodi_Inizio_foresta, 100.0f*numero_salvataggi_inutili_nodi_Inizio_foresta/tot_nodi_scoperti_Inizio_foresta, 100.0f*numero_salvataggi_inutili_nodi_Inizio_foresta/conta_calcoli_Inizio_foresta/tot_nodi_scoperti_Inizio_foresta, numero_stime_carenti_Fine_foresta, numero_salvataggi_inutili_nodi_Fine_foresta, 100.0f*numero_salvataggi_inutili_nodi_Fine_foresta/tot_nodi_scoperti_Fine_foresta, 100.0f*numero_salvataggi_inutili_nodi_Fine_foresta/conta_calcoli_Fine_foresta/tot_nodi_scoperti_Fine_foresta);
  printf(" Percentuali nodi passivi scoperti:  NPE=%.1f%%  ;  p. Iniziale=%.1f%%  ;  p. Finale=%.1f%%\n", 100.0f*conta_passivi_scoperti_NPE/numero_nodi, 100.0f*conta_passivi_scoperti_Parte_Iniziale/numero_nodi, 100.0f*conta_passivi_scoperti_Parte_Finale/numero_nodi);
  printf(" Numero di nodi swappati:  p. Iniziale=%lu (%.1f%%)  ;  p. Finale=%lu (%.1f%%)\n", tot_swappati_Inizio_foresta, 100.0f*tot_swappati_Inizio_foresta/numero_nodi, tot_nodi_scoperti_Fine_foresta, 100.0f*tot_nodi_scoperti_Fine_foresta/numero_nodi);
//  printf(" Numero di radici swappate: %lu *****\n", parziale_nodi_radice_swappati); //*****
}



//*****
//void statistiche_caricamento_archi()
//{
//  unsigned long quanti_figli_di_nonesclusi_passivi, quanti_figli_passivi_di_nonesclusi_passivi, num_nonesclusi_passivi, tot_archi_anomali, quanti_nodi_da_escludere, quanti_figli_padri_esclusi, quanti_figli_passivi, quanti_figli_presenti;
//
//  quanti_nodi_da_escludere= 0;
//  quanti_figli_padri_esclusi= 0;
//  quanti_figli_passivi= 0;
//  quanti_figli_presenti= 0;
//  tot_archi_anomali= 0;
//  num_nonesclusi_passivi= 0;
//  quanti_figli_passivi_di_nonesclusi_passivi= 0;
//  quanti_figli_di_nonesclusi_passivi= 0;
//
//  const unsigned long size_memoria_prova= 4*1024*1024;
//  unsigned long memoria_prova[size_memoria_prova / sizeof(unsigned long)];
//
//  VettoreBits padri_da_escludere(numero_nodi);
//  VettoreBits bits_swappati(numero_nodi);
//  bits_swappati.copia( *nodi_passivi ); //inizializziamo il vettore di bits ausiliario copiando tutti i nodi passivi finora individuati
//
//  //cancelliamo i nodi raggiungibili in una visita della foresta (che non sono swappati):
//  for(unsigned long nodo_src=0; nodo_src<=NODO_SUPER_ROOT; nodo_src++)
//  {
//    unsigned long degree= liste_adiacenza->degree_of(nodo_src);
//
//    for( unsigned long ind_adiac= 0; ind_adiac < degree ; ind_adiac++)
//    {
//      unsigned long nodo_dest= liste_adiacenza->get_adiac(nodo_src, ind_adiac); //compreso tra 0 e N-1 perche' il "super root" non ha mai archi entranti
//
//      long errore;
//      bits_swappati.set(nodo_dest, false, errore); //se l'abbiamo raggiunto, allora questo nodo non era tra quelli swappati, e ne resettiamo il bit corrispondente
//      accertati_che( (errore==0), MSG_ERRORE_BITS);
//    }
//  }
//
//
//  if(numero_padri_da_escludere > 0)
//    padri_da_escludere.caricaDaFile(nome_file_bits_padri_esclusi);
//  else
//    padri_da_escludere.reset(false);
//
//  alloca_buffers_lettura_IPS(memoria_prova, size_memoria_prova);
//
//  for(unsigned long nodo_src=0; nodo_src < numero_nodi; nodo_src++)
//  {
//    struct grafoInfo info;
//    unsigned long size_lista_adiac;
//    long errore;
//
//    bool ris= buf_info->get(info); //leggiamo l'info del nodo successivo
//    accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoINFO);
//
//    if(visita_avanti)
//      size_lista_adiac= info.outDeg;
//    else
//      size_lista_adiac= info.inDeg;
//
//    bool is_da_ignorare= padri_da_escludere.get(nodo_src, errore);
//    assert(!errore);
//
//    if(is_da_ignorare)
//    {
//      quanti_nodi_da_escludere++;
//      quanti_figli_padri_esclusi += size_lista_adiac;
//
//      bool ok= buf_adiac->skip(size_lista_adiac);
//      accertati_che( ok, MSG_ERRORE_SEEK, grafoADIAC);
//    }
//    else
//    {
//      long errore;
//      bool swap= bits_swappati.get(nodo_src, errore);
//      assert(!errore);
//      assert(!swap);
//
//      if( is_passivo(nodo_src) )
//      {
//        num_nonesclusi_passivi++;
//        quanti_figli_di_nonesclusi_passivi += size_lista_adiac;
//      }
//
//      for(unsigned long i=0; i < size_lista_adiac; i++) //consideriamo tutti gli adiacenti nel grafo complessivo:
//      {
//        long errore;
//        unsigned long nodo_dest;
//        ris= buf_adiac->get(nodo_dest);
//        accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoADIAC);
//
//        bool swap= bits_swappati.get(nodo_dest, errore);
//        assert(!errore);
////        accertati_che(is_passivo(nodo_src) || !swap, "trovato un arco da un nodo non-passivo verso un nodo swappato (%lu->%lu)", nodo_src, nodo_dest);
//        if(swap)
//          tot_archi_anomali++;
//
//        if( is_passivo(nodo_dest) )
//        {
//          quanti_figli_passivi++;
//
//          if( is_passivo(nodo_src) )
//            quanti_figli_passivi_di_nonesclusi_passivi++;
//        }
//        else
//        if( liste_adiacenza->ricerca_sequenziale_adiacente(nodo_src, nodo_dest, liste_adiacenza->degree_of(nodo_src) ) )
//          quanti_figli_presenti++;
//      }
//    }
//  }
//
//
//  libera_buffers_lettura_IPS();
//
//  assert(quanti_nodi_da_escludere==numero_padri_da_escludere);
//
//  unsigned long bonus_radici;
//  unsigned long num_radici_in_memoria= liste_adiacenza->degree_of(NODO_SUPER_ROOT);
//  if(num_radici_in_memoria < PERC_MINIMA_RADICI_OUT * numero_nodi)
//    bonus_radici= 0;
//  else
//    bonus_radici= num_radici_in_memoria;
//
//  unsigned long archi_caricati_totali= (numero_archi-quanti_figli_padri_esclusi-quanti_figli_passivi-quanti_figli_presenti);
//  printf("\nStatistiche effettive caricamento archi:\n");
//  printf("quanti_nodi_da_escludere:%lu\n", quanti_nodi_da_escludere);
//  printf("quanti_figli_padri_esclusi:%lu\n", quanti_figli_padri_esclusi);
//  printf("# nodi non esclusi:%lu (%lu passivi e %lu non-passivi)\n", numero_nodi - quanti_nodi_da_escludere, num_nonesclusi_passivi, (numero_nodi - quanti_nodi_da_escludere) - num_nonesclusi_passivi);
//  printf(" -->i non-esclusi passivi hanno %lu figli, mentre i non-esclusi non-passivi ne hanno %lu\n", quanti_figli_di_nonesclusi_passivi, numero_archi - quanti_figli_padri_esclusi - quanti_figli_di_nonesclusi_passivi);
//
//  printf("quanti_figli_passivi:%lu\n", quanti_figli_passivi);
//  printf(" -->di cui %lu figli di non-esclusi passivi e %lu figli di non-esclusi non-passivi\n", quanti_figli_passivi_di_nonesclusi_passivi, quanti_figli_passivi - quanti_figli_passivi_di_nonesclusi_passivi);
//
//  printf("perc. figlio passivo per padre non escluso:%.3f\n", quanti_figli_passivi/((float)numero_archi-quanti_figli_padri_esclusi));
//  printf("archi ignorati perche' verso figli:%lu\n", quanti_figli_presenti);
//  printf("archi verso nodi swappati (sottoinsieme di quelli verso nodi passivi):%lu\n", tot_archi_anomali);
//  printf("archi caricati:%lu\n", archi_caricati_totali);
//  printf("perc. scansione:%.1f%%\n", MIN(1.0f*(archi_caricabili_alla_volta + bonus_radici)/archi_caricati_totali, 1.0f)*100.0f);
//  printf("\n");
//}



//stima empiricamente la percentuale di grafo (i.e. archi) che sara' possibile mantenere in memoria con la prossima porzione del grafo che leggeremo dal disco. Si tiene conto degli archi verso nodi passivi che vengono ignorati, che non vengono letti archi gia' appartenenti alla foresta DFS, e che per i nodi swappati tutti gli adiacenti su disco vengono ignorati. Si tiene conto dello spazio aggiuntivo che si rende disponibile in memoria grazie ai nodi swappati e grazie alle radici swappate. La stima dovrebbe approssimare per difetto, dato che non si considera che gli adiacenti dei nodi passivi stabili (passivi da 1+ round) vengono anch'essi sempre ignorati. Non viene valutato nemmeno il fatto che i nodi non ancora passivi sul cammino piu' a SX non vengono caricati
float stima_percentuale_grafo_caricabile()
{
  float pos_richieste;
  unsigned long figli_in_foresta_da_escludere, conta_padri_da_escludere, pos_disponibili, num_radici_in_memoria, bonus_radici;

  if(numero_archi < numero_nodi)
    return 100.0f;

  num_radici_in_memoria= liste_adiacenza->degree_of(NODO_SUPER_ROOT);
  if(num_radici_in_memoria < PERC_MINIMA_RADICI_OUT * numero_nodi)
    bonus_radici= 0;
  else
    bonus_radici= num_radici_in_memoria;

//  tot_swappati= tot_nodi_scoperti_Fine_foresta;
//  num_archi_out_foresta= numero_archi - (numero_nodi - num_radici);
//  num_archi_out_foresta= numero_archi - liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT); //(numero_archi-numero_nodi+num_radici);
//  conta_padri_da_escludere= (max( num_passivi_in_round_precedente, tot_nodi_scoperti_Fine_foresta + tot_swappati_Inizio_foresta) + (num_passivi_in_round_precedente + tot_nodi_scoperti_Fine_foresta + tot_swappati_Inizio_foresta))/2;
  conta_padri_da_escludere= numero_padri_da_escludere;
    
//  pos_richieste= ((numero_nodi-numero_passivi)/((float)numero_nodi)) * (numero_archi-numero_nodi); //*****
//  unsigned long pippo= liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT); //*****
  pos_disponibili= archi_caricabili_alla_volta + bonus_radici;
//  pos_richieste= ((numero_nodi-numero_passivi)/((float)numero_nodi)) * ((numero_nodi-tot_swappati)/((float)numero_nodi)) * num_archi_out_foresta;
//  pos_richieste= (1 - conta_padri_da_escludere/((float)numero_nodi)) * (1 - (numero_passivi-tot_nodi_scoperti_Fine_foresta)/((float)numero_nodi-tot_nodi_scoperti_Fine_foresta)) * numero_archi;

//  unsigned long padri_nonesclusi= numero_nodi - conta_padri_da_escludere;
//  unsigned long padri_nonesclusi_passivi= numero_passivi - conta_padri_da_escludere;
//  unsigned long padri_nonesclusi_nonpassivi= padri_nonesclusi - padri_nonesclusi_passivi;

  float prob_p= (numero_passivi - conta_padri_da_escludere)/((float) numero_nodi - conta_padri_da_escludere);

  float c1= numero_passivi/((float) numero_nodi);
  float c2= 0.5f*numero_passivi/((float) numero_nodi);//(numero_passivi - tot_nodi_scoperti_Fine_foresta)/((float) numero_nodi - tot_nodi_scoperti_Fine_foresta);
  float pr_pes= prob_p*c1 + (1.0f - prob_p)*c2;
//  pos_richieste= (1.0f - ( prob_p*(numero_passivi/((float)numero_nodi)) + (1.0f - prob_p)*0.5f*(numero_passivi - tot_nodi_scoperti_Fine_foresta)/(numero_nodi - tot_nodi_scoperti_Fine_foresta) )) * numero_archi;  
  pos_richieste= (1.0f - pr_pes) * (1.0f - conta_padri_da_escludere/((float) numero_nodi) ) * numero_archi;
//printf("prob_p=%f  ;  c1=%.3f  ;  c2=%.3f  ;  pr_pes=%.3f\n", prob_p, c1, c2, pr_pes);  

//  figli_in_foresta_da_escludere= liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT) * (1 - numero_passivi/((float)numero_nodi));
//  figli_in_foresta_da_escludere= subtrunc(numero_nodi, numero_passivi + num_radici_in_memoria);
//  figli_in_foresta_da_escludere= (numero_nodi - parziale_nodi_radice_swappati - num_radici_in_memoria) * (1 - numero_passivi/((float)numero_nodi));
//  figli_in_foresta_da_escludere= liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT) * (1 - (numero_passivi-tot_nodi_scoperti_Fine_foresta)/((float)numero_nodi-tot_nodi_scoperti_Fine_foresta));
  figli_in_foresta_da_escludere= liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT) * (1.0f - (numero_passivi-tot_swappati_Inizio_foresta-tot_nodi_scoperti_Fine_foresta)/((float)numero_nodi-tot_swappati_Inizio_foresta-tot_nodi_scoperti_Fine_foresta));
  
  if(pos_richieste >= figli_in_foresta_da_escludere)
    pos_richieste -= figli_in_foresta_da_escludere;
  else
    pos_richieste= 0;

//  unsigned long quanti_figli_padri_esclusi= (unsigned long) (conta_padri_da_escludere*(((float) numero_archi)/numero_nodi));
//  printf("\nStime caricamento archi:\n");
//  printf("quanti_nodi_da_escludere:%lu\n", conta_padri_da_escludere);
//  printf("quanti_figli_padri_esclusi:%lu\n", quanti_figli_padri_esclusi);
//  printf("# nodi non esclusi:%lu (%lu passivi e %lu non-passivi)\n", numero_nodi - conta_padri_da_escludere, (unsigned long) (prob_p*(numero_nodi - conta_padri_da_escludere)), (unsigned long) ((1.0f - prob_p)*(numero_nodi - conta_padri_da_escludere)));
//  printf(" -->i non-esclusi passivi hanno %lu figli, mentre i non-esclusi non-passivi ne hanno %lu\n", (unsigned long) ( prob_p * (numero_archi - quanti_figli_padri_esclusi) ), (unsigned long) ( (1.0f - prob_p) * (numero_archi - quanti_figli_padri_esclusi)) );
//
//  printf("quanti_figli_passivi:%lu\n", (unsigned long) ( pr_pes * (numero_archi - quanti_figli_padri_esclusi) ) );
//  printf(" -->di cui %lu figli di non-esclusi passivi e %lu figli di non-esclusi non-passivi\n", (unsigned long) ( c1 * prob_p * (numero_archi - quanti_figli_padri_esclusi) ), (unsigned long) ( c2 * (1.0f - prob_p) * (numero_archi - quanti_figli_padri_esclusi)) );
//
//  printf("quanti_figli_passivi*:%lu\n", (unsigned long) ((numero_archi - quanti_figli_padri_esclusi) * (((float)numero_passivi-tot_nodi_scoperti_Fine_foresta)/(numero_nodi-tot_nodi_scoperti_Fine_foresta))) );
//  printf("quanti_figli_passivi**:%lu\n", (unsigned long) ((numero_archi - quanti_figli_padri_esclusi) * (((float)numero_passivi)/(numero_nodi))) );
//  printf("quanti_figli_passivi***:%lu\n", (unsigned long) ((numero_archi - quanti_figli_padri_esclusi) * (((float)numero_passivi-tot_nodi_scoperti_Fine_foresta/2)/(numero_nodi-tot_nodi_scoperti_Fine_foresta/2))) );
//  printf("archi ignorati perche' verso figli:%lu\n", figli_in_foresta_da_escludere);
//  printf("archi ignorati perche' verso figli**:%lu\n", (unsigned long) (liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT) * (1.0f - numero_passivi/((float) numero_nodi))) );
//  printf("archi caricati:%lu\n", (unsigned long) pos_richieste);
//  printf("**perc. effettiva round precedente:%.1f%%\n", 100.0f*somma_perc_caricamento_archi/numero_caricamenti_archi_nel_round);
//  printf("\n");
        
  if((unsigned long)pos_richieste <= pos_disponibili)
    return 100.0f; //dovrebbe entrare tutto il grafo in memoria
  else
    return 100.0f * (pos_disponibili / pos_richieste); //solo una frazione delle info. significative del grafo trovera' posto in memoria
}



//esegue la sottrazione troncando a zero il risultato se esso dovesse essere negativo
//in pratica equivale a MIN(0, (signed long) sottraendo - quanto_togliere)
inline unsigned long subtrunc(unsigned long sottraendo, unsigned long quanto_togliere)
{
  long sottrazione_con_segno= sottraendo - quanto_togliere;

  if(sottrazione_con_segno < 0)
    return 0; //tronchiamo a zero
  else
    return (unsigned long) sottrazione_con_segno; //ritorniamo la sottrazione calcolata, che e' non-negativa
}



//ricarica dal disco il contenuto del vettore dei nodi passivi
void ripristina_nodi_passivi_se_necessario()
{
  if(is_dirty_vettore_bits)
  {
    if(numero_passivi == 0)
      nodi_passivi->reset(false); //evitiamo di ricaricare da disco tutti zeri
    else
    {
      bool ok= nodi_passivi->caricaDaFile(nome_file_bits_passivi_prec); //ripristiniamo il vettore di bits dei nodi passivi dal disco. Serve perche' la selezione degli archi evita di caricare quelli diretti verso nodi passivi
      accertati_che(ok, MSG_ERRORE_LETTURA_BITS);
      tot_ricariche_passivi_da_disco++;
    }
    is_dirty_vettore_bits= false;
  }
}



////(!) N.B. non va usata con il "super root"
//bool is_passivo(unsigned long nodo)
//{
//  long errore;
//
//  bool risposta= nodi_passivi->get(nodo, errore);
//  accertati_che( (errore==0), MSG_ERRORE_BITS);
//
//  return risposta;
//}
//
//
//
//bool set_passivo(unsigned long nodo)
//{
//  long errore;
//  bool risposta= nodi_passivi->set(nodo, true, errore);
//  accertati_che( (errore==0), MSG_ERRORE_BITS);
//  return risposta;
//}
//
//
//
//bool reset_passivo(unsigned long nodo)
//{
//  long errore;
//  bool risposta= nodi_passivi->set(nodo, false, errore);
//  accertati_che( (errore==0), MSG_ERRORE_BITS);
//  return risposta;
//}



//------------------CALCOLO-NODI-PASSIVI--No Passing Edges-----------------------------------------



//(!) controllare che la cosa funzioni quando ho una visita da un singolo nodo

/* esplora il sottoalbero corrispondente al nodo affiorante dalla pila e contenente solo nodi non-passivi (poiche' il primo deve essere per ipotesi non-passivo).
*/
inline void numera_sottoalbero(unsigned long * mem_numeri_preordine, SwappedStack<unsigned long> * pila, unsigned long * conta_preordine)
{
  bool ok;
  unsigned long nodo_affiorante, livello_iniziale_pila;

  livello_iniziale_pila= pila->stackSize(); //salviamo il # di elementi di partenza (per ipotesi la pila puo' non contenere solo l'elemento da esplorare, ma questo e' solo il nodo affiorante)


#ifdef OPT_PRIMO_CAMMINO
  ok= pila->pop(nodo_affiorante);
  accertati_che(ok, MSG_ERRORE_PILA);
  unsigned long degree= liste_adiacenza->degree_of(nodo_affiorante);

  while(degree > 0)
  {
    mem_numeri_preordine[nodo_affiorante]= (*conta_preordine); //ci ricordiamo del numero di preordine del nodo corrente
    (*conta_preordine)++; //incrementiamo il conteggio

    liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_affiorante, pila, degree - 1);

    nodo_affiorante= liste_adiacenza->get_adiac(nodo_affiorante, 0);
    degree= liste_adiacenza->degree_of(nodo_affiorante);
  }
  mem_numeri_preordine[nodo_affiorante]= (*conta_preordine); //ci ricordiamo del numero di preordine del nodo corrente
  (*conta_preordine)++; //incrementiamo il conteggio
#endif


  while((unsigned long) pila->stackSize() >= livello_iniziale_pila) //usciamo quando e' stata conclusa l'elaborazione del sottoalbero del nodo affiorante inizialmente dalla pila
  {  
    ok= pila->pop(nodo_affiorante);
    accertati_che(ok, MSG_ERRORE_PILA);

    mem_numeri_preordine[nodo_affiorante]= (*conta_preordine); //ci ricordiamo del numero di preordine del nodo corrente
    (*conta_preordine)++; //incrementiamo il conteggio

    //mettiamo i suoi adiacenti nello stack (IN ORDINE INVERSO!):
    liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_affiorante, pila);
  }

}



//PRECondizioni: serve il vettore dei bits "pulito"
void calcola_numero_preordine(unsigned long * mem_numeri_preordine, unsigned long size_memoria_pila, unsigned long * memoria_pila)
{
  SwappedStack<unsigned long> pila(size_memoria_pila, memoria_pila);

  //inizializzo tutto a zero: serve poiche' i valori arbitrari non inizializzati (per nodi non raggiungibili dalla foresta, o perche' abbiamo inizializzato con meno di N nodi, o perche' abbiamo swappato dei nodi passivi) verrebbero letti da calcola_max_preordine_raggiunto() e porterebbero a calcolare un valore errato per i nodi con archi verso questi nodi per cui non e' stato calcolato il # di preordine. Il valore 0 viene ignorato perche' calcola_max_preordine_raggiunto() calcola appunto un massimo. Un'altra possibilita' per risolvere il problema (solo per il caso dei nodi swappati) era quella di ignorare gli archi verso nodi passivi in calcola_max_preordine_raggiunto() con un opportuno controllo nel vettore dei bits
  for(unsigned long i=0; i < numero_nodi; i++) //per tutti i nodi tranne il "super root" inizializzo a 0
    mem_numeri_preordine[i]= 0;

  unsigned long conta_preordine= 1; //parte da 1 in modo da usare lo 0 come un valore "nil" che viene sicuramente trascurato

  unsigned long * const vettore_adiacenti= liste_adiacenza->vettore_adiacenti();
  unsigned long numero_alberi= liste_adiacenza->degree_of(NODO_SUPER_ROOT); //ogni arco che parte dal nodo "super root" individua un albero DFS
  unsigned long * punt_nodo_radice= vettore_adiacenti + liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT);

  for(unsigned long i=0; i<numero_alberi ; i++, punt_nodo_radice++) //i figli del nodo super root vengono trattati come caso particolare per evitare di inserirli nella pila tutti assieme
  {
    if( !is_passivo( *punt_nodo_radice) )
    { //nodo non passivo: la sua lista di adiac. va riordinata in base ai pesi, che bisogna percio' calcolare
      pila.push( *punt_nodo_radice); //inseriamo il nodo radice nella pila
      numera_sottoalbero(mem_numeri_preordine, &pila, &conta_preordine); //calcoliamo i pesi di tutti i nodi dell'albero della radice corrente
    } //a questo punto il nodo non-passivo e' stato rimosso dalla pila
    else
    { //in questo caso non ci interessa calcolare il peso dei sottoalberi, fino al prossimo nodo non-passivo continuiamo l'esplorazione dell'albero senza fare nulla
      unsigned long nodo_top;

      pila.push(*punt_nodo_radice);

      do
      {
        pila.readTop(nodo_top); //leggiamo adesso in 'nodo_top' il nodo affiorante (figlio di un passivo), senza toglierlo dalla pila

        if( !is_passivo(nodo_top) )
        { //nodo non passivo: la sua lista di adiac. va riordinata in base ai pesi, che bisogna percio' calcolare
          numera_sottoalbero(mem_numeri_preordine, &pila, &conta_preordine); //calcoliamo i pesi di tutti i nodi del sottoalbero relativo a 'nodo_top'
        } //a questo punto il nodo non-passivo e' stato rimosso dalla pila
        else
        { //in questo caso non ci interessa calcolare il peso dei sottoalberi, fino al prossimo nodo non-passivo continuiamo l'esplorazione dell'albero senza fare nulla
#ifdef OPT_PRIMO_CAMMINO
          unsigned long nodo_corrente= nodo_top;
          unsigned long degree= liste_adiacenza->degree_of(nodo_corrente);
          bool passivo= true;

          pila.pop(nodo_top); //(!) rimuove dalla pila il nodo affiorante (ricopiandolo di nuovo in 'nodo_top')

          while(passivo && (degree > 0))
          {
            liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_corrente, &pila, degree - 1);

            nodo_corrente= liste_adiacenza->get_adiac(nodo_corrente, 0);
            degree= liste_adiacenza->degree_of(nodo_corrente);
            passivo= is_passivo(nodo_corrente);
          }

          if(degree > 0)
            pila.push(nodo_corrente); //lo mettiamo sulla pila per elaborarlo alla prossima iterazione del loop
          else
            if(!passivo) //se l'ultimo nodo esaminato era passivo, ma senza figli, lo ignoriamo ; se era non-passivo, allora il suo peso e' 1
            {
              mem_numeri_preordine[nodo_corrente]= conta_preordine;
              conta_preordine++;
            }
#else
          pila.pop(nodo_top); //rimuove dalla pila il nodo affiorante (ricopiandolo di nuovo in 'nodo_top')

          liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_top, &pila); //consideriamo "ricorsivamente", mettendoli nella pila, i figli del nodo corrente:
#endif
        }
      } while( !pila.isEmpty() );
    }//fine blocco else delle radici passive
  }//fine ciclo for dei nodi radice

}




//********
#ifndef NPE_MAGIC

//N.B. si assume che i nodi passivi siano stati calcolati da almeno 1 round
void calcola_max_preordine_raggiunto(unsigned long * vettore_numeri, unsigned long dim_tot_mem_buffers, unsigned long * memoria_per_buffers)
{
  unsigned long ris, parti_mfile_max_reached, il_prossimo_passivo;
  struct grafoInfo * blocco_buffer_info;
  unsigned long * blocco_buffer_adiac, * blocco_scrittura_dati;
  unsigned long size_blocco_buffer_info, size_blocco_buffer_adiac, nodi_letti_per_blocco;
  unsigned long info_corrente_nel_buffer;

  //calcoliamo quanta memoria assegnare ai buffers:
  size_blocco_buffer_adiac= dim_tot_mem_buffers / 2; //fifty fifty (+-)
  size_blocco_buffer_adiac -= (size_blocco_buffer_adiac % sizeof(unsigned long)); //usiamo multipli di 4 byte
  size_blocco_buffer_info= dim_tot_mem_buffers - size_blocco_buffer_adiac; //cio' che resta va all'altro buffer
  nodi_letti_per_blocco= size_blocco_buffer_info / sizeof(struct grafoInfo); //numero di info sui nodi caricabili alla volta

  //impostiamo i puntatori ai buffers:
  blocco_buffer_adiac= memoria_per_buffers;
  blocco_buffer_info= (struct grafoInfo *) (memoria_per_buffers + size_blocco_buffer_adiac/sizeof(unsigned long)); //occhio! e' una somma tra puntatori
  blocco_scrittura_dati= (long unsigned *) blocco_buffer_info; //(!) N.B.!!! il buffer scrittura sovrascrive la memoria del blocco buffer di lettura delle info: dopo ogni info letta i byte corrispondenti sono dispponibili e vengono sfruttati

  //apriamo i mfile:
  multiFileReader mf_lettura_info(grafoINFO, numINFO); //apertura dei multifile di input
  multiFileReader mf_lettura_adiac(grafoADIAC, numADIAC);
  BufferLetturaMultifile<unsigned long> buf_lettura_adiac(&mf_lettura_adiac, size_blocco_buffer_adiac, blocco_buffer_adiac);

  eraseMultiFile(nome_mfile_max_reached); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  multiFileWriter mfile_out((char*)nome_mfile_max_reached, 512*1024*1024);

  //leggiamo il primo blocco di info dal file:
  ris= mf_lettura_info.read(blocco_buffer_info, sizeof(struct grafoInfo), nodi_letti_per_blocco);
  accertati_che( (ris==nodi_letti_per_blocco) || (ris==numero_nodi), MSG_ERRORE_LETTURA_MFILE, grafoINFO);
  info_corrente_nel_buffer= 0;

  //usiamo findNext1 per accedere al vettore di bits, perche' l'accesso e' sequenziale. Inizializziamo la variabile usata:
  if(numero_passivi == 0)
    il_prossimo_passivo= MAX_ULONG; //massimo valore intero, corrisponde a "nessun nodo del grafo"
  else
  {
    bool found= nodi_passivi->findNext1(il_prossimo_passivo, 0);
    accertati_che(found, "Errore nei bits nodi passivi: ci aspettavamo almeno un bit 1");
  }

  for(unsigned long nodo_src=0; nodo_src < numero_nodi; nodo_src++)
  {
    unsigned long size_lista_adiac, preord_nodo_src, max_preord_dest;

    preord_nodo_src= vettore_numeri[nodo_src];
    max_preord_dest= preord_nodo_src; //N.B. se inizializzassi a vettore_numeri[nodo_src] sarebbe corretto ed elimineri delle operazioni superflue. Pero' se rimane zero alla fine (out degree=0...) un link al nodo corrente da parte di//I valori inferiori al # di preordine del nodo sorgente non ci interessano. Risparmiamo cosi' un po' di assegnazioni e di accessi ai bit

    //leggiamo la parte significativa dell'info del nodo corrente direttamente dal buffer per il file .info
    if(visita_avanti)
      size_lista_adiac= blocco_buffer_info[info_corrente_nel_buffer].outDeg;
    else
      size_lista_adiac= blocco_buffer_info[info_corrente_nel_buffer].inDeg;

    if(nodo_src == il_prossimo_passivo) //nodo corrente passivo?
    {
      bool ok, found;

      ok= buf_lettura_adiac.skip(size_lista_adiac);
      accertati_che( ok, MSG_ERRORE_SEEK, grafoADIAC);

      //vediamo qual'e' il prossimo nodo passivo che incontreremo:
      found= nodi_passivi->findNext1(il_prossimo_passivo);
      if(!found)
        il_prossimo_passivo= MAX_ULONG; //massimo valore intero, corrisponde a "nessun nodo del grafo"
    }
    else // non e' passivo
    {
      unsigned long degree, max_da_trascurare;

      degree= liste_adiacenza->degree_of(nodo_src);
      if(degree > 0)
//        max_da_trascurare= vettore_numeri[ liste_adiacenza->get_adiac(nodo_src, degree - 1) ];
//*****
      {
        unsigned long figlio_DX= nodo_src;
        do
        {
          figlio_DX= liste_adiacenza->get_adiac(figlio_DX, degree-1);
          degree= liste_adiacenza->degree_of(figlio_DX);
        } while(degree > 0);

        max_da_trascurare= vettore_numeri[figlio_DX];
      }      
      else //'nodo_src' e' una "foglia" della foresta DFS, non ha figli
        max_da_trascurare= preord_nodo_src; //I valori inferiori al # di preordine del nodo sorgente non ci interessano. Risparmiamo cosi' un po' di assegnazioni, piuttosto che se avessi inizializzato con 0

      max_preord_dest= max_da_trascurare;
    
      for(unsigned long i=0; i < size_lista_adiac; i++) //consideriamo tutti gli adiacenti nel grafo complessivo:
      {
        unsigned long nodo_dest, preord_dest;

        ris= buf_lettura_adiac.get(nodo_dest);
        accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoADIAC);

        preord_dest= vettore_numeri[nodo_dest]; //# di preordine del nodo destinazione dell'arco

        if(preord_dest > max_preord_dest) //e' vantaggioso controllare PRIMA se ci puo' essere un incremento e POI se il nodo non e' figlio; altrimenti e' piu' costoso (un accesso ad un bit costa piu' di un accesso ad un elemento di un array normale)
          max_preord_dest= preord_dest;
      }

      if(max_preord_dest <= max_da_trascurare)
        max_preord_dest= preord_nodo_src;
    }

    //gestiamo i buffers:
    blocco_scrittura_dati[info_corrente_nel_buffer]= max_preord_dest; //salviamo il dato calcolato nel buffer di scrittura (ricavato all'interno di quello per leggere le info dei nodi)
    info_corrente_nel_buffer++;

    
    if(info_corrente_nel_buffer == nodi_letti_per_blocco) //controlliamo se bisogna leggere nuove info (buffer finito). N.B. Se si vengono prima salvati i dati calcolati per i nodi del blocco precedentemente letto (che sono alloggiati all'interno del buffer di lettura delle info, nella sua parte iniziale)
    {
      ris= mfile_out.write(blocco_scrittura_dati, sizeof(unsigned long), nodi_letti_per_blocco); //scriviamo i dati relativi ai nodi del blocco precedentemente letto (salvati sovcrascrivendo la memoria del buffer di lettura del file .info)
      accertati_che( (ris==nodi_letti_per_blocco), "Errore nello scrivere su disco i dati `max reached' per il calcolo dei nodi passivi");
      ris= mf_lettura_info.read(blocco_buffer_info, sizeof(struct grafoInfo), nodi_letti_per_blocco); //(!) N.B. la scrittura deve precedere la lettura
      accertati_che( (ris==nodi_letti_per_blocco) || (nodo_src+1+ris==numero_nodi), MSG_ERRORE_LETTURA_MFILE, grafoINFO);
      info_corrente_nel_buffer= 0;
    }
  } //fine blocco for di tutti i nodi


  //ricopiamo in memoria cio' che resta nel buffer (eventuali dati relativi agli ultimi nodi esaminati) in fondo al vettore dei numeri
  if(info_corrente_nel_buffer > 0)
  {
//    ris= mfile_out.write(blocco_scrittura_dati, sizeof(unsigned long), info_corrente_nel_buffer);
//    accertati_che( (ris==info_corrente_nel_buffer), "Errore nello scrivere su disco i dati max reached per il calcolo dei nodi passivi");
  
    unsigned long * punt_dest, * punt_src;

    punt_src= blocco_scrittura_dati + info_corrente_nel_buffer - 1;
    punt_dest= vettore_numeri + numero_nodi - 1;

    for(unsigned long i=0 ; i<info_corrente_nel_buffer ;i++, punt_src--, punt_dest--)
      (*punt_dest)= (*punt_src);
  }

  //chiusura dei file e buffers usati
  parti_mfile_max_reached= mfile_out.close();
  mf_lettura_info.close();
  mf_lettura_adiac.close();

  //caricamento in memoria dei dati appena calcolati, vengono messi nello stesso vettore di input
//  carica_mfile_in_memoria(nome_mfile_max_reached, parti_mfile_max_reached, vettore_numeri, sizeof(unsigned long)*numero_nodi);
  
  if(info_corrente_nel_buffer < numero_nodi)
    carica_mfile_in_memoria(nome_mfile_max_reached, parti_mfile_max_reached, vettore_numeri, sizeof(unsigned long)*(numero_nodi-info_corrente_nel_buffer));

  eraseMultiFile(nome_mfile_max_reached); //eliminiamo il file temporaneo usato
}


#else


inline unsigned long trova_max_valore_figli(unsigned long * vettore_numeri, unsigned long * punt_lista, unsigned long degree)
{
  unsigned long risposta= 0;

  unsigned long * fine_lista= punt_lista + degree;
  for( ; punt_lista < fine_lista; punt_lista++)
  {
    if( vettore_numeri[ *punt_lista ] > risposta)
      risposta= vettore_numeri[ *punt_lista ];
  }

  return risposta;
}


//*****
inline unsigned long trova_max_valore_figli(unsigned long nodo_src, unsigned long * vettore_numeri, unsigned long * punt_lista, unsigned long degree)
{
  unsigned long risposta;

  assert(degree>0);

  unsigned long * fine_lista= punt_lista + degree - 1; //l'ultimo e' trattato a parte (prossima istruzione)
  risposta= vettore_numeri[ (*fine_lista) ];
  
  for( ; punt_lista < fine_lista; punt_lista++)
  {
    if( (*punt_lista) < nodo_src )
      if( vettore_numeri[ *punt_lista ] > risposta)
        risposta= vettore_numeri[ *punt_lista ];
  }

  return risposta;
}


//mia euristica per riutilizzare il vettore di input per l'output senza passare per buffers/files di appoggio
void calcola_max_preordine_raggiunto(unsigned long * vettore_numeri, unsigned long dim_tot_mem_buffers, unsigned long * memoria_per_buffers)
{
  unsigned long il_prossimo_passivo;
  unsigned long * const vettore_adiacenze= liste_adiacenza->vettore_adiacenti();

  alloca_buffers_lettura_IPS(memoria_per_buffers, dim_tot_mem_buffers);

  //usiamo findNext1 per accedere al vettore di bits, perche' l'accesso e' sequenziale. Inizializziamo la variabile usata:
  if(numero_passivi == 0)
    il_prossimo_passivo= MAX_ULONG; //massimo valore intero, corrisponde a "nessun nodo del grafo"
  else
  {
    bool found= nodi_passivi->findNext1(il_prossimo_passivo, 0);
    accertati_che(found, "Errore nei bits nodi passivi: ci aspettavamo almeno un bit 1");
  }


  for(unsigned long nodo_src=0; nodo_src < numero_nodi; nodo_src++)
  {
    struct grafoInfo info;
    unsigned long size_lista_adiac;

    bool ris= buf_info->get(info); //leggiamo l'info del nodo successivo
    accertati_che( (ris), MSG_ERRORE_LETTURA_MFILE, grafoINFO);

    if(visita_avanti)
      size_lista_adiac= info.outDeg;
    else
      size_lista_adiac= info.inDeg;

    if(nodo_src == il_prossimo_passivo) //nodo corrente passivo?
    {
      bool ok, found;
      //(!) saltiamo tutti gli adiacenti del grafo passivo: infatti SE I NODI PASSIVI SONO STATI CALCOLATI DA ALMENO UN ROUND, allora tutti gli archi uscenti dal nodo sono o all'indietro (cross/tree), o forward tree (ma non minacciano il sottoalbero), oppure sono figli del nodo passivo stesso. Non ci possono essere cioe' forward cross edges.
      ok= buf_adiac->skip(size_lista_adiac);
      accertati_che( ok, MSG_ERRORE_SEEK, grafoADIAC);

      //vediamo qual'e' il prossimo nodo passivo che incontreremo:
      found= nodi_passivi->findNext1(il_prossimo_passivo);
      if(!found)
        il_prossimo_passivo= MAX_ULONG; //massimo valore intero, corrisponde a "nessun nodo del grafo"
    }
    else // non e' passivo, bisogna esaminarne gli adiacenti nel grafo complessivo
    {
      unsigned long preord_nodo_src, max_preord_dest, degree, max_da_trascurare;
      preord_nodo_src= vettore_numeri[nodo_src]; //leggiamo il # di preordine del nodo sorgente

      degree= liste_adiacenza->degree_of(nodo_src);
      if(degree > 0)
//#ifdef NPEMAGIC_SIMPLE
//        max_da_trascurare= vettore_numeri[ liste_adiacenza->get_adiac(nodo_src, degree-1) ];
//#else
//        max_da_trascurare= trova_max_valore_figli(nodo_src, vettore_numeri, vettore_adiacenze + liste_adiacenza->get_indice_lista_adiacenza(nodo_src), degree); //euristica superTM*****
//#endif
      //*****
      {
        max_da_trascurare= trova_max_valore_figli(nodo_src, vettore_numeri, vettore_adiacenze + liste_adiacenza->get_indice_lista_adiacenza(nodo_src), degree); //euristica superTM*****

        unsigned long figlio_DX= nodo_src;

        do
        {
          figlio_DX= liste_adiacenza->get_adiac(figlio_DX, degree-1);
          degree= liste_adiacenza->degree_of(figlio_DX);
        } while(degree > 0);

        if(vettore_numeri[figlio_DX] > max_da_trascurare)
          max_da_trascurare= vettore_numeri[figlio_DX];
      }
      else //'nodo_src' e' una "foglia" della foresta DFS, non ha figli
        max_da_trascurare= preord_nodo_src; //I valori inferiori al # di preordine del nodo sorgente non ci interessano. Risparmiamo cosi' un po' di assegnazioni, piuttosto che se avessi inizializzato con 0
        
      max_preord_dest= max_da_trascurare;

      for(unsigned long i=0; i < size_lista_adiac; i++) //consideriamo tutti gli adiacenti nel grafo complessivo
      {
        unsigned long nodo_dest, preord_dest;

        bool ok= buf_adiac->get(nodo_dest);
        accertati_che( ok, MSG_ERRORE_LETTURA_MFILE, grafoADIAC);

        preord_dest= vettore_numeri[nodo_dest]; //# di preordine del nodo destinazione dell'arco

        if(preord_dest > max_preord_dest) //vediamo se il massimo corrente va aggiornato
          max_preord_dest= preord_dest;
      }

      if(max_preord_dest > max_da_trascurare)
        vettore_numeri[nodo_src]= max_preord_dest; //euristica per evitare di usare due vettori...
        
    }//fine blocco else (caso nodo non passivo)

  }//fine blocco for di tutti i nodi

  libera_buffers_lettura_IPS();
}

#endif




inline void esplora_sottoalbero_preordine(unsigned long * vettore_numeri, SwappedStack<unsigned long> * pila_albero, unsigned long * preordine_corrente, unsigned long * max_reached_sottoalb)
{
  bool ok;
  unsigned long nodo_cima, livello_iniziale_pila;

  livello_iniziale_pila= pila_albero->stackSize(); //salviamo il # di elementi di partenza (per ipotesi la pila puo' non contenere solo l'elemento da esplorare, ma questo e' solo il nodo affiorante)

  do
  {
    ok= pila_albero->pop(nodo_cima); //leggiamo il prossimo nodo (e lo togliamo dalla pila)
    assert(ok);
    
    //aggiorniamo le variabili:
    (*preordine_corrente)++;
    if(vettore_numeri[nodo_cima] > (*max_reached_sottoalb) )
      (*max_reached_sottoalb)= vettore_numeri[nodo_cima];

    //mettiamo i suoi adiacenti nello stack (IN ORDINE INVERSO!):
    liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_cima, pila_albero);
  } while(pila_albero->stackSize() >= livello_iniziale_pila); //usciamo quando e' stata conclusa l'elaborazione del sottoalbero del nodo affiorante inizialmente dalla pila
}



/*N.B. esplora il sottoalbero corrispondente al nodo affiorante dalla pila. All'uscita dalla procedura l'elemento affiorante e' stato rimosso
       aggiorna 'max_reached_sottoalb', se necessario
       incrementa 'conta_nodi_esplorati', che deve essere gia' stato inizializzato
*/
inline void elabora_sottoalbero_non_passivi(unsigned long * vettore_numeri, SwappedStack<unsigned long> * pila_albero, unsigned long * preordine_corrente, unsigned long * max_reached_tot)
{
  bool ok;
  unsigned long nodo_cima, livello_iniziale_pila;

  livello_iniziale_pila= pila_albero->stackSize(); //salviamo il # di elementi di partenza (per ipotesi la pila puo' non contenere solo l'elemento da esplorare, ma questo e' solo il nodo affiorante)

  do
  {
    ok= pila_albero->readTop(nodo_cima); //leggiamo il prossimo nodo
    assert(ok);
    
    if( (*max_reached_tot) >= (*preordine_corrente) ) //il nodo corrente non e' OK
    {
      esplora_sottoalbero_preordine(vettore_numeri, pila_albero, preordine_corrente, max_reached_tot); //aggiorniamo il valore di 'preordine_corrente' e 'max_reached_tot' con i nodi del sottoalbero, senza fare altro perche' questi nodi non possono essere resi passivi
    } //a questo punto il nodo non-OK e' stato rimosso dalla pila
    else //nodo OK
    {
      pila_albero->pop(nodo_cima); //togliamo il nodo corrente dalla pila (rileggendolo di nuovo nella variabile 'nodo_cima')

      //il nodo corrente e' OK e figlio di un nodo passivo: lo rendiamo passivo
      bool val_prec= set_passivo(nodo_cima);
      assert(!val_prec);
      numero_passivi++; //per ipotesi il nodo non era gia' passivo, perche' e' discendente di un nodo non-passivo
      
      //aggiorniamo le variabili:
      (*preordine_corrente)++;
      if(vettore_numeri[nodo_cima] > (*max_reached_tot) )
        (*max_reached_tot)= vettore_numeri[nodo_cima];

      //mettiamo i suoi adiacenti nello stack (IN ORDINE INVERSO!):
      liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_cima, pila_albero);
    }
  } while(pila_albero->stackSize() >= livello_iniziale_pila); //usciamo quando e' stata conclusa l'elaborazione del sottoalbero del nodo affiorante inizialmente dalla pila
}



//PRECondizioni: serve che il vettore di bits con i nodi passivi sia gia' stato ripristinato
void calcola_nodi_ok_e_nuovi_passivi(unsigned long * vettore_numeri, unsigned long size_memoria_pila, unsigned long * memoria_pila)
{
  SwappedStack<unsigned long> pila(size_memoria_pila, memoria_pila);

  unsigned long max_reached_tot, preordine_corrente;
  unsigned long * const vettore_adiacenti= liste_adiacenza->vettore_adiacenti();

  preordine_corrente= 1; //parte da 1 in modo da usare lo 0 come un valore "nil" che viene sicuramente trascurato
  max_reached_tot= 0; //valore "nil"

  unsigned long numero_alberi= liste_adiacenza->degree_of(NODO_SUPER_ROOT); //ogni arco che parte dal nodo "super root" individua un albero DFS
  unsigned long * punt_nodo_radice= vettore_adiacenti + liste_adiacenza->get_indice_lista_adiacenza(NODO_SUPER_ROOT);

  for(unsigned long i=0; i<numero_alberi ; i++, punt_nodo_radice++) //i figli del nodo super root vengono trattati come caso particolare per evitare di inserirli nella pila tutti assieme
  {
    pila.push(*punt_nodo_radice);

    if( !is_passivo(*punt_nodo_radice) ) //nodo non-passivo: finche' ho nodi OK allora ricorsivamente li marchiamo passivi ; appena trovo nodi non-OK, allora ci limitiamo ad aggiornare il conteggio del # di preordine, come anche 'max_reached_tot'
    {
      elabora_sottoalbero_non_passivi(vettore_numeri, &pila, &preordine_corrente, &max_reached_tot); //(!) aggiorna (se serve) 'max_reached_tot'. Incrementa 'preordine_corrente' con il numero di nodi nel sottoalbero. Inoltre vengono resi passivi tutti i nodi OK percorsi.
    }
    else //il nodo corrente e' passivo: esploriamo senza fare niente tutti i nodi passivi fino ad incontrare il prossimo non-passivo
    {
      unsigned long nodo_top;

      do //in questo loop percorriamo senza fare niente (NOP) tutti i nodi passivi, mentre elaboriamo i primi nodi non-passivi che troviamo
      {
        pila.readTop(nodo_top); //leggiamo adesso in 'nodo_top' il nodo affiorante (figlio di un passivo), senza toglierlo dalla pila

        if(!is_passivo(nodo_top))
        {
          elabora_sottoalbero_non_passivi(vettore_numeri, &pila, &preordine_corrente, &max_reached_tot); //(!) aggiorna (se serve) 'max_reached_tot'. Incrementa 'preordine_corrente' con il numero di nodi nel sottoalbero
        } //a questo punto il nodo non-passivo e' stato rimosso dalla pila
        else
        { //per i nodi passivi non dobbiamo fare niente: il # di preordine non va incrementato perche' per i nodi passivi lo abbiamo gia' trascurato nel calcolo iniziale del numero di preordine dei nodi. Per lo stesso motivo 'max_reached_tot' non verrebbe mai modificato e percio' non lo consideriamo. Invece ci interessano i primi nodi non-passivi che incontrimo esplorando i cammini di nodi passivi: infatti se questi sono OK, possono essere resi a loro volta passivi
#ifdef OPT_PRIMO_CAMMINO
          unsigned long nodo_corrente= nodo_top;
          unsigned long degree= liste_adiacenza->degree_of(nodo_corrente);
          bool passivo= true; //vero per ipotesi

          pila.pop(nodo_top); //(!) rimuove dalla pila il nodo affiorante (ricopiandolo di nuovo in 'nodo_top')

          while(passivo && (degree > 0))
          {
            liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_corrente, &pila, degree - 1);

            nodo_corrente= liste_adiacenza->get_adiac(nodo_corrente, 0);
            degree= liste_adiacenza->degree_of(nodo_corrente);
            passivo= is_passivo(nodo_corrente);
          }

          if(!passivo)
            pila.push(nodo_corrente); //lo mettiamo sulla pila per elaborarlo alla prossima iterazione del loop
          //else.. se l'ultimo nodo esaminato era passivo e senza figli, lo ignoriamo

#else
          pila.pop(nodo_top); //rimuove dalla pila il nodo affiorante (ricopiandolo di nuovo in 'nodo_top')

          liste_adiacenza->riversa_lista_in_pila_DX_SX(nodo_top, &pila); //consideriamo "ricorsivamente", mettendoli nella pila, i figli del nodo corrente:
#endif
        }
      } while( !pila.isEmpty() );
        

    } //fine blocco else (nodi radice passivi)
  } //fine ciclo for dei nodi radice

}



//aggiorna il vettore di bits in memoria con i nuovi passivi individuati.
//N.B. NON salva su disco il vettore di bits, questo compito spetta alla funzione che chiamera' calcola_nodi_passivi_NPE()
//ritorna true se ha scoperto nuovi nodi passivi
//POSTcondizioni: restituisce il vettore dei bits "pulito" e aggiornato
unsigned long calcola_nodi_passivi_NPE()
{
  unsigned long old_number_passivi;
  unsigned long * vettore_lavoro; //vettore con N (numero_nodi) elementi
  unsigned long * vettore_memoria_extra; //vettore con almeno 'elementi_riservati_buffer' elementi
  unsigned long dim_memoria_extra;

  printf("\n     Calcolo passivi NPE %lu)\n\n", conta_calcoli_NPE); fflush(stdout);//*****

  accertati_che(!is_dirty_vettore_bits, "Errore: bisogna che calcola_nodi_passivi_NPE() riceva il vettore di bits non ``sporcato''");
  
  //calcoliamo la memoria libera:
  unsigned long capienza_mem_libera= liste_adiacenza->capienzaMemoriaInutilizzata();
  accertati_che( (capienza_mem_libera >= archi_caricabili_alla_volta+elementi_riservati_buffer), MSG_ERR_MEM_LIBERA_RISERVATA);

  vettore_lavoro= liste_adiacenza->get_punt_mem_libera(); //riceviamo un puntatore alla memoria libera all'interno delle liste di adiacenza. Sono piu' di N elementi perche' in questo momento rappresentiamo un albero di N+1 nodi--> N adiacenti. Il puntatore resta valido finche' non si modificano le liste di adiacenza
  vettore_memoria_extra= vettore_lavoro + numero_nodi; //(!) occhio, aritmetica dei puntatori.. il vettore extra si prende la memoria libera che segue quella del vettore con N elementi
  dim_memoria_extra= (capienza_mem_libera - numero_nodi) * sizeof(unsigned long);

tag001= clock();  
  calcola_numero_preordine(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra);
tag002= clock();  tot_numero_preordine_NPE += tag002 - tag001;

  printf("\n\n***calcolo nodi passivi-calcola_numero_preordine fatto\n\n"); fflush(stdout);//*****

tag001= clock();  
  calcola_max_preordine_raggiunto(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra);
tag002= clock();  tot_max_preord_calcolo_passivi_NPE += tag002 - tag001;

//printf("\n   Numeri di preordine:\n");//******
//for(unsigned long nodo_src=0; nodo_src < numero_nodi; nodo_src++)
//{
//  //*******
//  printf("     ----->   # preordine nodo %lu= %lu   <----- \n", nodo_src, vettore_lavoro[nodo_src]);
//}//*****

  printf("\n\n***calcolo nodi passivi-calcola_max_preordine_raggiunto fatto\n\n"); fflush(stdout);//*****

  old_number_passivi= numero_passivi; //salviamo il vecchio valore prima che venga modificato

  calcola_nodi_ok_e_nuovi_passivi(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra);

  printf("\n\n>> Numero di nodi passivi:%ld (%.1f%% del totale: +%.1f%%)\n\n", numero_passivi, 100.0f*numero_passivi/numero_nodi, 100.0f*(numero_passivi - old_number_passivi)/numero_nodi);

  #ifdef VERBOSE_DEBUG
  print_passivi();
  #endif

  conta_calcoli_NPE++; //aggiorniamo il conteggio (usato solo a scopi statistici)
  conta_passivi_scoperti_NPE += (numero_passivi - old_number_passivi);
  return (numero_passivi - old_number_passivi);
}





//------------------CALCOLO-NODI-PASSIVI--No Passing Edges-----------------------------------------


#ifdef CHECK_PASSIVI
//****** solo per debug
unsigned long controlla_nodi_rimasti_forward(SwappedStack<unsigned long> * stack_original, unsigned long * conta_prossimi_passivi) //*****
{
  bool ok, esci= false, ultimo_passivo= true;
  unsigned long conta_nodi= 0;
  unsigned long * const vettore_adiacenze= liste_adiacenza->vettore_adiacenti();
  unsigned long * const vettore_punt= liste_adiacenza->vettore_riferimenti();
  
  *conta_prossimi_passivi= 0;
  
  SwappedStack<unsigned long> pila1(100000);
  SwappedStack<unsigned long> pila2(100000);

  while(!stack_original->isEmpty())
  {
    unsigned long  elem;
    stack_original->pop(elem);
    pila2.push(elem);
  }

  while(!pila2.isEmpty())
  {
    unsigned long  elem;
    pila2.pop(elem);
    stack_original->push(elem);
    pila1.push(elem);
  }


  while(!esci) 
  {
    unsigned long indice_next, nodo_top;

    ok= pila1.pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      unsigned long nodo_figlio;

      ok= pila1.readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      nodo_figlio= vettore_adiacenze[ vettore_punt[nodo_top + 1] - indice_next ]; //il figlio corrente del nodo_top

      //gestiamo la scoperta del nodo (nuovo nodo incontrato nella visita in preordine):
      conta_nodi++;
      
      if(ultimo_passivo)
        (*conta_prossimi_passivi)++;
      else
        ultimo_passivo= false;
        
      //aggiorniamo lo stack:
      indice_next--; //(!) ci dobbiamo ricordare di passare al figlio successivo di 'nodo_top'. N.B. decrementiamo perche' l'indice memorizza il # di figli che restano da visitare
      pila1.push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

      pila1.push(nodo_figlio); //mettiamo il nodo trovato sullo stack
      pila1.push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
    }
    else //indice_next==0, ovvero il nodo affiorante sullo stack e' appena finito
    {
      ok= pila1.pop(nodo_top); //leggiamo il nodo in cima, appena finito, e lo togliamo dalla pila
      accertati_che(ok, MSG_ERRORE_PILA);

      if(nodo_top == NODO_SUPER_ROOT)
        esci= true;
    }
  }//fine blocco while

  return conta_nodi;
}
#endif



//N.B. il valore stimato restituito puo' essere anche zero. Cio' e' necessario ad es. se size_ultima_volta + size_tot_precedenti = numero_nodi  . In questo caso un valore > 0 darebbe un errore perche' non vi sono piu' nodi da visitare
//     Imposta la variabile 'match_volta_precedente_Inizio_foresta'
unsigned long stima_prossima_porzione_Inizio_Foresta(unsigned long match_correnti, unsigned long incremento_parte_iniziale_stabile, unsigned long numero_iterazioni)
{
  unsigned long valore_stimato, match_adj, nodi_rimasti_in_gioco;

  const unsigned long STIMA_DI_PARTENZA= (unsigned long) (numero_nodi*0.10f); //quanti nodi calcolare (e salvare su disco) nel primo tentativo
  const float RATE_DI_PARTENZA= 4.0f;
  const float PESO_LAST_TIME= 0.85f; //quanto conta l'ultimo valore registrato rispetto a quelli precedenti (base della potenza con cui decrescono i pesi delle volte piu' lontane nel tempo)

  nodi_rimasti_in_gioco= subtrunc(numero_nodi, tot_nodi_scoperti_Inizio_foresta + incremento_parte_iniziale_stabile + tot_nodi_scoperti_Fine_foresta); //necessario troncare a zero la sottrazione se viene negativa: infatti tot_nodi_scoperti_Inizio_foresta e tot_nodi_scoperti_Fine_foresta possono includere nodi comuni, in maniera tale che la somma supera 'numero_nodi'

  const unsigned long STIMA_MIN= (unsigned long) (nodi_rimasti_in_gioco*0.04f);

  //N.B. le seguenti due correzioni vengono fatte con valori indeterminati nelle iterazioni 0 e 1, ma tanto in questo caso i valori ottenuti non vengono utilizzati in alcun modo:
  if(match_correnti == nodi_salvati_Inizio_foresta) //l'ultima volta la stima era stata troppo bassa
    match_adj= 2 * match_correnti; //in questo caso stimiamo che la porzione da salvare fosse il doppio di quanto abbiamo salvato noi
  else
    match_adj= match_correnti; //questo fattore moltiplicativo non produce effetti

  if(match_volta_precedente_Inizio_foresta == 0)
    match_volta_precedente_Inizio_foresta= 1; //(unsigned long)(0.125f*match_adj); //evitiamo cosi' di fare una divisione per zero e inoltre il coefficiente per cui dividiamo e' in pratica il coefficiente con cui moltiplichiamo per dedurre i match futuri sulla base di quelli correnti. N.B. la variabile viene poi settata ad un valore significativo subito prima di uscire

  switch(numero_iterazioni)
  {
    case 0: //nessuna informazione
      valore_stimato= STIMA_DI_PARTENZA;
      break;

    case 1: //solo l'informazione sul calcolo appena effettuato
      valore_stimato= (unsigned long) (match_adj * RATE_DI_PARTENZA);
      break;

    case 2: //informazioni sul calcolo appena effettuato e sul precedente
      if(match_adj != 0) //cio' implica che anche il denominatore e' !=0 e il rapporto e' determinato
        somma_pesata_rate_Inizio_foresta= ((float) match_adj) / match_volta_precedente_Inizio_foresta;
      else
        somma_pesata_rate_Inizio_foresta= 1.0f;
      valore_stimato= (unsigned long) (1.20f * match_adj * somma_pesata_rate_Inizio_foresta);
      break;

    default: //informazioni sul calcolo appena effettuato ed altri precedenti
      if(match_adj != 0) //cio' implica che anche il denominatore e' !=0 e il rapporto e' determinato    
        somma_pesata_rate_Inizio_foresta= PESO_LAST_TIME * ( ((float) match_adj) / match_volta_precedente_Inizio_foresta)  +  (1 - PESO_LAST_TIME) * somma_pesata_rate_Inizio_foresta; //facciamo la somma pesata tra il tasso di crescita attuale e quello medio
      //else.. lasciamo invariata la variabile 'somma_pesata_rate_Inizio_foresta'
      valore_stimato= (unsigned long) (1.20f * match_adj * somma_pesata_rate_Inizio_foresta);
      break;
  }


  if(valore_stimato < STIMA_MIN) //soglia inferiore (vincolo "elastico": poco utile fare il calcolo per solo pochi nodi)
    valore_stimato= STIMA_MIN;

  //controllo soglia superiore (vincolo rigido):
  if(valore_stimato > nodi_rimasti_in_gioco)
    valore_stimato= nodi_rimasti_in_gioco;

  if(valore_stimato > numero_nodi/2)
    valore_stimato= numero_nodi/2;

  match_volta_precedente_Inizio_foresta= match_correnti; //aggiorniamo la variabile per la prossima iterazione di calcolo

  return valore_stimato;
}




//sfruttiamo il fatto che con la rimozione dei nodi passivi swappati (tutti quelli che terminavano in una visita in preordine della parte iniziale stabile) non facciamo mai backtracking nella parte iniziale stabile
//PRECondizioni: lo stack e' vuoto
//Notare che per ogni nodo scoperto, tranne l'ultimo, l'indice relativo ai figli deve indicare che mancano ancora degree(u)-1 nodi; per l'ultimo nodo invece mancano ancora tutti i suoi figli da scoprire, e avra' come indice: degree(u)
void inizializza_stack(SwappedStack<unsigned long> * pila, unsigned long nodi_da_scoprire)
{
  //ogni volta che eseguiamo il calcolo della parte iniziale stabile, lo stack va inizializzato ripartendo "da zero": nelle iterazioni successive alla prima, pero', bisogna saltare alcuni nodi per riportarsi alla giusta situazione di partenza (i.e. i nodi della parte iniziale stabile non ancora swappati)
  pila->push(NODO_SUPER_ROOT);
  
  unsigned long ultimo_scoperto= NODO_SUPER_ROOT;
  
  for(unsigned long i= 0; i < nodi_da_scoprire; i++)
  {
    pila->push( liste_adiacenza->degree_of(ultimo_scoperto) - 1); //seconda info sulla pila del nodo precedente: completa la coppia di info per il nodo che precede nella pila (il padre di quello corrente)

    unsigned long primogenito= liste_adiacenza->get_adiac(ultimo_scoperto, 0);
    pila->push(primogenito); //prima info sulla pila del nodo corrente        
    ultimo_scoperto= primogenito; //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
  }

  pila->push( liste_adiacenza->degree_of(ultimo_scoperto)); //seconda info sulla pila dell'ultimo nodo scoperto
}



/*
  Confronta il prossimo pezzo di parte iniziale di foresta con quello salvato nell'iterazione precedente. Ogni nodo il cui confronto combacia viene dichiarato passivo.
  Durante la visita i nodi che vengono terminati sono dei nuovi candidati ad essere swappati (perche' appartengono alla parte iniziale stabile e sono stati completati), percio' i loro padri vengono salvati nel vettore di output.
  La visita termina o al primo confronto che fallisce, o quando si e' fatto il # di confronti massimo, o quando si sono terminati N/2 nodi (e in pratica il vettore di output viene considerato pieno)
  ritorna nella var. puntata da 'numero_padri_salvati' il # di nodi terminati durante il confronto, i padri dei quali sono stati scritti nel vettore 'vettore_output_padri'

  PRECondizioni: 1) lo stack e' gia' riempito
                 2) max_confronti_da_effettuare <= numero_nodi/2
                 3) vettore_output_padri ha almeno numero_nodi/2 elementi
                 4) <!> le informazioni dell'iterazione precedente sono salvate nel file come coppie: <padre,figlio><padre,figlio>...<padre,figlio>
*/
unsigned long confronta_parte_Iniziale_foresta(unsigned long * vettore_output_padri, unsigned long dim_tot_mem_buffer, unsigned long * memoria_per_buffer, SwappedStack<unsigned long> * pila, unsigned long max_confronti_da_effettuare, unsigned long * numero_padri_salvati)
{
  bool ok;
  unsigned long confronti_coincidenti_effettuati, indice_scrittura;

  if(max_confronti_da_effettuare == 0)
  {
    (*numero_padri_salvati)= 0;
    return 0;
  }
    
  assert(max_confronti_da_effettuare <= numero_nodi/2);

  unsigned long * const vettore_adiacenze= liste_adiacenza->vettore_adiacenti();
  unsigned long * const vettore_punt= liste_adiacenza->vettore_riferimenti();

  //apriamo il mfile:
  multiFileReader mf_input((char *)nome_mfile_Inizio_foresta_prec, parti_mfile_Inizio_foresta_prec);
  BufferLetturaMultifile<unsigned long> buf_input(&mf_input, dim_tot_mem_buffer, memoria_per_buffer);

  confronti_coincidenti_effettuati= 0;
  indice_scrittura= 0; //indica quanti elementi (padri) abbiamo gia' scritto nel buffer di output

  while(1) //in realta' limitiamo sia il # max di confronti che effettuiamo, sia il # di nodi terminati nella visita, di cui salviamo i padri nel vettore di output. Inoltre usciamo alla prima differenza riscontrata nei nodi scoperti.
  {
    unsigned long indice_next, nodo_top;

    ok= pila->pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      unsigned long nodo_figlio, old_padre, old_figlio;

      //accediamo al prossimo figlio:
      ok= pila->readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      nodo_figlio= vettore_adiacenze[ vettore_punt[nodo_top + 1] - indice_next ]; //il figlio corrente del nodo_top

      //leggiamo la prossima coppia (padre, figlio) di riferimento dal file:
      ok= buf_input.get(old_padre);
      accertati_che( (ok), MSG_ERRORE_LETTURA_MFILE, nome_mfile_Inizio_foresta_prec);
      ok= buf_input.get(old_figlio);
      accertati_che( (ok), MSG_ERRORE_LETTURA_MFILE, nome_mfile_Inizio_foresta_prec);

      
      //gestiamo la scoperta del nodo (nuovo nodo incontrato nella visita in preordine):
      if( (old_padre == nodo_top) && (old_figlio == nodo_figlio) ) //per ogni nodo 'u' incontrato abbiamo salvato la coppia: (padre(u), u)
      {
        bool val_prec= set_passivo(nodo_figlio); //il nodo appena scoperto era nella stessa posizione nell'iterazione precedente, percio' appartiene alla parte iniziale stabile e puo' essere dichiarato passivo
        if(!val_prec) //se non era passivo prima lo diventa adesso e incrementiamo il conteggio
          numero_passivi++;
        
        confronti_coincidenti_effettuati++;

        //aggiorniamo lo stack:
        indice_next--; //(!) ci dobbiamo ricordare di passare al figlio successivo di 'nodo_top'. N.B. decrementiamo perche' l'indice memorizza il # di figli che restano da visitare
        pila->push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

        pila->push(nodo_figlio); //mettiamo il nodo trovato sullo stack
        pila->push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare

        if(confronti_coincidenti_effettuati >= max_confronti_da_effettuare)
          break; //---> Uscita dal loop
      }
      else //il confronto da' esito negativo
      {
        pila->push(indice_next); //lo rimettiamo sullo stack in modo che poi ricominciamo dal primo nodo che non coincideva
        break; //---> Uscita dal loop
      }

    }
    else //(indice_next == 0) --> il nodo e' terminato, e poiche' appartiene per ipotesi alla parte iniziale stabile della foresta, potra' essere swappato.
    {
      pila->pop(nodo_top); //leggiamo e togliamo l'elemento affiorante dallo stack

      unsigned long padre_di_nodotop;
      ok= pila->readTop(padre_di_nodotop, 1); //leggiamo il secondo elemento dalla cima dello stack, cioe' l'info. sul nodo padre di 'nodo_top'
      accertati_che(ok, "Errore nell'usare readTop( X, N)");
      
      vettore_output_padri[indice_scrittura]= padre_di_nodotop; //salviamo nel vettore il nodo _padre_
//printf("padre nodo da swappare: %lu\n", padre_di_nodotop); //*****
      indice_scrittura++;

      if(indice_scrittura >= numero_nodi/2) //non possiamo salvare piu' di N/2 nodi da swappare, per vincoli con operazioni successive
        break; //---> Uscita dal loop
    }
  }

  mf_input.close();
  
  *numero_padri_salvati= indice_scrittura; //restituisce il numero di nodi che possono essere swappati, di cui abbiamo salvato i padri nel vettore di output
  return confronti_coincidenti_effettuati;
}



//'punt_src' punta al primo elemento della lista di adiacenza corrente
void trascrivi_Inizio_lista_corrente(unsigned long * punt_src, unsigned long num_figli_da_swappare, unsigned long * * vettore_output_swap)
{
  for(unsigned long i= 0; i<num_figli_da_swappare; i++)
  {
    *(*vettore_output_swap)= *punt_src; //N.B. vettore_output_swap e' un puntatore ad un puntatore
#ifdef VERBOSE_DEBUG
    printf("swap(%lu) ", *punt_src); fflush(stdout); //*****
#endif
    punt_src++; //passo all'adiacente successivo
    (*vettore_output_swap)++; //incr. il puntatore nel vettore (modificando la variabile della funzione chiamante)
  }
}



void shifta_indietro_nodi_lista(unsigned long * punt_inizio_lista, unsigned long anticipo, unsigned long size_lista)
{
  for(unsigned long i=0; i < size_lista - anticipo; i++)
  {
    *punt_inizio_lista= *(punt_inizio_lista + anticipo);
    punt_inizio_lista++;
  }
}



//metodo usato: poiche' non e' possibile usare liste_adiacenza->sposta_indietro_liste() a partire dalla lista del nodo 0, usiamo un metodo simile a quello di swappa_nodi_da_Fine_liste_adiacenza(): in pratica shiftiamo in avanti i nodi della generica lista di adiacenza da ridimensionare, spostando cosi' il "buco" dall'inizio della lista alla fine. A questo punto ci siamo riportati nel caso di swappa_nodi_da_Fine_liste_adiacenza()
void swappa_nodi_da_Inizio_liste_adiacenza(unsigned long * vettore_input_padri, unsigned long tot_nodi_da_swappare, unsigned long * vettore_output_swap)
{
  bool continua;
  unsigned long * punt_src;
  unsigned long num_figli_da_swappare, last_nodo_src, nodo_src, dim_corrente_buco;

  if(tot_nodi_da_swappare==0)
    return;

  unsigned long * const vettore_adiacenze= liste_adiacenza->vettore_adiacenti();
  unsigned long * const vettore_punt= liste_adiacenza->vettore_riferimenti();  
  unsigned long conta_elem_input_letti= 0; //tiene il conto di quanti nodi di 'vettore_input_padri' abbiamo gia' letto
  unsigned long * punt_scrittura= vettore_output_swap; //punta sempre alla prossima locazione da scrivere

  //consideriamo la prima lista con nodi da swappare. Questa e le precedenti non vanno spostate:
  continua= next_padre_da_processare(&nodo_src, &num_figli_da_swappare, &conta_elem_input_letti, tot_nodi_da_swappare, vettore_input_padri);
  accertati_che(continua, "Errore in elabora_liste_adiacenza(): ci deve essere almeno una lista con nodi da swappare");

  punt_src= vettore_adiacenze + vettore_punt[nodo_src]; //puntiamo al nodo all'inizio della lista di 'nodo_src'
  trascrivi_Inizio_lista_corrente(punt_src, num_figli_da_swappare, &punt_scrittura);

  shifta_indietro_nodi_lista(punt_src, num_figli_da_swappare, liste_adiacenza->degree_of(nodo_src));

  last_nodo_src= nodo_src;
  dim_corrente_buco= num_figli_da_swappare; //conta gli elementi in fondo alla lista corrente che vanno rimossi

  do
  {
    continua= next_padre_da_processare(&nodo_src, &num_figli_da_swappare, &conta_elem_input_letti, tot_nodi_da_swappare, vettore_input_padri);

    if(continua)
    {
      unsigned long size_lista_nodo_src= liste_adiacenza->degree_of(nodo_src); //salviamo questa info. qui perche' quando la useremo sara' stata "sporcata" dallo spostamento delle liste
      punt_src= vettore_adiacenze + vettore_punt[nodo_src]; //puntiamo al nodo all'inizio della lista di 'nodo_src'
      trascrivi_Inizio_lista_corrente(punt_src, num_figli_da_swappare, &punt_scrittura);

      liste_adiacenza->sposta_indietro_liste(dim_corrente_buco, last_nodo_src + 1, nodo_src); //compattiamo le liste all'indietro eliminando il vecchio buco

      shifta_indietro_nodi_lista(punt_src - dim_corrente_buco, num_figli_da_swappare, size_lista_nodo_src); //(!) N.B. bisogna tenere in conto degli effetti dello spostamento, sia sul puntatore all'inizio della lista, che del degree. Passiamo in pratica il buco presente all'inizio della lista corrente per via dei figli da swappare in fondo alla lista stessa
      
      last_nodo_src= nodo_src; //il nodo corrente diventa quello precedente
      dim_corrente_buco += num_figli_da_swappare; //il "buco" e' formato dagli elementi in fondo alla lista corrente (di 'nodo_src') e dagli spazi formati dagli elementi eliminati in precedenza dalle altre liste, che ora si trovano tra la lista corrente e la successiva            
    }
  } while(continua);

  //ricompattiamo il resto delle liste di adiacenza (eliminando il "buco" dovuto all'ultima lista processata):
  if(last_nodo_src == NODO_SUPER_ROOT) //se cioe' l'ultima lista processata era quella dell'ultimo nodo delle liste di adiacenza (il "super root")
    liste_adiacenza->accorcia_lista_del_nodo(NODO_SUPER_ROOT, dim_corrente_buco); //in questo caso non ci sono altre liste che seguono, va solo ridimensionata l'ultima (quella del "super root", appunto)
  else
    liste_adiacenza->sposta_indietro_liste(dim_corrente_buco, last_nodo_src + 1); //compattiamo all'indietro le liste rimanenti eliminando il buco


  //adesso che abbiamo tolto dalla memoria (ricopiandoli in 'vettore_output_swap') i nodi passivi da swappare, dobbiamo tenerne traccia scrivendoli su disco:
  unsigned long ris= mf_nodi_swap_passivi_InizioForesta->write(vettore_output_swap, sizeof(unsigned long), tot_nodi_da_swappare); //ogni nodo tolto dalla memoria viene salvato su disco (notare che sono stati copiati nel vettore in modo tale che in una stessa lista di adiacenza i nodi piu' all'inizio precedono gli altri).
  accertati_che( (ris==tot_nodi_da_swappare), MSG_ERRORE_SCRITTURA_MFILE, nome_mfile_nodi_swap_passivi_InizioForesta);
  //N.B. il mfile deve restare aperto
}



//ritorna il numero di nodi percorsi sul cammino piu' a SX, che sono diventati passivi qualora non lo fossero stati gia' prima
//setta inoltre 'ultimo_nodo_leftmost_path'
unsigned long esplora_cammino_leftmost(SwappedStack<unsigned long> * pila)
{
  bool ok;
  unsigned long risposta, nodo_top, indice_nodo_top, degree, nodo_figlio;

  risposta= 0;
  
  ok= pila->pop(indice_nodo_top); //lo leggiamo nuovamente, questa volta togliendolo dallo stack
  accertati_che(ok, MSG_ERRORE_PILA);

  ok= pila->readTop(nodo_top);
  accertati_che(ok, MSG_ERRORE_PILA);
  
  if(indice_nodo_top == 0) //usciamo senza fare niente: infatti dobbiamo continuare in questa procedura fino a quando non e' necessario fare backtracking
  {
    pila->push(indice_nodo_top); //rimettiamo l'informazione al suo posto nello stack
    ultimo_nodo_leftmost_path= nodo_top; //memorizziamo l'ultimo nodo sul cammino piu' a SX
    return 0;
  }
  
  degree= liste_adiacenza->degree_of(nodo_top);
  nodo_figlio= liste_adiacenza->get_adiac(nodo_top, degree - indice_nodo_top); //l'indice rappresenta il numero di figli piu' a destra che rimangono. Sappiamo che ce ne e' almeno uno perche' era (indice_nodo_top > 0)
  degree= indice_nodo_top; //(!) trucco: poiche' nel loop viene impostata l'info. sull'indice del nodo padre al valore (degree-1). Infatti questo va bene per tutti i nodi padri di cui abbiamo trattato solo il primo figlio; per il primo nodo padre, che abbiamo letto dalla pila, possiamo invece aver trattato anche altri figli
  
  //esploro il cammino piu' a SX: continuo finche' il nodo attuale in cima alla pila ha dei figli, e finche' non ho salvato il numero di nodi voluto
  do
  {
    risposta++; //ci ricordiamo di quanti nodi abbiamo esaminato sul cammino piu' a SX
    
    pila->push(degree - 1); //mettiamo sullo stack l'informazione sull'indice del nodo padre del nodo corrente: va decrementato per tener traccia della scoperta del nodo corrente

    //rendiamo passivo l'ultimo nodo scoperto:
    bool val_prec= set_passivo(nodo_figlio);
    if(!val_prec) //se non era passivo prima lo diventa adesso e incrementiamo il conteggio
      numero_passivi++;

    pila->push(nodo_figlio); //mettiamo la prima info. relativa al nodo corrente: la seconda la mettiamo nel ciclo seguente, quando il nodo corrente sara' il nodo padre corrente, oppure dopo la fine del loop per chiudere la pila
    degree= liste_adiacenza->degree_of( nodo_figlio );

    if(degree == 0) //questo controllo evita anche un accesso ad un figlio di un nodo con degree==0
      break;

    nodo_figlio= liste_adiacenza->get_adiac(nodo_figlio, 0); //ha senso eseguire questa operazione solo se degree > 0

  } while( 1 );

  pila->push(degree); //mettiamo sullo stack l'informazione sull'indice dell'ultimo nodo scoperto. N.B. per tutti i nodi scoperti, tranne l'ultimo, va messo come indice (degree - 1)

  ultimo_nodo_leftmost_path= nodo_figlio; //memorizziamo l'ultimo nodo sul cammino piu' a SX
  return risposta;
}



//PRECondizioni: 'quanti_nodi_salvare' deve essere <= del numero di nodi della foresta che rimangono
void calcola_porzione_successiva_Inizio_foresta(unsigned long * vettore_lavoro, SwappedStack<unsigned long> * pila, unsigned long quanti_nodi_salvare)
{
  bool ok;
  unsigned long pos_corrente, nodi_rimasti_da_salvare;

  unsigned long * const vettore_adiacenze= liste_adiacenza->vettore_adiacenti();
  unsigned long * const vettore_punt= liste_adiacenza->vettore_riferimenti();
  
  pos_corrente= 0;
  nodi_rimasti_da_salvare= quanti_nodi_salvare;
  
  while(nodi_rimasti_da_salvare > 0)
  {
    unsigned long indice_next, nodo_top;

    ok= pila->pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      unsigned long nodo_figlio;

      //accediamo al prossimo figlio:
      ok= pila->readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      nodo_figlio= vettore_adiacenze[ vettore_punt[nodo_top + 1] - indice_next ]; //il figlio corrente del nodo_top

      //gestiamo la scoperta del nodo (nuovo nodo incontrato nella visita in preordine):
      vettore_lavoro[pos_corrente]= nodo_top;
      pos_corrente++;

      vettore_lavoro[pos_corrente]= nodo_figlio;
      pos_corrente++;

      nodi_rimasti_da_salvare--;
      
      //aggiorniamo lo stack:
      indice_next--; //(!) ci dobbiamo ricordare di passare al figlio successivo di 'nodo_top'. N.B. decrementiamo perche' l'indice memorizza il # di figli che restano da visitare
      pila->push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

      pila->push(nodo_figlio); //mettiamo il nodo trovato sullo stack
      pila->push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
    }
    else //sono stati considerati tutti gli adiacenti
    {
      pila->pop(nodo_top); //togliamo l'elemento affiorante dallo stack (che viene copiato [di nuovo] in nodo_top solo come "escamotage"). N.B. il contatore dei figli gia' esaminati di nodo_top era gia' stato estratto prima dallo stack
    }
  }

  //salvataggio dei dati si disco:
  parti_mfile_Inizio_foresta_prec= salva_su_mfile(nome_mfile_Inizio_foresta_prec, vettore_lavoro, 2 * sizeof(unsigned long)*quanti_nodi_salvare); //per ogni nodo salvato nella visita in prordine ne salviamo anche l'info. sul padre

  nodi_salvati_Inizio_foresta= quanti_nodi_salvare; //ci ricordiamo di quanti nodi abbiamo calcolato per la prossima iterazione
}




//PRECondizioni: il vettore di bits dei nodi passivi deve essere "pulito", i.e. deve rappresentare effettivamente i nodi passivi
//POSTcondizioni: restituisce il vettore dei bits "pulito" e aggiornato
unsigned long calcola_nodi_passivi_Inizio_foresta()
{
  const unsigned long SOGLIA_POCHI_NODI= 200;
  const unsigned long CAPIENZA_FISSA_BUFFER_LETTURA= SOGLIA_POCHI_NODI; //in modo da poter caricare in una lettura tutte le informazioni (sono 2 interi per ciascun nodo e ne vengono salvati su disco al massimo meta' --> 2*N/2)
  unsigned long old_number_passivi, dim_memoria_extra, dim_memoria_buffer_lettura, numero_match, quanti_nodi_calcolare, quanti_nodi_swappare;
  unsigned long * vettore_lavoro; 
  unsigned long * vettore_memoria_extra, * vettore_memoria_buffer_lettura;

  printf("\n     Calcolo passivi Parte Iniziale %lu)\n\n", conta_calcoli_Inizio_foresta); fflush(stdout);//*****

  accertati_che(!is_dirty_vettore_bits, "Errore: bisogna che calcola_nodi_passivi_Inizio_foresta() riceva il vettore di bits non ``sporcato''");

  old_number_passivi= numero_passivi;

  //calcoliamo la memoria libera:
  unsigned long capienza_mem_libera= liste_adiacenza->capienzaMemoriaInutilizzata();
  accertati_che( (capienza_mem_libera >= archi_caricabili_alla_volta+elementi_riservati_buffer), MSG_ERR_MEM_LIBERA_RISERVATA);

  vettore_lavoro= liste_adiacenza->get_punt_mem_libera(); //riceviamo un puntatore alla memoria libera all'interno delle liste di adiacenza.
    
  if(numero_nodi <= SOGLIA_POCHI_NODI) //ci sono pochi nodi: ritagliamo una fetta della memoria libera appositamente per il buffer, tanto costa poco. Usare meta' del vettore di lavoro potrebbe risultare errato, perche' potrebbe non fornire spazio sufficiente per caricare nemmeno un elemento.
  {
    dim_memoria_buffer_lettura= CAPIENZA_FISSA_BUFFER_LETTURA*sizeof(unsigned long); //assumiamo di avere questo spazio, supponendo di aver dimensionato adeguatamente i buffers
    dim_memoria_extra= (capienza_mem_libera - numero_nodi - CAPIENZA_FISSA_BUFFER_LETTURA) * sizeof(unsigned long);
    //(!) occhio, aritmetica dei puntatori..
    vettore_memoria_buffer_lettura= vettore_lavoro + numero_nodi; //il buffer lettura si prende la memoria libera che segue quella del vettore con N elementi
    vettore_memoria_extra= vettore_lavoro + numero_nodi + CAPIENZA_FISSA_BUFFER_LETTURA; //il vettore extra si prende la memoria libera che segue quella del vettore con N elementi e quella del buffer lettura
  }
  else
  {
    dim_memoria_buffer_lettura= numero_nodi/2; //destiniamo al buffer di lettura meta' della memoria del vettore di lavoro (quello con N elementi, i.e. N/2 elementi). Cio' non influenza percio' la memoria del vettore extra
    dim_memoria_extra= (capienza_mem_libera - numero_nodi) * sizeof(unsigned long);  
    //(!) occhio, aritmetica dei puntatori..
    vettore_memoria_buffer_lettura= vettore_lavoro + numero_nodi/2; //i.e. punta alla seconda meta' del vettore di lavoro, che supponiamo di non usare altrimenti durante l'utilizzo del buffer lettura (infatti nella prima parte del vettore scriveremo al massimo N/2 elementi)
    vettore_memoria_extra= vettore_lavoro + numero_nodi; //il vettore extra si prende la memoria libera che segue quella del vettore con N elementi
  }
  
  SwappedStack<unsigned long> pila(dim_memoria_extra, vettore_memoria_extra);

  if(conta_calcoli_Inizio_foresta == 0)
  {
    inizializza_stack(&pila, 0);

    unsigned long incremento_foresta= esplora_cammino_leftmost(&pila); //tutti i nodi sul cammino piu' a SX sono sicuramente passivi e stabili: li rendiamo passivi e li annettiamo alla parte iniziale stabile
        
    quanti_nodi_calcolare= stima_prossima_porzione_Inizio_Foresta(0, incremento_foresta, 0); //il numero di match non e' significativo per l'iterazione iniziale
    printf("\n--> nodi sul leftmost path:%lu, stima di partenza I.F.: %lu\n", incremento_foresta, quanti_nodi_calcolare); //*****

    calcola_porzione_successiva_Inizio_foresta(vettore_lavoro, &pila, quanti_nodi_calcolare); //calcola e salva su disco i nodi da provare nella prossima iterazione.

    //aggiornamento variabili:
    tot_nodi_scoperti_Inizio_foresta += incremento_foresta;
    conta_calcoli_Inizio_foresta++;
  }
  else
  {
    unsigned long incremento_foresta; //'incremento_foresta' indica quanti nuovi nodi si aggiungono con questa iterazione alla parte iniziale stabile della foresta
    
    assert(nodi_salvati_Inizio_foresta <= numero_nodi/2);

    assert(tot_nodi_scoperti_Inizio_foresta >= tot_swappati_Inizio_foresta);
    inizializza_stack(&pila, tot_nodi_scoperti_Inizio_foresta - tot_swappati_Inizio_foresta);

    #ifdef VERBOSE_DEBUG
      print_stack("dopo visita_preordine_nodi()", &pila); //*****
    #endif
        
    unsigned long limite_confronti= MIN(nodi_salvati_Inizio_foresta, subtrunc(numero_nodi, tot_nodi_scoperti_Inizio_foresta + tot_nodi_scoperti_Fine_foresta)); //non dobbiamo tentare di elaborare piu' nodi di quanti ne rimangano in memoria (perche' magari quelli salvati nell'iterazione precedente sono stati swappati)
    numero_match= confronta_parte_Iniziale_foresta(vettore_lavoro, dim_memoria_buffer_lettura, vettore_memoria_buffer_lettura, &pila, limite_confronti, &quanti_nodi_swappare); //ad ogni match incontrato setta il nodo corrispondente come passivo e tiene traccia, nel vettore passato, dei nodi della parte iniziale stabile che possono essere swappati.
    incremento_foresta= numero_match;

    printf("\n     <<<trovati %lu/%lu match nella parte Iniziale (eff./max)>>>>\n", numero_match, nodi_salvati_Inizio_foresta); //*****
    if(numero_match == nodi_salvati_Inizio_foresta) //*****
    {
      numero_stime_carenti_Inizio_foresta++; printf("\n     ! Stima I.F. insufficiente !  \n");
    }
    else
      numero_salvataggi_inutili_nodi_Inizio_foresta += (nodi_salvati_Inizio_foresta - numero_match); //*****

    assert(quanti_nodi_swappare <= numero_nodi/2);

    
    unsigned long * subvettore_appoggio= vettore_lavoro + quanti_nodi_swappare; //e' il resto del vettore, che non contiene dati interessanti, ed e' grande per ipotesi almeno meta' del vettore totale

    //ordiniamo i padri dei nodi da swappare (il resto del vettore non ci serve piu', infatti i figli swappati sono quelli in fondo alle loro liste di adiacenza e basta saperne il # per ciascuna lista, che si ottiene contando appunto le occorrenze di ciascun padre):
    MergeSort_iterativo<unsigned long>(vettore_lavoro, quanti_nodi_swappare, subvettore_appoggio); //ci da' all'inizio del vettore l'elenco ordinato in modo crescente dei padri dei nodi da swappare. Il secondo vettore passato e' appunto d'appoggio per l'ordinamento (e per ipotesi e' grande almeno quanto quello da ordinare)

#ifdef VERBOSE_DEBUG
printf("\nPrima dello Swap dei passivi Inizio Foresta:\n"); liste_adiacenza->print_adiacenti();
#endif
#ifdef CHECK_PASSIVI //*****
controlla_passivi("Check nodi passivi tra il calcolo ParteIniziale e prima di fare lo Swap");
#endif

    //salviamo su disco i nodi da swappare, dopo averli copiati nel vettore 'subvettore_appoggio', e li togliamo dalle rispettive liste di adiacenza (che vengono tutte ricompattate):
    swappa_nodi_da_Inizio_liste_adiacenza(vettore_lavoro, quanti_nodi_swappare, subvettore_appoggio); //'subvettore_appoggio' e' un vettore d'appoggio per la scrittura dei nodi swappati, con almeno 'quanti_nodi_swappare' elementi (perche' per ipotesi le posizioni gia' impegnate del vettore di lavoro sono meno di meta' del totale)

#ifdef VERBOSE_DEBUG
printf("\nDOPO lo Swap dei passivi Inizio Foresta:\n"); liste_adiacenza->print_adiacenti();
#endif

    //ora invece salviamo le info sui padri dei nodi swappati, necessarie per rimettere poi i nodi swappati al loro posto:
    salva_info_nodi_swappati(vettore_lavoro, quanti_nodi_swappare, mf_info_swap_passivi_InizioForesta, nome_mfile_info_swap_passivi_InizioForesta); //il vettore viene rielaborato (sfruttando le informazioni dei padri), ottenendo le necessarie coppie (padre, # figli swappati) che vengono scritte in blocco su disco

    #ifdef CHECK_PASSIVI //*****
    unsigned long conta_prossimi_passivi= 0;
    unsigned long conta_nodi= controlla_nodi_rimasti_forward(&pila, &conta_prossimi_passivi); //*****
    printf("prossimi passivi da annettere a Inizio Foresta: %lu\n", conta_prossimi_passivi);    
    printf("\nconta_nodi=%lu ; numero_nodi=%lu ; tot_nodi_scoperti_Fine_foresta=%lu ; #match=%lu\n", conta_nodi, numero_nodi, tot_nodi_scoperti_Fine_foresta, numero_match);
//    printf("\nscarto=%ld\n", conta_nodi - numero_nodi + tot_nodi_scoperti_Inizio_foresta + numero_match + tot_nodi_scoperti_Fine_foresta);
    accertati_che(conta_nodi==numero_nodi-tot_nodi_scoperti_Inizio_foresta-numero_match-tot_nodi_scoperti_Fine_foresta, "err. test");
    #endif //*****


    incremento_foresta += esplora_cammino_leftmost(&pila); //tutti i nodi sul cammino piu' a SX sono sicuramente passivi e stabili: li rendiamo passivi e li annettiamo alla parte iniziale stabile
    printf("\n tot_nodi_scoperti_Inizio_foresta= %lu,tot_nodi_scoperti_Fine_foresta=%lu, numero_match=%lu, incremento_foresta=%lu, numero_nodi=%lu\n", tot_nodi_scoperti_Inizio_foresta, tot_nodi_scoperti_Fine_foresta, numero_match, incremento_foresta, numero_nodi); //*****

    quanti_nodi_calcolare= stima_prossima_porzione_Inizio_Foresta(numero_match, incremento_foresta, conta_calcoli_Inizio_foresta);
    printf("\n nodi sul leftmost path:%lu, stima I.F.: %lu\n", incremento_foresta - numero_match, quanti_nodi_calcolare); //******

    #ifdef VERBOSE_DEBUG
      print_stack("prima di calcola_porzione_successiva_Inizio_foresta()", &pila); //*****
    #endif
    
    calcola_porzione_successiva_Inizio_foresta(vettore_lavoro, &pila, quanti_nodi_calcolare); //calcola e salva su disco i nodi da provare nella prossima iterazione. N.B. ha senso continuare con lo stack nel punto in cui eravamo rimasti nel confronto perche' le eliminazioni di nodi sono avvenute all'inizio delle liste di adiac., mentre nello stack i riferimenti indicano quanti nodi rimangono nella parte finale della lista, e sono percio' ancora validi.
//printf("* dopo calcola_porzione_successiva_Inizio_foresta() \n"); //*****

    //aggiornamento variabili:
    valore_test_modifiche_albero_prec= quick_test_modifiche_albero(); //(!) va aggiornata perche' se no ogni nodo swappato (o quasi..) farebbe pensare ad una modifica nella foresta
    tot_nodi_scoperti_Inizio_foresta += incremento_foresta;
    tot_swappati_Inizio_foresta += quanti_nodi_swappare; //due conteggi separati per i nodi scoperti nella parte finale stabile, e quelli scoperti e swappati
    archi_caricabili_alla_volta += quanti_nodi_swappare; //(!) i nodi passivi swappati creano posto per altri archi caricabili nelle liste di adiacenza
//    num_swappati_ultima_volta_Inizio_foresta= quanti_nodi_swappare; //*****
    conta_calcoli_Inizio_foresta++;

    printf("\n\n>> Numero di nodi passivi:%ld (%.1f%% del totale: +%.1f%%)\n", numero_passivi, 100.0f*numero_passivi/numero_nodi, 100.0f*(numero_passivi - old_number_passivi)/numero_nodi);
    printf(">> Dim. parte Iniziale stabile=%lu (%.1f%% dei nodi) -- nodi swappati nella parte Iniziale=%lu (+%lu)\n", tot_nodi_scoperti_Inizio_foresta, 100.0f*tot_nodi_scoperti_Inizio_foresta/numero_nodi, tot_swappati_Inizio_foresta, quanti_nodi_swappare);
  }

#ifdef VERBOSE_DEBUG
print_passivi();
#endif

  conta_passivi_scoperti_Parte_Iniziale += (numero_passivi - old_number_passivi);
  return (numero_passivi - old_number_passivi);
}



//---------------------------------------------------------------------------------------------------------------





//****** solo per debug
unsigned long controlla_nodi_rimasti(SwappedStack<unsigned long> * stack_original) //*****
{
  bool ok, esci= false;
  unsigned long conta_nodi= 0;

  SwappedStack<unsigned long> pila1(100000);
  SwappedStack<unsigned long> pila2(100000);

  while(!stack_original->isEmpty())
  {
    unsigned long  elem;
    stack_original->pop(elem);
    pila2.push(elem);
  }

  while(!pila2.isEmpty())
  {
    unsigned long  elem;
    pila2.pop(elem);
    stack_original->push(elem);
    pila1.push(elem);
  }


  while(!esci) //notare che 'quanti_nodi_salvare' viene decrementato
  {
    unsigned long indice_next, nodo_top;

    ok= pila1.pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      ok= pila1.readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      indice_next--; //(!) dobbiamo PRIMA decrementare (l'indice sulla pila rappr. il numero di nodi restanti all'inizio della lista di adiac. del nodo padre)

      unsigned long nodo_figlio= liste_adiacenza->get_adiac( nodo_top, indice_next); //il figlio corrente del nodo_top
      //scoperto 'nodo_figlio', ma non ci interessa. Aggiustiamo adesso lo stack:
      pila1.push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

      pila1.push(nodo_figlio); //mettiamo il nodo trovato sullo stack: prima il suo ID, poi il # di suoi adiacenti che rimangono da considerare (tutti)
      pila1.push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
    }
    else //indice_next==0, ovvero il nodo affiorante sullo stack e' appena finito
    {
      ok= pila1.pop(nodo_top); //leggiamo il nodo in cima, appena finito, e lo togliamo dalla pila
      accertati_che(ok, MSG_ERRORE_PILA);

      if(nodo_top == NODO_SUPER_ROOT)
        esci= true;
      else
      {
        conta_nodi++;
//        printf("(%lu) ", nodo_top);
      }
    }
  }//fine blocco while

  return conta_nodi;
}




unsigned long stima_prossima_porzione_Fine_foresta(unsigned long match_correnti, unsigned long incremento_parte_finale_stabile, unsigned long numero_iterazioni)
{
  const unsigned long STIMA_DI_PARTENZA= (unsigned long) (numero_nodi*0.20f); //quanti nodi calcolare (e salvare su disco) nel primo tentativo
  const unsigned long STIMA_MIN= (unsigned long) (numero_nodi*0.05f);
  const unsigned long NUMERO_MIN_MATCH= (unsigned long) (numero_nodi*0.03f);
  const float RATE_DI_PARTENZA= 4.0f;
  const float PESO_LAST_TIME= 0.75f; //quanto conta l'ultimo valore registrato rispetto a quelli precedenti (base della potenza con cui decrescono i pesi delle volte piu' lontane nel tempo)

  unsigned long valore_stimato, match_adj;

  if(match_correnti == nodi_salvati_Fine_foresta) //l'ultima volta la stima era stata troppo bassa
    match_adj= 2 * match_correnti; //in questo caso stimiamo che la porzione da salvare fosse il doppio di quanto abbiamo salvato noi
  else
    match_adj= match_correnti; //questo fattore moltiplicativo non produce effetti

  if(match_adj < NUMERO_MIN_MATCH)
    match_adj= NUMERO_MIN_MATCH; //per evitare ad es. che un'iterazione che non trovi nulla non faccia calcolare piu' nulla alle iterazioni seguenti

  if(match_volta_precedente_Fine_foresta == 0)
    match_volta_precedente_Fine_foresta= 1; //evitiamo cosi' di fare una divisione per zero. N.B. la variabile viene poi settata ad un valore significativo subito prima di uscire

  switch(numero_iterazioni)
  {
    case 0: //nessuna informazione
      valore_stimato= STIMA_DI_PARTENZA;
      break;

    case 1: //solo l'informazione sul calcolo appena effettuato
      valore_stimato= (unsigned long) (match_adj * RATE_DI_PARTENZA);
      break;

    case 2: //infomazioni sul calcolo appena effettuato e sul precedente
      somma_pesata_rate_Fine_foresta= ((float) match_adj) / match_volta_precedente_Fine_foresta;
      valore_stimato= (unsigned long) (1.20f * match_adj * somma_pesata_rate_Fine_foresta);
      break;

    default: //infomazioni sul calcolo appena effettuato ed altri precedenti
      somma_pesata_rate_Fine_foresta= PESO_LAST_TIME * ( ((float) match_adj) / match_volta_precedente_Fine_foresta)  +  (1 - PESO_LAST_TIME) * somma_pesata_rate_Fine_foresta; //facciamo la somma pesata tra il tasso di crescita attuale e quello medio
      valore_stimato= (unsigned long) (1.20f * match_adj * somma_pesata_rate_Fine_foresta);
      break;
  }


  if(valore_stimato < STIMA_MIN) //soglia inferiore (vincolo "elastico": poco utile fare il calcolo per solo pochi nodi)
    valore_stimato= STIMA_MIN;

  //controllo soglia superiore (vincolo rigido):
  if(valore_stimato + tot_nodi_scoperti_Inizio_foresta + incremento_parte_finale_stabile + tot_nodi_scoperti_Fine_foresta > numero_nodi)
    valore_stimato= subtrunc(numero_nodi, tot_nodi_scoperti_Inizio_foresta + incremento_parte_finale_stabile + tot_nodi_scoperti_Fine_foresta); //necessario troncare a zero la sottrazione se viene negativa: infatti tot_nodi_scoperti_Inizio_foresta e tot_nodi_scoperti_Fine_foresta possono includere nodi comuni, in maniera tale che la somma supera 'numero_nodi'

  if(valore_stimato > numero_nodi/2)
    valore_stimato= numero_nodi/2;

  match_volta_precedente_Fine_foresta= match_correnti; //aggiorniamo la variabile per la prossima iterazione di calcolo

  return valore_stimato;
}



//versione che usa un nodo di riferimento (l'ultimo della parte finale della foresta, i.e. quello con # di preordine minimo) per posizionarsi.
//sfruttiamo la compatibilita'/dualita'/reversibilita' tra le visite in preordine e in "postordine inverso"
void riporta_indietro_stack(SwappedStack<unsigned long> * pila)
{
  bool ok;
  unsigned long indice_next, nodo_top, nodo_figlio;
  const unsigned long valore_inizio_lista= (unsigned long) -1;

  if(ultimo_nodo_Parte_Finale == MAX_ULONG) //in questo caso non possiamo sfruttare la scoperta del primo nodo completato e non saltato (per riportare lo stack nella situazione di partenza), perche' non c'e' tale nodo.
  {
    pila->svuota(); //togliamo ogni cosa dallo stack

    pila->push(NODO_SUPER_ROOT);
    pila->push( liste_adiacenza->degree_of(NODO_SUPER_ROOT) ); //(!) i.e. vanno ancora esplorate tutti le radici. Notare che la visita avviene in "preordine inverso", e che gli indici rappresentano il numero di nodi nella lista ancora da processare.
    return; //fatto
  }
  //else..

  ok= pila->pop(indice_next); //informazione nodo adiacente corrente relativamente al nodo in cima allo stack
  accertati_che(ok, MSG_ERRORE_PILA);
  indice_next--;
  pila->push(indice_next); //compensiamo l'incremento iniziale dell'indice del nodo in cima, che non ci deve essere

  while(1)
  {
    ok= pila->pop(indice_next); //informazione nodo adiacente corrente relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    ok= pila->readTop(nodo_top); //consideriamo il nodo in cima
    accertati_che(ok, MSG_ERRORE_PILA);

    indice_next++; //(!)

    if(indice_next < liste_adiacenza->degree_of(nodo_top)) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      nodo_figlio= liste_adiacenza->get_adiac( nodo_top, indice_next); //il figlio corrente del nodo_top

      if(nodo_figlio == ultimo_nodo_Parte_Finale)
      {
        pila->push(indice_next); //rimette il contatore aggiornato
        return; //usciamo dal ciclo e dalla procedura
      }
      else
      {
        //aggiorniamo lo stack:
        pila->push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

        pila->push(nodo_figlio); //mettiamo il nodo trovato sullo stack: prima il suo ID, poi uno zero come indice del prossimo figlio da considerare
        pila->push(valore_inizio_lista); //mettiamo -1 perche' l'indice segna il nodo figlio corrente, che non c'e' ancora, e dovra' essere 0 al primo incremento.
      }
    }
    else //sono stati considerati tutti gli adiacenti del nodo affiorante
    {
      ok= pila->pop(nodo_top); //togliamo l'elemento affiorante dallo stack (che viene copiato [di nuovo] in nodo_top solo come "escamotage"). N.B. il contatore dei figli gia' esaminati di nodo_top era gia' stato estratto prima dallo stack
      accertati_che(ok, MSG_ERRORE_PILA);
    }
  }
}





// * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * - * -





//PRECondizioni: e' gia' stata fatta almeno una iterazione, poiche' leggiamo i dati dell'iterazione precedente da disco ; si assume che lo stack sia gia' stato riempito correttamente
//la visita dell'albero e' in "post-ordine inverso", cioe' in post-ordine con le liste di adiacenza esaminate da DX a SX. In pratica l'output e' lo stesso della visita in preordine, ma i nodi compaiono nell'ordine contrario.
// 'max_confronti_da_effettuare' e' il massimo di confronti da provare
unsigned long confronta_parte_Finale_foresta(unsigned long * vettore_lavoro, SwappedStack<unsigned long> * pila, unsigned long max_confronti_da_effettuare)
{
  bool ok;
  unsigned long confronti_coincidenti_effettuati, posizione_prossimo_padre, posizione_prossimo_figlio;

  if(max_confronti_da_effettuare == 0)
    return 0;
    
  assert(max_confronti_da_effettuare <= numero_nodi/2);
  
  //carichiamo i dati dell'iterazione precedente:
  carica_mfile_in_memoria(nome_mfile_Fine_foresta_prec, parti_mfile_Fine_foresta_prec, vettore_lavoro, 2*sizeof(unsigned long)*nodi_salvati_Fine_foresta); //per ogni nodo salvato nella visita in preordine ne salviamo anche l'info. sul padre

  confronti_coincidenti_effettuati= 0;
  posizione_prossimo_padre= 0;
  posizione_prossimo_figlio= nodi_salvati_Fine_foresta; //prima c'e' il blocco di nodi dei nodi padri, poi il blocco dei corrispondenti nodi figli
  
  while(confronti_coincidenti_effettuati < max_confronti_da_effettuare)
  {
    unsigned long indice_next, nodo_top;

    ok= pila->pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      ok= pila->readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      indice_next--; //(!) dobbiamo PRIMA decrementare (l'indice sulla pila rappr. il numero di nodi restanti all'inizio della lista di adiac. del nodo padre)

      unsigned long nodo_figlio= liste_adiacenza->get_adiac( nodo_top, indice_next); //il figlio corrente del nodo_top
      //scoperto 'nodo_figlio', ma non ci interessa. Aggiustiamo adesso lo stack:
      pila->push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

      pila->push(nodo_figlio); //mettiamo il nodo trovato sullo stack: prima il suo ID, poi il # di suoi adiacenti che rimangono da considerare (tutti)
      pila->push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
    }
    else //indice_next==0, ovvero il nodo affiorante sullo stack e' appena finito
    {
      ok= pila->pop(nodo_top); //leggiamo il nodo in cima, appena finito, e lo togliamo dalla pila
      accertati_che(ok, MSG_ERRORE_PILA);

      assert(nodo_top != NODO_SUPER_ROOT);

      unsigned long padre_di_nodotop;

      ok= pila->readTop(padre_di_nodotop, 1); //leggiamo il secondo elemento dalla cima dello stack, cioe' l'info. sul nodo padre di 'nodo_top'
      accertati_che(ok, "Errore nell'usare readTop( X, N). Dim. stack=%lu", pila->stackSize());

      if( (vettore_lavoro[posizione_prossimo_padre] == padre_di_nodotop) && (vettore_lavoro[posizione_prossimo_figlio] == nodo_top) ) //per ogni nodo 'u' terminato abbiamo salvato la coppia: (padre(u), u)
      {
        confronti_coincidenti_effettuati++;
        posizione_prossimo_padre++;
        posizione_prossimo_figlio++;
//printf("\n                       (%lu, %lu)\n", padre_di_nodotop, nodo_top); //******
      }
      else //***** (!) controlla bene questo
      {
        pila->push(nodo_top);
        pila->push(indice_next); //i.e. 0
//printf("confr. !=  --> (%lu, %lu)\n", padre_di_nodotop, nodo_top); //*****
        return confronti_coincidenti_effettuati; //usciamo dal loop e dalla procedura
      }
    }
  }//fine blocco while

  return confronti_coincidenti_effettuati;
}



//leggiamo le coppie (padre, figlio) della porzione di Fine foresta che erano state salvate nel round precedente e che coincidono ancora. Per ogni nodo terminato nella visita, che e' quello dato in output, lo rendiamo passivo se e solo se il suo padre e' passivo.
//Una volta individuato il nodo con il minimo # di preordine e con il padre passivo, tutti i nodi che lo seguono nell'ordine "tipo preordine" saranno anch'essi figli di passivi e possono quindi essere resi passivi. A partire dal primo nodo che soddisfa il criterio, tutti gli altri auomaticamente lo soddisferanno: non ci sono cioe' dei "buchi". Supponendo che 'u' sia il primo nodo che soddisfa: allora il nodo 'v' con # di preordine successivo a quello di 'u' o e' figlio di 'u', o e' suo fratello, o e' comunque figlio di un avo di 'u': in tutti i casi se 'u' diventa passivo, anche il padre di 'v' e' passivo, dunque 'v' puo' essere reso passivo.
//Ritorna il numero di "match effettivi", cioe' nodi che effettivamente entreranno a far parte della parte finale stabile della foresta
//Aggiorna 'ultimo_nodo_Parte_Finale'
unsigned long imposta_passivi_individuati_Fine_foresta(unsigned long * vettore_lavoro, unsigned long quanti_nodi_considerare)
{
  unsigned long posizione_corrente, risposta;

  if(quanti_nodi_considerare == 0)
    return 0;

  //conviene esaminare i nodi al crescere del loro # di preordine: infatti li dobbiamo rendere passivi SSE il lo padre e' passivo; in questo modo partendo dagli eventuali padri verso i figli possiamo propagare il passaggio a nodi passivi
  posizione_corrente= quanti_nodi_considerare; //ci posizioniamo subito dopo l'ultimo nodo padre da considerare (nel loop predecrementiamo)

  //cerchiamo il primo nodo con un padre passivo:
  while(posizione_corrente > 0) 
  {
    posizione_corrente--; //predecrementiamo, passando a considerare (il padre del) nodo con # di preordine subito successivo
    
    unsigned long nodo_padre= vettore_lavoro[posizione_corrente];
    
    if( (nodo_padre == NODO_SUPER_ROOT) || is_passivo( nodo_padre ) )  //se e' passivo il padre..
    {
      posizione_corrente++; //incrementiamo, annullando in pratica l'ultimo decremento: 'posizione_corrente' indica cosi' il # di match effettivi. In questo modo il valore 0 dopo il loop vuol dire che non e' stato trovato nessun nodo rispondente, e un # > 0 indica quanti nodi rispondenti sono stati trovati.
      break; //..usciamo dal loop
    }
  }

  if(posizione_corrente == 0) //non e' stato trovato alcun nodo rispondente
    return 0;
  //else..e' stato trovato almeno un nodo rispondente
  
  risposta= posizione_corrente; //salviamo il valore da restituire

  posizione_corrente += nodi_salvati_Fine_foresta; //passiamo al blocco dei nodi figli: ci posizioniamo subito dopo il primo figlio da rendere passivo ; infatti nel loop predecrementiamo
  
  ultimo_nodo_Parte_Finale= vettore_lavoro[posizione_corrente - 1]; //salviamo il nodo con # di preordine minore della parte finale stabile della foresta

  //a partire dal nodo individuato, per ogni coppia (padre, figlio) rendiamo passivo il nodo figlio, che e' quello che e' stato dato in output nella visita in "postordine inverso". N.B. una volta trovato il primo nodo figlio di passivo nella parte U.F.P, non ci possono essere "buchi" di nodi non figli di nodi passivi.
  while(posizione_corrente > nodi_salvati_Fine_foresta) //scorriamo la parte iniziale del blocco dei figli (sono 'risposta' posizioni)
  {
    posizione_corrente--; //predecrementiamo

    assert((vettore_lavoro[posizione_corrente - nodi_salvati_Fine_foresta]==NODO_SUPER_ROOT) || is_passivo(vettore_lavoro[posizione_corrente - nodi_salvati_Fine_foresta]));

    bool val_prec= set_passivo( vettore_lavoro[posizione_corrente] ); //rendiamo passivo il nodo figlio

    if(!val_prec) //se non era passivo prima lo diventa adesso e incrementiamo il conteggio
      numero_passivi++;
  }

  return risposta;
}



//salta tutti i prossimi nodi passivi che terminiamo continuando la visita, saltandone pero' al massimo 'max_nodi_da_saltare'.
//In pratica va chiamata solo nel caso in cui in numero dei match "potenziali" ed "effettivi" coincidono: altrimenti il primo nodo da provare sarebbe figlio di un non-passivo e percio' certamente non-passivo. In questo caso sfrutta il lavoro di NPE e non lo ripete inutilmente.
//Scrive nel vettore di interi passato i PADRI dei nodi passivi saltati
//Aggiorna 'ultimo_nodo_Parte_Finale'
unsigned long salta_prossimi_nodi_passivi_Fine_Foresta(unsigned long * vettore_output, SwappedStack<unsigned long> * pila, unsigned long max_nodi_da_saltare)
{
  bool ok;
  unsigned long quanti_saltati;
  
  quanti_saltati= 0;
  
  while(quanti_saltati < max_nodi_da_saltare) //usciamo o perche' abbiamo saltato il numero max di nodi passivi, oppure perche' abbiamo incontrato un nodo non passivo
  {
    unsigned long indice_next, nodo_top;

    ok= pila->pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      ok= pila->readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      indice_next--; //(!) dobbiamo PRIMA decrementare (l'indice sulla pila rappr. il numero di nodi restanti all'inizio della lista di adiac. del nodo padre)

      unsigned long nodo_figlio= liste_adiacenza->get_adiac( nodo_top, indice_next); //il figlio corrente del nodo_top
      //scoperto 'nodo_figlio', ma non ci interessa. Aggiustiamo adesso lo stack:
      pila->push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

      pila->push(nodo_figlio); //mettiamo il nodo trovato sullo stack: prima il suo ID, poi il # di suoi adiacenti che rimangono da considerare (tutti)
      pila->push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
    }
    else //indice_next==0, ovvero il nodo affiorante sullo stack e' appena finito
    {
      ok= pila->pop(nodo_top); //leggiamo il nodo in cima, appena finito, e lo togliamo dalla pila
      accertati_che(ok, MSG_ERRORE_PILA);

      assert(nodo_top != NODO_SUPER_ROOT);

      //gestiamo la fine del nodo (nuovo nodo terminato nella visita in "postordine inverso"):
      if(is_passivo(nodo_top))
      {
        unsigned long padre_di_nodotop;
        ok= pila->readTop(padre_di_nodotop, 1); //leggiamo il secondo elemento dalla cima dello stack, cioe' l'info. sul nodo padre di 'nodo_top'
        accertati_che(ok, "Errore nell'usare readTop( X, N). Dim. stack=%lu", pila->stackSize());
        vettore_output[quanti_saltati]= padre_di_nodotop; //salviamo il padre del nodo saltato nella pos. corrente del vettore di output
        
        ultimo_nodo_Parte_Finale= nodo_top;
        quanti_saltati++;
      }
      else //nodo non-passivo: non dobbiamo saltarlo e ci fermiamo qui
      {
        riporta_indietro_stack(pila); //siamo finiti oltre l'ultimo nodo della parte finale stabile: dobbiamo tornare ad esso con il contenuto dello stack
        break; //usciamo dal loop
      }
    }
  }
  //N.B.: se siamo usciti perche' !(quanti_saltati < max_nodi_da_saltare), e non per il break, allora lo stack e' gia' a posto e non bisogna tornare indietro ("punta" gia' subito dopo l'ultimo nodo della parte finale stabile)

  return quanti_saltati;
}



//'punt_src' punta all'ultimo elemento della lista di adiacenza corrente
void trascrivi_Fine_lista_corrente(unsigned long * punt_src, unsigned long num_figli_da_swappare, unsigned long * * vettore_output_swap)
{
  for(unsigned long i= 0; i<num_figli_da_swappare; i++)
  {
    *(*vettore_output_swap)= *punt_src; //N.B. vettore_output_swap e' un puntatore ad un puntatore
#ifdef VERBOSE_DEBUG
    printf("swap(%lu) ", *punt_src); //*****
#endif
    punt_src--; //passo all'adiacente successivo    
    (*vettore_output_swap)++; //incr. il puntatore nel vettore (modificando la variabile della funzione chiamante)
  }
}



bool next_padre_da_processare(unsigned long * nodo_src, unsigned long * num_figli_da_swappare, unsigned long * conta_elem_input_letti, unsigned long tot_nodi_da_rimuovere, unsigned long * vettore_input_padri)
{
  if( *conta_elem_input_letti >= tot_nodi_da_rimuovere)
    return false;
  //else..

  *nodo_src= vettore_input_padri[ *conta_elem_input_letti ];
  *num_figli_da_swappare= 0; //azzeriamo il conteggio

  //contiamo quante volte di seguito compare lo stesso nodo padre (= numero di figli da swappare di quel nodo padre)
  while(( *conta_elem_input_letti < tot_nodi_da_rimuovere) && (vettore_input_padri[ *conta_elem_input_letti ] == *nodo_src)) //per ipotesi viene eseguito almeno una volta
  {
    (*num_figli_da_swappare)++;
    (*conta_elem_input_letti)++;
  }
  
  return true;
}



void swappa_nodi_da_Fine_liste_adiacenza(unsigned long * vettore_input_padri, unsigned long tot_nodi_da_swappare, unsigned long * vettore_output_swap)
{
  bool continua;
  unsigned long * punt_src;
  unsigned long num_figli_da_swappare, last_nodo_src, nodo_src, dim_corrente_buco;

  if(tot_nodi_da_swappare==0)
    return;

  unsigned long * const vettore_adiacenze= liste_adiacenza->vettore_adiacenti();
  unsigned long * const vettore_punt= liste_adiacenza->vettore_riferimenti();        
  unsigned long conta_elem_input_letti= 0; //tiene il conto di quanti nodi di 'vettore_input_padri' abbiamo gia' letto
  unsigned long * punt_scrittura= vettore_output_swap; //punta sempre alla prossima locazione da scrivere

  //consideriamo la prima lista con nodi da swappare. Questa e le precedenti non vanno spostate:
  continua= next_padre_da_processare(&nodo_src, &num_figli_da_swappare, &conta_elem_input_letti, tot_nodi_da_swappare, vettore_input_padri);
  accertati_che(continua, "Errore in elabora_liste_adiacenza(): ci deve essere almeno una lista con nodi da swappare");

  punt_src= vettore_adiacenze + (vettore_punt[nodo_src + 1] - 1); //puntiamo al nodo in fondo alla lista di 'nodo_src'
  trascrivi_Fine_lista_corrente(punt_src, num_figli_da_swappare, &punt_scrittura);

  last_nodo_src= nodo_src;
  dim_corrente_buco= num_figli_da_swappare; //conta gli elementi in fondo alla lista corrente che vanno rimossi
  
  do 
  {  
    continua= next_padre_da_processare(&nodo_src, &num_figli_da_swappare, &conta_elem_input_letti, tot_nodi_da_swappare, vettore_input_padri);

    if(continua)
    {
      punt_src= vettore_adiacenze + (vettore_punt[nodo_src + 1] - 1); //puntiamo al nodo in fondo alla lista di 'nodo_src'
      trascrivi_Fine_lista_corrente(punt_src, num_figli_da_swappare, &punt_scrittura); //N.B. va prima elaborata la lista, e poi va spostata (se no andiamo a leggere nelle locazioni DOPO quelle che la lista occupa adesso)

      liste_adiacenza->sposta_indietro_liste(dim_corrente_buco, last_nodo_src + 1, nodo_src); //compattiamo le liste all'indietro eliminando il vecchio buco
                  
      last_nodo_src= nodo_src; //il nodo corrente diventa quello precedente
      dim_corrente_buco += num_figli_da_swappare; //il "buco" e' formato dagli elementi in fondo alla lista corrente (di 'nodo_src') e dagli spazi formati dagli elementi eliminati in precedenza dalle altre liste, che ora si trovano tra la lista corrente e la successiva
    }    
  } while(continua);

  //ricompattiamo il resto delle liste di adiacenza (eliminando il "buco" dovuto all'ultima lista processata):
  if(last_nodo_src == NODO_SUPER_ROOT) //se cioe' l'ultima lista processata era quella dell'ultimo nodo delle liste di adiacenza (il "super root")
    liste_adiacenza->accorcia_lista_del_nodo(NODO_SUPER_ROOT, dim_corrente_buco); //in questo caso non ci sono altre liste che seguono, va solo ridimensionata l'ultima (quella del "super root", appunto)
  else
    liste_adiacenza->sposta_indietro_liste(dim_corrente_buco, last_nodo_src + 1); //compattiamo all'indietro le liste rimanenti eliminando il buco

    
  //adesso che abbiamo tolto dalla memoria (ricopiandoli in 'vettore_output_swap') i nodi passivi da swappare, dobbiamo tenerne traccia scrivendoli su disco:
  unsigned long ris= mf_nodi_swap_passivi_FineForesta->write(vettore_output_swap, sizeof(unsigned long), tot_nodi_da_swappare); //ogni nodo tolto dalla memoria viene salvato su disco (notare che sono stati copiati nel vettore in modo tale che in una stessa lista di adiacenza i nodi piu' in fondo precedono gli altri).
  accertati_che( (ris==tot_nodi_da_swappare), MSG_ERRORE_SCRITTURA_MFILE, nome_mfile_nodi_swap_passivi_FineForesta);
  //N.B. il mfile deve restare aperto
}



//calcoliamo le coppie per le info dei nodi swappati (del tipo struct SwapPassiviInfo: (padre, num. figli swappati) ) e le salviamo su disco nel file opportuno
//partiamo dall'elenco ordinato, con possibili ripetizioni, dei nodi padri, costituito da 'tot_nodi_da_swappare' elementi (max numero_nodi/2). Esso costituisce la parte iniziale del vettore
//scriviamo le coppie a partire dalla fine del vettore (partendo da quelle dei nodi con identificatore maggiore). Nel caso piu' complesso ci sono numero_nodi/2 padri senza ripetizioni, cosicche' da numero_nodi/2 celle significative dobbiamo passare a numero_nodi celle significative, senza naturalmente perdere informazioni. Per ogni cella letta dalla parte iniziale del vettore ne scriviamo 2 nella parte finale: la cella letta puo' essere subito riutilizzata in scrittura cosicche' ad ogni passo le celle significative da leggere diminuiscono di 1, mentre quelle disponibili per la scrittura diminuiscono di 2-1=1. Percio' ad ogni passo ho tante celle ancora da leggere quante sono quelle disponibili per scrivere, percio' non perdo informazioni sovrascrivendo le informazioni significative ancora da leggere.
//PRECondizioni: l'elenco dei padri e' ordinato in maniera crescente e non occupa piu' di meta' vettore (i.e. 'tot_nodi_da_swappare' <= N/2)
//N.B. trattiamo le coppie scritte come se fossero una struct SwapPassiviInfo, quindi va fatta bene attenzione all'ordine in cui scrivere gli elementi della coppia
void salva_info_nodi_swappati(unsigned long * vettore_lavoro, unsigned long tot_nodi_da_swappare, multiFileWriter * mf_info_swap, const char * nome_mfile_info_swap)
{
  unsigned long indice_src, info_da_scrivere;
  struct SwapPassiviInfo * punt_dst;
  
  if(tot_nodi_da_swappare == 0)
    return;
  //else..

  assert(tot_nodi_da_swappare <= numero_nodi/2);

  info_da_scrivere= 0;
  indice_src= tot_nodi_da_swappare; //punta subito dopo l'ultimo dell'elenco ordinato dei padri: infatti nel loop predecrementiamo.
  punt_dst= (struct SwapPassiviInfo *) (vettore_lavoro + numero_nodi); //punta subito dopo l'ultima (i.e. verso la fine del vettore) posizione disponibile per la scrittura: infatti nel loop predecrementiamo. Al primo decremento permettera' di accedere all'ultima coppia di long presenti nel vettore.

    
  bool continua= true;
    
  do //il # di figli che ha il generico padre e' dato dal # di ripetizioni consecutive del padre che troviamo nell'elenco
  {
    indice_src--; //predecrementiamo e ci posizioniamo sul prossimo nodo padre
  
    unsigned long nodo_src= vettore_lavoro[indice_src]; //indica il nodo padre corrente

    unsigned long num_figli= indice_src + 1; //il # di ripetizioni del nodo padre posso calcolarle come differenza tra gli indici degli estremi dell'intervallo di ripetizioni, piu' 1

    //ci posizioniamo sull'ultima occorrenza del valore 'nodo_src' (i.e. quella piu' vicina all'inizio del vettore):
    while((indice_src > 0) && (vettore_lavoro[indice_src - 1] == nodo_src))
      indice_src--;
    
    num_figli -= indice_src; //= 1 + (indice_src0 - indice_src1)  N.B. poiche' indice_src decresce la differenza (indice_src0 - indice_src1) e' positiva

    //salvo la coppia di informazioni:
    punt_dst--; //predecrementiamo posizionandoci sulla prossima coppia da scrivere
    punt_dst->nodoPadre= nodo_src;
    punt_dst->numFigliSwappati= num_figli;
    info_da_scrivere++; //aggiorniamo il conto delle info create, e che andranno salvate su file
    
    if(indice_src == 0) //abbiamo gia' esaminato l'ultimo elemento da leggere
      continua= false; //usciamo dal loop
      
  } while(continua);

  
  //'punt_dst' punta adesso all'ultima coppia scritta (quella piu' vicina all'inizio del vettore):
  unsigned long ris= mf_info_swap->write(punt_dst, sizeof(struct SwapPassiviInfo), info_da_scrivere);
  accertati_che( (ris==info_da_scrivere), MSG_ERRORE_SCRITTURA_MFILE, nome_mfile_info_swap);
  
//  //*****
//  //vediamo se ci sono nodi figli del super root (radici) da swappare: se si aggiorniamo il conteggio apposito
//  struct SwapPassiviInfo * ultima_info= punt_dst + info_da_scrivere - 1;
//  if(ultima_info->nodoPadre == NODO_SUPER_ROOT)
//    parziale_nodi_radice_swappati += ultima_info->numFigliSwappati;

  #ifdef VERBOSE_DEBUG
  printf("\n   # record di info scritti: %lu",info_da_scrivere); //*****
  struct SwapPassiviInfo * pippo= punt_dst;
  for(unsigned long i= 0; i<info_da_scrivere; i++) //*****
  {
    printf("\n   # record swap: (padre=%lu, # swap figli= %lu) \n", pippo->nodoPadre, pippo->numFigliSwappati); //*****
    pippo++;
  }
  #endif
    
  //N.B. il mfile deve restare aperto
}



//PRECondizioni: 'quanti_nodi_salvare' deve essere <= del numero di nodi della foresta che rimangono
//aggiorna 'nodi_salvati_Fine_foresta'
void calcola_porzione_successiva_Fine_foresta(unsigned long * vettore_lavoro, SwappedStack<unsigned long> * pila, unsigned long quanti_nodi_salvare)
{
  bool ok;
  unsigned long pos_corrente_padre, pos_corrente_figlio;

  pos_corrente_padre= 0;
  pos_corrente_figlio= quanti_nodi_salvare; //il blocco dei nodi padri precede quello dei rispettivi figli: ciascuno contiene 'quanti_nodi_salvare' posizioni

//printf("\n nodi calcolati:\n"); //******
  while(pos_corrente_padre < quanti_nodi_salvare) //finche' non abbiamo salvato 'quanti_nodi_salvare' nodi
  {
    unsigned long indice_next, nodo_top;

    ok= pila->pop(indice_next); //informazione prossimo nodo adiacente da considerare relativamente al nodo in cima allo stack
    accertati_che(ok, MSG_ERRORE_PILA);

    if(indice_next > 0) //vediamo se il nodo affiorante ha (altri) figli da visitare
    {
      ok= pila->readTop(nodo_top); //consideriamo il nodo in cima
      accertati_che(ok, MSG_ERRORE_PILA);

      indice_next--; //(!) dobbiamo PRIMA decrementare (l'indice sulla pila rappr. il numero di nodi restanti all'inizio della lista di adiac. del nodo padre)

      unsigned long nodo_figlio= liste_adiacenza->get_adiac( nodo_top, indice_next); //il figlio corrente del nodo_top
      //scoperto 'nodo_figlio', ma non ci interessa. Aggiustiamo adesso lo stack:
      pila->push(indice_next); //rimette il contatore aggiornato per il nodo affiorante sulla pila

      pila->push(nodo_figlio); //mettiamo il nodo trovato sullo stack: prima il suo ID, poi il # di suoi adiacenti che rimangono da considerare (tutti)
      pila->push(liste_adiacenza->degree_of(nodo_figlio)); //mettiamo il suo degree: rimangono cioe' ancora tutti i suoi figli da esaminare
    }
    else //indice_next==0, ovvero il nodo affiorante sullo stack e' appena finito
    {
      ok= pila->pop(nodo_top); //leggiamo il nodo in cima, appena finito, e lo togliamo dalla pila
      accertati_che(ok, MSG_ERRORE_PILA);

      assert(nodo_top != NODO_SUPER_ROOT);

      unsigned long padre_di_nodotop;
      ok= pila->readTop(padre_di_nodotop, 1); //leggiamo il secondo elemento dalla cima dello stack, cioe' l'info. sul nodo padre di 'nodo_top'
      accertati_che(ok, "Errore nell'usare readTop( X, N). Dim. stack=%lu", pila->stackSize());

      //gestiamo la fine del nodo (nuovo nodo terminato nella visita in "postordine inverso"):
      vettore_lavoro[pos_corrente_padre]= padre_di_nodotop;
      vettore_lavoro[pos_corrente_figlio]= nodo_top;
      
      pos_corrente_padre++;
      pos_corrente_figlio++;
//printf(" <%lu, %lu> ", padre_di_nodotop, nodo_top); //******
    }
  }//fine blocco while
//printf("\n"); //******


  //scrittura dei dati calcolati su disco (serviranno per la prossima iterazione del calcolo):
  parti_mfile_Fine_foresta_prec= salva_su_mfile(nome_mfile_Fine_foresta_prec, vettore_lavoro, 2*sizeof(unsigned long)*quanti_nodi_salvare); //per ogni nodo salvato nella visita in "postordine inverso" ne salviamo anche l'info. sul padre

  nodi_salvati_Fine_foresta= quanti_nodi_salvare; //ci ricordiamo di quanti nodi abbiamo calcolato per la prossima iterazione
}



//PRECondizioni: il vettore di bits dei nodi passivi deve essere "pulito", i.e. deve rappresentare effettivamente i nodi passivi
//POSTcondizioni: restituisce il vettore dei bits "pulito" e aggiornato
unsigned long calcola_nodi_passivi_Fine_foresta()
{
  unsigned long old_number_passivi, dim_memoria_extra, numero_match_effettivi, potenziali_match, quanti_nodi_calcolare;
  unsigned long * vettore_lavoro; //vettore con N (numero_nodi) + 1 elementi
  unsigned long * vettore_memoria_extra; //vettore con almeno 'elementi_riservati_buffer' elementi
  
  accertati_che(!is_dirty_vettore_bits, "Errore: bisogna che calcola_nodi_passivi_Fine_foresta() riceva il vettore di bits non ``sporcato''");

  printf("\n     Calcolo passivi Parte Finale %lu)\n\n", conta_calcoli_Fine_foresta); fflush(stdout);//*****
  
  old_number_passivi= numero_passivi;

  //calcoliamo la memoria libera:
  unsigned long capienza_mem_libera= liste_adiacenza->capienzaMemoriaInutilizzata();
  accertati_che( (capienza_mem_libera >= archi_caricabili_alla_volta+elementi_riservati_buffer), MSG_ERR_MEM_LIBERA_RISERVATA);

  vettore_lavoro= liste_adiacenza->get_punt_mem_libera(); //riceviamo un puntatore alla memoria libera all'interno delle liste di adiacenza.
  vettore_memoria_extra= vettore_lavoro + numero_nodi; //(!) occhio, aritmetica dei puntatori.. il vettore extra si prende la memoria libera che segue quella del vettore con N elementi
  dim_memoria_extra= (capienza_mem_libera - numero_nodi) * sizeof(unsigned long);

  SwappedStack<unsigned long> pila(dim_memoria_extra, vettore_memoria_extra);

  //ogni volta che eseguiamo il calcolo (non solo la prima volta) lo stack va inizializzato ripartendo "da zero": infatti i passivi della parte finale stabile della foresta sono stati swappati
  pila.push(NODO_SUPER_ROOT);
  pila.push( liste_adiacenza->degree_of(NODO_SUPER_ROOT) ); //(!) i.e. vanno ancora esplorate tutti le radici. Notare che la visita avviene in "postordine inverso", e che gli indici rappresentano il numero di nodi nella lista ancora da processare.
  ultimo_nodo_Parte_Finale= MAX_ULONG; //inizializziamo con un valore speciale: per la prima iterazione cio' indica che la parte finale stabile e' ancora vuota, mentre per le altre impedisce di cercare un nodo swappato nell'iterazione precedente
  
  if(conta_calcoli_Fine_foresta == 0)
  {
    quanti_nodi_calcolare= stima_prossima_porzione_Fine_foresta(0, 0, 0); //il numero di match e l'incremento della parte finale stabile non sono significativi per l'iterazione iniziale
    printf("\n--> stima di partenza F.F.: %lu\n", quanti_nodi_calcolare); //*****
    
    calcola_porzione_successiva_Fine_foresta(vettore_lavoro, &pila, quanti_nodi_calcolare); //calcola e salva su disco i nodi da provare nella prossima iterazione.

    //aggiornamento variabili:    
    conta_calcoli_Fine_foresta++;
  }
  else
  {    
    assert(nodi_salvati_Fine_foresta <= numero_nodi/2);
  
    unsigned long incremento_foresta; //'incremento_foresta' indica quanti nuovi nodi si aggiungono con questa iterazione alla parte finale stabile della foresta
        
    unsigned long limite_confronti= MIN(nodi_salvati_Fine_foresta, subtrunc(numero_nodi, tot_nodi_scoperti_Inizio_foresta + tot_nodi_scoperti_Fine_foresta)); //non dobbiamo tentare di elaborare piu' nodi di quanti ne rimangano in memoria (perche' magari quelli salvati nell'iterazione precedente sono stati swappati)
    potenziali_match= confronta_parte_Finale_foresta(vettore_lavoro, &pila, limite_confronti); //in pratica il numero max di confronti effettuabili e' MIN(nodi_salvati_Fine_foresta, "nodi rimasti in memoria")

    numero_match_effettivi= imposta_passivi_individuati_Fine_foresta(vettore_lavoro, potenziali_match); //per ciascun match setta (eventualmente) un nodo come passivo. Ritorna il numero di nodi che effettivamente entreranno nella parte finale stabile della foresta.
    incremento_foresta= numero_match_effettivi;

    printf("\n     <<<trovati %lu/%lu/%lu match nella parte Finale (eff./pot./max)>>>>\n", numero_match_effettivi, potenziali_match, nodi_salvati_Fine_foresta); //*****
    if(numero_match_effettivi == nodi_salvati_Fine_foresta) //*****
    {
      numero_stime_carenti_Fine_foresta++; printf("\n     ! Stima insufficiente !  \n");
    }
    else
      numero_salvataggi_inutili_nodi_Fine_foresta += (nodi_salvati_Fine_foresta - numero_match_effettivi); //*****

//    printf("\n  riporta_indietro_stack() ..."); //*****
    riporta_indietro_stack(&pila);
//    printf("Fatto\n"); //*****

    #ifdef VERBOSE_DEBUG
      print_stack("dopo riporta_indietro_stack()", &pila); //*****
    #endif

    
    //dell'attuale contenuto del vettore ci interessa solo la parte iniziale con i _padri_ dei nodi passivi "effettivi", a cui adesso aggiungeremo, se possibile, anche i padri dei nodi gia' passivi che potremmo saltare:
    if(numero_match_effettivi == potenziali_match) //se (numero_match_effettivi<potenziali_match) allora il prossimo nodo che si incontrerebbe in "postordine inverso" sarebbe sicuramente non-passivo, perche' figlio di un nodo non-passivo
    {
      unsigned long limite_salti= MIN( numero_nodi/2 - numero_match_effettivi, subtrunc(numero_nodi, tot_nodi_scoperti_Inizio_foresta + numero_match_effettivi + tot_nodi_scoperti_Fine_foresta)); //dobbiamo evitare di percorrere (i.e. completare) piu' nodi di quanti ne rimangano da completare ed inoltre abbiamo il vincolo che non possiamo aggiungere alla parte finale stabile della foresta piu' di N/2 nodi con un colpo: infatti nelle operazioni successive supponiamo che i nodi padri non occupino piu' di meta' del vettore di lavoro. Notare che per ipotesi e': (numero_match_effettivi < numero_nodi/2)
      
      unsigned long num_nodi_saltati= salta_prossimi_nodi_passivi_Fine_Foresta(vettore_lavoro + numero_match_effettivi, &pila, limite_salti); //i _padri_ dei nodi gia' passivi scoperti vengono scritti subito dopo i _padri_ dei nodi passivi "effettivi" determinati poco fa
      printf(">   saltati %ld nodi gia' passivi\n", num_nodi_saltati);
      incremento_foresta += num_nodi_saltati; //anche questi nodi saltati possono entrare nella parte finale stabile della foresta
    }
    
    assert(incremento_foresta <= numero_nodi/2);

    #ifdef CHECK_PASSIVI
    unsigned long conta_nodi= controlla_nodi_rimasti(&pila); //*****
    printf("\nconta_nodi=%lu ; numero_nodi=%lu ; tot_nodi_scoperti_Fine_foresta=%lu ; #match=%lu ; incremento_foresta=%lu\n", conta_nodi, numero_nodi, tot_nodi_scoperti_Fine_foresta, numero_match_effettivi, incremento_foresta);
//    printf("\nscarto=%ld\n", conta_nodi - numero_nodi + tot_swappati_Inizio_foresta + tot_nodi_scoperti_Fine_foresta + incremento_foresta);
    accertati_che(conta_nodi==numero_nodi-tot_swappati_Inizio_foresta-tot_nodi_scoperti_Fine_foresta-incremento_foresta, "err. test");
    #endif

    unsigned long * subvettore_appoggio= vettore_lavoro + incremento_foresta; //e' il resto del vettore, che non contiene dati interessanti, ed e' grande per ipotesi almeno meta' del vettore totale

    //ordiniamo i padri dei nodi da swappare (il resto del vettore non ci serve piu', infatti i figli swappati sono quelli in fondo alle loro liste di adiacenza e basta saperne il # per ciascuna lista, che si ottiene contando appunto le occorrenze di ciascun padre):
    MergeSort_iterativo<unsigned long>(vettore_lavoro, incremento_foresta, subvettore_appoggio); //ci da' all'inizio del vettore l'elenco ordinato in modo crescente dei padri dei nodi da swappare. Il secondo vettore passato e' appunto d'appoggio per l'ordinamento (e per ipotesi e' grande almeno quanto quello da ordinare)

#ifdef VERBOSE_DEBUG
printf("\nPrima dello Swap dei passivi Fine Foresta:\n"); liste_adiacenza->print_adiacenti();
#endif
    
    //salviamo su disco i nodi da swappare, dopo averli copiati nel vettore 'subvettore_appoggio', e li togliamo dalle rispettive liste di adiacenza (che vengono tutte ricompattate):
    swappa_nodi_da_Fine_liste_adiacenza(vettore_lavoro, incremento_foresta, subvettore_appoggio); //'subvettore_appoggio' e' un vettore d'appoggio per la scrittura dei nodi swappati, con almeno 'incremento_foresta' elementi (perche' per ipotesi le posizioni gia' impegnate del vettore di lavoro sono meno di meta' del totale)

#ifdef VERBOSE_DEBUG
printf("\nDOPO lo Swap dei passivi Fine Foresta:\n"); liste_adiacenza->print_adiacenti();
#endif
    
    //ora invece salviamo le info sui padri dei nodi swappati, necessarie per rimettere poi i nodi swappati al loro posto:
    salva_info_nodi_swappati(vettore_lavoro, incremento_foresta, mf_info_swap_passivi_FineForesta, nome_mfile_info_swap_passivi_FineForesta); //il vettore viene rielaborato (sfruttando le informazioni dei padri), ottenendo le necessarie coppie (padre, # figli swappati) che vengono scritte in blocco su disco
    
    quanti_nodi_calcolare= stima_prossima_porzione_Fine_foresta(numero_match_effettivi, incremento_foresta, conta_calcoli_Fine_foresta);
    printf("\n stima F.F.: %lu\n", quanti_nodi_calcolare); //******

    calcola_porzione_successiva_Fine_foresta(vettore_lavoro, &pila, quanti_nodi_calcolare); //calcola e salva su disco i nodi da provare nella prossima iterazione.
            
    //aggiornamento variabili:
    valore_test_modifiche_albero_prec= quick_test_modifiche_albero(); //(!) va aggiornata perche' se no ogni nodo swappato (o quasi..) farebbe pensare ad una modifica nella foresta
    tot_nodi_scoperti_Fine_foresta += incremento_foresta; //i match effettivi ed i nodi saltati si vanno ad aggiungere alla parte finale stabile della foresta
    archi_caricabili_alla_volta += incremento_foresta; //(!) i nodi passivi swappati creano posto per altri archi caricabili nelle liste di adiacenza
//    num_swappati_ultima_volta_Fine_foresta= incremento_foresta; //*****
    conta_calcoli_Fine_foresta++;

    printf("\n\n>> Numero di nodi passivi:%ld (%.1f%% del totale: +%.1f%%)\n", numero_passivi, 100.0f*numero_passivi/numero_nodi, 100.0f*(numero_passivi - old_number_passivi)/numero_nodi);
    printf(">> Dim. parte Finale stabile=%lu (+%lu), %.1f%% dei nodi -- archi caricabili=%lu\n", tot_nodi_scoperti_Fine_foresta, incremento_foresta, 100.0f*tot_nodi_scoperti_Fine_foresta/numero_nodi, archi_caricabili_alla_volta);    
  }
  
#ifdef VERBOSE_DEBUG
print_passivi();
#endif

  conta_passivi_scoperti_Parte_Finale += (numero_passivi - old_number_passivi);
  return (numero_passivi - old_number_passivi);
}



//------------------------------------------------------------------------------------------



//Effettuiamo il calcolo di quanti figli passivi ha ciascun nodo (compreso il "super root"). Il risultato viene salvato nel 'vettore_numeri', dove l'indice indica il nodo padre ed il valore e' il # di figli swappati
//PRECondizioni: vi e' almeno un nodo swappato
unsigned long conta_figli_swappati(unsigned long * vettore_numeri, unsigned long dim_tot_mem_buffers, unsigned long * memoria_per_buffers, const char * nome_mfile_info_swap, unsigned long num_parti_mfile_info_swap, unsigned long * num_padri_distinti)
{
  struct SwapPassiviInfo info;
  unsigned long tot_swappati;

  //azzeriamo il vettore che deve contare il # di nodi figli swappati per ciascun nodo (incluso il "super root")
  for(unsigned long i=0; i<numero_nodi + 1; i++)
    vettore_numeri[i]= 0;

  //apriamo il mfile delle info, e lo leggiamo sequenzialmente con un buffer:
  multiFileReader mf_input((char *) nome_mfile_info_swap, num_parti_mfile_info_swap);
  BufferLetturaMultifile<struct SwapPassiviInfo> buf_input(&mf_input, dim_tot_mem_buffers, (struct SwapPassiviInfo *) memoria_per_buffers);

  tot_swappati= 0;
  *num_padri_distinti= 0;

  bool continua= buf_input.get(info);
  accertati_che(continua, MSG_ERRORE_LETTURA_MFILE, nome_mfile_info_swap);
  while(continua)
  {
    if(vettore_numeri[ info.nodoPadre ] == 0) //controllo necessario perche' dobbiamo contare una sola volta per tutti i contributi relativi allo stesso padre
      (*num_padri_distinti)++;

    vettore_numeri[ info.nodoPadre ] += info.numFigliSwappati;
    tot_swappati += info.numFigliSwappati;

    continua= buf_input.get(info);
  }

  mf_input.close();

  return tot_swappati;
}



/*
  rilegge i file con i dati dei nodi passivi swappati e provvede a ricopiarli al loro posto in memoria
  utilizziamo il vettore passato (N+1 celle) per memorizzare per ogni nodo quanti figli abbiamo gia' resinserito nella lista rispettiva
  'inizio_foresta' indica se lavoriamo con la parte iniziale (true) o con la parte finale (false) della foresta.
  PRECondizioni: 1) e' gia' stato ricreato lo spazio per i nodi swappati nelle liste di adiacenza (in fondo alle liste se 'inizio_foresta'==false, all'inizio se 'inizio_foresta'==true).
                 2) c'e' almeno un nodo da ripristinare.
*/
void ripopola_foresta(unsigned long * vettore_numeri, unsigned long dim_tot_mem_buffers, unsigned long * memoria_per_buffers, bool inizio_foresta, const char * nome_mfile_info_swap, const char * nome_mfile_nodi_swap, unsigned long num_parti_mfile_info_swap, unsigned long num_parti_mfile_nodi_swap)
{
  struct SwapPassiviInfo info;
  unsigned long dim_mem_buf_info, dim_mem_buf_nodi;
  struct SwapPassiviInfo * punt_mem_buf_info;
  unsigned long * punt_mem_buf_nodi;

  //azzeriamo il vettore che deve contare il # di nodi figli swappati e gia' reinseriti per ciascun nodo (incluso il "super root")
  for(unsigned long i=0; i<numero_nodi + 1; i++)
    vettore_numeri[i]= 0;

  //dimensioniamo la memoria a disposizione per i due buffers di lettura:
  dim_mem_buf_info= dim_tot_mem_buffers / 2; //fifty fifty
  dim_mem_buf_nodi= dim_tot_mem_buffers / 2;
  punt_mem_buf_info= (struct SwapPassiviInfo *) memoria_per_buffers;
  punt_mem_buf_nodi= (unsigned long *) ( (char *) memoria_per_buffers + dim_mem_buf_info); // (!) aritmetica dei puntatori!!!

  //apriamo i buffers per la lettura dei dati sui passivi swappati:
  multiFileReader mf_info_swap((char *) nome_mfile_info_swap, num_parti_mfile_info_swap);
  BufferLetturaMultifile<struct SwapPassiviInfo> buf_info_swap(&mf_info_swap, dim_mem_buf_info, punt_mem_buf_info);

  multiFileReader mf_nodi_swap((char *) nome_mfile_nodi_swap, num_parti_mfile_nodi_swap);
  BufferLetturaMultifile<unsigned long> buf_nodi_swap(&mf_nodi_swap, dim_mem_buf_nodi, punt_mem_buf_nodi);


  bool continua= buf_info_swap.get(info);
  accertati_che(continua, MSG_ERRORE_LETTURA_MFILE, nome_mfile_info_swap);

  if(inizio_foresta) //parte Iniziale della foresta
    while(continua)
    {
      unsigned long indice_corrente= vettore_numeri[ info.nodoPadre ]; //dobbiamo inserire a partire dall'inizio della lista verso la fine

      //reinseriamo il blocco di figli swappati per il nodo corrente
      for(unsigned long i=0; i<info.numFigliSwappati; i++)
      {
        unsigned long nodo_swappato;
        bool ok= buf_nodi_swap.get(nodo_swappato);
        accertati_che(ok, MSG_ERRORE_LETTURA_MFILE, nome_mfile_nodi_swap);

        unsigned long & rif_nodo_figlio= liste_adiacenza->get_adiac(info.nodoPadre, indice_corrente);
        rif_nodo_figlio= nodo_swappato; //copiamo in memoria il nodo letto dal file

        indice_corrente++; //i figli piu' interni alla lista sono quelli swappati dopo
      }

      vettore_numeri[ info.nodoPadre ] += info.numFigliSwappati; //aggiorna il conteggio dei figli gia' ripristinati per il nodo 'info.nodoPadre'

      continua= buf_info_swap.get(info);
    }
  else //parte Finale della foresta
    while(continua)
    {
      unsigned long indice_corrente= liste_adiacenza->degree_of(info.nodoPadre) - 1 - vettore_numeri[ info.nodoPadre ]; //dobbiamo inserire a partire dalla fine della lista verso l'inizio

      //reinseriamo il blocco di figli swappati per il nodo corrente
      for(unsigned long i=0; i<info.numFigliSwappati; i++)
      {
        unsigned long nodo_swappato;
        bool ok= buf_nodi_swap.get(nodo_swappato);
        accertati_che(ok, MSG_ERRORE_LETTURA_MFILE, nome_mfile_nodi_swap);

        unsigned long & rif_nodo_figlio= liste_adiacenza->get_adiac(info.nodoPadre, indice_corrente);
        rif_nodo_figlio= nodo_swappato; //copiamo in memoria il nodo letto dal file

        indice_corrente--; //i figli piu' interni alla lista sono quelli swappati dopo
      }

      vettore_numeri[ info.nodoPadre ] += info.numFigliSwappati; //aggiorna il conteggio dei figli gia' ripristinati per il nodo 'info.nodoPadre'

      continua= buf_info_swap.get(info);
    }

  mf_info_swap.close();
  mf_nodi_swap.close();
}



void ripristina_passivi_swappati()
{
  unsigned long * vettore_lavoro; //vettore con N (numero_nodi) + 1 elementi
  unsigned long * vettore_memoria_extra; //vettore con almeno 'elementi_riservati_buffer' elementi
  unsigned long dim_memoria_extra;
  unsigned long tot_swappati, quanti_padri_con_swappati, num_parti_mfile_info_swap_FineForesta, num_parti_mfile_nodi_swap_FineForesta, num_parti_mfile_info_swap_InizioForesta, num_parti_mfile_nodi_swap_InizioForesta;

  //chiudiamo (liberando la memoria) i mfile con i dati sui passivi swappati su disco (importante perche' sono buffers di scrittura):
  num_parti_mfile_info_swap_InizioForesta= mf_info_swap_passivi_InizioForesta->close();
  num_parti_mfile_nodi_swap_InizioForesta= mf_nodi_swap_passivi_InizioForesta->close();
  num_parti_mfile_info_swap_FineForesta= mf_info_swap_passivi_FineForesta->close();
  num_parti_mfile_nodi_swap_FineForesta= mf_nodi_swap_passivi_FineForesta->close();

  delete mf_info_swap_passivi_InizioForesta;
  delete mf_nodi_swap_passivi_InizioForesta;
  delete mf_info_swap_passivi_FineForesta;
  delete mf_nodi_swap_passivi_FineForesta;

  //calcoliamo la memoria libera:
  unsigned long capienza_mem_disponibile= liste_adiacenza->get_max_adiacenti() - numero_nodi; //non possiamo usare le prime N posizioni, che dovranno contenere la foresta completa
  assert(capienza_mem_disponibile == minimo_archi_caricabili_alla_volta+elementi_riservati_buffer);
  vettore_lavoro= liste_adiacenza->vettore_adiacenti() + numero_nodi; //dobbiamo prevedere che il vettore degli adiacenti verra' riempito
  vettore_memoria_extra= vettore_lavoro + numero_nodi + 1; //(!) occhio, aritmetica dei puntatori.. il vettore extra si prende la memoria libera che segue quella del vettore con N + 1 elementi
  dim_memoria_extra= (capienza_mem_disponibile - numero_nodi - 1) * sizeof(unsigned long); //una LW in piu' serve al primo vettore per il nodo super root

  //se abbiamo swappato nodi all'Inizio della foresta:
  if(tot_swappati_Inizio_foresta > 0)
  {
    //calcoliamo nel vettore il numero di figli swappati per ogni nodo ("super root" compreso):
    tot_swappati= conta_figli_swappati(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra, nome_mfile_info_swap_passivi_InizioForesta, num_parti_mfile_info_swap_InizioForesta, &quanti_padri_con_swappati);
    //adegua la dimensione delle liste di adiacenza in modo da poter re-inserire i passivi swappati.
    liste_adiacenza->aumenta_spazio_liste(vettore_lavoro, tot_swappati, quanti_padri_con_swappati, true); //inseriamo i nuovi posti alla fine delle delle liste
    //rilegge i file con i dati dei nodi passivi swappati e provvede a ricopiarli al loro posto in memoria:
    ripopola_foresta(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra, true, nome_mfile_info_swap_passivi_InizioForesta, nome_mfile_nodi_swap_passivi_InizioForesta, num_parti_mfile_info_swap_InizioForesta, num_parti_mfile_nodi_swap_InizioForesta); //'true' specifica che vanno inseriti all'inizio della lista
  }

  //se abbiamo swappato nodi alla Fine della foresta:
  if(tot_nodi_scoperti_Fine_foresta > 0)
  {
    //calcoliamo nel vettore il numero di figli swappati per ogni nodo ("super root" compreso):
    tot_swappati= conta_figli_swappati(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra, nome_mfile_info_swap_passivi_FineForesta, num_parti_mfile_info_swap_FineForesta, &quanti_padri_con_swappati);
    //adegua la dimensione delle liste di adiacenza in modo da poter re-inserire i passivi swappati.
    liste_adiacenza->aumenta_spazio_liste(vettore_lavoro, tot_swappati, quanti_padri_con_swappati, false); //inseriamo i nuovi posti all'inizio delle liste
    //rilegge i file con i dati dei nodi passivi swappati e provvede a ricopiarli al loro posto in memoria:
    ripopola_foresta(vettore_lavoro, dim_memoria_extra, vettore_memoria_extra, false, nome_mfile_info_swap_passivi_FineForesta, nome_mfile_nodi_swap_passivi_FineForesta, num_parti_mfile_info_swap_FineForesta, num_parti_mfile_nodi_swap_FineForesta); //'false' specifica che vanno inseriti in fondo alla lista, non all'inizio
  }

}



//----------------CALCOLO VETTORE BITS OLD-PASSIVI E NODI SWAPPATI------------------------------------------------------------


//*****solo per test
//void check_nodi_da_escludere(VettoreBits * vettore, const char * msg)
//{
//  unsigned long nodo_raggiunto, quanti_trovati= 0;
//  bool found;
//
//  //ricerca e output dei nodi marcati come visitati:
//  found= vettore->findNext1(nodo_raggiunto, 0); //cerchiamo il primo nodo raggiunto, a partire dal nodo 0
//
//  while(found)
//  {
//    quanti_trovati++;
//    found= vettore->findNext1(nodo_raggiunto);
//  }
//
//  accertati_che((quanti_trovati==numero_padri_da_escludere), "errore con numero_padri_da_escludere: %s\n quanti_trovati=%lu  ;  numero_padri_da_escludere=%lu", msg, quanti_trovati, numero_padri_da_escludere);
//}



//PRECondizioni: il vettore di bits dei nodi passivi deve essere "pulito", i.e. deve rappresentare effettivamente i nodi passivi
//calcoliamo l'unione di due insiemi di nodi: i nodi passivi da oltre un round (stabili), ed i nodi passivi swappati. I due insiemi non sono disgiunti (i vecchi passivi possono venire swappati, i passivi swappati "invecchiano")
void calcola_nodi_padri_da_escludere()
{
  printf("Calcolo dei nodi sorgente da escludere\n"); fflush(stdout); //*****

  if(numero_passivi==0)
    return;
  //else.. sappiamo che ci sono dei nodi passivi. Questa info. viene sfruttata alla fine, aggiornando la variabile 'num_passivi_in_round_precedente'

  accertati_che(!is_dirty_vettore_bits, "Errore: bisogna che calcola_nodi_padri_da_escludere() riceva il vettore di bits non ``sporcato''");
  
  //usiamo la memoria libera per due vettori di bits che ci servono (per ipotesi devono esserci almeno 32*N bit disponibili, a noi ne servono solo 2*N):
  unsigned long capienza_mem_libera, dim_memoria_per_bits;
  unsigned long * punt_memoria_bits_old_passivi, * punt_memoria_bits_swappati;
  
  capienza_mem_libera= liste_adiacenza->capienzaMemoriaInutilizzata(); //calcoliamo la capienza della memoria libera
  accertati_che( (capienza_mem_libera >= archi_caricabili_alla_volta+elementi_riservati_buffer), MSG_ERR_MEM_LIBERA_RISERVATA);

  dim_memoria_per_bits= ((numero_nodi/8) / sizeof(unsigned long)) * sizeof(unsigned long); //calcoliamo un numero di byte (arrotondato per difetto) multiplo di 4
  dim_memoria_per_bits= dim_memoria_per_bits + 32; //aggiungiamo qualche byte in piu' (minimo 4..) per sicurezza (VettoreBits alloca un numero di byte multiplo dell'unita' di base di memorizzazione del vettore, che in genere e' una long). Tanto possiamo confidare pure sulla memoria destinata ai buffers.
  
  punt_memoria_bits_old_passivi= liste_adiacenza->get_punt_mem_libera(); //riceviamo un puntatore alla memoria libera all'interno delle liste di adiacenza.
  punt_memoria_bits_swappati= punt_memoria_bits_old_passivi + (dim_memoria_per_bits/sizeof(unsigned long)); //(!) aritmetica dei puntatori
  
  VettoreBits bits_old_passivi(numero_nodi, dim_memoria_per_bits, punt_memoria_bits_old_passivi);
  VettoreBits bits_swappati(numero_nodi, dim_memoria_per_bits, punt_memoria_bits_swappati);

  
  unsigned long tipo_situazione= 0;
  
  //calcolo dei nodi passivi da almeno un round:
  if(num_passivi_in_round_precedente > 0)
  {
    bool ok= bits_old_passivi.caricaDaFile(nome_file_bits_passivi_prec); //ripristiniamo il vettore di bits dei nodi passivi dal disco. Serve perche' la selezione degli archi evita di caricare quelli diretti verso nodi passivi
    accertati_che(ok, MSG_ERRORE_LETTURA_BITS);
    tipo_situazione |= 1;
  }

  //calcolo dei nodi swappati:
  if(tot_swappati_Inizio_foresta + tot_nodi_scoperti_Fine_foresta > 0)
  {
//    bits_swappati.copia( *nodi_passivi ); //inizializziamo il vettore di bits ausiliario copiando tutti i nodi passivi finora individuati
    bits_swappati.reset( true ); //inizializziamo il vettore di bits ausiliario con tutti 1 e poi cancelliamo i nodi raggiungibili nella foresta

    //cancelliamo i nodi raggiungibili in una visita della foresta (che non sono swappati):
    for(unsigned long nodo_src=0; nodo_src<=NODO_SUPER_ROOT; nodo_src++)
    {
      unsigned long degree= liste_adiacenza->degree_of(nodo_src);

      for( unsigned long ind_adiac= 0; ind_adiac < degree ; ind_adiac++)
      {
        unsigned long nodo_dest= liste_adiacenza->get_adiac(nodo_src, ind_adiac); //compreso tra 0 e N-1 perche' il "super root" non ha mai archi entranti

        long errore;
        bits_swappati.set(nodo_dest, false, errore); //se l'abbiamo raggiunto, allora questo nodo non era tra quelli swappati, e ne resettiamo il bit corrispondente
        accertati_che( (errore==0), MSG_ERRORE_BITS);
      }
    }

    tipo_situazione |= 2;
  }

      
  if(tipo_situazione != 0) //altrimenti non bisogna fare nulla
    switch(tipo_situazione)
    {
      bool ok;

      case 1: //solo il primo contributo
        ok= bits_old_passivi.salvaSuFile( nome_file_bits_padri_esclusi ); //salviamo su disco il contenuto del vettore di bits
        accertati_che(ok, MSG_ERRORE_SALVA_BITS);
        numero_padri_da_escludere= num_passivi_in_round_precedente;
//        check_nodi_da_escludere(&bits_old_passivi, "caso 1"); //*****
        break;

      case 2: //solo il secondo contributo
        ok= bits_swappati.salvaSuFile( nome_file_bits_padri_esclusi ); //salviamo su disco il contenuto del vettore di bits
        accertati_che(ok, MSG_ERRORE_SALVA_BITS);
        numero_padri_da_escludere= tot_swappati_Inizio_foresta + tot_nodi_scoperti_Fine_foresta; //numero totale di nodi swappati
//        check_nodi_da_escludere(&bits_swappati, "caso 2"); //*****        
        break;

      case 3: //ci sono due contributi
        bits_swappati.OR( bits_old_passivi ); //calcoliamo l'unione dei due contributi

        ok= bits_swappati.salvaSuFile( nome_file_bits_padri_esclusi ); //salviamo su disco il contenuto del vettore di bits
        accertati_che(ok, MSG_ERRORE_SALVA_BITS);
        numero_padri_da_escludere= bits_swappati.contaBits1(); //in questo caso non e' facile capire quanti elementi avra' l'unione dei due contributi, perche' l'intersezione e' probabilmente non nulla
//        check_nodi_da_escludere(&bits_swappati, "caso 3"); //*****        
        break;

      default:
        accertati_che(false, "Errore: situazione imprevista in calcola_nodi_padri_da_escludere()");
        break;
    }
          
  num_passivi_in_round_precedente= numero_passivi; //*****per ipotesi ci sono passivi in questa iterazione
}




/* ripristiniamo all'inizio il vettore dei bit passivi, eseguiamo i calcoli che aggiungono nuovi nodi passivi, e salviamo il vettore di bit alla fine dei tre calcoli (non dopo ciascuno di essi). Assumiamo che ciascun calcolo (NPE, ULP e UIP) non sporchi il vettore di bits, ma lo riceva pulito, restituendolo pulito e aggiornato.
   LPE assume che i correnti nodi passivi siano stabili, cioe' non possano annettersi altri nodi: cio' e' automaticamente verificato eseguendo NPE almeno dopo un round ogni volta, e facendolo precedere i calcoli Inizio-Fine Foresta. I nodi passivi aggiunti da Fine Foresta solo sicuramente stabili (sono stati al loro posto per almeno un round), e anche quelli di Inizio Foresta otenuti dal confronto con il round precedente, mentre cio' non e' vero per quelli che possono essere aggiunti dal cammino piu' a SX
*/
void esegui_ricerca_nodi_passivi(unsigned long rounds_intermedi)
{
  unsigned long old_number_passivi;
  const float SOGLIA_STOP_NPE= 0.99f;//*****((unsigned long) (numero_nodi*0.70f)); //limite oltre il quale non viene fatto il calcolo NPE, perche' si ritiene che l'algoritmo sia gia' vicino alla conclusione
  const unsigned long SOGLIA_FRENO_NPE= ((unsigned long) (numero_nodi*0.35f)); //limite oltre il quale si tende a posticipare il calcolo NPE, perche' si ritiene che l'algoritmo sia gia' vicino alla conclusione e un'iterazione di NPE e' piuttosto costosa

  ripristina_nodi_passivi_se_necessario(); //dobbiamo sapere quelli che sono finora i nodi passivi  
  old_number_passivi= numero_passivi; //salviamo il vecchio numero di nodi passivi, prima di aggiungerne di nuovi con i calcoli che faremo

  rounds_da_ultimo_calcolo_passivi_NPE += rounds_intermedi;

    
  //N.B. il calcolo NPE assume che i nodi passivi siano _stabili_ , cioe' siano al loro posto gia' da un round almeno.
  if( (somma_perc_caricamento_archi / numero_caricamenti_archi_nel_round < SOGLIA_STOP_NPE)  &&
      (rounds_da_ultimo_calcolo_passivi_NPE >= rounds_da_attendere_x_prossimo_calcolo_passivi_NPE)
    )
  {
    rounds_da_ultimo_calcolo_passivi_NPE= 0;

    tag_1= clock();
    calcola_nodi_passivi_NPE();
    tag_2= clock();  tot_calcolo_passivi_NPE += tag_2 - tag_1;

//    if(numero_passivi >= SOGLIA_FRENO_NPE) //******
//      rounds_da_attendere_x_prossimo_calcolo_passivi_NPE += 1; //incrementiamo il numero corrente di rounds da attendere, perche' supponiamo che piu' andiamo avanti con la scoperta di nodi passivi e meno risulta vantaggioso usare NPE (per una questione di rapporto costi/benefici)
//    else
    rounds_da_attendere_x_prossimo_calcolo_passivi_NPE= 1; //***** sembra meglio farlo ogni round anziche' ogni 2

    #ifdef CHECK_PASSIVI
    controlla_passivi("Check nodi passivi subito dopo il loro calcolo NPE");
    #endif
  }

  
  //calcolo passivi nella parte Iniziale della foresta senza modifiche:
  tag_1= clock();
  calcola_nodi_passivi_Inizio_foresta();
  tag_2= clock();  tot_calcolo_passivi_InitialPart += tag_2 - tag_1;

  #ifdef CHECK_PASSIVI
  controlla_passivi("Check nodi passivi subito dopo il loro calcolo Initial Part");
  #endif

    
  //calcolo passivi nella parte Finale della foresta senza modifiche:
  tag_1= clock();
  calcola_nodi_passivi_Fine_foresta();
  tag_2= clock();  tot_calcolo_passivi_FinalPart += tag_2 - tag_1;

  #ifdef CHECK_PASSIVI
  controlla_passivi("Check nodi passivi subito dopo il loro calcolo Final Part");
  #endif

  
  //calcoliamo e salviamo i nodi di cui possiamo ignorare tutti i figli durante il caricamento degli archi:
  calcola_nodi_padri_da_escludere(); //(!) va chiamata prima di aggiornare il vettore di bits dei passivi su disco

  printf("\n>>> Percentuale di archi caricabile in memoria: %.1f%%  ;  stimata: %.1f%%\n\n", archi_caricabili_alla_volta >= numero_archi  ?  100.0f  :  100.0f * archi_caricabili_alla_volta/numero_archi, stima_percentuale_grafo_caricabile());  

//  statistiche_caricamento_archi(); //*****
    
  //salviamo su disco il vettore di bit aggiornato. Lo facciamo una volta per tutti e tre i calcoli. Questo perche' tanto assumiamo che nessun calcolo sporchi il vettore di bits.
  if(numero_passivi > old_number_passivi) //N.B. e' sempre numero_passivi >= old_number_passivi : se coincidono i due numeri allora devono coincere i due array, bit per bit; in tal caso e' inutile sovrascrivere su disco con gli stessi valori
  {
    bool ok= nodi_passivi->salvaSuFile(nome_file_bits_passivi_prec); //salviamo su disco il contenuto del vettore di bits dei nodi passivi
    accertati_che(ok, MSG_ERRORE_SALVA_BITS);
  }
}



//fa in modo di eseguire il calcolo dei nodi passivi a distanza di almeno un round (scansione M archi) l'uno dall'altro. Questo perche' Inizio Foresta e Fine Foresta richiedono di aspettare almeno un round prima di fare il confronto della foresta, mentre NPE vuole che i passivi siano stabili, cioe' si sono gia' annessi tutti i nodi che potevano annettersi
//'tot_archi_scanditi_finora' deve essere long long perche' diventa dopo qualche round un numero molto grande
void gestione_ricerca_nodi_passivi(unsigned long long tot_archi_scanditi_finora)
{
  unsigned long rounds_intermedi= (tot_archi_scanditi_finora - archi_scanditi_fino_a_ultimo_calcolo_passivi) / numero_archi;
  if(rounds_intermedi == 0) //il codice seguente va eseguito solo dopo la fine di ciascun round (scansione completa di M archi, cioe' un numero pari agli archi dell'intero grafo)
    return; //usciamo senza far niente: non e' stato ancora completato un round dall'ultima esecuzione del calcolo dei nodi passivi

  //se invece e' stato completato un round dall'ultima invocazione:
  esegui_ricerca_nodi_passivi(rounds_intermedi);

  //aggiornamento delle variabili:
  somma_perc_caricamento_archi= 0.0f;
  numero_caricamenti_archi_nel_round= 0;
  archi_scanditi_fino_a_ultimo_calcolo_passivi= tot_archi_scanditi_finora; //aggiorniamo la variabile che ci ricorda quando abbiamo fatto l'ultima volta il calcolo dei passivi    
}


