#ifndef NODI_PASSIVI_H
#define NODI_PASSIVI_H
#include <assert.h>

extern unsigned long numero_passivi;
extern bool is_dirty_vettore_bits;
extern unsigned long numero_padri_da_escludere;

extern unsigned long numero_caricamenti_archi_nel_round; //*****
extern float somma_perc_caricamento_archi; //*****

void init_modulo_nodi_passivi();
void print_statistiche_passivi();
void print_passivi();
void print_numero_passivi();
void controlla_passivi(const char * messaggio);
void ripristina_nodi_passivi_se_necessario();
void calcola_numero_preordine(unsigned long * mem_numeri_preordine, unsigned long size_memoria_pila, unsigned long * memoria_pila);
void ripristina_passivi_swappati();
void gestione_ricerca_nodi_passivi(unsigned long long tot_archi_scanditi_finora);

void salva_info_nodi_swappati(unsigned long * vettore_lavoro, unsigned long tot_nodi_da_swappare, multiFileWriter * mf_info_swap, const char * nome_mfile_info_swap);
bool next_padre_da_processare(unsigned long * nodo_src, unsigned long * num_figli_da_swappare, unsigned long * conta_elem_input_letti, unsigned long tot_nodi_da_rimuovere, unsigned long * vettore_input_padri);


//definizione funzioni inline con clausola "extern inline" per esportarle all'esterno:

//(!) N.B. non va usata con il "super root"
extern inline bool is_passivo(unsigned long nodo)
{
  long errore;

  bool risposta= nodi_passivi->get(nodo, errore);
  accertati_che( (errore==0), MSG_ERRORE_BITS);

  return risposta;
}

extern inline bool set_passivo(unsigned long nodo)
{
  long errore;
  bool risposta= nodi_passivi->set(nodo, true, errore);
  accertati_che( (errore==0), MSG_ERRORE_BITS);
  return risposta;
}

extern inline bool reset_passivo(unsigned long nodo)
{
  long errore;
  bool risposta= nodi_passivi->set(nodo, false, errore);
  accertati_che( (errore==0), MSG_ERRORE_BITS);
  return risposta;
}

#endif
