/*

  Ernesto Ricci
   7/4/2003

  
*/



#include <getopt.h>
#include "main.h"
#include <stdarg.h>
#include <stdlib.h>
#include <time.h>
#include "comuni.h"
#include "../common/scc_utl/VettoreBits.h"




//numero parti dei vari multifile di input:
long * num_parti_mfile_nodi_input= NULL;
long * num_parti_mfile_info_input= NULL;
char * * stringhe_nomi_mfile_nodi= NULL;
char * * nomi_mfile_info_input= NULL;
char * nome_mfile_info_output= NULL;




/*
void chiudi_tutto(int par) //intercetta la richiesta di chiudere forzatamante il programma da parte di assert() e libera la memoria uscendo ordinatamente
{
  printf("\n Deallocazione della memoria e preparazione all'uscita forzata\n");
  libera_memoria();
  ABORT();
} */



//scrive un messaggio ed esce dopo liberando le strutture di memoria impegnate
//per quanto riguarda i parametri usa la stessa sintassi di printf:  printf(const char *formato, ...)
void gestione_errore(const char *formato, ...)
{
  va_list ap;
  //stampiamo il messaggio d'errore ed usciamo:
  fprintf(stderr,"\n");
  va_start (ap, formato); //inizializziamo la struttura 'ap'
  vfprintf (stderr, formato, ap); //scriviamo il messaggio d'errore con tutti i parametri eventuali
  va_end (ap); //chiudiamo con la variabile 'ap'
  fprintf(stderr,"\n");
  perror("");

  libera_memoria();
  ABORT();
}


/*
void indiceProgressione(const char* testo)
{
  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

  printf("\r [%c] %s\r", cont, testo);
  fflush(stdout);
}


void indiceProgressione(const char* testo,long perc1,long perc2){

  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

  if (perc1<0) perc1=0;
  else if (perc1>100) perc1=100;

  if (perc2<0) perc2=0;
  else if (perc2>100) perc2=100;

  perc2=(long) (20.0*perc2/100);
  //indicatore
  char st[50];

  strcpy(st,"____________________");
  for (long i=0;(i<20)&&(i<perc2);i++ )
     st[i]='=';

  //limite a 30 la lunghezza del testo
  char s[55];
  long i=0;
  for (i=0; (testo[i]!=0)&&(i<40);i++)
    s[i]=testo[i];
  for (; (i<40);i++)
    s[i]=' ';
  s[40]=0;


	printf("\r [%c] %3ld%% %20s %s\r",cont,perc1,st, s);
  fflush(stdout);
}
*/



void eraseMultiFile(const char* nomeMulti){

    long conta=0;

    FILE* fp;
    char nomeFile[1000];

    while(true){
      sprintf(nomeFile,nomeMulti,conta);
      fp=fopen(nomeFile,"r");
      if (fp!=NULL){
          conta++;
          fclose(fp);
          remove(nomeFile);
      }
      else
          return;
    }
}



void libera_memoria()
{
  if(num_parti_mfile_info_input != NULL)
  {
    delete [] num_parti_mfile_info_input;
    num_parti_mfile_info_input= NULL;
  }

  if(num_parti_mfile_nodi_input != NULL)
  {
    delete [] num_parti_mfile_nodi_input;
    num_parti_mfile_nodi_input= NULL;
  }

  if(nomi_mfile_info_input != NULL)
  {
    delete [] nomi_mfile_info_input;
    nomi_mfile_info_input= NULL;
  }

  if(stringhe_nomi_mfile_nodi != NULL)
  {
    delete [] stringhe_nomi_mfile_nodi;
    stringhe_nomi_mfile_nodi= NULL;
  }
  
  if(nome_mfile_info_output != NULL)
  {
    delete [] nome_mfile_info_output;
    nome_mfile_info_output= NULL;
  }
}



//alloca una stringa, che va quindi deallocata quando non serve piu'
char * crea_nome_multifile_info(const char * nome_file_nodi)
{
  int lung_nome;
  char * stringa_creata;
  lung_nome= strlen(nome_file_nodi) + strlen(EXT_INFOALBERO);
  stringa_creata= new char[lung_nome + 1]; //un carattere in piu' per il NULL finale
  sprintf(stringa_creata, "%s%s", nome_file_nodi, EXT_INFOALBERO); //concateniamo il nome del file di output principale con un'estensione, ottenendo il nome del file con le info. sugli alberi

  return stringa_creata;
}



void concatena_nodi(char * * nomi_mfile_nodi_input, long numero_file_input, char * nome_mfile_nodi_output)
{
  eraseMultiFile(nome_mfile_nodi_output); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  multiFileWriter mf_scrittura_nodi(nome_mfile_nodi_output, 800*1024*1024);
  BufferScritturaMultifile<unsigned long> buffer_scrittura_nodi(&mf_scrittura_nodi, DIM_MEMORIA_BUFFER_SCRITTURA);

  for(long i=0; i<numero_file_input ; i++ )
  {
    multiFileReader mf_lettura_nodi(nomi_mfile_nodi_input[i], num_parti_mfile_nodi_input[i]);

    BufferLetturaMultifile<unsigned long> buffer_lettura_nodi(&mf_lettura_nodi, DIM_MEMORIA_BUFFER_LETTURA);

    unsigned long info;

    while( buffer_lettura_nodi.get(info) )
      buffer_scrittura_nodi.put(info);
    
    mf_lettura_nodi.close();
  }

      
  buffer_scrittura_nodi.chiudi();
  mf_scrittura_nodi.close();
}



void concatena_info(char * * nomi_mfile_info_input, long numero_file_input, char * nome_mfile_info_output)
{
  eraseMultiFile(nome_mfile_info_output); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  multiFileWriter mf_scrittura_info(nome_mfile_info_output, 800*1024*1024);
  BufferScritturaMultifile<struct InfoAlbero> buffer_scrittura_info(&mf_scrittura_info, DIM_MEMORIA_BUFFER_SCRITTURA);

  unsigned long numero_nodi_scritti= 0;
  
  for(long i=0; i<numero_file_input ; i++)
  {
    multiFileReader mf_lettura_info(nomi_mfile_info_input[i], num_parti_mfile_info_input[i]);

    BufferLetturaMultifile<struct InfoAlbero> buffer_lettura_nodi(&mf_lettura_info, DIM_MEMORIA_BUFFER_LETTURA);

    struct InfoAlbero info;

    while( buffer_lettura_nodi.get(info) )
    {
      info.punt= numero_nodi_scritti;
      buffer_scrittura_info.put(info);

      numero_nodi_scritti += info.num_nodi_albero;
    }
    
    mf_lettura_info.close();
  }


  buffer_scrittura_info.chiudi();
  mf_scrittura_info.close();
}



void stampaHelp(int arg,char** args){

  cout<<"This utility is not designed for stand alone use. It's used as a part of others utilities.\n";
  cout<<"\n";
  cout<<"This utility concatenate different sccs in adjacency list format\n";
  cout<<"Usage:\n";
  printf("%s {<neighbourNodesMultifile%%> <inputInfoSccMultifile%%>}... <fileOutputNodi%%>\n", args[0]);
  printf("<neighbourNodesMultifile%%>:  list of nodes of each Scc (neighbour file in infotree format)\n");
  printf("<inputInfoSccMultifile%%>:    pointer to nodes of each component (pointer file in infotree format)\n");  
  printf("<fileOutputNodi%%>:           output multifile in infoTree format\n");
  printf("\nOption:\n");
  printf("-c       clear input files after contatenation\n");         
  printf("%% implies that multifile name must include the char %%d\n");
}


//uscita dal programma per errore
#define ERRORE_PAR(STRINGA) {fprintf(stderr,"%s\n -help for the help\n",STRINGA);EXIT(1);}


int main(int argc,char* argv[])
{
    stampaLicenza(argc,argv);

//    signal(SIGABRT, chiudi_tutto); //permette di uscire ordinatamente in seguito ad una assert() fallita o ad altro errore
    
    struct option long_options[] =
    {
      {"clear", no_argument, NULL, 'c'},
      {0, 0, 0, 0}
    };

    /* getopt_long stores the option index here. */
    int option_index= 0;

    bool cancella_file_input= false;
    
    int car;

    do //esaminiamo le opzioni
    {
      car= getopt_long_only(argc, argv, "c", long_options, &option_index);

      switch(car)
      {
        case 'c': 
          cancella_file_input= true;
          break;
      
        case -1: //fine delle opzioni, ignoriamo il valore
          break;

        case '?': //parametro sconosciuto: lo ignoriamo, tanto il messaggio d'errore lo stampa getopt()
          EXIT(1);
          break;

        default:
          fprintf(stderr, "Unexcepted error in command line\n");
          EXIT(1);
      }

    } while(car != -1);

    if( argc - optind < 3 ) //contiamo quanti parametri che non sono opzioni restano: sono tutti i parametri dall'indice "optind" incluso in poi
      ERRORE_PAR("Invalid number of parameters.\n");

//    char * * stringhe_nomi_mfile_nodi= argv + optind;
    long num_file_input= (argc - optind - 1) / 2;
    if((argc - optind - 1) % 2)
      ERRORE_PAR("Invalid number of parameters.\n");
      
    char * nome_mfile_nodi_output= argv[optind + num_file_input*2];
//printf("nome_mfile_nodi_output=%s\n", nome_mfile_nodi_output);

    accertati_che( estMultiFileName(nome_mfile_nodi_output), "output multifile name <fileOutputNodi> must contains '%%d' ");

    nome_mfile_info_output= crea_nome_multifile_info(nome_mfile_nodi_output);

    stringhe_nomi_mfile_nodi= new char *[num_file_input];
    nomi_mfile_info_input= new char *[num_file_input];    
    num_parti_mfile_nodi_input= new long[num_file_input];
    num_parti_mfile_info_input= new long[num_file_input];
    
    for(long i=0; i<num_file_input; i++ )
    {
      stringhe_nomi_mfile_nodi[i]= argv[optind + 2*i];
      accertati_che( estMultiFileName(stringhe_nomi_mfile_nodi[i]), "input multifile name <fileInputNodi> %ld-th must contains '%%d' ", i);
      num_parti_mfile_nodi_input[i]= contaNumFilesMultiFile(stringhe_nomi_mfile_nodi[i]);
      accertati_che( (num_parti_mfile_nodi_input[i]>0), "Multifile %s not found", stringhe_nomi_mfile_nodi[i]);

//printf("stringhe_nomi_mfile_nodi=%s ;", stringhe_nomi_mfile_nodi[i]);
      nomi_mfile_info_input[i]= argv[optind + 2*i + 1];
      accertati_che( estMultiFileName(nomi_mfile_info_input[i]), "Input multifile <fileInputInfo> %ld-th must contains '%%d' ", i);
      num_parti_mfile_info_input[i]= contaNumFilesMultiFile(nomi_mfile_info_input[i]);
      accertati_che( (num_parti_mfile_info_input[i]>0), "Multifile %s not found", nomi_mfile_info_input[i]);
//printf("nomi_mfile_info_input=%s \n", nomi_mfile_info_input[i]);      
    }
    
    concatena_nodi(stringhe_nomi_mfile_nodi, num_file_input, nome_mfile_nodi_output);

    concatena_info(nomi_mfile_info_input, num_file_input, nome_mfile_info_output);
        
    if(cancella_file_input)
      for(long i=0; i<num_file_input; i++ )
      {
        eraseMultiFile(stringhe_nomi_mfile_nodi[i]);
        eraseMultiFile(nomi_mfile_info_input[i]);
      }

    //printf("\n done.\n");
    libera_memoria(); //va liberata solo alla fine perche' ci sono gli array con i nomi

    EXIT(0);
}

