#ifndef MAIN_H
#define MAIN_H

#include <stdio.h>
#include "comuni.h"
#include "../common/scc_utl/BufferLetturaMultifile.h"
#include "../common/scc_utl/BufferScritturaMultifile.h"
#include "../common/scc_utl/BufferAppoggio.h"
#include "../common/scc_utl/SwappedStack.h"



//definizione costanti:
#define DIM_MEMORIA_BUFFER_LETTURA 1024*1024
#define DIM_MEMORIA_BUFFER_SCRITTURA 1024*1024
#define INTERVALLO_REFRESH_INDICATORE 500000


const unsigned long MAX_ULONG= (unsigned long)((long)-1);

const char EXT_INFOALBERO[]=".infotree"; //estensione da aggiungere al file di output con le informazioni sugli alberi DFS, rispetto al file di output principale
const char MSG_ERRORE_PILA[]= "read error in the stack";
const char MSG_ERRORE_BITS[]= "error in bit vector";
const char MSG_ERRORE_SEEK[]= "seek error in the multifile %s";
const char MSG_ERR_NODO_OUTOFRANGE[]= "Node %lu out of range:";
const char MSG_ERRORE_LETTURA_MULTIFILE[]= "read error in the multifile %s";
const char MSG_DONE[]= "";

struct  grafoInfo{
  long inDeg;
  long outDeg;
  long long puntIn;
  long long puntOut;
};


struct InfoAlbero { //informazioni relative a ciascun albero DFS visitato, da salvare nel file .infotree dell'output
  long num_nodi_albero; //dimensione dell'albero
  long punt; //indice del primo nodo dell'albero nel file di output principale
};



//definizione della macro per verificare se ci sono errori. Il primo parametro e' la condizione da verificare e che deve risultare vera, il 2o, 3o, ecc. sono passati a printf per stampare i vari messaggi
#define accertati_che(a, resto...)  if(!(a)) {  gestione_errore( resto ); }




void libera_memoria();

#endif
