/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file arcOrdDest2succ.cc :source code of edges32sortbyprednode2succ utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <sys/stat.h>
#include "config.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <wait.h>
#include <unistd.h>
#include "comuni.h"



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
long getFileSizeMultiFile(char* nome,long indice){

  char nomeFile[2000];
  struct stat buf;

  sprintf(nomeFile,nome,indice);
  stat(nomeFile, &buf);
  return buf.st_size;//size del file
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//  stampa i parametri d'uso
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaHelp(int arg,char* argv[]){

  
    cout<<"This utility is not designed for stand alone use. It's used as a part of others utilities.\n";
    cout<<"\n";
		cout<< "This utility converts an 'extended' .edges format multifile (edges sorted by source node) in the .succ format\n";
		cout<< "\n";
		cout<< "Usage: "<<eliminaPath(argv[0])<<" memory -savesource|-deletesource nameInputMultifile%d nameOutputMultifile%d\n";
		cout<< "\n";
		cout<< "memory                     memory available(MB)\n";
		cout<< "-savesource|-deletesource  specify whether to delete or keep the input file\n";
		cout<< "nameInputMultifile%d       name of the multifile of the input graph ('extended' .edges format)\n";
		cout<< "nameOutputMultifile%d      name of the output multifile (.succ format)\n";
}




//#define MAX_NUM_SUCCESSORI (200000)

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void creaFileSucc(char* grafoArchiSorgente, long numSorgente, char* grafoOut ,bool cancella){

  //classe per la gestione di un buffer temporaneo...
  char tmpNome[1000];  
  strcpy(tmpNome,grafoOut);strcat(tmpNome,".tempo");
  externalBuffer buffer=externalBuffer(tmpNome,10);
  
  long long numArchiTotali=0;

  /*controlla che la size dei files sia uguale (escluso l'ultimo che puo' essere inferiore)*/
  for (int j=0;j<numSorgente;j++){
  	    numArchiTotali+=getFileSizeMultiFile(grafoArchiSorgente,j);
  }

  numArchiTotali=numArchiTotali/sizeof(arco);
  if (numArchiTotali<=0) numArchiTotali=1;


  // buffer per l'accesso ai files in scrittura...
  //long * buf = new long [MAX_NUM_SUCCESSORI];

  arco arcoSorg;//primo arco ordinato per sorgente     (tutti i successori vicini  )

  // nomi dei files grafo
  char nomeGrafoSucc[1000];strcpy(nomeGrafoSucc,grafoOut);

  //apertura del file grafo output SUCC
  bufferedThreadFileOutputStream fGrafoSUCC=bufferedThreadFileOutputStream(nomeGrafoSucc,MAX_DIM_FILES,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE);

  //  FILE ORDINATO PER SORGENTI     (x trovare i successori)
  bufferedThreadFileInputStream  fArchi=bufferedThreadFileInputStream(grafoArchiSorgente,numSorgente,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE ,cancella);

  //contiene il num del nodo corrente
  long nodoCorrente=0;
  long numSuccNodoCorrente=0;
  long long numArchiLetti=0;
  cout<<"Running conversion:\n";fflush(stdout);
  long numNodiDichiarati=0;

  //scrive solo i nodo con num successori >0 eccetto l'ultimo che viene cmq scritto

  //leggo tutti gli archi
  while ( fArchi.read(&arcoSorg,sizeof(arco),1 )>0    ){

     //controlla se sta dichiarando il num di nodi totali (arco con entrambi i nodi negativi e uguali) - tag esteso
     if (arcoSorg.source<0 || arcoSorg.dest<0 ){
       if (arcoSorg.dest==arcoSorg.source && numNodiDichiarati<-arcoSorg.dest)
            numNodiDichiarati=-arcoSorg.dest;
       else{
          cout<<"Error format in input multiFile.";
          FINE;
          }
          
       continue;
     }
     numArchiLetti++;


     if (nodoCorrente==arcoSorg.source){
         //buf[numSuccNodoCorrente]=arcoSorg.dest;
         buffer.memorizzaValore(arcoSorg.dest);
         
         numSuccNodoCorrente++;
         //if (numSuccNodoCorrente >=MAX_NUM_SUCCESSORI){cout<<"Numero di successori del nodo "<<nodoCorrente<<" eccessivi\n";FINE;}
     }
     else{
       
         if (numSuccNodoCorrente>0){
             fGrafoSUCC.write(&nodoCorrente,sizeof(long),1);
             fGrafoSUCC.write(&numSuccNodoCorrente,sizeof(long),1);

             //fGrafoSUCC.write(buf,sizeof(long),numSuccNodoCorrente);
             buffer.svuotaBufferSuFileAndSvuota(fGrafoSUCC);
         }
         
         numSuccNodoCorrente=0;
         nodoCorrente=arcoSorg.source;

         //buf[numSuccNodoCorrente]=arcoSorg.dest;
         buffer.memorizzaValore(arcoSorg.dest);
         
         numSuccNodoCorrente++;
     }

     if ( (numArchiLetti==1) || (numArchiLetti%1000000==0)){
        printf("%c [%6.2f%s] edges --> succ [%lld edges]%c",13,100.0*numArchiLetti/numArchiTotali,"%",numArchiLetti,13);
        fflush(stdout);
     }     
  }


  //scrive l'ultimo nodo o se == numNodiDichiarati-1 oppure se ha successori
  if (numSuccNodoCorrente>0 || numSuccNodoCorrente==numNodiDichiarati-1){
      fGrafoSUCC.write(&nodoCorrente,sizeof(long),1);
      fGrafoSUCC.write(&numSuccNodoCorrente,sizeof(long),1);

      //fGrafoSUCC.write(buf,sizeof(long),numSuccNodoCorrente);
      buffer.svuotaBufferSuFileAndSvuota(fGrafoSUCC);
  }


  //controlla che l'ultimo nodo del grafo sia cmq stato scritto.... se no lo scrive nuovamente  
  if (nodoCorrente<numNodiDichiarati-1){
      nodoCorrente=numNodiDichiarati-1;
      numSuccNodoCorrente=0;

      fGrafoSUCC.write(&nodoCorrente,sizeof(long),1);
      fGrafoSUCC.write(&numSuccNodoCorrente,sizeof(long),1);
  }



  printf("%c [%6.2f%s] edges --> succ [%lld edges converted]%c",13,100.0,"%",numArchiLetti,13);
  cout<<"\n";

  if (numNodiDichiarati>0){
    cout<<"Declared nodes = "<<numNodiDichiarati<<"\n";
  }

  fflush(stdout);

  //chiusura files
  //printf("Creati %ld files di output\n",fGrafoSUCC.close());
  fArchi.close();
  fGrafoSUCC.close();

  //cancellazione buffer
  //delete[] buf;
  buffer.cancella();

}





int main(int arg,char** argv)
{
  stampaLicenza(arg,argv);

  if (arg!=5) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

    long cancellaSource;
    if (strcasecmp(argv[1+1],"-saveSource")==0)  cancellaSource=FALSE;
    else    if (strcasecmp(argv[1+1],"-deleteSource")==0)  cancellaSource=TRUE;
            else  STAMPA_ERRORE_PARAMETRI(argv[0],"options -deleteSource and -saveSource not found");


    long numSorgente=contaNumFilesMultiFile(argv[2+1]);//atol(argv[3]);
    char* grafoArchiSorgente=argv[2+1];


    if (numSorgente<=0)   	      STAMPA_ERRORE_PARAMETRI(argv[0],"Error in input files number (order by SOURCE NODE): not valid");
    if (!estMultiFileName(argv[2+1]))  STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile filename (order by SOURCE NODE) must contain the substring '%d'");
    if (!estMultiFileName(argv[3+1]))  STAMPA_ERRORE_PARAMETRI(argv[0],"Output multifile  filename must contain the substring '%d' ");

    //************************ CONTROLLO FILES DI INPUT ***************************
    if (getTotalSizeMultiFiles(grafoArchiSorgente)<=0){cout<<"The input graph is empty or input filenames not valid\n";FINE};

    creaFileSucc( grafoArchiSorgente, numSorgente, argv[3+1],cancellaSource );

    EXIT(0);
    return 0;
}



