/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file grafoPredSucc.cc :source code of edges32sortbypredsucc2infopredsucc utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "config.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <wait.h>
#include <unistd.h>
#include "comuni.h"





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaMbyteCorrentiArchi(long long nodoCorrente ,long long byteInfo,long long bytePred,long long byteSucc){
  /*======================== STAMPA MESSAGGI ===================================================================*/
//  cout<<(char)13<<""<<nodoCorrente<<" nodes | INFO size = "<<byteInfo/1048576<<"MB PRED size files <info,pred,succ> ["<<
//  		<<","<<bytePred/1048576<<","<<byteSucc/1048576<<" MB]";
  printf("%c|%14lld |%14lld |%14lld |%14lld |",13,nodoCorrente,byteInfo/1048576,bytePred/1048576,byteSucc/1048576);
  fflush(stdout);
  /*============================================================================================================*/
}

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaMbyteCorrentiArchi(){
  /*======================== STAMPA MESSAGGI ===================================================================*/
  printf("+---------------+---------------+---------------+---------------+\n");
  printf("|  Number of    | INFO multifile| PRED multifile| SUCC multifile|\n");
  printf("|    nodes      |   size (MB)   |  size (MB)    |   size (MB)   |\n");
  printf("+---------------+---------------+---------------+---------------+\n");
  fflush(stdout);
  /*============================================================================================================*/
}



/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//  stampa i parametri d'uso
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void stampaHelp(int arg,char* argv[]){

    cout<<"This utility is not designed for stand alone use. It's used as a part of others utilities.\n";
    cout<<"\n";
		cout<< "This utility converts a couple edges format multifiles (sort by source node and destination node rispectively) in the ips format\n";
		cout<< " \n";
		cout<< "Usage: "<<eliminaPath(argv[0])<<" -savesource|-deletesource nameInputMultifile%d nameOutputMultifile%d\n";
		cout<< " \n";
		cout<< "-savesource|-deletesource  specify whether to delete or keep the input file\n";
		cout<< "nameInputMultifileSource%d  name of the multifile of the input graph ('extended' edge format sort by source node)\n";
		cout<< "nameInputMultifileDest%d    name of the multifile of the input graph ('extended' edge format sort by destination node)\n";
		cout<< "nameOutputMultifile%d       name of the output multifile (ips format)\n";
}





/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void creaFilePredSucc(char* grafoArchiSorgente, long numSorgente, char* grafoArchiDestinazione, long numDestinazione,char* grafoOut ,bool cancella){

  // buffer per l'accesso ai files in scrittura...
  long * buf = new long [NUM_ELEMENTI_BUFFER];

  arco primoArcoSorg;//primo arco ordinato per sorgente     (tutti i successori vicini  )
  arco primoArcoDest;//primo arco ordinato per destinazione (tutti i predecessori vicini)

  // nomi dei files grafo
  char nomeGrafoSucc[1000];strcpy(nomeGrafoSucc,grafoOut);strcat(nomeGrafoSucc,".succ");
  char nomeGrafoPred[1000];strcpy(nomeGrafoPred,grafoOut);strcat(nomeGrafoPred,".pred");
  char nomeGrafoInfo[1000];strcpy(nomeGrafoInfo,grafoOut);strcat(nomeGrafoInfo,".info");

  //apertura del file grafo output INFO/PRED/SUCC
  bufferedThreadFileOutputStream fGrafoINFO=bufferedThreadFileOutputStream(nomeGrafoInfo,MAX_DIM_FILES,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE);
  bufferedThreadFileOutputStream fGrafoPRED=bufferedThreadFileOutputStream(nomeGrafoPred,MAX_DIM_FILES,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE);
  bufferedThreadFileOutputStream fGrafoSUCC=bufferedThreadFileOutputStream(nomeGrafoSucc,MAX_DIM_FILES,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE);

  //apertura del file grafo ordinato sia per predecessori che successori

  //  FILE ORDINATO PER SORGENTI     (x trovare i successori)
  bufferedThreadFileInputStream  fGrafoSorg=bufferedThreadFileInputStream(grafoArchiSorgente,numSorgente,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE ,cancella);
  //  FILE ORDINATO PER DESTINAZIONI (x trovare i predecessori)
  bufferedThreadFileInputStream  fGrafoDest=bufferedThreadFileInputStream(grafoArchiDestinazione,numDestinazione,DIM_BUFFER_THREAD_FILE, NUM_BUFFER_THREAD_FILE ,cancella);

  //cantiene il num del nodo corrente
  long nodoCorrente=0;

  long finitiOrdSorg=false;
  long finitiOrdDest=false;

  long long puntPred=0;
  long long puntSucc=0;
  long numNodiDichiarati=-1;

  //leggo i primi archi dei due files eliminando da subito le dichiarazioni del num di nodi
  int n;
  while (  (n=fGrafoSorg.read(&primoArcoSorg,sizeof(arco),1))>0 ){
    if (primoArcoSorg.source<0 || primoArcoSorg.dest<0){
       //controlla che sia valido come dichiarazione (entrambi negativi e uguali)
       if (primoArcoSorg.dest==primoArcoSorg.source ){
         if ( numNodiDichiarati<-primoArcoSorg.dest) numNodiDichiarati=-primoArcoSorg.dest;
       }
       else {cout<<"Format error in source sorted edges file";FINE;}

    }
    else
       break;    
  }  
  if (n==0) finitiOrdSorg=true;
  else if (n<0){cout<<"Reading error in source node order file/s";FINE;}

  
  while (  ( n=fGrafoDest.read(&primoArcoDest,sizeof(arco),1) )>0 ){
    if (primoArcoDest.source<0 || primoArcoDest.dest<0){
       //controlla che sia valido come dichiarazione (entrambi negativi e uguali)
       if (primoArcoDest.dest==primoArcoDest.source ){
         if ( numNodiDichiarati<-primoArcoDest.dest) numNodiDichiarati=-primoArcoDest.dest;
       }
       else {cout<<"Format error in destination sorted edges file";FINE;}
    }
    else break;
  }
  if (n==0)  finitiOrdDest=true;
  else if (n<0){cout<<"Reading error in target node order file/s";FINE;}

  
  long long iterazioni=MAX_ITER;
  long long duplicazioniPred=0;
  long long duplicazioniSucc=0;

  cout<<"Data and format conversion: edges --> pred/succ/info:\n";fflush(stdout);
  stampaMbyteCorrentiArchi();

  while (!finitiOrdSorg || !finitiOrdDest){

    //nuovo nodo
    infoNodo nuovo;
    nuovo.inDeg   = 0;
    nuovo.outDeg  = 0;
    nuovo.puntIn  = puntPred;
    nuovo.puntOut = puntSucc;


    // ------------------------------------------------------------------------------------------------------------------------
    // -------------  SUCCESSORI  ----------------------  SUCCESSORI  ----------------------  SUCCESSORI ----------------------
    // ------------------------------------------------------------------------------------------------------------------------

    //punt alla prima pos libera e corrisponde anche al num di elementi occupati
    long puntLiberoBufferOut=0;
    //precedente successore
    long precedente=-1;

    //trovo i successori - e' una arco del tipo  ( nodoCorrente --> altro_nodo )
    while (!finitiOrdSorg && primoArcoSorg.source == nodoCorrente){      
    
      if (precedente!=primoArcoSorg.dest){
        //controlla che il file di input sia tc i successori siano ordinati per destinazione
          if (precedente>primoArcoSorg.dest){
        	cout<<"The successors of the node "<<nodoCorrente<<" (file order by target) not in increase order.\n"
        	    <<"  current edge :"<<nodoCorrente<<" --> "<<primoArcoDest.source<<"\n"
        	    <<"  previous edge: "<<nodoCorrente<<" --> "<<precedente<<"\n";
        	FINE;
          }
          precedente=primoArcoSorg.dest;

          //aggiunge il nuovo successore e lo aggiunge al buffer per la scrittura
          nuovo.outDeg++;
          buf[puntLiberoBufferOut++]=primoArcoSorg.dest;

          //se buffer pieno, lo scrive su file e lo svuota
          if (puntLiberoBufferOut==NUM_ELEMENTI_BUFFER){
             if (fGrafoSUCC.write(buf,sizeof(long),puntLiberoBufferOut)<puntLiberoBufferOut){cout<<"Errore nella scrittura dei successori del nodo "<<nodoCorrente;FINE;}
             puntLiberoBufferOut=0; //ora il buffer e' vuoto
          }

      }else{
         duplicazioniSucc++;
      }

      //leggo il prossimo arco x vedere un altro successore
      n=fGrafoSorg.read(&primoArcoSorg,sizeof(arco),1);
      if (primoArcoSorg.source<0 || primoArcoSorg.dest <0){cout<<"Format error in source sorted edges file";FINE;}
      
      if (n==0) finitiOrdSorg=true;
      else if (n<0){cout<<"Reading error in source sorted edges file";FINE;}

    }

    //se il buffer contiene ancora qualcosa, lo scrivo su file
    if (puntLiberoBufferOut>0){
             if (fGrafoSUCC.write(buf,sizeof(long),puntLiberoBufferOut)<puntLiberoBufferOut){cout<<"Writing error for successors of node "<<nodoCorrente;FINE;}
             puntLiberoBufferOut=0; //ora il buffer e' vuoto
    }

    //controlla che i nodi siano ordinati per sorgente nel primo file, cioe' il nodo successivo  deve essere > di quello corrente
    if (!finitiOrdSorg && primoArcoSorg.source<nodoCorrente){cout<<"Incorrect order in source order file/s";FINE;}

    //aggiorna il puntatore alla successiva lista di successori

    puntSucc+=nuovo.outDeg;
 		 		



 		
 		
    // ------------------------------------------------------------------------------------------------------------------------
    // -------------  PREDECESSORI  ----------------------  PREDECESSORI  ----------------------  PREDECESSORI ----------------
    // ------------------------------------------------------------------------------------------------------------------------

    //punt alla prima pos libera e corrisponde anche al num di elementi occupati
    puntLiberoBufferOut=0;

    //precedente predecessore considerato
    precedente=-1;

    //trovo i predecessori - archi del tipo   		( altro_nodo --> nodoCorrente )
    while (!finitiOrdDest && primoArcoDest.dest == nodoCorrente){
      if (precedente!=primoArcoDest.source){
          //controlla che il file di input sia tc i successori siano ordinati per destinazione
          if (precedente>=primoArcoDest.source){
          	cout<<"The successors of node "<<nodoCorrente<<" (file order by target) not in increase order.\n"
          	    <<"  current edge:"<<primoArcoDest.source<<" --> "<<nodoCorrente<<"\n"
          	    <<"  last edge: "<<precedente<<" --> "<<nodoCorrente<<"\n";
        	FINE;
          }
        				
          precedente=primoArcoDest.source;

          //aggiunge il nuovo successore e lo aggiunge al buffer per la scrittura
          nuovo.inDeg++;
          buf[puntLiberoBufferOut++]=primoArcoDest.source;

          //se buffer pieno, lo scrive su file e lo svuota
          if (puntLiberoBufferOut==NUM_ELEMENTI_BUFFER){
               if (fGrafoPRED.write(buf,sizeof(long),puntLiberoBufferOut)<puntLiberoBufferOut){cout<<"Errore nella scrittura dei predecessori del nodo "<<nodoCorrente;FINE;}
               puntLiberoBufferOut=0; //ora il buffer e' vuoto
          }

      }else{
         duplicazioniPred++;
      }

      //leggo il prossimo arco
      n=fGrafoDest.read(&primoArcoDest,sizeof(arco),1);
      if (primoArcoDest.source<0 || primoArcoDest.dest <0){cout<<"Format error in destination sorted edges file";FINE;}

      if (n==0)  finitiOrdDest=true;
      else if (n<0){cout<<"Reading error in target order file/s";FINE;}
    }

    //se il buffer contiene ancora qualcosa, lo scrivo su file
    if (puntLiberoBufferOut>0){
             if (fGrafoPRED.write(buf,sizeof(long),puntLiberoBufferOut)<puntLiberoBufferOut){cout<<"Writing error for predecessor of node "<<nodoCorrente;FINE;}
             puntLiberoBufferOut=0; //ora il buffer e' vuoto
    }

    //controlla che i nodi siano ordinati per sorgente nel primo file
    if (!finitiOrdDest && primoArcoDest.dest<nodoCorrente){
        cout<<"Incorrect order in source order file/s";FINE;
    }

    //aggiorna il puntatore alla successiva lista di successori
    puntPred+=nuovo.inDeg;




    //________________________________________________________________________________________________________________________
    //
    //                                                   scrive nel file il campo info
    //________________________________________________________________________________________________________________________
    if (fGrafoINFO.write(&nuovo,sizeof(infoNodo),1)<1){cout<<"Writing error for link to node "<<nodoCorrente; FINE;}



    if (iterazioni++>MAX_ITER){
          iterazioni=0;
          stampaMbyteCorrentiArchi(nodoCorrente ,nodoCorrente*sizeof(infoNodo),puntPred*sizeof(long),puntSucc*sizeof(long));
    }

    //nodoSuccessivo
    nodoCorrente++;
  }


  stampaMbyteCorrentiArchi(nodoCorrente ,nodoCorrente*sizeof(infoNodo),puntPred*sizeof(long),puntSucc*sizeof(long));
  printf("\n+---------------+---------------+---------------+---------------+\n");
  cout<<"\n";

  if (duplicazioniPred!=duplicazioniSucc){
      cout<<"Error: different numbers of duplicated edges between pred and succ file (pred="<<duplicazioniPred<<", succ="<<duplicazioniSucc<<"\n";FINE;}

  if (duplicazioniPred>0) cout<<"Found "<<duplicazioniPred<<" duplicated edges\n\n";


  //a questo punto nodoCorrente tiene il num di nodi inseriti
  long addedIsolatedNodes=0;
  while (nodoCorrente<numNodiDichiarati){
    infoNodo aux;
    aux.inDeg=0;
    aux.outDeg=0;
    aux.puntIn=0;
    aux.puntOut=0;
    if (fGrafoINFO.write(&aux,sizeof(aux),1)<1){cout<<"Writing error for link to node "<<nodoCorrente; FINE;}
    nodoCorrente++;
    addedIsolatedNodes++;
  }

  if (numNodiDichiarati>=0){
    cout<<"Declared nodes ......... "<<numNodiDichiarati<<"\n";
    cout<<"Added isolated nodes ... "<<addedIsolatedNodes<<"\n";    
  }


  //chiusura files
  //long numFilesInfo=fGrafoINFO.close();
  fGrafoINFO.close();

  //long numFilesSucc=fGrafoSUCC.close();
  fGrafoSUCC.close();

  //long numFilesPred=fGrafoPRED.close();
  fGrafoPRED.close();

  fGrafoSorg.close();fGrafoSorg.cancella();
  fGrafoDest.close();fGrafoDest.cancella();

  //cancellazione buffer
  delete[] buf;

  if (puntSucc!=puntPred){
    cout<<"Unexpected fatal error: Predecessors number != successors number :pred = "<<puntPred<<" - succ = "<<puntSucc;
    FINE;
  }


  //long numNodiTotali=nodoCorrente;
  //long long numArchi=puntSucc;

}



int main(int arg,char** argv)
{

    stampaLicenza(arg,argv);
    if (arg!=5) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
	
    long cancellaSource;
    if (strcasecmp(argv[1],"-saveSource")==0)  cancellaSource=FALSE;
    else    if (strcasecmp(argv[1],"-deleteSource")==0)  cancellaSource=TRUE;
            else  STAMPA_ERRORE_PARAMETRI(argv[0],"options -deleteSource and -saveSource not found");


    long numSorgente=contaNumFilesMultiFile(argv[2]);//atol(argv[3]);
    long numDestinazione=contaNumFilesMultiFile(argv[3]);//atol(argv[5]);
    char* grafoArchiSorgente=argv[2];
    char* grafoArchiDestinazione=argv[3];

    //************************ CONTROLLO FILES DI INPUT ***************************
    if (getTotalSizeMultiFiles(grafoArchiSorgente)<=0){cout<<"Input graph is empty\n";FINE};
    if (getTotalSizeMultiFiles(grafoArchiDestinazione)<=0){cout<<"Input graph is empty\n";FINE};

    if (numSorgente<=0)       STAMPA_ERRORE_PARAMETRI(argv[0],"Input graph is empty");
    if (numDestinazione<=0)   STAMPA_ERRORE_PARAMETRI(argv[0],"Input graph is empty");

    if (!estMultiFileName(argv[2])) STAMPA_ERRORE_PARAMETRI(argv[0],"Input filename must contain the substring '%d' ");
    if (!estMultiFileName(argv[3])) STAMPA_ERRORE_PARAMETRI(argv[0],"Input filename must contain the substring '%d' ");

    creaFilePredSucc( grafoArchiSorgente, numSorgente, grafoArchiDestinazione, numDestinazione,argv[4],cancellaSource );

    EXIT(0);
    return 0;
}



