#ifndef MAIN_H
#define MAIN_H

#include <stdio.h>
#include "comuni.h"
#include "../common/scc_utl/BufferLetturaMultifile.h"
#include "../common/scc_utl/BufferScritturaMultifile.h"
#include "../common/scc_utl/BufferAppoggio.h"
#include "../common/scc_utl/SwappedStack.h"


//#define NDEBUG //flag usato anche da assert, se definito indica che non stiamo sviluppando e non serve il controllo per il debugging

//flags per il debugging:
#ifndef NDEBUG
//flag per il debug:
//#define TEST_SEMIEXT //forza l'uso del metodo semi-external
#endif



//definizione costanti:
#define DIM_MINIMA_MEM_BUFFERS 6*1024*1024
#define INTERVALLO_REFRESH_INDICATORE ((unsigned long) (0.10f*numero_nodi)) //percentuale di nodi da processare prima di aggiornare la progress bar (usato nelle operazioni che scandiscono sequenzialmente tutti i nodi del grafo)
const float PERC_MIN_RAPPRESENTANTI= 0.005f; //rapporto minimo tra # di rappresentanti (i.e. elementi del vettore di lookup) e numero di nodi del grafo di partenza. Piu' scende questo rapporto, piu' le prestazioni peggiorano (relativamente alla conversione degli identificatori dei nodi selezionati per il sottografo).

const unsigned long MAX_ULONG= (unsigned long)((long)-1);

const char EXT_INFOALBERO[]=".infotree"; //estensione da aggiungere al file di output con le informazioni sugli alberi DFS, rispetto al file di output principale
const char MSG_ERRORE_PILA[]= "Impossibile leggere dalla pila";
const char MSG_ERRORE_BITS[]= "Errore nell'accedere al vettore di bit";
const char MSG_ERRORE_SEEK[]= "Errore nell'effettuare la seek sul multifile %s";
const char MSG_ERR_NODO_OUTOFRANGE[]= "Nodo fuori range:\n nodo=%lu";
const char MSG_ERRORE_LETTURA_MULTIFILE[]= "Impossibile leggere dal multifile %s";
const char MSG_DONE[]= "fatto.\n\n";

struct  grafoInfo{
  long inDeg;
  long outDeg;
  long long puntIn;
  long long puntOut;
};


struct InfoAlbero { //informazioni relative a ciascun albero DFS visitato, da salvare nel file .infotree dell'output
  long num_nodi_albero; //dimensione dell'albero
  long punt; //indice del primo nodo dell'albero nel file di output principale
};




//definizione della macro per verificare se ci sono errori. Il primo parametro e' la condizione da verificare e che deve risultare vera, il 2o, 3o, ecc. sono passati a printf per stampare i vari messaggi
#define accertati_che(a, resto...)  \
  if(!(a))                               \
  {  gestione_errore( resto ); }




void libera_memoria();
void gestione_errore(const char *formato, ...);
void indiceProgressione(const char* testo);
void indiceProgressione(const char* testo,long perc1,long perc2);
void eraseMultiFile(const char* nomeMulti);
char * crea_nome_multifile_grafo(const char * estensione);
void estrai_sottografo();



extern unsigned long numero_nodi; //numero nodi del grafo
extern unsigned long numero_archi; //numero archi del grafo
extern char grafoINFO[1000];
extern char grafoPRED[1000];
extern char grafoSUCC[1000];
extern char * nome_mfile_nodi_input;
extern bool nodi_input_come_bits;
extern bool escludi_nodi_specificati;
extern long numINFO;
extern long numPRED;
extern long numSUCC;
extern long numPartiNodiInput;
extern unsigned long memoria_per_buffers;
extern unsigned long * vettore_Id_nodi;
extern unsigned long numero_nodi_selezionati;


#endif
