/*
   questa parte l'ho fatta il 1/8/2003
*/

#include "../common/scc_utl/VettoreBits.h"
#include "semi_ext.h"
#include "main.h"

VettoreBits * nodi_da_includere= NULL;
unsigned long capienza_vettore_lookup; //indica quanti nodi sono mappati direttamente nel vettore di conversione. Informazione significativa solo nell'approccio semiexternal.
unsigned long nodi_per_rappresentante; //rapporto tra il numero nodi del grafo di partenza e la capienza del vettore di lookup. C'e' poi la correzione in caso di resto, in modo che ad ogni nodo del grafo corrisponda effettivamente un nodo del vettore di lookup.




//passiamo da un nome di multifile ad un nome di file (il primo file, 0, del multifile, assumendo che sia un unico file)
//la stringa creata va poi esplicitamente deallocata
char * crea_nome_file_da_nome_multifile(const char * nome_multifile)
{
  int lung_nome;
  char * stringa_creata;
  lung_nome= strlen(nome_multifile) + 1; //un carattere in piu' per il NULL finale
  stringa_creata= new char[lung_nome];
  snprintf(stringa_creata, lung_nome, nome_multifile, 0);

  return stringa_creata;
}



//inizializza il vettore di bits in memoria leggendo il file contenente gia' un vettore di bits.
//inverte il vettore dopo il caricamento se c'e' l'opzione che dice di escludere i nodi specificati da file.
void carica_vettore_bits_da_file_bits()
{
  accertati_che(numPartiNodiInput==1, "Errore: assumiamo che il multifile di input con il vettore dei nodi da includere/escludere sia composto da un unico file");

  char * nome_file_bits= crea_nome_file_da_nome_multifile(nome_mfile_nodi_input); //poiche' VettoreBits usa dei normali file per l'I/O

  bool ok= nodi_da_includere->caricaDaFile(nome_file_bits); //ripristiniamo il vettore di bits dei nodi passivi dal disco. Serve perche' la selezione degli archi evita di caricare quelli diretti verso nodi passivi
  accertati_che( ok, MSG_ERRORE_LETTURA_MULTIFILE, nome_mfile_nodi_input);

  if(escludi_nodi_specificati) //i bit sono da intendersi invertiti
    nodi_da_includere->NOT( *nodi_da_includere );

  delete [] nome_file_bits;
}



void carica_vettore_bits_da_lista_nodi()
{
  printf("Loading nodes to be left in the graph"); fflush(stdout);
  unsigned long nodo;

  multiFileReader mf_nodi_sel(nome_mfile_nodi_input, numPartiNodiInput);
  BufferLetturaMultifile<unsigned long> buffer_nodi_sel(&mf_nodi_sel, memoria_per_buffers);

  bool ris= buffer_nodi_sel.get(nodo);
  accertati_che( (ris), MSG_ERRORE_LETTURA_MULTIFILE, nome_mfile_nodi_input);

  if(escludi_nodi_specificati)
  {
    nodi_da_includere->reset(true); //tutto a 1 per default
    while( ris )
    {
      accertati_che( (nodo < numero_nodi), "Letto un nodo fuori range dal file con i nodi da selezionare: %lu", nodo);
      long errore;
      nodi_da_includere->set(nodo, false, errore); //resetta (a false)
      accertati_che( (errore==0), MSG_ERRORE_BITS);
      
      ris= buffer_nodi_sel.get(nodo);
    }
  }
  else //i nodi indicati vanno inclusi
  {
    nodi_da_includere->reset(false); //azzera tutto
    while( ris )
    {
      accertati_che( (nodo < numero_nodi), "Letto un nodo fuori range dal file con i nodi da selezionare: %lu", nodo);
      long errore;
      nodi_da_includere->set(nodo, true, errore); //setta (a true)
      accertati_che( (errore==0), MSG_ERRORE_BITS);
      
      ris= buffer_nodi_sel.get(nodo);
    }
  }

  
  mf_nodi_sel.close();

  //printf("fatto.\n");
}



//sono gestiti da due funzioni separate i casi in cui il file contenga una lista di nodi, oppure sia un vettore di bit
void imposta_vettore_bits()
{
  printf("Loading nodes to be left in the graph"); fflush(stdout);

  if(nodi_input_come_bits)
    carica_vettore_bits_da_file_bits();
  else
    carica_vettore_bits_da_lista_nodi();

  nodi_da_includere->print("Nodi selezionati");

  //printf("fatto.\n");  
}



//riempie il vettore di lookup con le corrispondenze per la conversione degli identificatori dei nodi.
//il vettore contiene meno di 'numero_nodi' posizioni, percio' viene salvata il valore solo dei nodi "rappresentanti", scelti equidistanziati nell'intervallo dei nodi del grafo di partenza
//ogni posizione del vettore contiene il numero di nodi selezionati che precedono il nodo rappresentante nel grafo di partenza
void calcola_elementi_vettore_lookup()
{
  bool found;
  unsigned long prossimo_nodo_sel, indice_vettore_corrente, conta_nodi_selezionati_superati;

//printf("capienza_vettore_lookup=%lu\n", capienza_vettore_lookup); //*****
  
  nodi_per_rappresentante= numero_nodi / capienza_vettore_lookup; //inizializziamo questa variabile del modulo
  if(numero_nodi % capienza_vettore_lookup) //se c'era resto nella divisione..
    nodi_per_rappresentante++; //..ogni rappresentante deve assumersi un nodo in piu' in modo che siano tutti coperti

//printf("nodi_per_rappresentante=%lu, capienza_vettore_lookup=%lu\n", nodi_per_rappresentante, capienza_vettore_lookup); //*****

  indice_vettore_corrente= 0;
  conta_nodi_selezionati_superati= 0;
  vettore_Id_nodi[0]= 0; //prima del primo nodo non ci sono nodi selezionati
  
  found= nodi_da_includere->findNext1(prossimo_nodo_sel, 0);  
  while(found)
  {
    unsigned long indice_rappresentante_prossimo_nodo_sel= prossimo_nodo_sel / nodi_per_rappresentante;
//printf("conta_nodi_selezionati_superati=%lu , prossimo_nodo_sel=%lu  ,  indice_rappresentante_prossimo_nodo_sel=%lu  ,  indice_vettore_corrente=%lu\n", conta_nodi_selezionati_superati, prossimo_nodo_sel, indice_rappresentante_prossimo_nodo_sel, indice_vettore_corrente);
    if(indice_rappresentante_prossimo_nodo_sel > indice_vettore_corrente)
    {
      while(indice_vettore_corrente < indice_rappresentante_prossimo_nodo_sel)
      {
        indice_vettore_corrente++; //pre-incrementiamo: l'ultimo indice "corrente" non va modificato      
        vettore_Id_nodi[indice_vettore_corrente]= conta_nodi_selezionati_superati;
      }
    }
    else
      accertati_che(indice_rappresentante_prossimo_nodo_sel == indice_vettore_corrente, "Errore in calcola_elementi_vettore_lookup(): il nodo ritornato da findNext1() non puo' decrescere");

    conta_nodi_selezionati_superati++; 

    found= nodi_da_includere->findNext1(prossimo_nodo_sel);
  }
  
  accertati_che(indice_vettore_corrente < capienza_vettore_lookup, "Errore: oltrepassata la memoria del vettore in calcola_elementi_vettore_lookup()");

  indice_vettore_corrente++;    
  while(indice_vettore_corrente < capienza_vettore_lookup) //impostiamo gli elementi rimanenti del vettore
  {
    vettore_Id_nodi[indice_vettore_corrente]= conta_nodi_selezionati_superati;
    indice_vettore_corrente++;  
  }
  
//for(unsigned long i=0; i < capienza_vettore_lookup ; i++)
//  printf("indice %lu)  --> vettore_Id_nodi[i]=%lu \n", i, vettore_Id_nodi[i]);

  numero_nodi_selezionati= conta_nodi_selezionati_superati; //'conta_nodi_selezionati_superati' viene incrementato ad ogni nodo trovato, percio' conta anche il # totale di nodi selezionati
}



//legge dal vettore di bits se il nodo e' marcato come selezionato o no
bool is_selezionato(unsigned long nodo)
{
  long errore;

  bool risposta= nodi_da_includere->get(nodo, errore);
  accertati_che( (errore==0), MSG_ERRORE_BITS);

  return risposta;
}



//a partire dall'ID di un nodo nel grafo di partenza produce l'ID corrispondente per il sottografo
//PRECondizioni: il nodo da convertire deve essere uno di quelli selezionati
unsigned long converti_ID_al_volo(unsigned long ID_grafo_partenza)
{
  unsigned long traslated_ID, indice_rappresentante, rappresentante_del_nodo, nodo_selezionato;

  indice_rappresentante= ID_grafo_partenza / nodi_per_rappresentante; //l'indice nel vettore di lookup
  rappresentante_del_nodo= indice_rappresentante * nodi_per_rappresentante;

  traslated_ID= vettore_Id_nodi[indice_rappresentante]; //numero di nodi selezionati che precedono il nodo rappresentante

  bool found= nodi_da_includere->findNext1(nodo_selezionato, rappresentante_del_nodo); //cerchiamo e contiamo tutti i nodi selezionati in [rappresentante_del_nodo, ID_grafo_partenza[
  
  while((nodo_selezionato < ID_grafo_partenza) && found)
  {
    traslated_ID++;
    
    found= nodi_da_includere->findNext1(nodo_selezionato);
  }
  
  accertati_che(nodo_selezionato==ID_grafo_partenza, "Errore: passato a converti_ID_al_volo() un nodo non selezionato per il sottografo?");

  //N.B. il nodo 'ID_grafo_partenza' stesso non va contato: infatti l'ID del nodo nel sottografo e' pari al numero di nodi selezionati che lo precedevano nel grafo di partenza
  
  return traslated_ID;
}



unsigned long scansione_grafo_semiext()
{
  struct grafoInfo informazioni_nodo, informazioni_nodo_output;
  char * nome_mfile_output_info, * nome_mfile_output_pred, * nome_mfile_output_succ;
  unsigned long predecessori_dati_in_output, successori_dati_in_output;
  long conta_attesa_refresh= INTERVALLO_REFRESH_INDICATORE;
  const char messaggio_progress_bar[]= "Extracting subgraph";

  //creazione dei nomi dei multifile di output:
  nome_mfile_output_info= crea_nome_multifile_grafo(".info");
  nome_mfile_output_pred= crea_nome_multifile_grafo(".pred");
  nome_mfile_output_succ= crea_nome_multifile_grafo(".succ");

  //allocazione dei multifile e buffer di input:
  multiFileReader mf_lettura_info(grafoINFO, numINFO);
  multiFileReader mf_lettura_pred(grafoPRED, numPRED);
  multiFileReader mf_lettura_succ(grafoSUCC, numSUCC);

  BufferLetturaMultifile<struct grafoInfo> buffer_lettura_info(&mf_lettura_info, memoria_per_buffers/6);
  BufferLetturaMultifile<unsigned long> buffer_lettura_pred(&mf_lettura_pred, memoria_per_buffers/6);
  BufferLetturaMultifile<unsigned long> buffer_lettura_succ(&mf_lettura_succ, memoria_per_buffers/6);

  //allocazione dei multifile e buffer di output:
  eraseMultiFile(nome_mfile_output_info); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  multiFileWriter mf_scrittura_info(nome_mfile_output_info, 800*1024*1024);
  BufferScritturaMultifile<struct grafoInfo> buffer_scrittura_info(&mf_scrittura_info, memoria_per_buffers/6);

  eraseMultiFile(nome_mfile_output_pred); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  multiFileWriter mf_scrittura_pred(nome_mfile_output_pred, 800*1024*1024);
  BufferScritturaMultifile<unsigned long> buffer_scrittura_pred(&mf_scrittura_pred, memoria_per_buffers/6);

  eraseMultiFile(nome_mfile_output_succ); //per non ritrovarci nel nuovo multifile delle parti di un multifile vecchio
  multiFileWriter mf_scrittura_succ(nome_mfile_output_succ, 800*1024*1024);
  BufferScritturaMultifile<unsigned long> buffer_scrittura_succ(&mf_scrittura_succ, memoria_per_buffers/6);


  predecessori_dati_in_output= 0;
  successori_dati_in_output= 0;


  for(unsigned long nodo_corr=0; nodo_corr < numero_nodi ; nodo_corr++)
  {
    long ris= buffer_lettura_info.get(informazioni_nodo);
    accertati_che( (ris), MSG_ERRORE_LETTURA_MULTIFILE, grafoINFO);

    if( is_selezionato(nodo_corr) ) //il nodo e' selezionato per il sottografo di output?
    { 
      informazioni_nodo_output.puntIn= predecessori_dati_in_output;
      informazioni_nodo_output.puntOut= successori_dati_in_output;

      //esaminiamo i predecessori:
      for(unsigned long i=0; i < informazioni_nodo.inDeg ; i++)
      {
        unsigned long nodo_adiacente;

        long ris= buffer_lettura_pred.get(nodo_adiacente);
        accertati_che( (ris), MSG_ERRORE_LETTURA_MULTIFILE, grafoPRED);

        if( is_selezionato(nodo_adiacente) )
        {
          unsigned long Id_adiacente= converti_ID_al_volo(nodo_adiacente);
          buffer_scrittura_pred.put( Id_adiacente );
          predecessori_dati_in_output++;
        }
      }

      //esaminiamo i successori:
      for(unsigned long i=0; i < informazioni_nodo.outDeg ; i++)
      {
        unsigned long nodo_adiacente;

        long ris= buffer_lettura_succ.get(nodo_adiacente);
        accertati_che( (ris), MSG_ERRORE_LETTURA_MULTIFILE, grafoSUCC);

        if( is_selezionato(nodo_adiacente) )
        {
          unsigned long Id_adiacente= converti_ID_al_volo(nodo_adiacente);
          buffer_scrittura_succ.put( Id_adiacente );
          successori_dati_in_output++;
        }
      }

      informazioni_nodo_output.inDeg= predecessori_dati_in_output - informazioni_nodo_output.puntIn;
      informazioni_nodo_output.outDeg= successori_dati_in_output - informazioni_nodo_output.puntOut;
      buffer_scrittura_info.put( informazioni_nodo_output );
    }    
    else //non scriviamo nulla in output in questo caso
    {
      bool ok;
      ok= buffer_lettura_pred.skip( informazioni_nodo.inDeg );
      accertati_che( ok, MSG_ERRORE_SEEK, grafoPRED);
      ok= buffer_lettura_succ.skip( informazioni_nodo.outDeg );
      accertati_che( ok, MSG_ERRORE_SEEK, grafoSUCC);
    }

    
    if(++conta_attesa_refresh >= INTERVALLO_REFRESH_INDICATORE)
    {
      conta_attesa_refresh= 0;
      indiceProgressione(messaggio_progress_bar, (long)(100.0*nodo_corr/numero_nodi), (long)(100.0*nodo_corr/numero_nodi));
    }

  } //fine blocco ciclo for dei nodi

  indiceProgressione(messaggio_progress_bar, (long)100.0, (long)100.0); printf("\n");

  accertati_che( predecessori_dati_in_output==successori_dati_in_output, "Errore: il # di prec e' diverso dal # di successori" );

  //chiusura dei buffer scrittura e dei multifile:
  mf_lettura_info.close();
  mf_lettura_pred.close();
  mf_lettura_succ.close();

  buffer_scrittura_info.chiudi();
  buffer_scrittura_pred.chiudi();
  buffer_scrittura_succ.chiudi();

  mf_scrittura_info.close();
  mf_scrittura_pred.close();
  mf_scrittura_succ.close();

  //liberiamo la mem. per le stringhe dei nomi:
  delete [] nome_mfile_output_info;
  delete [] nome_mfile_output_pred;
  delete [] nome_mfile_output_succ;

  return predecessori_dati_in_output;
}
