/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file text2archibin32.cpp :source code of text2edges32 utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <stdio.h>
#include <math.h>
#include "comuni.h"
#include <stdlib.h>
#include "config.h"
#include <ctype.h>
#include <iostream>
#define STESSA_LINEA (char)13




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void indiceProgressione(long long numArchi){

  /*======================== STAMPA MESSAGGI ===================================================================*/
  static char cont='-';

  switch(cont){
  case '-': cont='\\';break;
  case '\\': cont='|';break;
  case '|': cont='/';break;
  case '/': cont='-';break;
  }

	printf("%c [%c] text format --> binary format (%lld edges) ",STESSA_LINEA,cont,numArchi);
  fflush(stdout);
  /*============================================================================================================*/
}




/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
bool estValido(char* s){
//  printf("%s",s);

  long lung=strlen(s);

  for (long i=0;i<lung;i++){
  	if (isdigit(s[i]))
    	   return true;    	
  }
  return false;
}



void stampaHelp(int arg,char* argv[]){
    cout<<"This utility is not designed for stand alone use. It's used as a part of others utilities.\n";
    cout<<"\n";
		cout<< "This utility converts a text format file in the edges format\n";
		cout<< " \n";
		cout<< "Usage: "<<eliminaPath(argv[0])<<" memory -savesource|-deletesource nameInputFile%d nameOutputMultifile%d\n";
		cout<< " \n";
		cout<< "memory                     memory available(MB)\n";
		cout<< "-savesource|-deletesource  specify whether to delete or keep the input file\n";
		cout<< "nameInputFile              name of the multifile of the input graph (text format)\n";
		cout<< "nameOutputMultifile%d      name of the output multifile (edges format)\n";
}


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

int main(int arg,char* argv[]){

   stampaLicenza(arg,argv);
  if (arg!=5) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");


  char*multiFileOut=argv[4];
  if (!estMultiFileName(multiFileOut))	STAMPA_ERRORE_PARAMETRI(argv[0],"Input multifile name must contain the substring '%d' ");


  //apertura files
  FILE* fp   = fopen(argv[3],"r");
	bufferedThreadFileOutputStream* fout=new bufferedThreadFileOutputStream(multiFileOut,MAX_DIM_OUTPUT ,DIM_BUFFER_LETTURA_GENERICA,NUM_BUFFER_LETTURA_GENERICA);

	//CONTROLLO apertura files
  if (fp==NULL || fout==NULL ){
      printError("Unable to open file");
      FINE;
  }


  //ricerca archi....
  arco ar;
  long long numArchi=0;
  long long iterazioni=10000;
  long long byteScritti=0;
  char buf[1000];
  long numNodi=-1;
  long righeErrate=0;
  cout<<"Format conversion:\n";fflush(stdout);
  while(fgets(buf,1000,fp)!=NULL){
    //cout<<buf<<"";
    if (estValido(buf)){
      //cout<<"*\n";
		  sscanf( buf,"%ld %ld",&(ar.source),&(ar.dest) );
//      cout<<" da "<<ar.source<<" a "<<ar.dest<<"\n";
   		iterazioni++;

      if (ar.source>=0 && ar.dest>=0){//arco normale
         numArchi++;
      	 fout -> write((&ar),sizeof(arco),1);
      }
      else
         if (ar.source==ar.dest){
             if (numNodi<-ar.dest) numNodi=-ar.dest;
             fout -> write((&ar),sizeof(arco),1);
         }
         else
           righeErrate++;        
  	 	byteScritti+=sizeof(arco);
	    if (iterazioni>MAX_ITER/5 ){iterazioni=0;indiceProgressione(numArchi);}
	  }
  }
  indiceProgressione(numArchi);


  //chiusura files
  fclose(fp);
  fp=NULL;
  fout->close();
  fout->cancella();
  fout=NULL;


  //controlla se cancellare l'input file
  cout<<"\n";
  if (strcasecmp("-deletesource",argv[2])==0){
    remove(argv[3]);    
  }
  
  
  /* STAMPA RAPPORTO ESECUZIONE */
/*	fprintf(stdout,"Grafo in formato lista di archi a 32bit\n");
	fprintf(stdout,"Nome multiFiles grafo.....................%s\n",multiFileOut);
	fprintf(stdout,"Numero files grafo creati (da 0 a MAX-1)..%ld\n",numFilesCreati);
*/

	fprintf(stdout,"\nNumber of edges ................%lld\n",byteScritti/sizeof(arco) );
  if (numNodi>=0)
    fprintf(stdout,"Number of nodes declared .......%ld\n",numNodi);
	fprintf(stdout,"Lines with error ...............%ld\n",righeErrate );
  
  EXIT(0);

}

